-- To obtain the mapping:
--[[
wget -qO - https://github.com/ryanoasis/nerd-fonts/raw/master/glyphnames.json \
| jq -r 'with_entries(select(.key != "METADATA")) | keys_unsorted[] as $keys | "\($keys)\t\(.[$keys] | .code)"' \
| awk '
  BEGIN {
    printf "{\n"
  }
  {
    printf "  [\"%s\"] = 0x%s,\n", $1, $2
  }
  END {
    printf "}\n"
  }'
--]]

local codepoints = {
  ["cod-account"] = 0xeb99,
  ["cod-activate_breakpoints"] = 0xea97,
  ["cod-add"] = 0xea60,
  ["cod-archive"] = 0xea98,
  ["cod-arrow_both"] = 0xea99,
  ["cod-arrow_down"] = 0xea9a,
  ["cod-arrow_left"] = 0xea9b,
  ["cod-arrow_right"] = 0xea9c,
  ["cod-arrow_small_down"] = 0xea9d,
  ["cod-arrow_small_left"] = 0xea9e,
  ["cod-arrow_small_right"] = 0xea9f,
  ["cod-arrow_small_up"] = 0xeaa0,
  ["cod-arrow_swap"] = 0xebcb,
  ["cod-arrow_up"] = 0xeaa1,
  ["cod-azure"] = 0xebd8,
  ["cod-azure_devops"] = 0xebe8,
  ["cod-beaker"] = 0xea79,
  ["cod-beaker_stop"] = 0xebe1,
  ["cod-bell"] = 0xeaa2,
  ["cod-bell_dot"] = 0xeb9a,
  ["cod-bold"] = 0xeaa3,
  ["cod-book"] = 0xeaa4,
  ["cod-bookmark"] = 0xeaa5,
  ["cod-bracket_dot"] = 0xebe5,
  ["cod-bracket_error"] = 0xebe6,
  ["cod-briefcase"] = 0xeaac,
  ["cod-broadcast"] = 0xeaad,
  ["cod-browser"] = 0xeaae,
  ["cod-bug"] = 0xeaaf,
  ["cod-calendar"] = 0xeab0,
  ["cod-call_incoming"] = 0xeb92,
  ["cod-call_outgoing"] = 0xeb93,
  ["cod-case_sensitive"] = 0xeab1,
  ["cod-check"] = 0xeab2,
  ["cod-check_all"] = 0xebb1,
  ["cod-checklist"] = 0xeab3,
  ["cod-chevron_down"] = 0xeab4,
  ["cod-chevron_left"] = 0xeab5,
  ["cod-chevron_right"] = 0xeab6,
  ["cod-chevron_up"] = 0xeab7,
  ["cod-chrome_close"] = 0xeab8,
  ["cod-chrome_maximize"] = 0xeab9,
  ["cod-chrome_minimize"] = 0xeaba,
  ["cod-chrome_restore"] = 0xeabb,
  ["cod-circle"] = 0xeabc,
  ["cod-circle_filled"] = 0xea71,
  ["cod-circle_large"] = 0xebb5,
  ["cod-circle_large_filled"] = 0xebb4,
  ["cod-circle_slash"] = 0xeabd,
  ["cod-circle_small_filled"] = 0xeb8a,
  ["cod-circuit_board"] = 0xeabe,
  ["cod-clear_all"] = 0xeabf,
  ["cod-clippy"] = 0xeac0,
  ["cod-close"] = 0xea76,
  ["cod-close_all"] = 0xeac1,
  ["cod-cloud"] = 0xebaa,
  ["cod-cloud_download"] = 0xeac2,
  ["cod-cloud_upload"] = 0xeac3,
  ["cod-code"] = 0xeac4,
  ["cod-collapse_all"] = 0xeac5,
  ["cod-color_mode"] = 0xeac6,
  ["cod-combine"] = 0xebb6,
  ["cod-comment"] = 0xea6b,
  ["cod-comment_discussion"] = 0xeac7,
  ["cod-compass"] = 0xebd5,
  ["cod-compass_active"] = 0xebd7,
  ["cod-compass_dot"] = 0xebd6,
  ["cod-copy"] = 0xebcc,
  ["cod-credit_card"] = 0xeac9,
  ["cod-dash"] = 0xeacc,
  ["cod-dashboard"] = 0xeacd,
  ["cod-database"] = 0xeace,
  ["cod-debug"] = 0xead8,
  ["cod-debug_all"] = 0xebdc,
  ["cod-debug_alt"] = 0xeb91,
  ["cod-debug_alt_small"] = 0xeba8,
  ["cod-debug_breakpoint_conditional"] = 0xeaa7,
  ["cod-debug_breakpoint_conditional_unverified"] = 0xeaa6,
  ["cod-debug_breakpoint_data"] = 0xeaa9,
  ["cod-debug_breakpoint_data_unverified"] = 0xeaa8,
  ["cod-debug_breakpoint_function"] = 0xeb88,
  ["cod-debug_breakpoint_function_unverified"] = 0xeb87,
  ["cod-debug_breakpoint_log"] = 0xeaab,
  ["cod-debug_breakpoint_log_unverified"] = 0xeaaa,
  ["cod-debug_breakpoint_unsupported"] = 0xeb8c,
  ["cod-debug_console"] = 0xeb9b,
  ["cod-debug_continue"] = 0xeacf,
  ["cod-debug_continue_small"] = 0xebe0,
  ["cod-debug_coverage"] = 0xebdd,
  ["cod-debug_disconnect"] = 0xead0,
  ["cod-debug_line_by_line"] = 0xebd0,
  ["cod-debug_pause"] = 0xead1,
  ["cod-debug_rerun"] = 0xebc0,
  ["cod-debug_restart"] = 0xead2,
  ["cod-debug_restart_frame"] = 0xeb90,
  ["cod-debug_reverse_continue"] = 0xeb8e,
  ["cod-debug_stackframe"] = 0xeb8b,
  ["cod-debug_stackframe_active"] = 0xeb89,
  ["cod-debug_start"] = 0xead3,
  ["cod-debug_step_back"] = 0xeb8f,
  ["cod-debug_step_into"] = 0xead4,
  ["cod-debug_step_out"] = 0xead5,
  ["cod-debug_step_over"] = 0xead6,
  ["cod-debug_stop"] = 0xead7,
  ["cod-desktop_download"] = 0xea78,
  ["cod-device_camera"] = 0xeada,
  ["cod-device_camera_video"] = 0xead9,
  ["cod-device_mobile"] = 0xeadb,
  ["cod-diff"] = 0xeae1,
  ["cod-diff_added"] = 0xeadc,
  ["cod-diff_ignored"] = 0xeadd,
  ["cod-diff_modified"] = 0xeade,
  ["cod-diff_removed"] = 0xeadf,
  ["cod-diff_renamed"] = 0xeae0,
  ["cod-discard"] = 0xeae2,
  ["cod-edit"] = 0xea73,
  ["cod-editor_layout"] = 0xeae3,
  ["cod-ellipsis"] = 0xea7c,
  ["cod-empty_window"] = 0xeae4,
  ["cod-error"] = 0xea87,
  ["cod-exclude"] = 0xeae5,
  ["cod-expand_all"] = 0xeb95,
  ["cod-export"] = 0xebac,
  ["cod-extensions"] = 0xeae6,
  ["cod-eye"] = 0xea70,
  ["cod-eye_closed"] = 0xeae7,
  ["cod-feedback"] = 0xeb96,
  ["cod-file"] = 0xea7b,
  ["cod-file_binary"] = 0xeae8,
  ["cod-file_code"] = 0xeae9,
  ["cod-file_media"] = 0xeaea,
  ["cod-file_pdf"] = 0xeaeb,
  ["cod-file_submodule"] = 0xeaec,
  ["cod-file_symlink_directory"] = 0xeaed,
  ["cod-file_symlink_file"] = 0xeaee,
  ["cod-file_zip"] = 0xeaef,
  ["cod-files"] = 0xeaf0,
  ["cod-filter"] = 0xeaf1,
  ["cod-filter_filled"] = 0xebce,
  ["cod-flame"] = 0xeaf2,
  ["cod-fold"] = 0xeaf5,
  ["cod-fold_down"] = 0xeaf3,
  ["cod-fold_up"] = 0xeaf4,
  ["cod-folder"] = 0xea83,
  ["cod-folder_active"] = 0xeaf6,
  ["cod-folder_library"] = 0xebdf,
  ["cod-folder_opened"] = 0xeaf7,
  ["cod-gear"] = 0xeaf8,
  ["cod-gift"] = 0xeaf9,
  ["cod-gist_secret"] = 0xeafa,
  ["cod-git_commit"] = 0xeafc,
  ["cod-git_compare"] = 0xeafd,
  ["cod-git_merge"] = 0xeafe,
  ["cod-git_pull_request"] = 0xea64,
  ["cod-git_pull_request_closed"] = 0xebda,
  ["cod-git_pull_request_create"] = 0xebbc,
  ["cod-git_pull_request_draft"] = 0xebdb,
  ["cod-github"] = 0xea84,
  ["cod-github_action"] = 0xeaff,
  ["cod-github_alt"] = 0xeb00,
  ["cod-github_inverted"] = 0xeba1,
  ["cod-globe"] = 0xeb01,
  ["cod-go_to_file"] = 0xea94,
  ["cod-grabber"] = 0xeb02,
  ["cod-graph"] = 0xeb03,
  ["cod-graph_left"] = 0xebad,
  ["cod-graph_line"] = 0xebe2,
  ["cod-graph_scatter"] = 0xebe3,
  ["cod-gripper"] = 0xeb04,
  ["cod-group_by_ref_type"] = 0xeb97,
  ["cod-heart"] = 0xeb05,
  ["cod-history"] = 0xea82,
  ["cod-home"] = 0xeb06,
  ["cod-horizontal_rule"] = 0xeb07,
  ["cod-hubot"] = 0xeb08,
  ["cod-inbox"] = 0xeb09,
  ["cod-info"] = 0xea74,
  ["cod-inspect"] = 0xebd1,
  ["cod-issue_draft"] = 0xebd9,
  ["cod-issue_reopened"] = 0xeb0b,
  ["cod-issues"] = 0xeb0c,
  ["cod-italic"] = 0xeb0d,
  ["cod-jersey"] = 0xeb0e,
  ["cod-json"] = 0xeb0f,
  ["cod-kebab_vertical"] = 0xeb10,
  ["cod-key"] = 0xeb11,
  ["cod-law"] = 0xeb12,
  ["cod-layers"] = 0xebd2,
  ["cod-layers_active"] = 0xebd4,
  ["cod-layers_dot"] = 0xebd3,
  ["cod-layout"] = 0xebeb,
  ["cod-library"] = 0xeb9c,
  ["cod-lightbulb"] = 0xea61,
  ["cod-lightbulb_autofix"] = 0xeb13,
  ["cod-link"] = 0xeb15,
  ["cod-link_external"] = 0xeb14,
  ["cod-list_filter"] = 0xeb83,
  ["cod-list_flat"] = 0xeb84,
  ["cod-list_ordered"] = 0xeb16,
  ["cod-list_selection"] = 0xeb85,
  ["cod-list_tree"] = 0xeb86,
  ["cod-list_unordered"] = 0xeb17,
  ["cod-live_share"] = 0xeb18,
  ["cod-loading"] = 0xeb19,
  ["cod-location"] = 0xeb1a,
  ["cod-lock"] = 0xea75,
  ["cod-lock_small"] = 0xebe7,
  ["cod-magnet"] = 0xebae,
  ["cod-mail"] = 0xeb1c,
  ["cod-mail_read"] = 0xeb1b,
  ["cod-markdown"] = 0xeb1d,
  ["cod-megaphone"] = 0xeb1e,
  ["cod-mention"] = 0xeb1f,
  ["cod-menu"] = 0xeb94,
  ["cod-merge"] = 0xebab,
  ["cod-milestone"] = 0xeb20,
  ["cod-mirror"] = 0xea69,
  ["cod-mortar_board"] = 0xeb21,
  ["cod-move"] = 0xeb22,
  ["cod-multiple_windows"] = 0xeb23,
  ["cod-mute"] = 0xeb24,
  ["cod-new_file"] = 0xea7f,
  ["cod-new_folder"] = 0xea80,
  ["cod-newline"] = 0xebea,
  ["cod-no_newline"] = 0xeb25,
  ["cod-note"] = 0xeb26,
  ["cod-notebook"] = 0xebaf,
  ["cod-notebook_template"] = 0xebbf,
  ["cod-octoface"] = 0xeb27,
  ["cod-open_preview"] = 0xeb28,
  ["cod-organization"] = 0xea7e,
  ["cod-output"] = 0xeb9d,
  ["cod-package"] = 0xeb29,
  ["cod-paintcan"] = 0xeb2a,
  ["cod-pass"] = 0xeba4,
  ["cod-pass_filled"] = 0xebb3,
  ["cod-person"] = 0xea67,
  ["cod-person_add"] = 0xebcd,
  ["cod-pie_chart"] = 0xebe4,
  ["cod-pin"] = 0xeb2b,
  ["cod-pinned"] = 0xeba0,
  ["cod-pinned_dirty"] = 0xebb2,
  ["cod-play"] = 0xeb2c,
  ["cod-play_circle"] = 0xeba6,
  ["cod-plug"] = 0xeb2d,
  ["cod-preserve_case"] = 0xeb2e,
  ["cod-preview"] = 0xeb2f,
  ["cod-primitive_square"] = 0xea72,
  ["cod-project"] = 0xeb30,
  ["cod-pulse"] = 0xeb31,
  ["cod-question"] = 0xeb32,
  ["cod-quote"] = 0xeb33,
  ["cod-radio_tower"] = 0xeb34,
  ["cod-reactions"] = 0xeb35,
  ["cod-record"] = 0xeba7,
  ["cod-record_keys"] = 0xea65,
  ["cod-redo"] = 0xebb0,
  ["cod-references"] = 0xeb36,
  ["cod-refresh"] = 0xeb37,
  ["cod-regex"] = 0xeb38,
  ["cod-remote"] = 0xeb3a,
  ["cod-remote_explorer"] = 0xeb39,
  ["cod-remove"] = 0xeb3b,
  ["cod-replace"] = 0xeb3d,
  ["cod-replace_all"] = 0xeb3c,
  ["cod-reply"] = 0xea7d,
  ["cod-repo"] = 0xea62,
  ["cod-repo_clone"] = 0xeb3e,
  ["cod-repo_force_push"] = 0xeb3f,
  ["cod-repo_forked"] = 0xea63,
  ["cod-repo_pull"] = 0xeb40,
  ["cod-repo_push"] = 0xeb41,
  ["cod-report"] = 0xeb42,
  ["cod-request_changes"] = 0xeb43,
  ["cod-rocket"] = 0xeb44,
  ["cod-root_folder"] = 0xeb46,
  ["cod-root_folder_opened"] = 0xeb45,
  ["cod-rss"] = 0xeb47,
  ["cod-ruby"] = 0xeb48,
  ["cod-run_above"] = 0xebbd,
  ["cod-run_all"] = 0xeb9e,
  ["cod-run_below"] = 0xebbe,
  ["cod-run_errors"] = 0xebde,
  ["cod-save"] = 0xeb4b,
  ["cod-save_all"] = 0xeb49,
  ["cod-save_as"] = 0xeb4a,
  ["cod-screen_full"] = 0xeb4c,
  ["cod-screen_normal"] = 0xeb4d,
  ["cod-search"] = 0xea6d,
  ["cod-search_stop"] = 0xeb4e,
  ["cod-server"] = 0xeb50,
  ["cod-server_environment"] = 0xeba3,
  ["cod-server_process"] = 0xeba2,
  ["cod-settings"] = 0xeb52,
  ["cod-settings_gear"] = 0xeb51,
  ["cod-shield"] = 0xeb53,
  ["cod-sign_in"] = 0xea6f,
  ["cod-sign_out"] = 0xea6e,
  ["cod-smiley"] = 0xeb54,
  ["cod-sort_precedence"] = 0xeb55,
  ["cod-source_control"] = 0xea68,
  ["cod-split_horizontal"] = 0xeb56,
  ["cod-split_vertical"] = 0xeb57,
  ["cod-squirrel"] = 0xeb58,
  ["cod-star_empty"] = 0xea6a,
  ["cod-star_full"] = 0xeb59,
  ["cod-star_half"] = 0xeb5a,
  ["cod-stop_circle"] = 0xeba5,
  ["cod-symbol_array"] = 0xea8a,
  ["cod-symbol_boolean"] = 0xea8f,
  ["cod-symbol_class"] = 0xeb5b,
  ["cod-symbol_color"] = 0xeb5c,
  ["cod-symbol_constant"] = 0xeb5d,
  ["cod-symbol_enum"] = 0xea95,
  ["cod-symbol_enum_member"] = 0xeb5e,
  ["cod-symbol_event"] = 0xea86,
  ["cod-symbol_field"] = 0xeb5f,
  ["cod-symbol_file"] = 0xeb60,
  ["cod-symbol_interface"] = 0xeb61,
  ["cod-symbol_key"] = 0xea93,
  ["cod-symbol_keyword"] = 0xeb62,
  ["cod-symbol_method"] = 0xea8c,
  ["cod-symbol_misc"] = 0xeb63,
  ["cod-symbol_namespace"] = 0xea8b,
  ["cod-symbol_numeric"] = 0xea90,
  ["cod-symbol_operator"] = 0xeb64,
  ["cod-symbol_parameter"] = 0xea92,
  ["cod-symbol_property"] = 0xeb65,
  ["cod-symbol_ruler"] = 0xea96,
  ["cod-symbol_snippet"] = 0xeb66,
  ["cod-symbol_string"] = 0xeb8d,
  ["cod-symbol_structure"] = 0xea91,
  ["cod-symbol_variable"] = 0xea88,
  ["cod-sync"] = 0xea77,
  ["cod-sync_ignored"] = 0xeb9f,
  ["cod-table"] = 0xebb7,
  ["cod-tag"] = 0xea66,
  ["cod-tasklist"] = 0xeb67,
  ["cod-telescope"] = 0xeb68,
  ["cod-terminal"] = 0xea85,
  ["cod-terminal_bash"] = 0xebca,
  ["cod-terminal_cmd"] = 0xebc4,
  ["cod-terminal_debian"] = 0xebc5,
  ["cod-terminal_linux"] = 0xebc6,
  ["cod-terminal_powershell"] = 0xebc7,
  ["cod-terminal_tmux"] = 0xebc8,
  ["cod-terminal_ubuntu"] = 0xebc9,
  ["cod-text_size"] = 0xeb69,
  ["cod-three_bars"] = 0xeb6a,
  ["cod-thumbsdown"] = 0xeb6b,
  ["cod-thumbsup"] = 0xeb6c,
  ["cod-tools"] = 0xeb6d,
  ["cod-trash"] = 0xea81,
  ["cod-triangle_down"] = 0xeb6e,
  ["cod-triangle_left"] = 0xeb6f,
  ["cod-triangle_right"] = 0xeb70,
  ["cod-triangle_up"] = 0xeb71,
  ["cod-twitter"] = 0xeb72,
  ["cod-type_hierarchy"] = 0xebb9,
  ["cod-type_hierarchy_sub"] = 0xebba,
  ["cod-type_hierarchy_super"] = 0xebbb,
  ["cod-unfold"] = 0xeb73,
  ["cod-ungroup_by_ref_type"] = 0xeb98,
  ["cod-unlock"] = 0xeb74,
  ["cod-unmute"] = 0xeb75,
  ["cod-unverified"] = 0xeb76,
  ["cod-variable_group"] = 0xebb8,
  ["cod-verified"] = 0xeb77,
  ["cod-verified_filled"] = 0xebe9,
  ["cod-versions"] = 0xeb78,
  ["cod-vm"] = 0xea7a,
  ["cod-vm_active"] = 0xeb79,
  ["cod-vm_connect"] = 0xeba9,
  ["cod-vm_outline"] = 0xeb7a,
  ["cod-vm_running"] = 0xeb7b,
  ["cod-wand"] = 0xebcf,
  ["cod-warning"] = 0xea6c,
  ["cod-watch"] = 0xeb7c,
  ["cod-whitespace"] = 0xeb7d,
  ["cod-whole_word"] = 0xeb7e,
  ["cod-window"] = 0xeb7f,
  ["cod-word_wrap"] = 0xeb80,
  ["cod-workspace_trusted"] = 0xebc1,
  ["cod-workspace_unknown"] = 0xebc3,
  ["cod-workspace_untrusted"] = 0xebc2,
  ["cod-zoom_in"] = 0xeb81,
  ["cod-zoom_out"] = 0xeb82,
  ["custom-asm"] = 0xe6ab,
  ["custom-c"] = 0xe61e,
  ["custom-common_lisp"] = 0xe6b0,
  ["custom-cpp"] = 0xe61d,
  ["custom-crystal"] = 0xe62f,
  ["custom-default"] = 0xe612,
  ["custom-electron"] = 0xe62e,
  ["custom-elixir"] = 0xe62d,
  ["custom-elm"] = 0xe62c,
  ["custom-emacs"] = 0xe632,
  ["custom-fennel"] = 0xe6af,
  ["custom-folder"] = 0xe5ff,
  ["custom-folder_config"] = 0xe5fc,
  ["custom-folder_git"] = 0xe5fb,
  ["custom-folder_git_branch"] = 0xe5fb,
  ["custom-folder_github"] = 0xe5fd,
  ["custom-folder_npm"] = 0xe5fa,
  ["custom-folder_oct"] = 0xe6ad,
  ["custom-folder_open"] = 0xe5fe,
  ["custom-go"] = 0xe626,
  ["custom-home"] = 0xe617,
  ["custom-kotlin"] = 0xe634,
  ["custom-msdos"] = 0xe629,
  ["custom-neovim"] = 0xe6ae,
  ["custom-orgmode"] = 0xe633,
  ["custom-play_arrow"] = 0xe602,
  ["custom-puppet"] = 0xe631,
  ["custom-purescript"] = 0xe630,
  ["custom-scheme"] = 0xe6b1,
  ["custom-toml"] = 0xe6b2,
  ["custom-v_lang"] = 0xe6ac,
  ["custom-vim"] = 0xe62b,
  ["custom-windows"] = 0xe62a,
  ["dev-android"] = 0xe70e,
  ["dev-angular"] = 0xe753,
  ["dev-appcelerator"] = 0xe7ab,
  ["dev-apple"] = 0xe711,
  ["dev-appstore"] = 0xe713,
  ["dev-aptana"] = 0xe799,
  ["dev-asterisk"] = 0xe7ac,
  ["dev-atlassian"] = 0xe75b,
  ["dev-atom"] = 0xe764,
  ["dev-aws"] = 0xe7ad,
  ["dev-backbone"] = 0xe752,
  ["dev-bing_small"] = 0xe700,
  ["dev-bintray"] = 0xe794,
  ["dev-bitbucket"] = 0xe703,
  ["dev-blackberry"] = 0xe723,
  ["dev-bootstrap"] = 0xe747,
  ["dev-bower"] = 0xe74d,
  ["dev-brackets"] = 0xe79d,
  ["dev-bugsense"] = 0xe78d,
  ["dev-celluloid"] = 0xe76b,
  ["dev-chart"] = 0xe760,
  ["dev-chrome"] = 0xe743,
  ["dev-cisco"] = 0xe765,
  ["dev-clojure"] = 0xe768,
  ["dev-clojure_alt"] = 0xe76a,
  ["dev-cloud9"] = 0xe79f,
  ["dev-coda"] = 0xe793,
  ["dev-code"] = 0xe796,
  ["dev-code_badge"] = 0xe7a3,
  ["dev-codeigniter"] = 0xe780,
  ["dev-codepen"] = 0xe716,
  ["dev-codrops"] = 0xe72f,
  ["dev-coffeescript"] = 0xe751,
  ["dev-compass"] = 0xe761,
  ["dev-composer"] = 0xe783,
  ["dev-creativecommons"] = 0xe789,
  ["dev-creativecommons_badge"] = 0xe78a,
  ["dev-css3"] = 0xe749,
  ["dev-css3_full"] = 0xe74a,
  ["dev-css_tricks"] = 0xe701,
  ["dev-cssdeck"] = 0xe72a,
  ["dev-dart"] = 0xe798,
  ["dev-database"] = 0xe706,
  ["dev-debian"] = 0xe77d,
  ["dev-digital_ocean"] = 0xe7ae,
  ["dev-django"] = 0xe71d,
  ["dev-dlang"] = 0xe7af,
  ["dev-docker"] = 0xe7b0,
  ["dev-doctrine"] = 0xe774,
  ["dev-dojo"] = 0xe71c,
  ["dev-dotnet"] = 0xe77f,
  ["dev-dreamweaver"] = 0xe79c,
  ["dev-dropbox"] = 0xe707,
  ["dev-drupal"] = 0xe742,
  ["dev-eclipse"] = 0xe79e,
  ["dev-ember"] = 0xe71b,
  ["dev-envato"] = 0xe75d,
  ["dev-erlang"] = 0xe7b1,
  ["dev-extjs"] = 0xe78e,
  ["dev-firebase"] = 0xe787,
  ["dev-firefox"] = 0xe745,
  ["dev-fsharp"] = 0xe7a7,
  ["dev-ghost"] = 0xe71f,
  ["dev-ghost_small"] = 0xe714,
  ["dev-git"] = 0xe702,
  ["dev-git_branch"] = 0xe725,
  ["dev-git_commit"] = 0xe729,
  ["dev-git_compare"] = 0xe728,
  ["dev-git_merge"] = 0xe727,
  ["dev-git_pull_request"] = 0xe726,
  ["dev-github"] = 0xe70a,
  ["dev-github_alt"] = 0xe708,
  ["dev-github_badge"] = 0xe709,
  ["dev-github_full"] = 0xe717,
  ["dev-gnu"] = 0xe779,
  ["dev-go"] = 0xe724,
  ["dev-google_cloud_platform"] = 0xe7b2,
  ["dev-google_drive"] = 0xe731,
  ["dev-grails"] = 0xe7b3,
  ["dev-groovy"] = 0xe775,
  ["dev-grunt"] = 0xe74c,
  ["dev-gulp"] = 0xe763,
  ["dev-hackernews"] = 0xe71a,
  ["dev-haskell"] = 0xe777,
  ["dev-heroku"] = 0xe77b,
  ["dev-html5"] = 0xe736,
  ["dev-html5_3d_effects"] = 0xe735,
  ["dev-html5_connectivity"] = 0xe734,
  ["dev-html5_device_access"] = 0xe733,
  ["dev-html5_multimedia"] = 0xe732,
  ["dev-ie"] = 0xe744,
  ["dev-illustrator"] = 0xe7b4,
  ["dev-intellij"] = 0xe7b5,
  ["dev-ionic"] = 0xe7a9,
  ["dev-java"] = 0xe738,
  ["dev-javascript"] = 0xe74e,
  ["dev-javascript_badge"] = 0xe781,
  ["dev-javascript_shield"] = 0xe74f,
  ["dev-jekyll_small"] = 0xe70d,
  ["dev-jenkins"] = 0xe767,
  ["dev-jira"] = 0xe75c,
  ["dev-joomla"] = 0xe741,
  ["dev-jquery"] = 0xe750,
  ["dev-jquery_ui"] = 0xe754,
  ["dev-komodo"] = 0xe792,
  ["dev-krakenjs"] = 0xe785,
  ["dev-krakenjs_badge"] = 0xe784,
  ["dev-laravel"] = 0xe73f,
  ["dev-less"] = 0xe758,
  ["dev-linux"] = 0xe712,
  ["dev-magento"] = 0xe740,
  ["dev-mailchimp"] = 0xe79a,
  ["dev-markdown"] = 0xe73e,
  ["dev-materializecss"] = 0xe7b6,
  ["dev-meteor"] = 0xe7a5,
  ["dev-meteorfull"] = 0xe7a6,
  ["dev-mitlicence"] = 0xe78b,
  ["dev-modernizr"] = 0xe720,
  ["dev-mongodb"] = 0xe7a4,
  ["dev-mootools"] = 0xe790,
  ["dev-mootools_badge"] = 0xe78f,
  ["dev-mozilla"] = 0xe786,
  ["dev-msql_server"] = 0xe77c,
  ["dev-mysql"] = 0xe704,
  ["dev-nancy"] = 0xe766,
  ["dev-netbeans"] = 0xe79b,
  ["dev-netmagazine"] = 0xe72e,
  ["dev-nginx"] = 0xe776,
  ["dev-nodejs"] = 0xe719,
  ["dev-nodejs_small"] = 0xe718,
  ["dev-npm"] = 0xe71e,
  ["dev-onedrive"] = 0xe762,
  ["dev-openshift"] = 0xe7b7,
  ["dev-opensource"] = 0xe771,
  ["dev-opera"] = 0xe746,
  ["dev-perl"] = 0xe769,
  ["dev-phonegap"] = 0xe730,
  ["dev-photoshop"] = 0xe7b8,
  ["dev-php"] = 0xe73d,
  ["dev-postgresql"] = 0xe76e,
  ["dev-prolog"] = 0xe7a1,
  ["dev-python"] = 0xe73c,
  ["dev-rackspace"] = 0xe7b9,
  ["dev-raphael"] = 0xe75f,
  ["dev-rasberry_pi"] = 0xe722,
  ["dev-react"] = 0xe7ba,
  ["dev-redhat"] = 0xe7bb,
  ["dev-redis"] = 0xe76d,
  ["dev-requirejs"] = 0xe770,
  ["dev-responsive"] = 0xe797,
  ["dev-ruby"] = 0xe739,
  ["dev-ruby_on_rails"] = 0xe73b,
  ["dev-ruby_rough"] = 0xe791,
  ["dev-rust"] = 0xe7a8,
  ["dev-safari"] = 0xe748,
  ["dev-sass"] = 0xe74b,
  ["dev-scala"] = 0xe737,
  ["dev-scriptcs"] = 0xe7bc,
  ["dev-scrum"] = 0xe7a0,
  ["dev-senchatouch"] = 0xe78c,
  ["dev-sizzlejs"] = 0xe788,
  ["dev-smashing_magazine"] = 0xe72d,
  ["dev-snap_svg"] = 0xe75e,
  ["dev-sqllite"] = 0xe7c4,
  ["dev-stackoverflow"] = 0xe710,
  ["dev-streamline"] = 0xe705,
  ["dev-stylus"] = 0xe759,
  ["dev-sublime"] = 0xe7aa,
  ["dev-swift"] = 0xe755,
  ["dev-symfony"] = 0xe756,
  ["dev-symfony_badge"] = 0xe757,
  ["dev-techcrunch"] = 0xe72c,
  ["dev-terminal"] = 0xe795,
  ["dev-terminal_badge"] = 0xe7a2,
  ["dev-travis"] = 0xe77e,
  ["dev-trello"] = 0xe75a,
  ["dev-typo3"] = 0xe772,
  ["dev-ubuntu"] = 0xe73a,
  ["dev-uikit"] = 0xe773,
  ["dev-unity_small"] = 0xe721,
  ["dev-vim"] = 0xe7c5,
  ["dev-visualstudio"] = 0xe70c,
  ["dev-w3c"] = 0xe76c,
  ["dev-webplatform"] = 0xe76f,
  ["dev-windows"] = 0xe70f,
  ["dev-wordpress"] = 0xe70b,
  ["dev-yahoo"] = 0xe715,
  ["dev-yahoo_small"] = 0xe72b,
  ["dev-yeoman"] = 0xe77a,
  ["dev-yii"] = 0xe782,
  ["dev-zend"] = 0xe778,
  ["fa-500px"] = 0xf26e,
  ["fa-address_book"] = 0xf2b9,
  ["fa-address_book_o"] = 0xf2ba,
  ["fa-address_card"] = 0xf2bb,
  ["fa-address_card_o"] = 0xf2bc,
  ["fa-adjust"] = 0xf042,
  ["fa-adn"] = 0xf170,
  ["fa-align_center"] = 0xf037,
  ["fa-align_justify"] = 0xf039,
  ["fa-align_left"] = 0xf036,
  ["fa-align_right"] = 0xf038,
  ["fa-amazon"] = 0xf270,
  ["fa-ambulance"] = 0xf0f9,
  ["fa-american_sign_language_interpreting"] = 0xf2a3,
  ["fa-anchor"] = 0xf13d,
  ["fa-android"] = 0xf17b,
  ["fa-angellist"] = 0xf209,
  ["fa-angle_double_down"] = 0xf103,
  ["fa-angle_double_left"] = 0xf100,
  ["fa-angle_double_right"] = 0xf101,
  ["fa-angle_double_up"] = 0xf102,
  ["fa-angle_down"] = 0xf107,
  ["fa-angle_left"] = 0xf104,
  ["fa-angle_right"] = 0xf105,
  ["fa-angle_up"] = 0xf106,
  ["fa-apple"] = 0xf179,
  ["fa-archive"] = 0xf187,
  ["fa-area_chart"] = 0xf1fe,
  ["fa-arrow_circle_down"] = 0xf0ab,
  ["fa-arrow_circle_left"] = 0xf0a8,
  ["fa-arrow_circle_o_down"] = 0xf01a,
  ["fa-arrow_circle_o_left"] = 0xf190,
  ["fa-arrow_circle_o_right"] = 0xf18e,
  ["fa-arrow_circle_o_up"] = 0xf01b,
  ["fa-arrow_circle_right"] = 0xf0a9,
  ["fa-arrow_circle_up"] = 0xf0aa,
  ["fa-arrow_down"] = 0xf063,
  ["fa-arrow_left"] = 0xf060,
  ["fa-arrow_right"] = 0xf061,
  ["fa-arrow_up"] = 0xf062,
  ["fa-arrows"] = 0xf047,
  ["fa-arrows_alt"] = 0xf0b2,
  ["fa-arrows_h"] = 0xf07e,
  ["fa-arrows_v"] = 0xf07d,
  ["fa-asl_interpreting"] = 0xf2a3,
  ["fa-assistive_listening_systems"] = 0xf2a2,
  ["fa-asterisk"] = 0xf069,
  ["fa-at"] = 0xf1fa,
  ["fa-audio_description"] = 0xf29e,
  ["fa-automobile"] = 0xf1b9,
  ["fa-backward"] = 0xf04a,
  ["fa-balance_scale"] = 0xf24e,
  ["fa-ban"] = 0xf05e,
  ["fa-bandcamp"] = 0xf2d5,
  ["fa-bank"] = 0xf19c,
  ["fa-bar_chart"] = 0xf080,
  ["fa-bar_chart_o"] = 0xf080,
  ["fa-barcode"] = 0xf02a,
  ["fa-bars"] = 0xf0c9,
  ["fa-bath"] = 0xf2cd,
  ["fa-bathtub"] = 0xf2cd,
  ["fa-battery"] = 0xf240,
  ["fa-battery_0"] = 0xf244,
  ["fa-battery_1"] = 0xf243,
  ["fa-battery_2"] = 0xf242,
  ["fa-battery_3"] = 0xf241,
  ["fa-battery_4"] = 0xf240,
  ["fa-battery_empty"] = 0xf244,
  ["fa-battery_full"] = 0xf240,
  ["fa-battery_half"] = 0xf242,
  ["fa-battery_quarter"] = 0xf243,
  ["fa-battery_three_quarters"] = 0xf241,
  ["fa-bed"] = 0xf236,
  ["fa-beer"] = 0xf0fc,
  ["fa-behance"] = 0xf1b4,
  ["fa-behance_square"] = 0xf1b5,
  ["fa-bell"] = 0xf0f3,
  ["fa-bell_o"] = 0xf0a2,
  ["fa-bell_slash"] = 0xf1f6,
  ["fa-bell_slash_o"] = 0xf1f7,
  ["fa-bicycle"] = 0xf206,
  ["fa-binoculars"] = 0xf1e5,
  ["fa-birthday_cake"] = 0xf1fd,
  ["fa-bitbucket"] = 0xf171,
  ["fa-bitbucket_square"] = 0xf172,
  ["fa-bitcoin"] = 0xf15a,
  ["fa-black_tie"] = 0xf27e,
  ["fa-blind"] = 0xf29d,
  ["fa-bluetooth"] = 0xf293,
  ["fa-bluetooth_b"] = 0xf294,
  ["fa-bold"] = 0xf032,
  ["fa-bolt"] = 0xf0e7,
  ["fa-bomb"] = 0xf1e2,
  ["fa-book"] = 0xf02d,
  ["fa-bookmark"] = 0xf02e,
  ["fa-bookmark_o"] = 0xf097,
  ["fa-braille"] = 0xf2a1,
  ["fa-briefcase"] = 0xf0b1,
  ["fa-btc"] = 0xf15a,
  ["fa-bug"] = 0xf188,
  ["fa-building"] = 0xf1ad,
  ["fa-building_o"] = 0xf0f7,
  ["fa-bullhorn"] = 0xf0a1,
  ["fa-bullseye"] = 0xf140,
  ["fa-bus"] = 0xf207,
  ["fa-buysellads"] = 0xf20d,
  ["fa-cab"] = 0xf1ba,
  ["fa-calculator"] = 0xf1ec,
  ["fa-calendar"] = 0xf073,
  ["fa-calendar_check_o"] = 0xf274,
  ["fa-calendar_minus_o"] = 0xf272,
  ["fa-calendar_o"] = 0xf133,
  ["fa-calendar_plus_o"] = 0xf271,
  ["fa-calendar_times_o"] = 0xf273,
  ["fa-camera"] = 0xf030,
  ["fa-camera_retro"] = 0xf083,
  ["fa-car"] = 0xf1b9,
  ["fa-caret_down"] = 0xf0d7,
  ["fa-caret_left"] = 0xf0d9,
  ["fa-caret_right"] = 0xf0da,
  ["fa-caret_square_o_down"] = 0xf150,
  ["fa-caret_square_o_left"] = 0xf191,
  ["fa-caret_square_o_right"] = 0xf152,
  ["fa-caret_square_o_up"] = 0xf151,
  ["fa-caret_up"] = 0xf0d8,
  ["fa-cart_arrow_down"] = 0xf218,
  ["fa-cart_plus"] = 0xf217,
  ["fa-cc"] = 0xf20a,
  ["fa-cc_amex"] = 0xf1f3,
  ["fa-cc_diners_club"] = 0xf24c,
  ["fa-cc_discover"] = 0xf1f2,
  ["fa-cc_jcb"] = 0xf24b,
  ["fa-cc_mastercard"] = 0xf1f1,
  ["fa-cc_paypal"] = 0xf1f4,
  ["fa-cc_stripe"] = 0xf1f5,
  ["fa-cc_visa"] = 0xf1f0,
  ["fa-certificate"] = 0xf0a3,
  ["fa-chain"] = 0xf0c1,
  ["fa-chain_broken"] = 0xf127,
  ["fa-check"] = 0xf00c,
  ["fa-check_circle"] = 0xf058,
  ["fa-check_circle_o"] = 0xf05d,
  ["fa-check_square"] = 0xf14a,
  ["fa-check_square_o"] = 0xf046,
  ["fa-chevron_circle_down"] = 0xf13a,
  ["fa-chevron_circle_left"] = 0xf137,
  ["fa-chevron_circle_right"] = 0xf138,
  ["fa-chevron_circle_up"] = 0xf139,
  ["fa-chevron_down"] = 0xf078,
  ["fa-chevron_left"] = 0xf053,
  ["fa-chevron_right"] = 0xf054,
  ["fa-chevron_up"] = 0xf077,
  ["fa-child"] = 0xf1ae,
  ["fa-chrome"] = 0xf268,
  ["fa-circle"] = 0xf111,
  ["fa-circle_o"] = 0xf10c,
  ["fa-circle_o_notch"] = 0xf1ce,
  ["fa-circle_thin"] = 0xf1db,
  ["fa-clipboard"] = 0xf0ea,
  ["fa-clock_o"] = 0xf017,
  ["fa-clone"] = 0xf24d,
  ["fa-close"] = 0xf00d,
  ["fa-cloud"] = 0xf0c2,
  ["fa-cloud_download"] = 0xf0ed,
  ["fa-cloud_upload"] = 0xf0ee,
  ["fa-cny"] = 0xf157,
  ["fa-code"] = 0xf121,
  ["fa-code_fork"] = 0xf126,
  ["fa-codepen"] = 0xf1cb,
  ["fa-codiepie"] = 0xf284,
  ["fa-coffee"] = 0xf0f4,
  ["fa-cog"] = 0xf013,
  ["fa-cogs"] = 0xf085,
  ["fa-columns"] = 0xf0db,
  ["fa-comment"] = 0xf075,
  ["fa-comment_o"] = 0xf0e5,
  ["fa-commenting"] = 0xf27a,
  ["fa-commenting_o"] = 0xf27b,
  ["fa-comments"] = 0xf086,
  ["fa-comments_o"] = 0xf0e6,
  ["fa-compass"] = 0xf14e,
  ["fa-compress"] = 0xf066,
  ["fa-connectdevelop"] = 0xf20e,
  ["fa-contao"] = 0xf26d,
  ["fa-copy"] = 0xf0c5,
  ["fa-copyright"] = 0xf1f9,
  ["fa-creative_commons"] = 0xf25e,
  ["fa-credit_card"] = 0xf09d,
  ["fa-credit_card_alt"] = 0xf283,
  ["fa-crop"] = 0xf125,
  ["fa-crosshairs"] = 0xf05b,
  ["fa-css3"] = 0xf13c,
  ["fa-cube"] = 0xf1b2,
  ["fa-cubes"] = 0xf1b3,
  ["fa-cut"] = 0xf0c4,
  ["fa-cutlery"] = 0xf0f5,
  ["fa-dashboard"] = 0xf0e4,
  ["fa-dashcube"] = 0xf210,
  ["fa-database"] = 0xf1c0,
  ["fa-deaf"] = 0xf2a4,
  ["fa-deafness"] = 0xf2a4,
  ["fa-dedent"] = 0xf03b,
  ["fa-delicious"] = 0xf1a5,
  ["fa-desktop"] = 0xf108,
  ["fa-deviantart"] = 0xf1bd,
  ["fa-diamond"] = 0xf219,
  ["fa-digg"] = 0xf1a6,
  ["fa-dollar"] = 0xf155,
  ["fa-dot_circle_o"] = 0xf192,
  ["fa-download"] = 0xf019,
  ["fa-dribbble"] = 0xf17d,
  ["fa-drivers_license"] = 0xf2c2,
  ["fa-drivers_license_o"] = 0xf2c3,
  ["fa-dropbox"] = 0xf16b,
  ["fa-drupal"] = 0xf1a9,
  ["fa-edge"] = 0xf282,
  ["fa-edit"] = 0xf044,
  ["fa-eercast"] = 0xf2da,
  ["fa-eject"] = 0xf052,
  ["fa-ellipsis_h"] = 0xf141,
  ["fa-ellipsis_v"] = 0xf142,
  ["fa-empire"] = 0xf1d1,
  ["fa-envelope"] = 0xf0e0,
  ["fa-envelope_o"] = 0xf003,
  ["fa-envelope_open"] = 0xf2b6,
  ["fa-envelope_open_o"] = 0xf2b7,
  ["fa-envelope_square"] = 0xf199,
  ["fa-envira"] = 0xf299,
  ["fa-eraser"] = 0xf12d,
  ["fa-etsy"] = 0xf2d7,
  ["fa-eur"] = 0xf153,
  ["fa-euro"] = 0xf153,
  ["fa-exchange"] = 0xf0ec,
  ["fa-exclamation"] = 0xf12a,
  ["fa-exclamation_circle"] = 0xf06a,
  ["fa-exclamation_triangle"] = 0xf071,
  ["fa-expand"] = 0xf065,
  ["fa-expeditedssl"] = 0xf23e,
  ["fa-external_link"] = 0xf08e,
  ["fa-external_link_square"] = 0xf14c,
  ["fa-eye"] = 0xf06e,
  ["fa-eye_slash"] = 0xf070,
  ["fa-eyedropper"] = 0xf1fb,
  ["fa-fa"] = 0xf2b4,
  ["fa-facebook"] = 0xf09a,
  ["fa-facebook_f"] = 0xf09a,
  ["fa-facebook_official"] = 0xf230,
  ["fa-facebook_square"] = 0xf082,
  ["fa-fast_backward"] = 0xf049,
  ["fa-fast_forward"] = 0xf050,
  ["fa-fax"] = 0xf1ac,
  ["fa-feed"] = 0xf09e,
  ["fa-female"] = 0xf182,
  ["fa-fighter_jet"] = 0xf0fb,
  ["fa-file"] = 0xf15b,
  ["fa-file_archive_o"] = 0xf1c6,
  ["fa-file_audio_o"] = 0xf1c7,
  ["fa-file_code_o"] = 0xf1c9,
  ["fa-file_excel_o"] = 0xf1c3,
  ["fa-file_image_o"] = 0xf1c5,
  ["fa-file_movie_o"] = 0xf1c8,
  ["fa-file_o"] = 0xf016,
  ["fa-file_pdf_o"] = 0xf1c1,
  ["fa-file_photo_o"] = 0xf1c5,
  ["fa-file_picture_o"] = 0xf1c5,
  ["fa-file_powerpoint_o"] = 0xf1c4,
  ["fa-file_sound_o"] = 0xf1c7,
  ["fa-file_text"] = 0xf15c,
  ["fa-file_text_o"] = 0xf0f6,
  ["fa-file_video_o"] = 0xf1c8,
  ["fa-file_word_o"] = 0xf1c2,
  ["fa-file_zip_o"] = 0xf1c6,
  ["fa-files_o"] = 0xf0c5,
  ["fa-film"] = 0xf008,
  ["fa-filter"] = 0xf0b0,
  ["fa-fire"] = 0xf06d,
  ["fa-fire_extinguisher"] = 0xf134,
  ["fa-firefox"] = 0xf269,
  ["fa-first_order"] = 0xf2b0,
  ["fa-flag"] = 0xf024,
  ["fa-flag_checkered"] = 0xf11e,
  ["fa-flag_o"] = 0xf11d,
  ["fa-flash"] = 0xf0e7,
  ["fa-flask"] = 0xf0c3,
  ["fa-flickr"] = 0xf16e,
  ["fa-floppy_o"] = 0xf0c7,
  ["fa-folder"] = 0xf07b,
  ["fa-folder_o"] = 0xf114,
  ["fa-folder_open"] = 0xf07c,
  ["fa-folder_open_o"] = 0xf115,
  ["fa-font"] = 0xf031,
  ["fa-font_awesome"] = 0xf2b4,
  ["fa-fonticons"] = 0xf280,
  ["fa-fort_awesome"] = 0xf286,
  ["fa-forumbee"] = 0xf211,
  ["fa-forward"] = 0xf04e,
  ["fa-foursquare"] = 0xf180,
  ["fa-free_code_camp"] = 0xf2c5,
  ["fa-frown_o"] = 0xf119,
  ["fa-futbol_o"] = 0xf1e3,
  ["fa-gamepad"] = 0xf11b,
  ["fa-gavel"] = 0xf0e3,
  ["fa-gbp"] = 0xf154,
  ["fa-ge"] = 0xf1d1,
  ["fa-gear"] = 0xf013,
  ["fa-gears"] = 0xf085,
  ["fa-genderless"] = 0xf22d,
  ["fa-get_pocket"] = 0xf265,
  ["fa-gg"] = 0xf260,
  ["fa-gg_circle"] = 0xf261,
  ["fa-gift"] = 0xf06b,
  ["fa-git"] = 0xf1d3,
  ["fa-git_square"] = 0xf1d2,
  ["fa-github"] = 0xf09b,
  ["fa-github_alt"] = 0xf113,
  ["fa-github_square"] = 0xf092,
  ["fa-gitlab"] = 0xf296,
  ["fa-gittip"] = 0xf184,
  ["fa-glass"] = 0xf000,
  ["fa-glide"] = 0xf2a5,
  ["fa-glide_g"] = 0xf2a6,
  ["fa-globe"] = 0xf0ac,
  ["fa-google"] = 0xf1a0,
  ["fa-google_plus"] = 0xf0d5,
  ["fa-google_plus_circle"] = 0xf2b3,
  ["fa-google_plus_official"] = 0xf2b3,
  ["fa-google_plus_square"] = 0xf0d4,
  ["fa-google_wallet"] = 0xf1ee,
  ["fa-graduation_cap"] = 0xf19d,
  ["fa-gratipay"] = 0xf184,
  ["fa-grav"] = 0xf2d6,
  ["fa-group"] = 0xf0c0,
  ["fa-h_square"] = 0xf0fd,
  ["fa-hacker_news"] = 0xf1d4,
  ["fa-hand_grab_o"] = 0xf255,
  ["fa-hand_lizard_o"] = 0xf258,
  ["fa-hand_o_down"] = 0xf0a7,
  ["fa-hand_o_left"] = 0xf0a5,
  ["fa-hand_o_right"] = 0xf0a4,
  ["fa-hand_o_up"] = 0xf0a6,
  ["fa-hand_paper_o"] = 0xf256,
  ["fa-hand_peace_o"] = 0xf25b,
  ["fa-hand_pointer_o"] = 0xf25a,
  ["fa-hand_rock_o"] = 0xf255,
  ["fa-hand_scissors_o"] = 0xf257,
  ["fa-hand_spock_o"] = 0xf259,
  ["fa-hand_stop_o"] = 0xf256,
  ["fa-handshake_o"] = 0xf2b5,
  ["fa-hard_of_hearing"] = 0xf2a4,
  ["fa-hashtag"] = 0xf292,
  ["fa-hdd_o"] = 0xf0a0,
  ["fa-header"] = 0xf1dc,
  ["fa-headphones"] = 0xf025,
  ["fa-heart"] = 0xf004,
  ["fa-heart_o"] = 0xf08a,
  ["fa-heartbeat"] = 0xf21e,
  ["fa-history"] = 0xf1da,
  ["fa-home"] = 0xf015,
  ["fa-hospital_o"] = 0xf0f8,
  ["fa-hotel"] = 0xf236,
  ["fa-hourglass"] = 0xf254,
  ["fa-hourglass_1"] = 0xf251,
  ["fa-hourglass_2"] = 0xf252,
  ["fa-hourglass_3"] = 0xf253,
  ["fa-hourglass_end"] = 0xf253,
  ["fa-hourglass_half"] = 0xf252,
  ["fa-hourglass_o"] = 0xf250,
  ["fa-hourglass_start"] = 0xf251,
  ["fa-houzz"] = 0xf27c,
  ["fa-html5"] = 0xf13b,
  ["fa-i_cursor"] = 0xf246,
  ["fa-id_badge"] = 0xf2c1,
  ["fa-id_card"] = 0xf2c2,
  ["fa-id_card_o"] = 0xf2c3,
  ["fa-ils"] = 0xf20b,
  ["fa-image"] = 0xf03e,
  ["fa-imdb"] = 0xf2d8,
  ["fa-inbox"] = 0xf01c,
  ["fa-indent"] = 0xf03c,
  ["fa-industry"] = 0xf275,
  ["fa-info"] = 0xf129,
  ["fa-info_circle"] = 0xf05a,
  ["fa-inr"] = 0xf156,
  ["fa-instagram"] = 0xf16d,
  ["fa-institution"] = 0xf19c,
  ["fa-internet_explorer"] = 0xf26b,
  ["fa-intersex"] = 0xf224,
  ["fa-ioxhost"] = 0xf208,
  ["fa-italic"] = 0xf033,
  ["fa-joomla"] = 0xf1aa,
  ["fa-jpy"] = 0xf157,
  ["fa-jsfiddle"] = 0xf1cc,
  ["fa-key"] = 0xf084,
  ["fa-keyboard_o"] = 0xf11c,
  ["fa-krw"] = 0xf159,
  ["fa-language"] = 0xf1ab,
  ["fa-laptop"] = 0xf109,
  ["fa-lastfm"] = 0xf202,
  ["fa-lastfm_square"] = 0xf203,
  ["fa-leaf"] = 0xf06c,
  ["fa-leanpub"] = 0xf212,
  ["fa-legal"] = 0xf0e3,
  ["fa-lemon_o"] = 0xf094,
  ["fa-level_down"] = 0xf149,
  ["fa-level_up"] = 0xf148,
  ["fa-life_bouy"] = 0xf1cd,
  ["fa-life_buoy"] = 0xf1cd,
  ["fa-life_ring"] = 0xf1cd,
  ["fa-life_saver"] = 0xf1cd,
  ["fa-lightbulb_o"] = 0xf0eb,
  ["fa-line_chart"] = 0xf201,
  ["fa-link"] = 0xf0c1,
  ["fa-linkedin"] = 0xf0e1,
  ["fa-linkedin_square"] = 0xf08c,
  ["fa-linode"] = 0xf2b8,
  ["fa-linux"] = 0xf17c,
  ["fa-list"] = 0xf03a,
  ["fa-list_alt"] = 0xf022,
  ["fa-list_ol"] = 0xf0cb,
  ["fa-list_ul"] = 0xf0ca,
  ["fa-location_arrow"] = 0xf124,
  ["fa-lock"] = 0xf023,
  ["fa-long_arrow_down"] = 0xf175,
  ["fa-long_arrow_left"] = 0xf177,
  ["fa-long_arrow_right"] = 0xf178,
  ["fa-long_arrow_up"] = 0xf176,
  ["fa-low_vision"] = 0xf2a8,
  ["fa-magic"] = 0xf0d0,
  ["fa-magnet"] = 0xf076,
  ["fa-mail_forward"] = 0xf064,
  ["fa-mail_reply"] = 0xf112,
  ["fa-mail_reply_all"] = 0xf122,
  ["fa-male"] = 0xf183,
  ["fa-map"] = 0xf279,
  ["fa-map_marker"] = 0xf041,
  ["fa-map_o"] = 0xf278,
  ["fa-map_pin"] = 0xf276,
  ["fa-map_signs"] = 0xf277,
  ["fa-mars"] = 0xf222,
  ["fa-mars_double"] = 0xf227,
  ["fa-mars_stroke"] = 0xf229,
  ["fa-mars_stroke_h"] = 0xf22b,
  ["fa-mars_stroke_v"] = 0xf22a,
  ["fa-maxcdn"] = 0xf136,
  ["fa-meanpath"] = 0xf20c,
  ["fa-medium"] = 0xf23a,
  ["fa-medkit"] = 0xf0fa,
  ["fa-meetup"] = 0xf2e0,
  ["fa-meh_o"] = 0xf11a,
  ["fa-mercury"] = 0xf223,
  ["fa-microchip"] = 0xf2db,
  ["fa-microphone"] = 0xf130,
  ["fa-microphone_slash"] = 0xf131,
  ["fa-minus"] = 0xf068,
  ["fa-minus_circle"] = 0xf056,
  ["fa-minus_square"] = 0xf146,
  ["fa-minus_square_o"] = 0xf147,
  ["fa-mixcloud"] = 0xf289,
  ["fa-mobile"] = 0xf10b,
  ["fa-mobile_phone"] = 0xf10b,
  ["fa-modx"] = 0xf285,
  ["fa-money"] = 0xf0d6,
  ["fa-moon_o"] = 0xf186,
  ["fa-mortar_board"] = 0xf19d,
  ["fa-motorcycle"] = 0xf21c,
  ["fa-mouse_pointer"] = 0xf245,
  ["fa-music"] = 0xf001,
  ["fa-navicon"] = 0xf0c9,
  ["fa-neuter"] = 0xf22c,
  ["fa-newspaper_o"] = 0xf1ea,
  ["fa-object_group"] = 0xf247,
  ["fa-object_ungroup"] = 0xf248,
  ["fa-odnoklassniki"] = 0xf263,
  ["fa-odnoklassniki_square"] = 0xf264,
  ["fa-opencart"] = 0xf23d,
  ["fa-openid"] = 0xf19b,
  ["fa-opera"] = 0xf26a,
  ["fa-optin_monster"] = 0xf23c,
  ["fa-outdent"] = 0xf03b,
  ["fa-pagelines"] = 0xf18c,
  ["fa-paint_brush"] = 0xf1fc,
  ["fa-paper_plane"] = 0xf1d8,
  ["fa-paper_plane_o"] = 0xf1d9,
  ["fa-paperclip"] = 0xf0c6,
  ["fa-paragraph"] = 0xf1dd,
  ["fa-paste"] = 0xf0ea,
  ["fa-pause"] = 0xf04c,
  ["fa-pause_circle"] = 0xf28b,
  ["fa-pause_circle_o"] = 0xf28c,
  ["fa-paw"] = 0xf1b0,
  ["fa-paypal"] = 0xf1ed,
  ["fa-pencil"] = 0xf040,
  ["fa-pencil_square"] = 0xf14b,
  ["fa-pencil_square_o"] = 0xf044,
  ["fa-percent"] = 0xf295,
  ["fa-phone"] = 0xf095,
  ["fa-phone_square"] = 0xf098,
  ["fa-photo"] = 0xf03e,
  ["fa-picture_o"] = 0xf03e,
  ["fa-pie_chart"] = 0xf200,
  ["fa-pied_piper"] = 0xf2ae,
  ["fa-pied_piper_alt"] = 0xf1a8,
  ["fa-pied_piper_pp"] = 0xf1a7,
  ["fa-pinterest"] = 0xf0d2,
  ["fa-pinterest_p"] = 0xf231,
  ["fa-pinterest_square"] = 0xf0d3,
  ["fa-plane"] = 0xf072,
  ["fa-play"] = 0xf04b,
  ["fa-play_circle"] = 0xf144,
  ["fa-play_circle_o"] = 0xf01d,
  ["fa-plug"] = 0xf1e6,
  ["fa-plus"] = 0xf067,
  ["fa-plus_circle"] = 0xf055,
  ["fa-plus_square"] = 0xf0fe,
  ["fa-plus_square_o"] = 0xf196,
  ["fa-podcast"] = 0xf2ce,
  ["fa-power_off"] = 0xf011,
  ["fa-print"] = 0xf02f,
  ["fa-product_hunt"] = 0xf288,
  ["fa-puzzle_piece"] = 0xf12e,
  ["fa-qq"] = 0xf1d6,
  ["fa-qrcode"] = 0xf029,
  ["fa-question"] = 0xf128,
  ["fa-question_circle"] = 0xf059,
  ["fa-question_circle_o"] = 0xf29c,
  ["fa-quora"] = 0xf2c4,
  ["fa-quote_left"] = 0xf10d,
  ["fa-quote_right"] = 0xf10e,
  ["fa-ra"] = 0xf1d0,
  ["fa-random"] = 0xf074,
  ["fa-ravelry"] = 0xf2d9,
  ["fa-rebel"] = 0xf1d0,
  ["fa-recycle"] = 0xf1b8,
  ["fa-reddit"] = 0xf1a1,
  ["fa-reddit_alien"] = 0xf281,
  ["fa-reddit_square"] = 0xf1a2,
  ["fa-refresh"] = 0xf021,
  ["fa-registered"] = 0xf25d,
  ["fa-remove"] = 0xf00d,
  ["fa-renren"] = 0xf18b,
  ["fa-reorder"] = 0xf0c9,
  ["fa-repeat"] = 0xf01e,
  ["fa-reply"] = 0xf112,
  ["fa-reply_all"] = 0xf122,
  ["fa-resistance"] = 0xf1d0,
  ["fa-retweet"] = 0xf079,
  ["fa-rmb"] = 0xf157,
  ["fa-road"] = 0xf018,
  ["fa-rocket"] = 0xf135,
  ["fa-rotate_left"] = 0xf0e2,
  ["fa-rotate_right"] = 0xf01e,
  ["fa-rouble"] = 0xf158,
  ["fa-rss"] = 0xf09e,
  ["fa-rss_square"] = 0xf143,
  ["fa-rub"] = 0xf158,
  ["fa-ruble"] = 0xf158,
  ["fa-rupee"] = 0xf156,
  ["fa-s15"] = 0xf2cd,
  ["fa-safari"] = 0xf267,
  ["fa-save"] = 0xf0c7,
  ["fa-scissors"] = 0xf0c4,
  ["fa-scribd"] = 0xf28a,
  ["fa-search"] = 0xf002,
  ["fa-search_minus"] = 0xf010,
  ["fa-search_plus"] = 0xf00e,
  ["fa-sellsy"] = 0xf213,
  ["fa-send"] = 0xf1d8,
  ["fa-send_o"] = 0xf1d9,
  ["fa-server"] = 0xf233,
  ["fa-share"] = 0xf064,
  ["fa-share_alt"] = 0xf1e0,
  ["fa-share_alt_square"] = 0xf1e1,
  ["fa-share_square"] = 0xf14d,
  ["fa-share_square_o"] = 0xf045,
  ["fa-shekel"] = 0xf20b,
  ["fa-sheqel"] = 0xf20b,
  ["fa-shield"] = 0xf132,
  ["fa-ship"] = 0xf21a,
  ["fa-shirtsinbulk"] = 0xf214,
  ["fa-shopping_bag"] = 0xf290,
  ["fa-shopping_basket"] = 0xf291,
  ["fa-shopping_cart"] = 0xf07a,
  ["fa-shower"] = 0xf2cc,
  ["fa-sign_in"] = 0xf090,
  ["fa-sign_language"] = 0xf2a7,
  ["fa-sign_out"] = 0xf08b,
  ["fa-signal"] = 0xf012,
  ["fa-signing"] = 0xf2a7,
  ["fa-simplybuilt"] = 0xf215,
  ["fa-sitemap"] = 0xf0e8,
  ["fa-skyatlas"] = 0xf216,
  ["fa-skype"] = 0xf17e,
  ["fa-slack"] = 0xf198,
  ["fa-sliders"] = 0xf1de,
  ["fa-slideshare"] = 0xf1e7,
  ["fa-smile_o"] = 0xf118,
  ["fa-snapchat"] = 0xf2ab,
  ["fa-snapchat_ghost"] = 0xf2ac,
  ["fa-snapchat_square"] = 0xf2ad,
  ["fa-snowflake_o"] = 0xf2dc,
  ["fa-soccer_ball_o"] = 0xf1e3,
  ["fa-sort"] = 0xf0dc,
  ["fa-sort_alpha_asc"] = 0xf15d,
  ["fa-sort_alpha_desc"] = 0xf15e,
  ["fa-sort_amount_asc"] = 0xf160,
  ["fa-sort_amount_desc"] = 0xf161,
  ["fa-sort_asc"] = 0xf0de,
  ["fa-sort_desc"] = 0xf0dd,
  ["fa-sort_down"] = 0xf0dd,
  ["fa-sort_numeric_asc"] = 0xf162,
  ["fa-sort_numeric_desc"] = 0xf163,
  ["fa-sort_up"] = 0xf0de,
  ["fa-soundcloud"] = 0xf1be,
  ["fa-space_shuttle"] = 0xf197,
  ["fa-spinner"] = 0xf110,
  ["fa-spoon"] = 0xf1b1,
  ["fa-spotify"] = 0xf1bc,
  ["fa-square"] = 0xf0c8,
  ["fa-square_o"] = 0xf096,
  ["fa-stack_exchange"] = 0xf18d,
  ["fa-stack_overflow"] = 0xf16c,
  ["fa-star"] = 0xf005,
  ["fa-star_half"] = 0xf089,
  ["fa-star_half_empty"] = 0xf123,
  ["fa-star_half_full"] = 0xf123,
  ["fa-star_half_o"] = 0xf123,
  ["fa-star_o"] = 0xf006,
  ["fa-steam"] = 0xf1b6,
  ["fa-steam_square"] = 0xf1b7,
  ["fa-step_backward"] = 0xf048,
  ["fa-step_forward"] = 0xf051,
  ["fa-stethoscope"] = 0xf0f1,
  ["fa-sticky_note"] = 0xf249,
  ["fa-sticky_note_o"] = 0xf24a,
  ["fa-stop"] = 0xf04d,
  ["fa-stop_circle"] = 0xf28d,
  ["fa-stop_circle_o"] = 0xf28e,
  ["fa-street_view"] = 0xf21d,
  ["fa-strikethrough"] = 0xf0cc,
  ["fa-stumbleupon"] = 0xf1a4,
  ["fa-stumbleupon_circle"] = 0xf1a3,
  ["fa-subscript"] = 0xf12c,
  ["fa-subway"] = 0xf239,
  ["fa-suitcase"] = 0xf0f2,
  ["fa-sun_o"] = 0xf185,
  ["fa-superpowers"] = 0xf2dd,
  ["fa-superscript"] = 0xf12b,
  ["fa-support"] = 0xf1cd,
  ["fa-table"] = 0xf0ce,
  ["fa-tablet"] = 0xf10a,
  ["fa-tachometer"] = 0xf0e4,
  ["fa-tag"] = 0xf02b,
  ["fa-tags"] = 0xf02c,
  ["fa-tasks"] = 0xf0ae,
  ["fa-taxi"] = 0xf1ba,
  ["fa-telegram"] = 0xf2c6,
  ["fa-television"] = 0xf26c,
  ["fa-tencent_weibo"] = 0xf1d5,
  ["fa-terminal"] = 0xf120,
  ["fa-text_height"] = 0xf034,
  ["fa-text_width"] = 0xf035,
  ["fa-th"] = 0xf00a,
  ["fa-th_large"] = 0xf009,
  ["fa-th_list"] = 0xf00b,
  ["fa-themeisle"] = 0xf2b2,
  ["fa-thermometer"] = 0xf2c7,
  ["fa-thermometer_0"] = 0xf2cb,
  ["fa-thermometer_1"] = 0xf2ca,
  ["fa-thermometer_2"] = 0xf2c9,
  ["fa-thermometer_3"] = 0xf2c8,
  ["fa-thermometer_4"] = 0xf2c7,
  ["fa-thermometer_empty"] = 0xf2cb,
  ["fa-thermometer_full"] = 0xf2c7,
  ["fa-thermometer_half"] = 0xf2c9,
  ["fa-thermometer_quarter"] = 0xf2ca,
  ["fa-thermometer_three_quarters"] = 0xf2c8,
  ["fa-thumb_tack"] = 0xf08d,
  ["fa-thumbs_down"] = 0xf165,
  ["fa-thumbs_o_down"] = 0xf088,
  ["fa-thumbs_o_up"] = 0xf087,
  ["fa-thumbs_up"] = 0xf164,
  ["fa-ticket"] = 0xf145,
  ["fa-times"] = 0xf00d,
  ["fa-times_circle"] = 0xf057,
  ["fa-times_circle_o"] = 0xf05c,
  ["fa-times_rectangle"] = 0xf2d3,
  ["fa-times_rectangle_o"] = 0xf2d4,
  ["fa-tint"] = 0xf043,
  ["fa-toggle_down"] = 0xf150,
  ["fa-toggle_left"] = 0xf191,
  ["fa-toggle_off"] = 0xf204,
  ["fa-toggle_on"] = 0xf205,
  ["fa-toggle_right"] = 0xf152,
  ["fa-toggle_up"] = 0xf151,
  ["fa-trademark"] = 0xf25c,
  ["fa-train"] = 0xf238,
  ["fa-transgender"] = 0xf224,
  ["fa-transgender_alt"] = 0xf225,
  ["fa-trash"] = 0xf1f8,
  ["fa-trash_o"] = 0xf014,
  ["fa-tree"] = 0xf1bb,
  ["fa-trello"] = 0xf181,
  ["fa-tripadvisor"] = 0xf262,
  ["fa-trophy"] = 0xf091,
  ["fa-truck"] = 0xf0d1,
  ["fa-try"] = 0xf195,
  ["fa-tty"] = 0xf1e4,
  ["fa-tumblr"] = 0xf173,
  ["fa-tumblr_square"] = 0xf174,
  ["fa-turkish_lira"] = 0xf195,
  ["fa-tv"] = 0xf26c,
  ["fa-twitch"] = 0xf1e8,
  ["fa-twitter"] = 0xf099,
  ["fa-twitter_square"] = 0xf081,
  ["fa-umbrella"] = 0xf0e9,
  ["fa-underline"] = 0xf0cd,
  ["fa-undo"] = 0xf0e2,
  ["fa-universal_access"] = 0xf29a,
  ["fa-university"] = 0xf19c,
  ["fa-unlink"] = 0xf127,
  ["fa-unlock"] = 0xf09c,
  ["fa-unlock_alt"] = 0xf13e,
  ["fa-unsorted"] = 0xf0dc,
  ["fa-upload"] = 0xf093,
  ["fa-usb"] = 0xf287,
  ["fa-usd"] = 0xf155,
  ["fa-user"] = 0xf007,
  ["fa-user_circle"] = 0xf2bd,
  ["fa-user_circle_o"] = 0xf2be,
  ["fa-user_md"] = 0xf0f0,
  ["fa-user_o"] = 0xf2c0,
  ["fa-user_plus"] = 0xf234,
  ["fa-user_secret"] = 0xf21b,
  ["fa-user_times"] = 0xf235,
  ["fa-users"] = 0xf0c0,
  ["fa-vcard"] = 0xf2bb,
  ["fa-vcard_o"] = 0xf2bc,
  ["fa-venus"] = 0xf221,
  ["fa-venus_double"] = 0xf226,
  ["fa-venus_mars"] = 0xf228,
  ["fa-viacoin"] = 0xf237,
  ["fa-viadeo"] = 0xf2a9,
  ["fa-viadeo_square"] = 0xf2aa,
  ["fa-video_camera"] = 0xf03d,
  ["fa-vimeo"] = 0xf27d,
  ["fa-vimeo_square"] = 0xf194,
  ["fa-vine"] = 0xf1ca,
  ["fa-vk"] = 0xf189,
  ["fa-volume_control_phone"] = 0xf2a0,
  ["fa-volume_down"] = 0xf027,
  ["fa-volume_off"] = 0xf026,
  ["fa-volume_up"] = 0xf028,
  ["fa-warning"] = 0xf071,
  ["fa-wechat"] = 0xf1d7,
  ["fa-weibo"] = 0xf18a,
  ["fa-weixin"] = 0xf1d7,
  ["fa-whatsapp"] = 0xf232,
  ["fa-wheelchair"] = 0xf193,
  ["fa-wheelchair_alt"] = 0xf29b,
  ["fa-wifi"] = 0xf1eb,
  ["fa-wikipedia_w"] = 0xf266,
  ["fa-window_close"] = 0xf2d3,
  ["fa-window_close_o"] = 0xf2d4,
  ["fa-window_maximize"] = 0xf2d0,
  ["fa-window_minimize"] = 0xf2d1,
  ["fa-window_restore"] = 0xf2d2,
  ["fa-windows"] = 0xf17a,
  ["fa-won"] = 0xf159,
  ["fa-wordpress"] = 0xf19a,
  ["fa-wpbeginner"] = 0xf297,
  ["fa-wpexplorer"] = 0xf2de,
  ["fa-wpforms"] = 0xf298,
  ["fa-wrench"] = 0xf0ad,
  ["fa-xing"] = 0xf168,
  ["fa-xing_square"] = 0xf169,
  ["fa-y_combinator"] = 0xf23b,
  ["fa-y_combinator_square"] = 0xf1d4,
  ["fa-yahoo"] = 0xf19e,
  ["fa-yc"] = 0xf23b,
  ["fa-yc_square"] = 0xf1d4,
  ["fa-yelp"] = 0xf1e9,
  ["fa-yen"] = 0xf157,
  ["fa-yoast"] = 0xf2b1,
  ["fa-youtube"] = 0xf167,
  ["fa-youtube_play"] = 0xf16a,
  ["fa-youtube_square"] = 0xf166,
  ["fae-apple_fruit"] = 0xe29e,
  ["fae-atom"] = 0xe27f,
  ["fae-bacteria"] = 0xe280,
  ["fae-banana"] = 0xe281,
  ["fae-bath"] = 0xe282,
  ["fae-bed"] = 0xe283,
  ["fae-benzene"] = 0xe284,
  ["fae-bigger"] = 0xe285,
  ["fae-biohazard"] = 0xe286,
  ["fae-blogger_circle"] = 0xe287,
  ["fae-blogger_square"] = 0xe288,
  ["fae-bones"] = 0xe289,
  ["fae-book_open"] = 0xe28a,
  ["fae-book_open_o"] = 0xe28b,
  ["fae-brain"] = 0xe28c,
  ["fae-bread"] = 0xe28d,
  ["fae-butterfly"] = 0xe28e,
  ["fae-carot"] = 0xe28f,
  ["fae-cc_by"] = 0xe290,
  ["fae-cc_cc"] = 0xe291,
  ["fae-cc_nc"] = 0xe292,
  ["fae-cc_nc_eu"] = 0xe293,
  ["fae-cc_nc_jp"] = 0xe294,
  ["fae-cc_nd"] = 0xe295,
  ["fae-cc_remix"] = 0xe296,
  ["fae-cc_sa"] = 0xe297,
  ["fae-cc_share"] = 0xe298,
  ["fae-cc_zero"] = 0xe299,
  ["fae-checklist_o"] = 0xe29a,
  ["fae-cheese"] = 0xe264,
  ["fae-cherry"] = 0xe29b,
  ["fae-chess_bishop"] = 0xe29c,
  ["fae-chess_horse"] = 0xe25f,
  ["fae-chess_king"] = 0xe260,
  ["fae-chess_pawn"] = 0xe261,
  ["fae-chess_queen"] = 0xe262,
  ["fae-chess_tower"] = 0xe263,
  ["fae-chicken_thigh"] = 0xe29f,
  ["fae-chilli"] = 0xe265,
  ["fae-chip"] = 0xe266,
  ["fae-cicling"] = 0xe267,
  ["fae-cloud"] = 0xe268,
  ["fae-cockroach"] = 0xe269,
  ["fae-coffe_beans"] = 0xe26a,
  ["fae-coins"] = 0xe26b,
  ["fae-comb"] = 0xe26c,
  ["fae-comet"] = 0xe26d,
  ["fae-crown"] = 0xe26e,
  ["fae-cup_coffe"] = 0xe26f,
  ["fae-dice"] = 0xe270,
  ["fae-disco"] = 0xe271,
  ["fae-dna"] = 0xe272,
  ["fae-donut"] = 0xe273,
  ["fae-dress"] = 0xe274,
  ["fae-drop"] = 0xe275,
  ["fae-ello"] = 0xe276,
  ["fae-envelope_open"] = 0xe277,
  ["fae-envelope_open_o"] = 0xe278,
  ["fae-equal"] = 0xe279,
  ["fae-equal_bigger"] = 0xe27a,
  ["fae-feedly"] = 0xe27b,
  ["fae-file_export"] = 0xe27c,
  ["fae-file_import"] = 0xe27d,
  ["fae-fingerprint"] = 0xe23f,
  ["fae-floppy"] = 0xe240,
  ["fae-footprint"] = 0xe241,
  ["fae-freecodecamp"] = 0xe242,
  ["fae-galaxy"] = 0xe243,
  ["fae-galery"] = 0xe244,
  ["fae-gift_card"] = 0xe2a0,
  ["fae-glass"] = 0xe245,
  ["fae-google_drive"] = 0xe246,
  ["fae-google_play"] = 0xe247,
  ["fae-gps"] = 0xe248,
  ["fae-grav"] = 0xe249,
  ["fae-guitar"] = 0xe24a,
  ["fae-gut"] = 0xe24b,
  ["fae-halter"] = 0xe24c,
  ["fae-hamburger"] = 0xe24d,
  ["fae-hat"] = 0xe24e,
  ["fae-hexagon"] = 0xe24f,
  ["fae-high_heel"] = 0xe250,
  ["fae-hotdog"] = 0xe251,
  ["fae-ice_cream"] = 0xe252,
  ["fae-id_card"] = 0xe253,
  ["fae-imdb"] = 0xe254,
  ["fae-infinity"] = 0xe255,
  ["fae-injection"] = 0xe2a1,
  ["fae-isle"] = 0xe2a2,
  ["fae-java"] = 0xe256,
  ["fae-layers"] = 0xe257,
  ["fae-lips"] = 0xe258,
  ["fae-lipstick"] = 0xe259,
  ["fae-liver"] = 0xe25a,
  ["fae-lollipop"] = 0xe2a3,
  ["fae-loyalty_card"] = 0xe2a4,
  ["fae-lung"] = 0xe25b,
  ["fae-makeup_brushes"] = 0xe25c,
  ["fae-maximize"] = 0xe25d,
  ["fae-meat"] = 0xe2a5,
  ["fae-medicine"] = 0xe221,
  ["fae-microscope"] = 0xe222,
  ["fae-milk_bottle"] = 0xe223,
  ["fae-minimize"] = 0xe224,
  ["fae-molecule"] = 0xe225,
  ["fae-moon_cloud"] = 0xe226,
  ["fae-mountains"] = 0xe2a6,
  ["fae-mushroom"] = 0xe227,
  ["fae-mustache"] = 0xe228,
  ["fae-mysql"] = 0xe229,
  ["fae-nintendo"] = 0xe22a,
  ["fae-orange"] = 0xe2a7,
  ["fae-palette_color"] = 0xe22b,
  ["fae-peach"] = 0xe2a8,
  ["fae-pear"] = 0xe2a9,
  ["fae-pi"] = 0xe22c,
  ["fae-pizza"] = 0xe22d,
  ["fae-planet"] = 0xe22e,
  ["fae-plant"] = 0xe22f,
  ["fae-playstation"] = 0xe230,
  ["fae-poison"] = 0xe231,
  ["fae-popcorn"] = 0xe232,
  ["fae-popsicle"] = 0xe233,
  ["fae-pulse"] = 0xe234,
  ["fae-python"] = 0xe235,
  ["fae-quora_circle"] = 0xe236,
  ["fae-quora_square"] = 0xe237,
  ["fae-radioactive"] = 0xe238,
  ["fae-raining"] = 0xe239,
  ["fae-real_heart"] = 0xe23a,
  ["fae-refrigerator"] = 0xe23b,
  ["fae-restore"] = 0xe23c,
  ["fae-ring"] = 0xe23d,
  ["fae-ruby"] = 0xe23e,
  ["fae-ruby_o"] = 0xe21e,
  ["fae-ruler"] = 0xe21f,
  ["fae-shirt"] = 0xe218,
  ["fae-slash"] = 0xe216,
  ["fae-smaller"] = 0xe200,
  ["fae-snowing"] = 0xe201,
  ["fae-soda"] = 0xe202,
  ["fae-sofa"] = 0xe203,
  ["fae-soup"] = 0xe204,
  ["fae-spermatozoon"] = 0xe205,
  ["fae-spin_double"] = 0xe206,
  ["fae-stomach"] = 0xe207,
  ["fae-storm"] = 0xe208,
  ["fae-sun_cloud"] = 0xe21d,
  ["fae-sushi"] = 0xe21a,
  ["fae-tacos"] = 0xe219,
  ["fae-telegram"] = 0xe217,
  ["fae-telegram_circle"] = 0xe215,
  ["fae-telescope"] = 0xe209,
  ["fae-thermometer"] = 0xe20a,
  ["fae-thermometer_high"] = 0xe20b,
  ["fae-thermometer_low"] = 0xe20c,
  ["fae-thin_close"] = 0xe20d,
  ["fae-toilet"] = 0xe20e,
  ["fae-tools"] = 0xe20f,
  ["fae-tooth"] = 0xe210,
  ["fae-tree"] = 0xe21c,
  ["fae-triangle_ruler"] = 0xe21b,
  ["fae-umbrella"] = 0xe220,
  ["fae-uterus"] = 0xe211,
  ["fae-virus"] = 0xe214,
  ["fae-w3c"] = 0xe212,
  ["fae-walking"] = 0xe213,
  ["fae-wallet"] = 0xe25e,
  ["fae-wind"] = 0xe27e,
  ["fae-xbox"] = 0xe29d,
  ["iec-power"] = 0x23fb,
  ["iec-power_off"] = 0x2b58,
  ["iec-power_on"] = 0x23fd,
  ["iec-sleep_mode"] = 0x23fe,
  ["iec-toggle_power"] = 0x23fc,
  ["indent-dotted_guide"] = 0xe621,
  ["indent-line"] = 0xe621,
  ["indentation-line"] = 0xe621,
  ["linux-almalinux"] = 0xf31d,
  ["linux-alpine"] = 0xf300,
  ["linux-aosc"] = 0xf301,
  ["linux-apple"] = 0xf302,
  ["linux-archcraft"] = 0xf345,
  ["linux-archlabs"] = 0xf31e,
  ["linux-archlinux"] = 0xf303,
  ["linux-arcolinux"] = 0xf346,
  ["linux-arduino"] = 0xf34b,
  ["linux-artix"] = 0xf31f,
  ["linux-awesome"] = 0xf354,
  ["linux-biglinux"] = 0xf347,
  ["linux-bspwm"] = 0xf355,
  ["linux-budgie"] = 0xf320,
  ["linux-centos"] = 0xf304,
  ["linux-cinnamon"] = 0xf35f,
  ["linux-codeberg"] = 0xf330,
  ["linux-coreos"] = 0xf305,
  ["linux-crystal"] = 0xf348,
  ["linux-debian"] = 0xf306,
  ["linux-deepin"] = 0xf321,
  ["linux-devuan"] = 0xf307,
  ["linux-docker"] = 0xf308,
  ["linux-dwm"] = 0xf356,
  ["linux-elementary"] = 0xf309,
  ["linux-endeavour"] = 0xf322,
  ["linux-enlightenment"] = 0xf357,
  ["linux-fdroid"] = 0xf36a,
  ["linux-fedora"] = 0xf30a,
  ["linux-fedora_inverse"] = 0xf30b,
  ["linux-ferris"] = 0xf323,
  ["linux-flathub"] = 0xf324,
  ["linux-fluxbox"] = 0xf358,
  ["linux-forgejo"] = 0xf335,
  ["linux-fosdem"] = 0xf36b,
  ["linux-freebsd"] = 0xf30c,
  ["linux-freecad"] = 0xf336,
  ["linux-freedesktop"] = 0xf360,
  ["linux-garuda"] = 0xf337,
  ["linux-gentoo"] = 0xf30d,
  ["linux-gimp"] = 0xf338,
  ["linux-gitea"] = 0xf339,
  ["linux-gnome"] = 0xf361,
  ["linux-gnu_guix"] = 0xf325,
  ["linux-gtk"] = 0xf362,
  ["linux-hyperbola"] = 0xf33a,
  ["linux-hyprland"] = 0xf359,
  ["linux-i3"] = 0xf35a,
  ["linux-illumos"] = 0xf326,
  ["linux-inkscape"] = 0xf33b,
  ["linux-jwm"] = 0xf35b,
  ["linux-kali_linux"] = 0xf327,
  ["linux-kde_neon"] = 0xf331,
  ["linux-kde_plasma"] = 0xf332,
  ["linux-kdenlive"] = 0xf33c,
  ["linux-kicad"] = 0xf34c,
  ["linux-krita"] = 0xf33d,
  ["linux-kubuntu"] = 0xf333,
  ["linux-kubuntu_inverse"] = 0xf334,
  ["linux-linuxmint"] = 0xf30e,
  ["linux-linuxmint_inverse"] = 0xf30f,
  ["linux-locos"] = 0xf349,
  ["linux-lxde"] = 0xf363,
  ["linux-lxle"] = 0xf33e,
  ["linux-lxqt"] = 0xf364,
  ["linux-mageia"] = 0xf310,
  ["linux-mandriva"] = 0xf311,
  ["linux-manjaro"] = 0xf312,
  ["linux-mate"] = 0xf365,
  ["linux-mpv"] = 0xf36e,
  ["linux-mxlinux"] = 0xf33f,
  ["linux-neovim"] = 0xf36f,
  ["linux-nixos"] = 0xf313,
  ["linux-octoprint"] = 0xf34d,
  ["linux-openbsd"] = 0xf328,
  ["linux-openscad"] = 0xf34e,
  ["linux-opensuse"] = 0xf314,
  ["linux-osh"] = 0xf34f,
  ["linux-oshwa"] = 0xf350,
  ["linux-osi"] = 0xf36c,
  ["linux-parabola"] = 0xf340,
  ["linux-parrot"] = 0xf329,
  ["linux-pop_os"] = 0xf32a,
  ["linux-prusaslicer"] = 0xf351,
  ["linux-puppy"] = 0xf341,
  ["linux-qtile"] = 0xf35c,
  ["linux-qubesos"] = 0xf342,
  ["linux-raspberry_pi"] = 0xf315,
  ["linux-redhat"] = 0xf316,
  ["linux-reprap"] = 0xf352,
  ["linux-riscv"] = 0xf353,
  ["linux-rocky_linux"] = 0xf32b,
  ["linux-sabayon"] = 0xf317,
  ["linux-slackware"] = 0xf318,
  ["linux-slackware_inverse"] = 0xf319,
  ["linux-snappy"] = 0xf32c,
  ["linux-solus"] = 0xf32d,
  ["linux-sway"] = 0xf35d,
  ["linux-tails"] = 0xf343,
  ["linux-thunderbird"] = 0xf370,
  ["linux-tor"] = 0xf371,
  ["linux-trisquel"] = 0xf344,
  ["linux-tux"] = 0xf31a,
  ["linux-ubuntu"] = 0xf31b,
  ["linux-ubuntu_inverse"] = 0xf31c,
  ["linux-vanilla"] = 0xf366,
  ["linux-void"] = 0xf32e,
  ["linux-vscodium"] = 0xf372,
  ["linux-wayland"] = 0xf367,
  ["linux-wikimedia"] = 0xf36d,
  ["linux-xerolinux"] = 0xf34a,
  ["linux-xfce"] = 0xf368,
  ["linux-xmonad"] = 0xf35e,
  ["linux-xorg"] = 0xf369,
  ["linux-zorin"] = 0xf32f,
  ["md-ab_testing"] = 0xf01c9,
  ["md-abacus"] = 0xf16e0,
  ["md-abjad_arabic"] = 0xf1328,
  ["md-abjad_hebrew"] = 0xf1329,
  ["md-abugida_devanagari"] = 0xf132a,
  ["md-abugida_thai"] = 0xf132b,
  ["md-access_point"] = 0xf0003,
  ["md-access_point_check"] = 0xf1538,
  ["md-access_point_minus"] = 0xf1539,
  ["md-access_point_network"] = 0xf0002,
  ["md-access_point_network_off"] = 0xf0be1,
  ["md-access_point_off"] = 0xf1511,
  ["md-access_point_plus"] = 0xf153a,
  ["md-access_point_remove"] = 0xf153b,
  ["md-account"] = 0xf0004,
  ["md-account_alert"] = 0xf0005,
  ["md-account_alert_outline"] = 0xf0b50,
  ["md-account_arrow_down"] = 0xf1868,
  ["md-account_arrow_down_outline"] = 0xf1869,
  ["md-account_arrow_left"] = 0xf0b51,
  ["md-account_arrow_left_outline"] = 0xf0b52,
  ["md-account_arrow_right"] = 0xf0b53,
  ["md-account_arrow_right_outline"] = 0xf0b54,
  ["md-account_arrow_up"] = 0xf1867,
  ["md-account_arrow_up_outline"] = 0xf186a,
  ["md-account_box"] = 0xf0006,
  ["md-account_box_multiple"] = 0xf0934,
  ["md-account_box_multiple_outline"] = 0xf100a,
  ["md-account_box_outline"] = 0xf0007,
  ["md-account_cancel"] = 0xf12df,
  ["md-account_cancel_outline"] = 0xf12e0,
  ["md-account_cash"] = 0xf1097,
  ["md-account_cash_outline"] = 0xf1098,
  ["md-account_check"] = 0xf0008,
  ["md-account_check_outline"] = 0xf0be2,
  ["md-account_child"] = 0xf0a89,
  ["md-account_child_circle"] = 0xf0a8a,
  ["md-account_child_outline"] = 0xf10c8,
  ["md-account_circle"] = 0xf0009,
  ["md-account_circle_outline"] = 0xf0b55,
  ["md-account_clock"] = 0xf0b56,
  ["md-account_clock_outline"] = 0xf0b57,
  ["md-account_cog"] = 0xf1370,
  ["md-account_cog_outline"] = 0xf1371,
  ["md-account_convert"] = 0xf000a,
  ["md-account_convert_outline"] = 0xf1301,
  ["md-account_cowboy_hat"] = 0xf0e9b,
  ["md-account_cowboy_hat_outline"] = 0xf17f3,
  ["md-account_details"] = 0xf0631,
  ["md-account_details_outline"] = 0xf1372,
  ["md-account_edit"] = 0xf06bc,
  ["md-account_edit_outline"] = 0xf0ffb,
  ["md-account_eye"] = 0xf0420,
  ["md-account_eye_outline"] = 0xf127b,
  ["md-account_filter"] = 0xf0936,
  ["md-account_filter_outline"] = 0xf0f9d,
  ["md-account_group"] = 0xf0849,
  ["md-account_group_outline"] = 0xf0b58,
  ["md-account_hard_hat"] = 0xf05b5,
  ["md-account_hard_hat_outline"] = 0xf1a1f,
  ["md-account_heart"] = 0xf0899,
  ["md-account_heart_outline"] = 0xf0be3,
  ["md-account_injury"] = 0xf1815,
  ["md-account_injury_outline"] = 0xf1816,
  ["md-account_key"] = 0xf000b,
  ["md-account_key_outline"] = 0xf0be4,
  ["md-account_lock"] = 0xf115e,
  ["md-account_lock_open"] = 0xf1960,
  ["md-account_lock_open_outline"] = 0xf1961,
  ["md-account_lock_outline"] = 0xf115f,
  ["md-account_minus"] = 0xf000d,
  ["md-account_minus_outline"] = 0xf0aec,
  ["md-account_multiple"] = 0xf000e,
  ["md-account_multiple_check"] = 0xf08c5,
  ["md-account_multiple_check_outline"] = 0xf11fe,
  ["md-account_multiple_minus"] = 0xf05d3,
  ["md-account_multiple_minus_outline"] = 0xf0be5,
  ["md-account_multiple_outline"] = 0xf000f,
  ["md-account_multiple_plus"] = 0xf0010,
  ["md-account_multiple_plus_outline"] = 0xf0800,
  ["md-account_multiple_remove"] = 0xf120a,
  ["md-account_multiple_remove_outline"] = 0xf120b,
  ["md-account_music"] = 0xf0803,
  ["md-account_music_outline"] = 0xf0ce9,
  ["md-account_network"] = 0xf0011,
  ["md-account_network_outline"] = 0xf0be6,
  ["md-account_off"] = 0xf0012,
  ["md-account_off_outline"] = 0xf0be7,
  ["md-account_outline"] = 0xf0013,
  ["md-account_plus"] = 0xf0014,
  ["md-account_plus_outline"] = 0xf0801,
  ["md-account_question"] = 0xf0b59,
  ["md-account_question_outline"] = 0xf0b5a,
  ["md-account_reactivate"] = 0xf152b,
  ["md-account_reactivate_outline"] = 0xf152c,
  ["md-account_remove"] = 0xf0015,
  ["md-account_remove_outline"] = 0xf0aed,
  ["md-account_school"] = 0xf1a20,
  ["md-account_school_outline"] = 0xf1a21,
  ["md-account_search"] = 0xf0016,
  ["md-account_search_outline"] = 0xf0935,
  ["md-account_settings"] = 0xf0630,
  ["md-account_settings_outline"] = 0xf10c9,
  ["md-account_star"] = 0xf0017,
  ["md-account_star_outline"] = 0xf0be8,
  ["md-account_supervisor"] = 0xf0a8b,
  ["md-account_supervisor_circle"] = 0xf0a8c,
  ["md-account_supervisor_circle_outline"] = 0xf14ec,
  ["md-account_supervisor_outline"] = 0xf112d,
  ["md-account_switch"] = 0xf0019,
  ["md-account_switch_outline"] = 0xf04cb,
  ["md-account_sync"] = 0xf191b,
  ["md-account_sync_outline"] = 0xf191c,
  ["md-account_tie"] = 0xf0ce3,
  ["md-account_tie_hat"] = 0xf1898,
  ["md-account_tie_hat_outline"] = 0xf1899,
  ["md-account_tie_outline"] = 0xf10ca,
  ["md-account_tie_voice"] = 0xf1308,
  ["md-account_tie_voice_off"] = 0xf130a,
  ["md-account_tie_voice_off_outline"] = 0xf130b,
  ["md-account_tie_voice_outline"] = 0xf1309,
  ["md-account_tie_woman"] = 0xf1a8c,
  ["md-account_voice"] = 0xf05cb,
  ["md-account_voice_off"] = 0xf0ed4,
  ["md-account_wrench"] = 0xf189a,
  ["md-account_wrench_outline"] = 0xf189b,
  ["md-adjust"] = 0xf001a,
  ["md-advertisements"] = 0xf192a,
  ["md-advertisements_off"] = 0xf192b,
  ["md-air_conditioner"] = 0xf001b,
  ["md-air_filter"] = 0xf0d43,
  ["md-air_horn"] = 0xf0dac,
  ["md-air_humidifier"] = 0xf1099,
  ["md-air_humidifier_off"] = 0xf1466,
  ["md-air_purifier"] = 0xf0d44,
  ["md-airbag"] = 0xf0be9,
  ["md-airballoon"] = 0xf001c,
  ["md-airballoon_outline"] = 0xf100b,
  ["md-airplane"] = 0xf001d,
  ["md-airplane_alert"] = 0xf187a,
  ["md-airplane_check"] = 0xf187b,
  ["md-airplane_clock"] = 0xf187c,
  ["md-airplane_cog"] = 0xf187d,
  ["md-airplane_edit"] = 0xf187e,
  ["md-airplane_landing"] = 0xf05d4,
  ["md-airplane_marker"] = 0xf187f,
  ["md-airplane_minus"] = 0xf1880,
  ["md-airplane_off"] = 0xf001e,
  ["md-airplane_plus"] = 0xf1881,
  ["md-airplane_remove"] = 0xf1882,
  ["md-airplane_search"] = 0xf1883,
  ["md-airplane_settings"] = 0xf1884,
  ["md-airplane_takeoff"] = 0xf05d5,
  ["md-airport"] = 0xf084b,
  ["md-alarm"] = 0xf0020,
  ["md-alarm_bell"] = 0xf078e,
  ["md-alarm_check"] = 0xf0021,
  ["md-alarm_light"] = 0xf078f,
  ["md-alarm_light_off"] = 0xf171e,
  ["md-alarm_light_off_outline"] = 0xf171f,
  ["md-alarm_light_outline"] = 0xf0bea,
  ["md-alarm_multiple"] = 0xf0022,
  ["md-alarm_note"] = 0xf0e71,
  ["md-alarm_note_off"] = 0xf0e72,
  ["md-alarm_off"] = 0xf0023,
  ["md-alarm_panel"] = 0xf15c4,
  ["md-alarm_panel_outline"] = 0xf15c5,
  ["md-alarm_plus"] = 0xf0024,
  ["md-alarm_snooze"] = 0xf068e,
  ["md-album"] = 0xf0025,
  ["md-alert"] = 0xf0026,
  ["md-alert_box"] = 0xf0027,
  ["md-alert_box_outline"] = 0xf0ce4,
  ["md-alert_circle"] = 0xf0028,
  ["md-alert_circle_check"] = 0xf11ed,
  ["md-alert_circle_check_outline"] = 0xf11ee,
  ["md-alert_circle_outline"] = 0xf05d6,
  ["md-alert_decagram"] = 0xf06bd,
  ["md-alert_decagram_outline"] = 0xf0ce5,
  ["md-alert_minus"] = 0xf14bb,
  ["md-alert_minus_outline"] = 0xf14be,
  ["md-alert_octagon"] = 0xf0029,
  ["md-alert_octagon_outline"] = 0xf0ce6,
  ["md-alert_octagram"] = 0xf0767,
  ["md-alert_octagram_outline"] = 0xf0ce7,
  ["md-alert_outline"] = 0xf002a,
  ["md-alert_plus"] = 0xf14ba,
  ["md-alert_plus_outline"] = 0xf14bd,
  ["md-alert_remove"] = 0xf14bc,
  ["md-alert_remove_outline"] = 0xf14bf,
  ["md-alert_rhombus"] = 0xf11ce,
  ["md-alert_rhombus_outline"] = 0xf11cf,
  ["md-alien"] = 0xf089a,
  ["md-alien_outline"] = 0xf10cb,
  ["md-align_horizontal_center"] = 0xf11c3,
  ["md-align_horizontal_distribute"] = 0xf1962,
  ["md-align_horizontal_left"] = 0xf11c2,
  ["md-align_horizontal_right"] = 0xf11c4,
  ["md-align_vertical_bottom"] = 0xf11c5,
  ["md-align_vertical_center"] = 0xf11c6,
  ["md-align_vertical_distribute"] = 0xf1963,
  ["md-align_vertical_top"] = 0xf11c7,
  ["md-all_inclusive"] = 0xf06be,
  ["md-all_inclusive_box"] = 0xf188d,
  ["md-all_inclusive_box_outline"] = 0xf188e,
  ["md-allergy"] = 0xf1258,
  ["md-alpha"] = 0xf002b,
  ["md-alpha_a"] = 0xf0aee,
  ["md-alpha_a_box"] = 0xf0b08,
  ["md-alpha_a_box_outline"] = 0xf0beb,
  ["md-alpha_a_circle"] = 0xf0bec,
  ["md-alpha_a_circle_outline"] = 0xf0bed,
  ["md-alpha_b"] = 0xf0aef,
  ["md-alpha_b_box"] = 0xf0b09,
  ["md-alpha_b_box_outline"] = 0xf0bee,
  ["md-alpha_b_circle"] = 0xf0bef,
  ["md-alpha_b_circle_outline"] = 0xf0bf0,
  ["md-alpha_c"] = 0xf0af0,
  ["md-alpha_c_box"] = 0xf0b0a,
  ["md-alpha_c_box_outline"] = 0xf0bf1,
  ["md-alpha_c_circle"] = 0xf0bf2,
  ["md-alpha_c_circle_outline"] = 0xf0bf3,
  ["md-alpha_d"] = 0xf0af1,
  ["md-alpha_d_box"] = 0xf0b0b,
  ["md-alpha_d_box_outline"] = 0xf0bf4,
  ["md-alpha_d_circle"] = 0xf0bf5,
  ["md-alpha_d_circle_outline"] = 0xf0bf6,
  ["md-alpha_e"] = 0xf0af2,
  ["md-alpha_e_box"] = 0xf0b0c,
  ["md-alpha_e_box_outline"] = 0xf0bf7,
  ["md-alpha_e_circle"] = 0xf0bf8,
  ["md-alpha_e_circle_outline"] = 0xf0bf9,
  ["md-alpha_f"] = 0xf0af3,
  ["md-alpha_f_box"] = 0xf0b0d,
  ["md-alpha_f_box_outline"] = 0xf0bfa,
  ["md-alpha_f_circle"] = 0xf0bfb,
  ["md-alpha_f_circle_outline"] = 0xf0bfc,
  ["md-alpha_g"] = 0xf0af4,
  ["md-alpha_g_box"] = 0xf0b0e,
  ["md-alpha_g_box_outline"] = 0xf0bfd,
  ["md-alpha_g_circle"] = 0xf0bfe,
  ["md-alpha_g_circle_outline"] = 0xf0bff,
  ["md-alpha_h"] = 0xf0af5,
  ["md-alpha_h_box"] = 0xf0b0f,
  ["md-alpha_h_box_outline"] = 0xf0c00,
  ["md-alpha_h_circle"] = 0xf0c01,
  ["md-alpha_h_circle_outline"] = 0xf0c02,
  ["md-alpha_i"] = 0xf1088,
  ["md-alpha_i_box"] = 0xf0b10,
  ["md-alpha_i_box_outline"] = 0xf0c03,
  ["md-alpha_i_circle"] = 0xf0c04,
  ["md-alpha_i_circle_outline"] = 0xf0c05,
  ["md-alpha_j"] = 0xf0af7,
  ["md-alpha_j_box"] = 0xf0b11,
  ["md-alpha_j_box_outline"] = 0xf0c06,
  ["md-alpha_j_circle"] = 0xf0c07,
  ["md-alpha_j_circle_outline"] = 0xf0c08,
  ["md-alpha_k"] = 0xf0af8,
  ["md-alpha_k_box"] = 0xf0b12,
  ["md-alpha_k_box_outline"] = 0xf0c09,
  ["md-alpha_k_circle"] = 0xf0c0a,
  ["md-alpha_k_circle_outline"] = 0xf0c0b,
  ["md-alpha_l"] = 0xf13a6,
  ["md-alpha_l_box"] = 0xf0b13,
  ["md-alpha_l_box_outline"] = 0xf0c0c,
  ["md-alpha_l_circle"] = 0xf0c0d,
  ["md-alpha_l_circle_outline"] = 0xf0c0e,
  ["md-alpha_m"] = 0xf0afa,
  ["md-alpha_m_box"] = 0xf0b14,
  ["md-alpha_m_box_outline"] = 0xf0c0f,
  ["md-alpha_m_circle"] = 0xf0c10,
  ["md-alpha_m_circle_outline"] = 0xf0c11,
  ["md-alpha_n"] = 0xf0afb,
  ["md-alpha_n_box"] = 0xf0b15,
  ["md-alpha_n_box_outline"] = 0xf0c12,
  ["md-alpha_n_circle"] = 0xf0c13,
  ["md-alpha_n_circle_outline"] = 0xf0c14,
  ["md-alpha_o"] = 0xf0b39,
  ["md-alpha_o_box"] = 0xf0b16,
  ["md-alpha_o_box_outline"] = 0xf0c15,
  ["md-alpha_o_circle"] = 0xf0c9e,
  ["md-alpha_o_circle_outline"] = 0xf0c9f,
  ["md-alpha_p"] = 0xf0afd,
  ["md-alpha_p_box"] = 0xf0b17,
  ["md-alpha_p_box_outline"] = 0xf0c18,
  ["md-alpha_p_circle"] = 0xf0c19,
  ["md-alpha_p_circle_outline"] = 0xf0c1a,
  ["md-alpha_q"] = 0xf0afe,
  ["md-alpha_q_box"] = 0xf0b18,
  ["md-alpha_q_box_outline"] = 0xf0c1b,
  ["md-alpha_q_circle"] = 0xf0c1c,
  ["md-alpha_q_circle_outline"] = 0xf0c1d,
  ["md-alpha_r"] = 0xf0aff,
  ["md-alpha_r_box"] = 0xf0b19,
  ["md-alpha_r_box_outline"] = 0xf0c1e,
  ["md-alpha_r_circle"] = 0xf0c1f,
  ["md-alpha_r_circle_outline"] = 0xf0c20,
  ["md-alpha_s"] = 0xf0b00,
  ["md-alpha_s_box"] = 0xf0b1a,
  ["md-alpha_s_box_outline"] = 0xf0c21,
  ["md-alpha_s_circle"] = 0xf0c22,
  ["md-alpha_s_circle_outline"] = 0xf0c23,
  ["md-alpha_t"] = 0xf0b01,
  ["md-alpha_t_box"] = 0xf0b1b,
  ["md-alpha_t_box_outline"] = 0xf0c24,
  ["md-alpha_t_circle"] = 0xf0c25,
  ["md-alpha_t_circle_outline"] = 0xf0c26,
  ["md-alpha_u"] = 0xf0b02,
  ["md-alpha_u_box"] = 0xf0b1c,
  ["md-alpha_u_box_outline"] = 0xf0c27,
  ["md-alpha_u_circle"] = 0xf0c28,
  ["md-alpha_u_circle_outline"] = 0xf0c29,
  ["md-alpha_v"] = 0xf108c,
  ["md-alpha_v_box"] = 0xf0b1d,
  ["md-alpha_v_box_outline"] = 0xf0c2a,
  ["md-alpha_v_circle"] = 0xf0c2b,
  ["md-alpha_v_circle_outline"] = 0xf0c2c,
  ["md-alpha_w"] = 0xf0b04,
  ["md-alpha_w_box"] = 0xf0b1e,
  ["md-alpha_w_box_outline"] = 0xf0c2d,
  ["md-alpha_w_circle"] = 0xf0c2e,
  ["md-alpha_w_circle_outline"] = 0xf0c2f,
  ["md-alpha_x"] = 0xf1091,
  ["md-alpha_x_box"] = 0xf0b1f,
  ["md-alpha_x_box_outline"] = 0xf0c30,
  ["md-alpha_x_circle"] = 0xf0c31,
  ["md-alpha_x_circle_outline"] = 0xf0c32,
  ["md-alpha_y"] = 0xf0b06,
  ["md-alpha_y_box"] = 0xf0b20,
  ["md-alpha_y_box_outline"] = 0xf0c33,
  ["md-alpha_y_circle"] = 0xf0c34,
  ["md-alpha_y_circle_outline"] = 0xf0c35,
  ["md-alpha_z"] = 0xf0b07,
  ["md-alpha_z_box"] = 0xf0b21,
  ["md-alpha_z_box_outline"] = 0xf0c36,
  ["md-alpha_z_circle"] = 0xf0c37,
  ["md-alpha_z_circle_outline"] = 0xf0c38,
  ["md-alphabet_aurebesh"] = 0xf132c,
  ["md-alphabet_cyrillic"] = 0xf132d,
  ["md-alphabet_greek"] = 0xf132e,
  ["md-alphabet_latin"] = 0xf132f,
  ["md-alphabet_piqad"] = 0xf1330,
  ["md-alphabet_tengwar"] = 0xf1337,
  ["md-alphabetical"] = 0xf002c,
  ["md-alphabetical_off"] = 0xf100c,
  ["md-alphabetical_variant"] = 0xf100d,
  ["md-alphabetical_variant_off"] = 0xf100e,
  ["md-altimeter"] = 0xf05d7,
  ["md-ambulance"] = 0xf002f,
  ["md-ammunition"] = 0xf0ce8,
  ["md-ampersand"] = 0xf0a8d,
  ["md-amplifier"] = 0xf0030,
  ["md-amplifier_off"] = 0xf11b5,
  ["md-anchor"] = 0xf0031,
  ["md-android"] = 0xf0032,
  ["md-android_messages"] = 0xf0d45,
  ["md-android_studio"] = 0xf0034,
  ["md-angle_acute"] = 0xf0937,
  ["md-angle_obtuse"] = 0xf0938,
  ["md-angle_right"] = 0xf0939,
  ["md-angular"] = 0xf06b2,
  ["md-angularjs"] = 0xf06bf,
  ["md-animation"] = 0xf05d8,
  ["md-animation_outline"] = 0xf0a8f,
  ["md-animation_play"] = 0xf093a,
  ["md-animation_play_outline"] = 0xf0a90,
  ["md-ansible"] = 0xf109a,
  ["md-antenna"] = 0xf1119,
  ["md-anvil"] = 0xf089b,
  ["md-apache_kafka"] = 0xf100f,
  ["md-api"] = 0xf109b,
  ["md-api_off"] = 0xf1257,
  ["md-apple"] = 0xf0035,
  ["md-apple_finder"] = 0xf0036,
  ["md-apple_icloud"] = 0xf0038,
  ["md-apple_ios"] = 0xf0037,
  ["md-apple_keyboard_caps"] = 0xf0632,
  ["md-apple_keyboard_command"] = 0xf0633,
  ["md-apple_keyboard_control"] = 0xf0634,
  ["md-apple_keyboard_option"] = 0xf0635,
  ["md-apple_keyboard_shift"] = 0xf0636,
  ["md-apple_safari"] = 0xf0039,
  ["md-application"] = 0xf08c6,
  ["md-application_array"] = 0xf10f5,
  ["md-application_array_outline"] = 0xf10f6,
  ["md-application_braces"] = 0xf10f7,
  ["md-application_braces_outline"] = 0xf10f8,
  ["md-application_brackets"] = 0xf0c8b,
  ["md-application_brackets_outline"] = 0xf0c8c,
  ["md-application_cog"] = 0xf0675,
  ["md-application_cog_outline"] = 0xf1577,
  ["md-application_edit"] = 0xf00ae,
  ["md-application_edit_outline"] = 0xf0619,
  ["md-application_export"] = 0xf0dad,
  ["md-application_import"] = 0xf0dae,
  ["md-application_outline"] = 0xf0614,
  ["md-application_parentheses"] = 0xf10f9,
  ["md-application_parentheses_outline"] = 0xf10fa,
  ["md-application_settings"] = 0xf0b60,
  ["md-application_settings_outline"] = 0xf1555,
  ["md-application_variable"] = 0xf10fb,
  ["md-application_variable_outline"] = 0xf10fc,
  ["md-approximately_equal"] = 0xf0f9e,
  ["md-approximately_equal_box"] = 0xf0f9f,
  ["md-apps"] = 0xf003b,
  ["md-apps_box"] = 0xf0d46,
  ["md-arch"] = 0xf08c7,
  ["md-archive"] = 0xf003c,
  ["md-archive_alert"] = 0xf14fd,
  ["md-archive_alert_outline"] = 0xf14fe,
  ["md-archive_arrow_down"] = 0xf1259,
  ["md-archive_arrow_down_outline"] = 0xf125a,
  ["md-archive_arrow_up"] = 0xf125b,
  ["md-archive_arrow_up_outline"] = 0xf125c,
  ["md-archive_cancel"] = 0xf174b,
  ["md-archive_cancel_outline"] = 0xf174c,
  ["md-archive_check"] = 0xf174d,
  ["md-archive_check_outline"] = 0xf174e,
  ["md-archive_clock"] = 0xf174f,
  ["md-archive_clock_outline"] = 0xf1750,
  ["md-archive_cog"] = 0xf1751,
  ["md-archive_cog_outline"] = 0xf1752,
  ["md-archive_edit"] = 0xf1753,
  ["md-archive_edit_outline"] = 0xf1754,
  ["md-archive_eye"] = 0xf1755,
  ["md-archive_eye_outline"] = 0xf1756,
  ["md-archive_lock"] = 0xf1757,
  ["md-archive_lock_open"] = 0xf1758,
  ["md-archive_lock_open_outline"] = 0xf1759,
  ["md-archive_lock_outline"] = 0xf175a,
  ["md-archive_marker"] = 0xf175b,
  ["md-archive_marker_outline"] = 0xf175c,
  ["md-archive_minus"] = 0xf175d,
  ["md-archive_minus_outline"] = 0xf175e,
  ["md-archive_music"] = 0xf175f,
  ["md-archive_music_outline"] = 0xf1760,
  ["md-archive_off"] = 0xf1761,
  ["md-archive_off_outline"] = 0xf1762,
  ["md-archive_outline"] = 0xf120e,
  ["md-archive_plus"] = 0xf1763,
  ["md-archive_plus_outline"] = 0xf1764,
  ["md-archive_refresh"] = 0xf1765,
  ["md-archive_refresh_outline"] = 0xf1766,
  ["md-archive_remove"] = 0xf1767,
  ["md-archive_remove_outline"] = 0xf1768,
  ["md-archive_search"] = 0xf1769,
  ["md-archive_search_outline"] = 0xf176a,
  ["md-archive_settings"] = 0xf176b,
  ["md-archive_settings_outline"] = 0xf176c,
  ["md-archive_star"] = 0xf176d,
  ["md-archive_star_outline"] = 0xf176e,
  ["md-archive_sync"] = 0xf176f,
  ["md-archive_sync_outline"] = 0xf1770,
  ["md-arm_flex"] = 0xf0fd7,
  ["md-arm_flex_outline"] = 0xf0fd6,
  ["md-arrange_bring_forward"] = 0xf003d,
  ["md-arrange_bring_to_front"] = 0xf003e,
  ["md-arrange_send_backward"] = 0xf003f,
  ["md-arrange_send_to_back"] = 0xf0040,
  ["md-arrow_all"] = 0xf0041,
  ["md-arrow_bottom_left"] = 0xf0042,
  ["md-arrow_bottom_left_bold_box"] = 0xf1964,
  ["md-arrow_bottom_left_bold_box_outline"] = 0xf1965,
  ["md-arrow_bottom_left_bold_outline"] = 0xf09b7,
  ["md-arrow_bottom_left_thick"] = 0xf09b8,
  ["md-arrow_bottom_left_thin"] = 0xf19b6,
  ["md-arrow_bottom_left_thin_circle_outline"] = 0xf1596,
  ["md-arrow_bottom_right"] = 0xf0043,
  ["md-arrow_bottom_right_bold_box"] = 0xf1966,
  ["md-arrow_bottom_right_bold_box_outline"] = 0xf1967,
  ["md-arrow_bottom_right_bold_outline"] = 0xf09b9,
  ["md-arrow_bottom_right_thick"] = 0xf09ba,
  ["md-arrow_bottom_right_thin"] = 0xf19b7,
  ["md-arrow_bottom_right_thin_circle_outline"] = 0xf1595,
  ["md-arrow_collapse"] = 0xf0615,
  ["md-arrow_collapse_all"] = 0xf0044,
  ["md-arrow_collapse_down"] = 0xf0792,
  ["md-arrow_collapse_horizontal"] = 0xf084c,
  ["md-arrow_collapse_left"] = 0xf0793,
  ["md-arrow_collapse_right"] = 0xf0794,
  ["md-arrow_collapse_up"] = 0xf0795,
  ["md-arrow_collapse_vertical"] = 0xf084d,
  ["md-arrow_decision"] = 0xf09bb,
  ["md-arrow_decision_auto"] = 0xf09bc,
  ["md-arrow_decision_auto_outline"] = 0xf09bd,
  ["md-arrow_decision_outline"] = 0xf09be,
  ["md-arrow_down"] = 0xf0045,
  ["md-arrow_down_bold"] = 0xf072e,
  ["md-arrow_down_bold_box"] = 0xf072f,
  ["md-arrow_down_bold_box_outline"] = 0xf0730,
  ["md-arrow_down_bold_circle"] = 0xf0047,
  ["md-arrow_down_bold_circle_outline"] = 0xf0048,
  ["md-arrow_down_bold_hexagon_outline"] = 0xf0049,
  ["md-arrow_down_bold_outline"] = 0xf09bf,
  ["md-arrow_down_box"] = 0xf06c0,
  ["md-arrow_down_circle"] = 0xf0cdb,
  ["md-arrow_down_circle_outline"] = 0xf0cdc,
  ["md-arrow_down_drop_circle"] = 0xf004a,
  ["md-arrow_down_drop_circle_outline"] = 0xf004b,
  ["md-arrow_down_left"] = 0xf17a1,
  ["md-arrow_down_left_bold"] = 0xf17a2,
  ["md-arrow_down_right"] = 0xf17a3,
  ["md-arrow_down_right_bold"] = 0xf17a4,
  ["md-arrow_down_thick"] = 0xf0046,
  ["md-arrow_down_thin"] = 0xf19b3,
  ["md-arrow_down_thin_circle_outline"] = 0xf1599,
  ["md-arrow_expand"] = 0xf0616,
  ["md-arrow_expand_all"] = 0xf004c,
  ["md-arrow_expand_down"] = 0xf0796,
  ["md-arrow_expand_horizontal"] = 0xf084e,
  ["md-arrow_expand_left"] = 0xf0797,
  ["md-arrow_expand_right"] = 0xf0798,
  ["md-arrow_expand_up"] = 0xf0799,
  ["md-arrow_expand_vertical"] = 0xf084f,
  ["md-arrow_horizontal_lock"] = 0xf115b,
  ["md-arrow_left"] = 0xf004d,
  ["md-arrow_left_bold"] = 0xf0731,
  ["md-arrow_left_bold_box"] = 0xf0732,
  ["md-arrow_left_bold_box_outline"] = 0xf0733,
  ["md-arrow_left_bold_circle"] = 0xf004f,
  ["md-arrow_left_bold_circle_outline"] = 0xf0050,
  ["md-arrow_left_bold_hexagon_outline"] = 0xf0051,
  ["md-arrow_left_bold_outline"] = 0xf09c0,
  ["md-arrow_left_bottom"] = 0xf17a5,
  ["md-arrow_left_bottom_bold"] = 0xf17a6,
  ["md-arrow_left_box"] = 0xf06c1,
  ["md-arrow_left_circle"] = 0xf0cdd,
  ["md-arrow_left_circle_outline"] = 0xf0cde,
  ["md-arrow_left_drop_circle"] = 0xf0052,
  ["md-arrow_left_drop_circle_outline"] = 0xf0053,
  ["md-arrow_left_right"] = 0xf0e73,
  ["md-arrow_left_right_bold"] = 0xf0e74,
  ["md-arrow_left_right_bold_outline"] = 0xf09c1,
  ["md-arrow_left_thick"] = 0xf004e,
  ["md-arrow_left_thin"] = 0xf19b1,
  ["md-arrow_left_thin_circle_outline"] = 0xf159a,
  ["md-arrow_left_top"] = 0xf17a7,
  ["md-arrow_left_top_bold"] = 0xf17a8,
  ["md-arrow_projectile"] = 0xf1840,
  ["md-arrow_projectile_multiple"] = 0xf183f,
  ["md-arrow_right"] = 0xf0054,
  ["md-arrow_right_bold"] = 0xf0734,
  ["md-arrow_right_bold_box"] = 0xf0735,
  ["md-arrow_right_bold_box_outline"] = 0xf0736,
  ["md-arrow_right_bold_circle"] = 0xf0056,
  ["md-arrow_right_bold_circle_outline"] = 0xf0057,
  ["md-arrow_right_bold_hexagon_outline"] = 0xf0058,
  ["md-arrow_right_bold_outline"] = 0xf09c2,
  ["md-arrow_right_bottom"] = 0xf17a9,
  ["md-arrow_right_bottom_bold"] = 0xf17aa,
  ["md-arrow_right_box"] = 0xf06c2,
  ["md-arrow_right_circle"] = 0xf0cdf,
  ["md-arrow_right_circle_outline"] = 0xf0ce0,
  ["md-arrow_right_drop_circle"] = 0xf0059,
  ["md-arrow_right_drop_circle_outline"] = 0xf005a,
  ["md-arrow_right_thick"] = 0xf0055,
  ["md-arrow_right_thin"] = 0xf19b0,
  ["md-arrow_right_thin_circle_outline"] = 0xf1598,
  ["md-arrow_right_top"] = 0xf17ab,
  ["md-arrow_right_top_bold"] = 0xf17ac,
  ["md-arrow_split_horizontal"] = 0xf093b,
  ["md-arrow_split_vertical"] = 0xf093c,
  ["md-arrow_top_left"] = 0xf005b,
  ["md-arrow_top_left_bold_box"] = 0xf1968,
  ["md-arrow_top_left_bold_box_outline"] = 0xf1969,
  ["md-arrow_top_left_bold_outline"] = 0xf09c3,
  ["md-arrow_top_left_bottom_right"] = 0xf0e75,
  ["md-arrow_top_left_bottom_right_bold"] = 0xf0e76,
  ["md-arrow_top_left_thick"] = 0xf09c4,
  ["md-arrow_top_left_thin"] = 0xf19b5,
  ["md-arrow_top_left_thin_circle_outline"] = 0xf1593,
  ["md-arrow_top_right"] = 0xf005c,
  ["md-arrow_top_right_bold_box"] = 0xf196a,
  ["md-arrow_top_right_bold_box_outline"] = 0xf196b,
  ["md-arrow_top_right_bold_outline"] = 0xf09c5,
  ["md-arrow_top_right_bottom_left"] = 0xf0e77,
  ["md-arrow_top_right_bottom_left_bold"] = 0xf0e78,
  ["md-arrow_top_right_thick"] = 0xf09c6,
  ["md-arrow_top_right_thin"] = 0xf19b4,
  ["md-arrow_top_right_thin_circle_outline"] = 0xf1594,
  ["md-arrow_u_down_left"] = 0xf17ad,
  ["md-arrow_u_down_left_bold"] = 0xf17ae,
  ["md-arrow_u_down_right"] = 0xf17af,
  ["md-arrow_u_down_right_bold"] = 0xf17b0,
  ["md-arrow_u_left_bottom"] = 0xf17b1,
  ["md-arrow_u_left_bottom_bold"] = 0xf17b2,
  ["md-arrow_u_left_top"] = 0xf17b3,
  ["md-arrow_u_left_top_bold"] = 0xf17b4,
  ["md-arrow_u_right_bottom"] = 0xf17b5,
  ["md-arrow_u_right_bottom_bold"] = 0xf17b6,
  ["md-arrow_u_right_top"] = 0xf17b7,
  ["md-arrow_u_right_top_bold"] = 0xf17b8,
  ["md-arrow_u_up_left"] = 0xf17b9,
  ["md-arrow_u_up_left_bold"] = 0xf17ba,
  ["md-arrow_u_up_right"] = 0xf17bb,
  ["md-arrow_u_up_right_bold"] = 0xf17bc,
  ["md-arrow_up"] = 0xf005d,
  ["md-arrow_up_bold"] = 0xf0737,
  ["md-arrow_up_bold_box"] = 0xf0738,
  ["md-arrow_up_bold_box_outline"] = 0xf0739,
  ["md-arrow_up_bold_circle"] = 0xf005f,
  ["md-arrow_up_bold_circle_outline"] = 0xf0060,
  ["md-arrow_up_bold_hexagon_outline"] = 0xf0061,
  ["md-arrow_up_bold_outline"] = 0xf09c7,
  ["md-arrow_up_box"] = 0xf06c3,
  ["md-arrow_up_circle"] = 0xf0ce1,
  ["md-arrow_up_circle_outline"] = 0xf0ce2,
  ["md-arrow_up_down"] = 0xf0e79,
  ["md-arrow_up_down_bold"] = 0xf0e7a,
  ["md-arrow_up_down_bold_outline"] = 0xf09c8,
  ["md-arrow_up_drop_circle"] = 0xf0062,
  ["md-arrow_up_drop_circle_outline"] = 0xf0063,
  ["md-arrow_up_left"] = 0xf17bd,
  ["md-arrow_up_left_bold"] = 0xf17be,
  ["md-arrow_up_right"] = 0xf17bf,
  ["md-arrow_up_right_bold"] = 0xf17c0,
  ["md-arrow_up_thick"] = 0xf005e,
  ["md-arrow_up_thin"] = 0xf19b2,
  ["md-arrow_up_thin_circle_outline"] = 0xf1597,
  ["md-arrow_vertical_lock"] = 0xf115c,
  ["md-artstation"] = 0xf0b5b,
  ["md-aspect_ratio"] = 0xf0a24,
  ["md-assistant"] = 0xf0064,
  ["md-asterisk"] = 0xf06c4,
  ["md-asterisk_circle_outline"] = 0xf1a27,
  ["md-at"] = 0xf0065,
  ["md-atlassian"] = 0xf0804,
  ["md-atm"] = 0xf0d47,
  ["md-atom"] = 0xf0768,
  ["md-atom_variant"] = 0xf0e7b,
  ["md-attachment"] = 0xf0066,
  ["md-attachment_check"] = 0xf1ac1,
  ["md-attachment_lock"] = 0xf19c4,
  ["md-attachment_minus"] = 0xf1ac2,
  ["md-attachment_off"] = 0xf1ac3,
  ["md-attachment_plus"] = 0xf1ac4,
  ["md-attachment_remove"] = 0xf1ac5,
  ["md-audio_input_rca"] = 0xf186b,
  ["md-audio_input_stereo_minijack"] = 0xf186c,
  ["md-audio_input_xlr"] = 0xf186d,
  ["md-audio_video"] = 0xf093d,
  ["md-audio_video_off"] = 0xf11b6,
  ["md-augmented_reality"] = 0xf0850,
  ["md-auto_download"] = 0xf137e,
  ["md-auto_fix"] = 0xf0068,
  ["md-auto_upload"] = 0xf0069,
  ["md-autorenew"] = 0xf006a,
  ["md-autorenew_off"] = 0xf19e7,
  ["md-av_timer"] = 0xf006b,
  ["md-aws"] = 0xf0e0f,
  ["md-axe"] = 0xf08c8,
  ["md-axe_battle"] = 0xf1842,
  ["md-axis"] = 0xf0d48,
  ["md-axis_arrow"] = 0xf0d49,
  ["md-axis_arrow_info"] = 0xf140e,
  ["md-axis_arrow_lock"] = 0xf0d4a,
  ["md-axis_lock"] = 0xf0d4b,
  ["md-axis_x_arrow"] = 0xf0d4c,
  ["md-axis_x_arrow_lock"] = 0xf0d4d,
  ["md-axis_x_rotate_clockwise"] = 0xf0d4e,
  ["md-axis_x_rotate_counterclockwise"] = 0xf0d4f,
  ["md-axis_x_y_arrow_lock"] = 0xf0d50,
  ["md-axis_y_arrow"] = 0xf0d51,
  ["md-axis_y_arrow_lock"] = 0xf0d52,
  ["md-axis_y_rotate_clockwise"] = 0xf0d53,
  ["md-axis_y_rotate_counterclockwise"] = 0xf0d54,
  ["md-axis_z_arrow"] = 0xf0d55,
  ["md-axis_z_arrow_lock"] = 0xf0d56,
  ["md-axis_z_rotate_clockwise"] = 0xf0d57,
  ["md-axis_z_rotate_counterclockwise"] = 0xf0d58,
  ["md-babel"] = 0xf0a25,
  ["md-baby"] = 0xf006c,
  ["md-baby_bottle"] = 0xf0f39,
  ["md-baby_bottle_outline"] = 0xf0f3a,
  ["md-baby_buggy"] = 0xf13e0,
  ["md-baby_carriage"] = 0xf068f,
  ["md-baby_carriage_off"] = 0xf0fa0,
  ["md-baby_face"] = 0xf0e7c,
  ["md-baby_face_outline"] = 0xf0e7d,
  ["md-backburger"] = 0xf006d,
  ["md-backspace"] = 0xf006e,
  ["md-backspace_outline"] = 0xf0b5c,
  ["md-backspace_reverse"] = 0xf0e7e,
  ["md-backspace_reverse_outline"] = 0xf0e7f,
  ["md-backup_restore"] = 0xf006f,
  ["md-bacteria"] = 0xf0ed5,
  ["md-bacteria_outline"] = 0xf0ed6,
  ["md-badge_account"] = 0xf0da7,
  ["md-badge_account_alert"] = 0xf0da8,
  ["md-badge_account_alert_outline"] = 0xf0da9,
  ["md-badge_account_horizontal"] = 0xf0e0d,
  ["md-badge_account_horizontal_outline"] = 0xf0e0e,
  ["md-badge_account_outline"] = 0xf0daa,
  ["md-badminton"] = 0xf0851,
  ["md-bag_carry_on"] = 0xf0f3b,
  ["md-bag_carry_on_check"] = 0xf0d65,
  ["md-bag_carry_on_off"] = 0xf0f3c,
  ["md-bag_checked"] = 0xf0f3d,
  ["md-bag_personal"] = 0xf0e10,
  ["md-bag_personal_off"] = 0xf0e11,
  ["md-bag_personal_off_outline"] = 0xf0e12,
  ["md-bag_personal_outline"] = 0xf0e13,
  ["md-bag_suitcase"] = 0xf158b,
  ["md-bag_suitcase_off"] = 0xf158d,
  ["md-bag_suitcase_off_outline"] = 0xf158e,
  ["md-bag_suitcase_outline"] = 0xf158c,
  ["md-baguette"] = 0xf0f3e,
  ["md-balcony"] = 0xf1817,
  ["md-balloon"] = 0xf0a26,
  ["md-ballot"] = 0xf09c9,
  ["md-ballot_outline"] = 0xf09ca,
  ["md-ballot_recount"] = 0xf0c39,
  ["md-ballot_recount_outline"] = 0xf0c3a,
  ["md-bandage"] = 0xf0daf,
  ["md-bank"] = 0xf0070,
  ["md-bank_check"] = 0xf1655,
  ["md-bank_minus"] = 0xf0db0,
  ["md-bank_off"] = 0xf1656,
  ["md-bank_off_outline"] = 0xf1657,
  ["md-bank_outline"] = 0xf0e80,
  ["md-bank_plus"] = 0xf0db1,
  ["md-bank_remove"] = 0xf0db2,
  ["md-bank_transfer"] = 0xf0a27,
  ["md-bank_transfer_in"] = 0xf0a28,
  ["md-bank_transfer_out"] = 0xf0a29,
  ["md-barcode"] = 0xf0071,
  ["md-barcode_off"] = 0xf1236,
  ["md-barcode_scan"] = 0xf0072,
  ["md-barley"] = 0xf0073,
  ["md-barley_off"] = 0xf0b5d,
  ["md-barn"] = 0xf0b5e,
  ["md-barrel"] = 0xf0074,
  ["md-barrel_outline"] = 0xf1a28,
  ["md-baseball"] = 0xf0852,
  ["md-baseball_bat"] = 0xf0853,
  ["md-baseball_diamond"] = 0xf15ec,
  ["md-baseball_diamond_outline"] = 0xf15ed,
  ["md-bash"] = 0xf1183,
  ["md-basket"] = 0xf0076,
  ["md-basket_check"] = 0xf18e5,
  ["md-basket_check_outline"] = 0xf18e6,
  ["md-basket_fill"] = 0xf0077,
  ["md-basket_minus"] = 0xf1523,
  ["md-basket_minus_outline"] = 0xf1524,
  ["md-basket_off"] = 0xf1525,
  ["md-basket_off_outline"] = 0xf1526,
  ["md-basket_outline"] = 0xf1181,
  ["md-basket_plus"] = 0xf1527,
  ["md-basket_plus_outline"] = 0xf1528,
  ["md-basket_remove"] = 0xf1529,
  ["md-basket_remove_outline"] = 0xf152a,
  ["md-basket_unfill"] = 0xf0078,
  ["md-basketball"] = 0xf0806,
  ["md-basketball_hoop"] = 0xf0c3b,
  ["md-basketball_hoop_outline"] = 0xf0c3c,
  ["md-bat"] = 0xf0b5f,
  ["md-bathtub"] = 0xf1818,
  ["md-bathtub_outline"] = 0xf1819,
  ["md-battery"] = 0xf0079,
  ["md-battery_10"] = 0xf007a,
  ["md-battery_10_bluetooth"] = 0xf093e,
  ["md-battery_20"] = 0xf007b,
  ["md-battery_20_bluetooth"] = 0xf093f,
  ["md-battery_30"] = 0xf007c,
  ["md-battery_30_bluetooth"] = 0xf0940,
  ["md-battery_40"] = 0xf007d,
  ["md-battery_40_bluetooth"] = 0xf0941,
  ["md-battery_50"] = 0xf007e,
  ["md-battery_50_bluetooth"] = 0xf0942,
  ["md-battery_60"] = 0xf007f,
  ["md-battery_60_bluetooth"] = 0xf0943,
  ["md-battery_70"] = 0xf0080,
  ["md-battery_70_bluetooth"] = 0xf0944,
  ["md-battery_80"] = 0xf0081,
  ["md-battery_80_bluetooth"] = 0xf0945,
  ["md-battery_90"] = 0xf0082,
  ["md-battery_90_bluetooth"] = 0xf0946,
  ["md-battery_alert"] = 0xf0083,
  ["md-battery_alert_bluetooth"] = 0xf0947,
  ["md-battery_alert_variant"] = 0xf10cc,
  ["md-battery_alert_variant_outline"] = 0xf10cd,
  ["md-battery_arrow_down"] = 0xf17de,
  ["md-battery_arrow_down_outline"] = 0xf17df,
  ["md-battery_arrow_up"] = 0xf17e0,
  ["md-battery_arrow_up_outline"] = 0xf17e1,
  ["md-battery_bluetooth"] = 0xf0948,
  ["md-battery_bluetooth_variant"] = 0xf0949,
  ["md-battery_charging"] = 0xf0084,
  ["md-battery_charging_10"] = 0xf089c,
  ["md-battery_charging_100"] = 0xf0085,
  ["md-battery_charging_20"] = 0xf0086,
  ["md-battery_charging_30"] = 0xf0087,
  ["md-battery_charging_40"] = 0xf0088,
  ["md-battery_charging_50"] = 0xf089d,
  ["md-battery_charging_60"] = 0xf0089,
  ["md-battery_charging_70"] = 0xf089e,
  ["md-battery_charging_80"] = 0xf008a,
  ["md-battery_charging_90"] = 0xf008b,
  ["md-battery_charging_high"] = 0xf12a6,
  ["md-battery_charging_low"] = 0xf12a4,
  ["md-battery_charging_medium"] = 0xf12a5,
  ["md-battery_charging_outline"] = 0xf089f,
  ["md-battery_charging_wireless"] = 0xf0807,
  ["md-battery_charging_wireless_10"] = 0xf0808,
  ["md-battery_charging_wireless_20"] = 0xf0809,
  ["md-battery_charging_wireless_30"] = 0xf080a,
  ["md-battery_charging_wireless_40"] = 0xf080b,
  ["md-battery_charging_wireless_50"] = 0xf080c,
  ["md-battery_charging_wireless_60"] = 0xf080d,
  ["md-battery_charging_wireless_70"] = 0xf080e,
  ["md-battery_charging_wireless_80"] = 0xf080f,
  ["md-battery_charging_wireless_90"] = 0xf0810,
  ["md-battery_charging_wireless_alert"] = 0xf0811,
  ["md-battery_charging_wireless_outline"] = 0xf0812,
  ["md-battery_check"] = 0xf17e2,
  ["md-battery_check_outline"] = 0xf17e3,
  ["md-battery_clock"] = 0xf19e5,
  ["md-battery_clock_outline"] = 0xf19e6,
  ["md-battery_heart"] = 0xf120f,
  ["md-battery_heart_outline"] = 0xf1210,
  ["md-battery_heart_variant"] = 0xf1211,
  ["md-battery_high"] = 0xf12a3,
  ["md-battery_lock"] = 0xf179c,
  ["md-battery_lock_open"] = 0xf179d,
  ["md-battery_low"] = 0xf12a1,
  ["md-battery_medium"] = 0xf12a2,
  ["md-battery_minus"] = 0xf17e4,
  ["md-battery_minus_outline"] = 0xf17e5,
  ["md-battery_minus_variant"] = 0xf008c,
  ["md-battery_negative"] = 0xf008d,
  ["md-battery_off"] = 0xf125d,
  ["md-battery_off_outline"] = 0xf125e,
  ["md-battery_outline"] = 0xf008e,
  ["md-battery_plus"] = 0xf17e6,
  ["md-battery_plus_outline"] = 0xf17e7,
  ["md-battery_plus_variant"] = 0xf008f,
  ["md-battery_positive"] = 0xf0090,
  ["md-battery_remove"] = 0xf17e8,
  ["md-battery_remove_outline"] = 0xf17e9,
  ["md-battery_sync"] = 0xf1834,
  ["md-battery_sync_outline"] = 0xf1835,
  ["md-battery_unknown"] = 0xf0091,
  ["md-battery_unknown_bluetooth"] = 0xf094a,
  ["md-beach"] = 0xf0092,
  ["md-beaker"] = 0xf0cea,
  ["md-beaker_alert"] = 0xf1229,
  ["md-beaker_alert_outline"] = 0xf122a,
  ["md-beaker_check"] = 0xf122b,
  ["md-beaker_check_outline"] = 0xf122c,
  ["md-beaker_minus"] = 0xf122d,
  ["md-beaker_minus_outline"] = 0xf122e,
  ["md-beaker_outline"] = 0xf0690,
  ["md-beaker_plus"] = 0xf122f,
  ["md-beaker_plus_outline"] = 0xf1230,
  ["md-beaker_question"] = 0xf1231,
  ["md-beaker_question_outline"] = 0xf1232,
  ["md-beaker_remove"] = 0xf1233,
  ["md-beaker_remove_outline"] = 0xf1234,
  ["md-bed"] = 0xf02e3,
  ["md-bed_double"] = 0xf0fd4,
  ["md-bed_double_outline"] = 0xf0fd3,
  ["md-bed_empty"] = 0xf08a0,
  ["md-bed_king"] = 0xf0fd2,
  ["md-bed_king_outline"] = 0xf0fd1,
  ["md-bed_outline"] = 0xf0099,
  ["md-bed_queen"] = 0xf0fd0,
  ["md-bed_queen_outline"] = 0xf0fdb,
  ["md-bed_single"] = 0xf106d,
  ["md-bed_single_outline"] = 0xf106e,
  ["md-bee"] = 0xf0fa1,
  ["md-bee_flower"] = 0xf0fa2,
  ["md-beehive_off_outline"] = 0xf13ed,
  ["md-beehive_outline"] = 0xf10ce,
  ["md-beekeeper"] = 0xf14e2,
  ["md-beer"] = 0xf0098,
  ["md-beer_outline"] = 0xf130c,
  ["md-bell"] = 0xf009a,
  ["md-bell_alert"] = 0xf0d59,
  ["md-bell_alert_outline"] = 0xf0e81,
  ["md-bell_badge"] = 0xf116b,
  ["md-bell_badge_outline"] = 0xf0178,
  ["md-bell_cancel"] = 0xf13e7,
  ["md-bell_cancel_outline"] = 0xf13e8,
  ["md-bell_check"] = 0xf11e5,
  ["md-bell_check_outline"] = 0xf11e6,
  ["md-bell_circle"] = 0xf0d5a,
  ["md-bell_circle_outline"] = 0xf0d5b,
  ["md-bell_cog"] = 0xf1a29,
  ["md-bell_cog_outline"] = 0xf1a2a,
  ["md-bell_minus"] = 0xf13e9,
  ["md-bell_minus_outline"] = 0xf13ea,
  ["md-bell_off"] = 0xf009b,
  ["md-bell_off_outline"] = 0xf0a91,
  ["md-bell_outline"] = 0xf009c,
  ["md-bell_plus"] = 0xf009d,
  ["md-bell_plus_outline"] = 0xf0a92,
  ["md-bell_remove"] = 0xf13eb,
  ["md-bell_remove_outline"] = 0xf13ec,
  ["md-bell_ring"] = 0xf009e,
  ["md-bell_ring_outline"] = 0xf009f,
  ["md-bell_sleep"] = 0xf00a0,
  ["md-bell_sleep_outline"] = 0xf0a93,
  ["md-beta"] = 0xf00a1,
  ["md-betamax"] = 0xf09cb,
  ["md-biathlon"] = 0xf0e14,
  ["md-bicycle"] = 0xf109c,
  ["md-bicycle_basket"] = 0xf1235,
  ["md-bicycle_cargo"] = 0xf189c,
  ["md-bicycle_electric"] = 0xf15b4,
  ["md-bicycle_penny_farthing"] = 0xf15e9,
  ["md-bike"] = 0xf00a3,
  ["md-bike_fast"] = 0xf111f,
  ["md-billboard"] = 0xf1010,
  ["md-billiards"] = 0xf0b61,
  ["md-billiards_rack"] = 0xf0b62,
  ["md-binoculars"] = 0xf00a5,
  ["md-bio"] = 0xf00a6,
  ["md-biohazard"] = 0xf00a7,
  ["md-bird"] = 0xf15c6,
  ["md-bitbucket"] = 0xf00a8,
  ["md-bitcoin"] = 0xf0813,
  ["md-black_mesa"] = 0xf00a9,
  ["md-blender"] = 0xf0ceb,
  ["md-blender_outline"] = 0xf181a,
  ["md-blender_software"] = 0xf00ab,
  ["md-blinds"] = 0xf00ac,
  ["md-blinds_horizontal"] = 0xf1a2b,
  ["md-blinds_horizontal_closed"] = 0xf1a2c,
  ["md-blinds_open"] = 0xf1011,
  ["md-blinds_vertical"] = 0xf1a2d,
  ["md-blinds_vertical_closed"] = 0xf1a2e,
  ["md-block_helper"] = 0xf00ad,
  ["md-blood_bag"] = 0xf0cec,
  ["md-bluetooth"] = 0xf00af,
  ["md-bluetooth_audio"] = 0xf00b0,
  ["md-bluetooth_connect"] = 0xf00b1,
  ["md-bluetooth_off"] = 0xf00b2,
  ["md-bluetooth_settings"] = 0xf00b3,
  ["md-bluetooth_transfer"] = 0xf00b4,
  ["md-blur"] = 0xf00b5,
  ["md-blur_linear"] = 0xf00b6,
  ["md-blur_off"] = 0xf00b7,
  ["md-blur_radial"] = 0xf00b8,
  ["md-bolt"] = 0xf0db3,
  ["md-bomb"] = 0xf0691,
  ["md-bomb_off"] = 0xf06c5,
  ["md-bone"] = 0xf00b9,
  ["md-bone_off"] = 0xf19e0,
  ["md-book"] = 0xf00ba,
  ["md-book_account"] = 0xf13ad,
  ["md-book_account_outline"] = 0xf13ae,
  ["md-book_alert"] = 0xf167c,
  ["md-book_alert_outline"] = 0xf167d,
  ["md-book_alphabet"] = 0xf061d,
  ["md-book_arrow_down"] = 0xf167e,
  ["md-book_arrow_down_outline"] = 0xf167f,
  ["md-book_arrow_left"] = 0xf1680,
  ["md-book_arrow_left_outline"] = 0xf1681,
  ["md-book_arrow_right"] = 0xf1682,
  ["md-book_arrow_right_outline"] = 0xf1683,
  ["md-book_arrow_up"] = 0xf1684,
  ["md-book_arrow_up_outline"] = 0xf1685,
  ["md-book_cancel"] = 0xf1686,
  ["md-book_cancel_outline"] = 0xf1687,
  ["md-book_check"] = 0xf14f3,
  ["md-book_check_outline"] = 0xf14f4,
  ["md-book_clock"] = 0xf1688,
  ["md-book_clock_outline"] = 0xf1689,
  ["md-book_cog"] = 0xf168a,
  ["md-book_cog_outline"] = 0xf168b,
  ["md-book_cross"] = 0xf00a2,
  ["md-book_edit"] = 0xf168c,
  ["md-book_edit_outline"] = 0xf168d,
  ["md-book_education"] = 0xf16c9,
  ["md-book_education_outline"] = 0xf16ca,
  ["md-book_heart"] = 0xf1a1d,
  ["md-book_heart_outline"] = 0xf1a1e,
  ["md-book_information_variant"] = 0xf106f,
  ["md-book_lock"] = 0xf079a,
  ["md-book_lock_open"] = 0xf079b,
  ["md-book_lock_open_outline"] = 0xf168e,
  ["md-book_lock_outline"] = 0xf168f,
  ["md-book_marker"] = 0xf1690,
  ["md-book_marker_outline"] = 0xf1691,
  ["md-book_minus"] = 0xf05d9,
  ["md-book_minus_multiple"] = 0xf0a94,
  ["md-book_minus_multiple_outline"] = 0xf090b,
  ["md-book_minus_outline"] = 0xf1692,
  ["md-book_multiple"] = 0xf00bb,
  ["md-book_multiple_outline"] = 0xf0436,
  ["md-book_music"] = 0xf0067,
  ["md-book_music_outline"] = 0xf1693,
  ["md-book_off"] = 0xf1694,
  ["md-book_off_outline"] = 0xf1695,
  ["md-book_open"] = 0xf00bd,
  ["md-book_open_blank_variant"] = 0xf00be,
  ["md-book_open_outline"] = 0xf0b63,
  ["md-book_open_page_variant"] = 0xf05da,
  ["md-book_open_page_variant_outline"] = 0xf15d6,
  ["md-book_open_variant"] = 0xf14f7,
  ["md-book_outline"] = 0xf0b64,
  ["md-book_play"] = 0xf0e82,
  ["md-book_play_outline"] = 0xf0e83,
  ["md-book_plus"] = 0xf05db,
  ["md-book_plus_multiple"] = 0xf0a95,
  ["md-book_plus_multiple_outline"] = 0xf0ade,
  ["md-book_plus_outline"] = 0xf1696,
  ["md-book_refresh"] = 0xf1697,
  ["md-book_refresh_outline"] = 0xf1698,
  ["md-book_remove"] = 0xf0a97,
  ["md-book_remove_multiple"] = 0xf0a96,
  ["md-book_remove_multiple_outline"] = 0xf04ca,
  ["md-book_remove_outline"] = 0xf1699,
  ["md-book_search"] = 0xf0e84,
  ["md-book_search_outline"] = 0xf0e85,
  ["md-book_settings"] = 0xf169a,
  ["md-book_settings_outline"] = 0xf169b,
  ["md-book_sync"] = 0xf169c,
  ["md-book_sync_outline"] = 0xf16c8,
  ["md-book_variant"] = 0xf00bf,
  ["md-book_variant_multiple"] = 0xf00bc,
  ["md-bookmark"] = 0xf00c0,
  ["md-bookmark_box_multiple"] = 0xf196c,
  ["md-bookmark_box_multiple_outline"] = 0xf196d,
  ["md-bookmark_check"] = 0xf00c1,
  ["md-bookmark_check_outline"] = 0xf137b,
  ["md-bookmark_minus"] = 0xf09cc,
  ["md-bookmark_minus_outline"] = 0xf09cd,
  ["md-bookmark_multiple"] = 0xf0e15,
  ["md-bookmark_multiple_outline"] = 0xf0e16,
  ["md-bookmark_music"] = 0xf00c2,
  ["md-bookmark_music_outline"] = 0xf1379,
  ["md-bookmark_off"] = 0xf09ce,
  ["md-bookmark_off_outline"] = 0xf09cf,
  ["md-bookmark_outline"] = 0xf00c3,
  ["md-bookmark_plus"] = 0xf00c5,
  ["md-bookmark_plus_outline"] = 0xf00c4,
  ["md-bookmark_remove"] = 0xf00c6,
  ["md-bookmark_remove_outline"] = 0xf137a,
  ["md-bookshelf"] = 0xf125f,
  ["md-boom_gate"] = 0xf0e86,
  ["md-boom_gate_alert"] = 0xf0e87,
  ["md-boom_gate_alert_outline"] = 0xf0e88,
  ["md-boom_gate_arrow_down"] = 0xf0e89,
  ["md-boom_gate_arrow_down_outline"] = 0xf0e8a,
  ["md-boom_gate_arrow_up"] = 0xf0e8c,
  ["md-boom_gate_arrow_up_outline"] = 0xf0e8d,
  ["md-boom_gate_outline"] = 0xf0e8b,
  ["md-boom_gate_up"] = 0xf17f9,
  ["md-boom_gate_up_outline"] = 0xf17fa,
  ["md-boombox"] = 0xf05dc,
  ["md-boomerang"] = 0xf10cf,
  ["md-bootstrap"] = 0xf06c6,
  ["md-border_all"] = 0xf00c7,
  ["md-border_all_variant"] = 0xf08a1,
  ["md-border_bottom"] = 0xf00c8,
  ["md-border_bottom_variant"] = 0xf08a2,
  ["md-border_color"] = 0xf00c9,
  ["md-border_horizontal"] = 0xf00ca,
  ["md-border_inside"] = 0xf00cb,
  ["md-border_left"] = 0xf00cc,
  ["md-border_left_variant"] = 0xf08a3,
  ["md-border_none"] = 0xf00cd,
  ["md-border_none_variant"] = 0xf08a4,
  ["md-border_outside"] = 0xf00ce,
  ["md-border_right"] = 0xf00cf,
  ["md-border_right_variant"] = 0xf08a5,
  ["md-border_style"] = 0xf00d0,
  ["md-border_top"] = 0xf00d1,
  ["md-border_top_variant"] = 0xf08a6,
  ["md-border_vertical"] = 0xf00d2,
  ["md-bottle_soda"] = 0xf1070,
  ["md-bottle_soda_classic"] = 0xf1071,
  ["md-bottle_soda_classic_outline"] = 0xf1363,
  ["md-bottle_soda_outline"] = 0xf1072,
  ["md-bottle_tonic"] = 0xf112e,
  ["md-bottle_tonic_outline"] = 0xf112f,
  ["md-bottle_tonic_plus"] = 0xf1130,
  ["md-bottle_tonic_plus_outline"] = 0xf1131,
  ["md-bottle_tonic_skull"] = 0xf1132,
  ["md-bottle_tonic_skull_outline"] = 0xf1133,
  ["md-bottle_wine"] = 0xf0854,
  ["md-bottle_wine_outline"] = 0xf1310,
  ["md-bow_arrow"] = 0xf1841,
  ["md-bow_tie"] = 0xf0678,
  ["md-bowl"] = 0xf028e,
  ["md-bowl_mix"] = 0xf0617,
  ["md-bowl_mix_outline"] = 0xf02e4,
  ["md-bowl_outline"] = 0xf02a9,
  ["md-bowling"] = 0xf00d3,
  ["md-box"] = 0xf00d4,
  ["md-box_cutter"] = 0xf00d5,
  ["md-box_cutter_off"] = 0xf0b4a,
  ["md-box_shadow"] = 0xf0637,
  ["md-boxing_glove"] = 0xf0b65,
  ["md-braille"] = 0xf09d0,
  ["md-brain"] = 0xf09d1,
  ["md-bread_slice"] = 0xf0cee,
  ["md-bread_slice_outline"] = 0xf0cef,
  ["md-bridge"] = 0xf0618,
  ["md-briefcase"] = 0xf00d6,
  ["md-briefcase_account"] = 0xf0cf0,
  ["md-briefcase_account_outline"] = 0xf0cf1,
  ["md-briefcase_arrow_left_right"] = 0xf1a8d,
  ["md-briefcase_arrow_left_right_outline"] = 0xf1a8e,
  ["md-briefcase_arrow_up_down"] = 0xf1a8f,
  ["md-briefcase_arrow_up_down_outline"] = 0xf1a90,
  ["md-briefcase_check"] = 0xf00d7,
  ["md-briefcase_check_outline"] = 0xf131e,
  ["md-briefcase_clock"] = 0xf10d0,
  ["md-briefcase_clock_outline"] = 0xf10d1,
  ["md-briefcase_download"] = 0xf00d8,
  ["md-briefcase_download_outline"] = 0xf0c3d,
  ["md-briefcase_edit"] = 0xf0a98,
  ["md-briefcase_edit_outline"] = 0xf0c3e,
  ["md-briefcase_eye"] = 0xf17d9,
  ["md-briefcase_eye_outline"] = 0xf17da,
  ["md-briefcase_minus"] = 0xf0a2a,
  ["md-briefcase_minus_outline"] = 0xf0c3f,
  ["md-briefcase_off"] = 0xf1658,
  ["md-briefcase_off_outline"] = 0xf1659,
  ["md-briefcase_outline"] = 0xf0814,
  ["md-briefcase_plus"] = 0xf0a2b,
  ["md-briefcase_plus_outline"] = 0xf0c40,
  ["md-briefcase_remove"] = 0xf0a2c,
  ["md-briefcase_remove_outline"] = 0xf0c41,
  ["md-briefcase_search"] = 0xf0a2d,
  ["md-briefcase_search_outline"] = 0xf0c42,
  ["md-briefcase_upload"] = 0xf00d9,
  ["md-briefcase_upload_outline"] = 0xf0c43,
  ["md-briefcase_variant"] = 0xf1494,
  ["md-briefcase_variant_off"] = 0xf165a,
  ["md-briefcase_variant_off_outline"] = 0xf165b,
  ["md-briefcase_variant_outline"] = 0xf1495,
  ["md-brightness_1"] = 0xf00da,
  ["md-brightness_2"] = 0xf00db,
  ["md-brightness_3"] = 0xf00dc,
  ["md-brightness_4"] = 0xf00dd,
  ["md-brightness_5"] = 0xf00de,
  ["md-brightness_6"] = 0xf00df,
  ["md-brightness_7"] = 0xf00e0,
  ["md-brightness_auto"] = 0xf00e1,
  ["md-brightness_percent"] = 0xf0cf2,
  ["md-broadcast"] = 0xf1720,
  ["md-broadcast_off"] = 0xf1721,
  ["md-broom"] = 0xf00e2,
  ["md-brush"] = 0xf00e3,
  ["md-brush_off"] = 0xf1771,
  ["md-brush_outline"] = 0xf1a0d,
  ["md-brush_variant"] = 0xf1813,
  ["md-bucket"] = 0xf1415,
  ["md-bucket_outline"] = 0xf1416,
  ["md-buffet"] = 0xf0578,
  ["md-bug"] = 0xf00e4,
  ["md-bug_check"] = 0xf0a2e,
  ["md-bug_check_outline"] = 0xf0a2f,
  ["md-bug_outline"] = 0xf0a30,
  ["md-bugle"] = 0xf0db4,
  ["md-bulkhead_light"] = 0xf1a2f,
  ["md-bulldozer"] = 0xf0b22,
  ["md-bullet"] = 0xf0cf3,
  ["md-bulletin_board"] = 0xf00e5,
  ["md-bullhorn"] = 0xf00e6,
  ["md-bullhorn_outline"] = 0xf0b23,
  ["md-bullhorn_variant"] = 0xf196e,
  ["md-bullhorn_variant_outline"] = 0xf196f,
  ["md-bullseye"] = 0xf05dd,
  ["md-bullseye_arrow"] = 0xf08c9,
  ["md-bulma"] = 0xf12e7,
  ["md-bunk_bed"] = 0xf1302,
  ["md-bunk_bed_outline"] = 0xf0097,
  ["md-bus"] = 0xf00e7,
  ["md-bus_alert"] = 0xf0a99,
  ["md-bus_articulated_end"] = 0xf079c,
  ["md-bus_articulated_front"] = 0xf079d,
  ["md-bus_clock"] = 0xf08ca,
  ["md-bus_double_decker"] = 0xf079e,
  ["md-bus_electric"] = 0xf191d,
  ["md-bus_marker"] = 0xf1212,
  ["md-bus_multiple"] = 0xf0f3f,
  ["md-bus_school"] = 0xf079f,
  ["md-bus_side"] = 0xf07a0,
  ["md-bus_stop"] = 0xf1012,
  ["md-bus_stop_covered"] = 0xf1013,
  ["md-bus_stop_uncovered"] = 0xf1014,
  ["md-butterfly"] = 0xf1589,
  ["md-butterfly_outline"] = 0xf158a,
  ["md-cabin_a_frame"] = 0xf188c,
  ["md-cable_data"] = 0xf1394,
  ["md-cached"] = 0xf00e8,
  ["md-cactus"] = 0xf0db5,
  ["md-cake"] = 0xf00e9,
  ["md-cake_layered"] = 0xf00ea,
  ["md-cake_variant"] = 0xf00eb,
  ["md-cake_variant_outline"] = 0xf17f0,
  ["md-calculator"] = 0xf00ec,
  ["md-calculator_variant"] = 0xf0a9a,
  ["md-calculator_variant_outline"] = 0xf15a6,
  ["md-calendar"] = 0xf00ed,
  ["md-calendar_account"] = 0xf0ed7,
  ["md-calendar_account_outline"] = 0xf0ed8,
  ["md-calendar_alert"] = 0xf0a31,
  ["md-calendar_arrow_left"] = 0xf1134,
  ["md-calendar_arrow_right"] = 0xf1135,
  ["md-calendar_blank"] = 0xf00ee,
  ["md-calendar_blank_multiple"] = 0xf1073,
  ["md-calendar_blank_outline"] = 0xf0b66,
  ["md-calendar_check"] = 0xf00ef,
  ["md-calendar_check_outline"] = 0xf0c44,
  ["md-calendar_clock"] = 0xf00f0,
  ["md-calendar_clock_outline"] = 0xf16e1,
  ["md-calendar_collapse_horizontal"] = 0xf189d,
  ["md-calendar_cursor"] = 0xf157b,
  ["md-calendar_edit"] = 0xf08a7,
  ["md-calendar_end"] = 0xf166c,
  ["md-calendar_expand_horizontal"] = 0xf189e,
  ["md-calendar_export"] = 0xf0b24,
  ["md-calendar_heart"] = 0xf09d2,
  ["md-calendar_import"] = 0xf0b25,
  ["md-calendar_lock"] = 0xf1641,
  ["md-calendar_lock_outline"] = 0xf1642,
  ["md-calendar_minus"] = 0xf0d5c,
  ["md-calendar_month"] = 0xf0e17,
  ["md-calendar_month_outline"] = 0xf0e18,
  ["md-calendar_multiple"] = 0xf00f1,
  ["md-calendar_multiple_check"] = 0xf00f2,
  ["md-calendar_multiselect"] = 0xf0a32,
  ["md-calendar_outline"] = 0xf0b67,
  ["md-calendar_plus"] = 0xf00f3,
  ["md-calendar_question"] = 0xf0692,
  ["md-calendar_range"] = 0xf0679,
  ["md-calendar_range_outline"] = 0xf0b68,
  ["md-calendar_refresh"] = 0xf01e1,
  ["md-calendar_refresh_outline"] = 0xf0203,
  ["md-calendar_remove"] = 0xf00f4,
  ["md-calendar_remove_outline"] = 0xf0c45,
  ["md-calendar_search"] = 0xf094c,
  ["md-calendar_star"] = 0xf09d3,
  ["md-calendar_start"] = 0xf166d,
  ["md-calendar_sync"] = 0xf0e8e,
  ["md-calendar_sync_outline"] = 0xf0e8f,
  ["md-calendar_text"] = 0xf00f5,
  ["md-calendar_text_outline"] = 0xf0c46,
  ["md-calendar_today"] = 0xf00f6,
  ["md-calendar_today_outline"] = 0xf1a30,
  ["md-calendar_week"] = 0xf0a33,
  ["md-calendar_week_begin"] = 0xf0a34,
  ["md-calendar_week_begin_outline"] = 0xf1a31,
  ["md-calendar_week_end"] = 0xf1a32,
  ["md-calendar_week_end_outline"] = 0xf1a33,
  ["md-calendar_week_outline"] = 0xf1a34,
  ["md-calendar_weekend"] = 0xf0ed9,
  ["md-calendar_weekend_outline"] = 0xf0eda,
  ["md-call_made"] = 0xf00f7,
  ["md-call_merge"] = 0xf00f8,
  ["md-call_missed"] = 0xf00f9,
  ["md-call_received"] = 0xf00fa,
  ["md-call_split"] = 0xf00fb,
  ["md-camcorder"] = 0xf00fc,
  ["md-camcorder_off"] = 0xf00ff,
  ["md-camera"] = 0xf0100,
  ["md-camera_account"] = 0xf08cb,
  ["md-camera_burst"] = 0xf0693,
  ["md-camera_control"] = 0xf0b69,
  ["md-camera_document"] = 0xf1871,
  ["md-camera_document_off"] = 0xf1872,
  ["md-camera_enhance"] = 0xf0101,
  ["md-camera_enhance_outline"] = 0xf0b6a,
  ["md-camera_flip"] = 0xf15d9,
  ["md-camera_flip_outline"] = 0xf15da,
  ["md-camera_front"] = 0xf0102,
  ["md-camera_front_variant"] = 0xf0103,
  ["md-camera_gopro"] = 0xf07a1,
  ["md-camera_image"] = 0xf08cc,
  ["md-camera_iris"] = 0xf0104,
  ["md-camera_lock"] = 0xf1a14,
  ["md-camera_lock_outline"] = 0xf1a15,
  ["md-camera_marker"] = 0xf19a7,
  ["md-camera_marker_outline"] = 0xf19a8,
  ["md-camera_metering_center"] = 0xf07a2,
  ["md-camera_metering_matrix"] = 0xf07a3,
  ["md-camera_metering_partial"] = 0xf07a4,
  ["md-camera_metering_spot"] = 0xf07a5,
  ["md-camera_off"] = 0xf05df,
  ["md-camera_off_outline"] = 0xf19bf,
  ["md-camera_outline"] = 0xf0d5d,
  ["md-camera_party_mode"] = 0xf0105,
  ["md-camera_plus"] = 0xf0edb,
  ["md-camera_plus_outline"] = 0xf0edc,
  ["md-camera_rear"] = 0xf0106,
  ["md-camera_rear_variant"] = 0xf0107,
  ["md-camera_retake"] = 0xf0e19,
  ["md-camera_retake_outline"] = 0xf0e1a,
  ["md-camera_switch"] = 0xf0108,
  ["md-camera_switch_outline"] = 0xf084a,
  ["md-camera_timer"] = 0xf0109,
  ["md-camera_wireless"] = 0xf0db6,
  ["md-camera_wireless_outline"] = 0xf0db7,
  ["md-campfire"] = 0xf0edd,
  ["md-cancel"] = 0xf073a,
  ["md-candelabra"] = 0xf17d2,
  ["md-candelabra_fire"] = 0xf17d3,
  ["md-candle"] = 0xf05e2,
  ["md-candy"] = 0xf1970,
  ["md-candy_off"] = 0xf1971,
  ["md-candy_off_outline"] = 0xf1972,
  ["md-candy_outline"] = 0xf1973,
  ["md-candycane"] = 0xf010a,
  ["md-cannabis"] = 0xf07a6,
  ["md-cannabis_off"] = 0xf166e,
  ["md-caps_lock"] = 0xf0a9b,
  ["md-car"] = 0xf010b,
  ["md-car_2_plus"] = 0xf1015,
  ["md-car_3_plus"] = 0xf1016,
  ["md-car_arrow_left"] = 0xf13b2,
  ["md-car_arrow_right"] = 0xf13b3,
  ["md-car_back"] = 0xf0e1b,
  ["md-car_battery"] = 0xf010c,
  ["md-car_brake_abs"] = 0xf0c47,
  ["md-car_brake_alert"] = 0xf0c48,
  ["md-car_brake_fluid_level"] = 0xf1909,
  ["md-car_brake_hold"] = 0xf0d5e,
  ["md-car_brake_low_pressure"] = 0xf190a,
  ["md-car_brake_parking"] = 0xf0d5f,
  ["md-car_brake_retarder"] = 0xf1017,
  ["md-car_brake_temperature"] = 0xf190b,
  ["md-car_brake_worn_linings"] = 0xf190c,
  ["md-car_child_seat"] = 0xf0fa3,
  ["md-car_clock"] = 0xf1974,
  ["md-car_clutch"] = 0xf1018,
  ["md-car_cog"] = 0xf13cc,
  ["md-car_connected"] = 0xf010d,
  ["md-car_convertible"] = 0xf07a7,
  ["md-car_coolant_level"] = 0xf1019,
  ["md-car_cruise_control"] = 0xf0d60,
  ["md-car_defrost_front"] = 0xf0d61,
  ["md-car_defrost_rear"] = 0xf0d62,
  ["md-car_door"] = 0xf0b6b,
  ["md-car_door_lock"] = 0xf109d,
  ["md-car_electric"] = 0xf0b6c,
  ["md-car_electric_outline"] = 0xf15b5,
  ["md-car_emergency"] = 0xf160f,
  ["md-car_esp"] = 0xf0c49,
  ["md-car_estate"] = 0xf07a8,
  ["md-car_hatchback"] = 0xf07a9,
  ["md-car_info"] = 0xf11be,
  ["md-car_key"] = 0xf0b6d,
  ["md-car_lifted_pickup"] = 0xf152d,
  ["md-car_light_alert"] = 0xf190d,
  ["md-car_light_dimmed"] = 0xf0c4a,
  ["md-car_light_fog"] = 0xf0c4b,
  ["md-car_light_high"] = 0xf0c4c,
  ["md-car_limousine"] = 0xf08cd,
  ["md-car_multiple"] = 0xf0b6e,
  ["md-car_off"] = 0xf0e1c,
  ["md-car_outline"] = 0xf14ed,
  ["md-car_parking_lights"] = 0xf0d63,
  ["md-car_pickup"] = 0xf07aa,
  ["md-car_seat"] = 0xf0fa4,
  ["md-car_seat_cooler"] = 0xf0fa5,
  ["md-car_seat_heater"] = 0xf0fa6,
  ["md-car_select"] = 0xf1879,
  ["md-car_settings"] = 0xf13cd,
  ["md-car_shift_pattern"] = 0xf0f40,
  ["md-car_side"] = 0xf07ab,
  ["md-car_speed_limiter"] = 0xf190e,
  ["md-car_sports"] = 0xf07ac,
  ["md-car_tire_alert"] = 0xf0c4d,
  ["md-car_traction_control"] = 0xf0d64,
  ["md-car_turbocharger"] = 0xf101a,
  ["md-car_wash"] = 0xf010e,
  ["md-car_windshield"] = 0xf101b,
  ["md-car_windshield_outline"] = 0xf101c,
  ["md-car_wireless"] = 0xf1878,
  ["md-car_wrench"] = 0xf1814,
  ["md-carabiner"] = 0xf14c0,
  ["md-caravan"] = 0xf07ad,
  ["md-card"] = 0xf0b6f,
  ["md-card_account_details"] = 0xf05d2,
  ["md-card_account_details_outline"] = 0xf0dab,
  ["md-card_account_details_star"] = 0xf02a3,
  ["md-card_account_details_star_outline"] = 0xf06db,
  ["md-card_account_mail"] = 0xf018e,
  ["md-card_account_mail_outline"] = 0xf0e98,
  ["md-card_account_phone"] = 0xf0e99,
  ["md-card_account_phone_outline"] = 0xf0e9a,
  ["md-card_bulleted"] = 0xf0b70,
  ["md-card_bulleted_off"] = 0xf0b71,
  ["md-card_bulleted_off_outline"] = 0xf0b72,
  ["md-card_bulleted_outline"] = 0xf0b73,
  ["md-card_bulleted_settings"] = 0xf0b74,
  ["md-card_bulleted_settings_outline"] = 0xf0b75,
  ["md-card_minus"] = 0xf1600,
  ["md-card_minus_outline"] = 0xf1601,
  ["md-card_multiple"] = 0xf17f1,
  ["md-card_multiple_outline"] = 0xf17f2,
  ["md-card_off"] = 0xf1602,
  ["md-card_off_outline"] = 0xf1603,
  ["md-card_outline"] = 0xf0b76,
  ["md-card_plus"] = 0xf11ff,
  ["md-card_plus_outline"] = 0xf1200,
  ["md-card_remove"] = 0xf1604,
  ["md-card_remove_outline"] = 0xf1605,
  ["md-card_search"] = 0xf1074,
  ["md-card_search_outline"] = 0xf1075,
  ["md-card_text"] = 0xf0b77,
  ["md-card_text_outline"] = 0xf0b78,
  ["md-cards"] = 0xf0638,
  ["md-cards_club"] = 0xf08ce,
  ["md-cards_club_outline"] = 0xf189f,
  ["md-cards_diamond"] = 0xf08cf,
  ["md-cards_diamond_outline"] = 0xf101d,
  ["md-cards_outline"] = 0xf0639,
  ["md-cards_playing"] = 0xf18a1,
  ["md-cards_playing_club"] = 0xf18a2,
  ["md-cards_playing_club_multiple"] = 0xf18a3,
  ["md-cards_playing_club_multiple_outline"] = 0xf18a4,
  ["md-cards_playing_club_outline"] = 0xf18a5,
  ["md-cards_playing_diamond"] = 0xf18a6,
  ["md-cards_playing_diamond_multiple"] = 0xf18a7,
  ["md-cards_playing_diamond_multiple_outline"] = 0xf18a8,
  ["md-cards_playing_diamond_outline"] = 0xf18a9,
  ["md-cards_playing_heart"] = 0xf18aa,
  ["md-cards_playing_heart_multiple"] = 0xf18ab,
  ["md-cards_playing_heart_multiple_outline"] = 0xf18ac,
  ["md-cards_playing_heart_outline"] = 0xf18ad,
  ["md-cards_playing_outline"] = 0xf063a,
  ["md-cards_playing_spade"] = 0xf18ae,
  ["md-cards_playing_spade_multiple"] = 0xf18af,
  ["md-cards_playing_spade_multiple_outline"] = 0xf18b0,
  ["md-cards_playing_spade_outline"] = 0xf18b1,
  ["md-cards_spade"] = 0xf08d1,
  ["md-cards_spade_outline"] = 0xf18b2,
  ["md-cards_variant"] = 0xf06c7,
  ["md-carrot"] = 0xf010f,
  ["md-cart"] = 0xf0110,
  ["md-cart_arrow_down"] = 0xf0d66,
  ["md-cart_arrow_right"] = 0xf0c4e,
  ["md-cart_arrow_up"] = 0xf0d67,
  ["md-cart_check"] = 0xf15ea,
  ["md-cart_heart"] = 0xf18e0,
  ["md-cart_minus"] = 0xf0d68,
  ["md-cart_off"] = 0xf066b,
  ["md-cart_outline"] = 0xf0111,
  ["md-cart_plus"] = 0xf0112,
  ["md-cart_remove"] = 0xf0d69,
  ["md-cart_variant"] = 0xf15eb,
  ["md-case_sensitive_alt"] = 0xf0113,
  ["md-cash"] = 0xf0114,
  ["md-cash_100"] = 0xf0115,
  ["md-cash_check"] = 0xf14ee,
  ["md-cash_clock"] = 0xf1a91,
  ["md-cash_fast"] = 0xf185c,
  ["md-cash_lock"] = 0xf14ea,
  ["md-cash_lock_open"] = 0xf14eb,
  ["md-cash_marker"] = 0xf0db8,
  ["md-cash_minus"] = 0xf1260,
  ["md-cash_multiple"] = 0xf0116,
  ["md-cash_plus"] = 0xf1261,
  ["md-cash_refund"] = 0xf0a9c,
  ["md-cash_register"] = 0xf0cf4,
  ["md-cash_remove"] = 0xf1262,
  ["md-cash_sync"] = 0xf1a92,
  ["md-cassette"] = 0xf09d4,
  ["md-cast"] = 0xf0118,
  ["md-cast_audio"] = 0xf101e,
  ["md-cast_audio_variant"] = 0xf1749,
  ["md-cast_connected"] = 0xf0119,
  ["md-cast_education"] = 0xf0e1d,
  ["md-cast_off"] = 0xf078a,
  ["md-cast_variant"] = 0xf001f,
  ["md-castle"] = 0xf011a,
  ["md-cat"] = 0xf011b,
  ["md-cctv"] = 0xf07ae,
  ["md-cctv_off"] = 0xf185f,
  ["md-ceiling_fan"] = 0xf1797,
  ["md-ceiling_fan_light"] = 0xf1798,
  ["md-ceiling_light"] = 0xf0769,
  ["md-ceiling_light_multiple"] = 0xf18dd,
  ["md-ceiling_light_multiple_outline"] = 0xf18de,
  ["md-ceiling_light_outline"] = 0xf17c7,
  ["md-cellphone"] = 0xf011c,
  ["md-cellphone_arrow_down"] = 0xf09d5,
  ["md-cellphone_arrow_down_variant"] = 0xf19c5,
  ["md-cellphone_basic"] = 0xf011e,
  ["md-cellphone_charging"] = 0xf1397,
  ["md-cellphone_check"] = 0xf17fd,
  ["md-cellphone_cog"] = 0xf0951,
  ["md-cellphone_dock"] = 0xf011f,
  ["md-cellphone_information"] = 0xf0f41,
  ["md-cellphone_key"] = 0xf094e,
  ["md-cellphone_link"] = 0xf0121,
  ["md-cellphone_link_off"] = 0xf0122,
  ["md-cellphone_lock"] = 0xf094f,
  ["md-cellphone_marker"] = 0xf183a,
  ["md-cellphone_message"] = 0xf08d3,
  ["md-cellphone_message_off"] = 0xf10d2,
  ["md-cellphone_nfc"] = 0xf0e90,
  ["md-cellphone_nfc_off"] = 0xf12d8,
  ["md-cellphone_off"] = 0xf0950,
  ["md-cellphone_play"] = 0xf101f,
  ["md-cellphone_remove"] = 0xf094d,
  ["md-cellphone_screenshot"] = 0xf0a35,
  ["md-cellphone_settings"] = 0xf0123,
  ["md-cellphone_sound"] = 0xf0952,
  ["md-cellphone_text"] = 0xf08d2,
  ["md-cellphone_wireless"] = 0xf0815,
  ["md-centos"] = 0xf111a,
  ["md-certificate"] = 0xf0124,
  ["md-certificate_outline"] = 0xf1188,
  ["md-chair_rolling"] = 0xf0f48,
  ["md-chair_school"] = 0xf0125,
  ["md-chandelier"] = 0xf1793,
  ["md-charity"] = 0xf0c4f,
  ["md-chart_arc"] = 0xf0126,
  ["md-chart_areaspline"] = 0xf0127,
  ["md-chart_areaspline_variant"] = 0xf0e91,
  ["md-chart_bar"] = 0xf0128,
  ["md-chart_bar_stacked"] = 0xf076a,
  ["md-chart_bell_curve"] = 0xf0c50,
  ["md-chart_bell_curve_cumulative"] = 0xf0fa7,
  ["md-chart_box"] = 0xf154d,
  ["md-chart_box_outline"] = 0xf154e,
  ["md-chart_box_plus_outline"] = 0xf154f,
  ["md-chart_bubble"] = 0xf05e3,
  ["md-chart_donut"] = 0xf07af,
  ["md-chart_donut_variant"] = 0xf07b0,
  ["md-chart_gantt"] = 0xf066c,
  ["md-chart_histogram"] = 0xf0129,
  ["md-chart_line"] = 0xf012a,
  ["md-chart_line_stacked"] = 0xf076b,
  ["md-chart_line_variant"] = 0xf07b1,
  ["md-chart_multiline"] = 0xf08d4,
  ["md-chart_multiple"] = 0xf1213,
  ["md-chart_pie"] = 0xf012b,
  ["md-chart_ppf"] = 0xf1380,
  ["md-chart_sankey"] = 0xf11df,
  ["md-chart_sankey_variant"] = 0xf11e0,
  ["md-chart_scatter_plot"] = 0xf0e92,
  ["md-chart_scatter_plot_hexbin"] = 0xf066d,
  ["md-chart_timeline"] = 0xf066e,
  ["md-chart_timeline_variant"] = 0xf0e93,
  ["md-chart_timeline_variant_shimmer"] = 0xf15b6,
  ["md-chart_tree"] = 0xf0e94,
  ["md-chart_waterfall"] = 0xf1918,
  ["md-chat"] = 0xf0b79,
  ["md-chat_alert"] = 0xf0b7a,
  ["md-chat_alert_outline"] = 0xf12c9,
  ["md-chat_minus"] = 0xf1410,
  ["md-chat_minus_outline"] = 0xf1413,
  ["md-chat_outline"] = 0xf0ede,
  ["md-chat_plus"] = 0xf140f,
  ["md-chat_plus_outline"] = 0xf1412,
  ["md-chat_processing"] = 0xf0b7b,
  ["md-chat_processing_outline"] = 0xf12ca,
  ["md-chat_question"] = 0xf1738,
  ["md-chat_question_outline"] = 0xf1739,
  ["md-chat_remove"] = 0xf1411,
  ["md-chat_remove_outline"] = 0xf1414,
  ["md-chat_sleep"] = 0xf12d1,
  ["md-chat_sleep_outline"] = 0xf12d2,
  ["md-check"] = 0xf012c,
  ["md-check_all"] = 0xf012d,
  ["md-check_bold"] = 0xf0e1e,
  ["md-check_circle"] = 0xf05e0,
  ["md-check_circle_outline"] = 0xf05e1,
  ["md-check_decagram"] = 0xf0791,
  ["md-check_decagram_outline"] = 0xf1740,
  ["md-check_network"] = 0xf0c53,
  ["md-check_network_outline"] = 0xf0c54,
  ["md-check_outline"] = 0xf0855,
  ["md-check_underline"] = 0xf0e1f,
  ["md-check_underline_circle"] = 0xf0e20,
  ["md-check_underline_circle_outline"] = 0xf0e21,
  ["md-checkbook"] = 0xf0a9d,
  ["md-checkbox_blank"] = 0xf012e,
  ["md-checkbox_blank_badge"] = 0xf1176,
  ["md-checkbox_blank_badge_outline"] = 0xf0117,
  ["md-checkbox_blank_circle"] = 0xf0765,
  ["md-checkbox_blank_circle_outline"] = 0xf0766,
  ["md-checkbox_blank_off"] = 0xf12ec,
  ["md-checkbox_blank_off_outline"] = 0xf12ed,
  ["md-checkbox_blank_outline"] = 0xf0131,
  ["md-checkbox_intermediate"] = 0xf0856,
  ["md-checkbox_marked"] = 0xf0132,
  ["md-checkbox_marked_circle"] = 0xf0133,
  ["md-checkbox_marked_circle_outline"] = 0xf0134,
  ["md-checkbox_marked_circle_plus_outline"] = 0xf1927,
  ["md-checkbox_marked_outline"] = 0xf0135,
  ["md-checkbox_multiple_blank"] = 0xf0136,
  ["md-checkbox_multiple_blank_circle"] = 0xf063b,
  ["md-checkbox_multiple_blank_circle_outline"] = 0xf063c,
  ["md-checkbox_multiple_blank_outline"] = 0xf0137,
  ["md-checkbox_multiple_marked"] = 0xf0138,
  ["md-checkbox_multiple_marked_circle"] = 0xf063d,
  ["md-checkbox_multiple_marked_circle_outline"] = 0xf063e,
  ["md-checkbox_multiple_marked_outline"] = 0xf0139,
  ["md-checkbox_multiple_outline"] = 0xf0c51,
  ["md-checkbox_outline"] = 0xf0c52,
  ["md-checkerboard"] = 0xf013a,
  ["md-checkerboard_minus"] = 0xf1202,
  ["md-checkerboard_plus"] = 0xf1201,
  ["md-checkerboard_remove"] = 0xf1203,
  ["md-cheese"] = 0xf12b9,
  ["md-cheese_off"] = 0xf13ee,
  ["md-chef_hat"] = 0xf0b7c,
  ["md-chemical_weapon"] = 0xf013b,
  ["md-chess_bishop"] = 0xf085c,
  ["md-chess_king"] = 0xf0857,
  ["md-chess_knight"] = 0xf0858,
  ["md-chess_pawn"] = 0xf0859,
  ["md-chess_queen"] = 0xf085a,
  ["md-chess_rook"] = 0xf085b,
  ["md-chevron_double_down"] = 0xf013c,
  ["md-chevron_double_left"] = 0xf013d,
  ["md-chevron_double_right"] = 0xf013e,
  ["md-chevron_double_up"] = 0xf013f,
  ["md-chevron_down"] = 0xf0140,
  ["md-chevron_down_box"] = 0xf09d6,
  ["md-chevron_down_box_outline"] = 0xf09d7,
  ["md-chevron_down_circle"] = 0xf0b26,
  ["md-chevron_down_circle_outline"] = 0xf0b27,
  ["md-chevron_left"] = 0xf0141,
  ["md-chevron_left_box"] = 0xf09d8,
  ["md-chevron_left_box_outline"] = 0xf09d9,
  ["md-chevron_left_circle"] = 0xf0b28,
  ["md-chevron_left_circle_outline"] = 0xf0b29,
  ["md-chevron_right"] = 0xf0142,
  ["md-chevron_right_box"] = 0xf09da,
  ["md-chevron_right_box_outline"] = 0xf09db,
  ["md-chevron_right_circle"] = 0xf0b2a,
  ["md-chevron_right_circle_outline"] = 0xf0b2b,
  ["md-chevron_triple_down"] = 0xf0db9,
  ["md-chevron_triple_left"] = 0xf0dba,
  ["md-chevron_triple_right"] = 0xf0dbb,
  ["md-chevron_triple_up"] = 0xf0dbc,
  ["md-chevron_up"] = 0xf0143,
  ["md-chevron_up_box"] = 0xf09dc,
  ["md-chevron_up_box_outline"] = 0xf09dd,
  ["md-chevron_up_circle"] = 0xf0b2c,
  ["md-chevron_up_circle_outline"] = 0xf0b2d,
  ["md-chili_alert"] = 0xf17ea,
  ["md-chili_alert_outline"] = 0xf17eb,
  ["md-chili_hot"] = 0xf07b2,
  ["md-chili_hot_outline"] = 0xf17ec,
  ["md-chili_medium"] = 0xf07b3,
  ["md-chili_medium_outline"] = 0xf17ed,
  ["md-chili_mild"] = 0xf07b4,
  ["md-chili_mild_outline"] = 0xf17ee,
  ["md-chili_off"] = 0xf1467,
  ["md-chili_off_outline"] = 0xf17ef,
  ["md-chip"] = 0xf061a,
  ["md-church"] = 0xf0144,
  ["md-cigar"] = 0xf1189,
  ["md-cigar_off"] = 0xf141b,
  ["md-circle_box"] = 0xf15dc,
  ["md-circle_box_outline"] = 0xf15dd,
  ["md-circle_double"] = 0xf0e95,
  ["md-circle_edit_outline"] = 0xf08d5,
  ["md-circle_expand"] = 0xf0e96,
  ["md-circle_half"] = 0xf1395,
  ["md-circle_half_full"] = 0xf1396,
  ["md-circle_medium"] = 0xf09de,
  ["md-circle_multiple"] = 0xf0b38,
  ["md-circle_multiple_outline"] = 0xf0695,
  ["md-circle_off_outline"] = 0xf10d3,
  ["md-circle_opacity"] = 0xf1853,
  ["md-circle_slice_1"] = 0xf0a9e,
  ["md-circle_slice_2"] = 0xf0a9f,
  ["md-circle_slice_3"] = 0xf0aa0,
  ["md-circle_slice_4"] = 0xf0aa1,
  ["md-circle_slice_5"] = 0xf0aa2,
  ["md-circle_slice_6"] = 0xf0aa3,
  ["md-circle_slice_7"] = 0xf0aa4,
  ["md-circle_slice_8"] = 0xf0aa5,
  ["md-circle_small"] = 0xf09df,
  ["md-circular_saw"] = 0xf0e22,
  ["md-city"] = 0xf0146,
  ["md-city_variant"] = 0xf0a36,
  ["md-city_variant_outline"] = 0xf0a37,
  ["md-clipboard"] = 0xf0147,
  ["md-clipboard_account"] = 0xf0148,
  ["md-clipboard_account_outline"] = 0xf0c55,
  ["md-clipboard_alert"] = 0xf0149,
  ["md-clipboard_alert_outline"] = 0xf0cf7,
  ["md-clipboard_arrow_down"] = 0xf014a,
  ["md-clipboard_arrow_down_outline"] = 0xf0c56,
  ["md-clipboard_arrow_left"] = 0xf014b,
  ["md-clipboard_arrow_left_outline"] = 0xf0cf8,
  ["md-clipboard_arrow_right"] = 0xf0cf9,
  ["md-clipboard_arrow_right_outline"] = 0xf0cfa,
  ["md-clipboard_arrow_up"] = 0xf0c57,
  ["md-clipboard_arrow_up_outline"] = 0xf0c58,
  ["md-clipboard_check"] = 0xf014e,
  ["md-clipboard_check_multiple"] = 0xf1263,
  ["md-clipboard_check_multiple_outline"] = 0xf1264,
  ["md-clipboard_check_outline"] = 0xf08a8,
  ["md-clipboard_clock"] = 0xf16e2,
  ["md-clipboard_clock_outline"] = 0xf16e3,
  ["md-clipboard_edit"] = 0xf14e5,
  ["md-clipboard_edit_outline"] = 0xf14e6,
  ["md-clipboard_file"] = 0xf1265,
  ["md-clipboard_file_outline"] = 0xf1266,
  ["md-clipboard_flow"] = 0xf06c8,
  ["md-clipboard_flow_outline"] = 0xf1117,
  ["md-clipboard_list"] = 0xf10d4,
  ["md-clipboard_list_outline"] = 0xf10d5,
  ["md-clipboard_minus"] = 0xf1618,
  ["md-clipboard_minus_outline"] = 0xf1619,
  ["md-clipboard_multiple"] = 0xf1267,
  ["md-clipboard_multiple_outline"] = 0xf1268,
  ["md-clipboard_off"] = 0xf161a,
  ["md-clipboard_off_outline"] = 0xf161b,
  ["md-clipboard_outline"] = 0xf014c,
  ["md-clipboard_play"] = 0xf0c59,
  ["md-clipboard_play_multiple"] = 0xf1269,
  ["md-clipboard_play_multiple_outline"] = 0xf126a,
  ["md-clipboard_play_outline"] = 0xf0c5a,
  ["md-clipboard_plus"] = 0xf0751,
  ["md-clipboard_plus_outline"] = 0xf131f,
  ["md-clipboard_pulse"] = 0xf085d,
  ["md-clipboard_pulse_outline"] = 0xf085e,
  ["md-clipboard_remove"] = 0xf161c,
  ["md-clipboard_remove_outline"] = 0xf161d,
  ["md-clipboard_search"] = 0xf161e,
  ["md-clipboard_search_outline"] = 0xf161f,
  ["md-clipboard_text"] = 0xf014d,
  ["md-clipboard_text_clock"] = 0xf18f9,
  ["md-clipboard_text_clock_outline"] = 0xf18fa,
  ["md-clipboard_text_multiple"] = 0xf126b,
  ["md-clipboard_text_multiple_outline"] = 0xf126c,
  ["md-clipboard_text_off"] = 0xf1620,
  ["md-clipboard_text_off_outline"] = 0xf1621,
  ["md-clipboard_text_outline"] = 0xf0a38,
  ["md-clipboard_text_play"] = 0xf0c5b,
  ["md-clipboard_text_play_outline"] = 0xf0c5c,
  ["md-clipboard_text_search"] = 0xf1622,
  ["md-clipboard_text_search_outline"] = 0xf1623,
  ["md-clippy"] = 0xf014f,
  ["md-clock"] = 0xf0954,
  ["md-clock_alert"] = 0xf0955,
  ["md-clock_alert_outline"] = 0xf05ce,
  ["md-clock_check"] = 0xf0fa8,
  ["md-clock_check_outline"] = 0xf0fa9,
  ["md-clock_digital"] = 0xf0e97,
  ["md-clock_edit"] = 0xf19ba,
  ["md-clock_edit_outline"] = 0xf19bb,
  ["md-clock_end"] = 0xf0151,
  ["md-clock_fast"] = 0xf0152,
  ["md-clock_in"] = 0xf0153,
  ["md-clock_minus"] = 0xf1863,
  ["md-clock_minus_outline"] = 0xf1864,
  ["md-clock_out"] = 0xf0154,
  ["md-clock_outline"] = 0xf0150,
  ["md-clock_plus"] = 0xf1861,
  ["md-clock_plus_outline"] = 0xf1862,
  ["md-clock_remove"] = 0xf1865,
  ["md-clock_remove_outline"] = 0xf1866,
  ["md-clock_start"] = 0xf0155,
  ["md-clock_time_eight"] = 0xf1446,
  ["md-clock_time_eight_outline"] = 0xf1452,
  ["md-clock_time_eleven"] = 0xf1449,
  ["md-clock_time_eleven_outline"] = 0xf1455,
  ["md-clock_time_five"] = 0xf1443,
  ["md-clock_time_five_outline"] = 0xf144f,
  ["md-clock_time_four"] = 0xf1442,
  ["md-clock_time_four_outline"] = 0xf144e,
  ["md-clock_time_nine"] = 0xf1447,
  ["md-clock_time_nine_outline"] = 0xf1453,
  ["md-clock_time_one"] = 0xf143f,
  ["md-clock_time_one_outline"] = 0xf144b,
  ["md-clock_time_seven"] = 0xf1445,
  ["md-clock_time_seven_outline"] = 0xf1451,
  ["md-clock_time_six"] = 0xf1444,
  ["md-clock_time_six_outline"] = 0xf1450,
  ["md-clock_time_ten"] = 0xf1448,
  ["md-clock_time_ten_outline"] = 0xf1454,
  ["md-clock_time_three"] = 0xf1441,
  ["md-clock_time_three_outline"] = 0xf144d,
  ["md-clock_time_twelve"] = 0xf144a,
  ["md-clock_time_twelve_outline"] = 0xf1456,
  ["md-clock_time_two"] = 0xf1440,
  ["md-clock_time_two_outline"] = 0xf144c,
  ["md-close"] = 0xf0156,
  ["md-close_box"] = 0xf0157,
  ["md-close_box_multiple"] = 0xf0c5d,
  ["md-close_box_multiple_outline"] = 0xf0c5e,
  ["md-close_box_outline"] = 0xf0158,
  ["md-close_circle"] = 0xf0159,
  ["md-close_circle_multiple"] = 0xf062a,
  ["md-close_circle_multiple_outline"] = 0xf0883,
  ["md-close_circle_outline"] = 0xf015a,
  ["md-close_network"] = 0xf015b,
  ["md-close_network_outline"] = 0xf0c5f,
  ["md-close_octagon"] = 0xf015c,
  ["md-close_octagon_outline"] = 0xf015d,
  ["md-close_outline"] = 0xf06c9,
  ["md-close_thick"] = 0xf1398,
  ["md-closed_caption"] = 0xf015e,
  ["md-closed_caption_outline"] = 0xf0dbd,
  ["md-cloud"] = 0xf015f,
  ["md-cloud_alert"] = 0xf09e0,
  ["md-cloud_braces"] = 0xf07b5,
  ["md-cloud_check"] = 0xf0160,
  ["md-cloud_check_outline"] = 0xf12cc,
  ["md-cloud_circle"] = 0xf0161,
  ["md-cloud_download"] = 0xf0162,
  ["md-cloud_download_outline"] = 0xf0b7d,
  ["md-cloud_lock"] = 0xf11f1,
  ["md-cloud_lock_outline"] = 0xf11f2,
  ["md-cloud_off_outline"] = 0xf0164,
  ["md-cloud_outline"] = 0xf0163,
  ["md-cloud_percent"] = 0xf1a35,
  ["md-cloud_percent_outline"] = 0xf1a36,
  ["md-cloud_print"] = 0xf0165,
  ["md-cloud_print_outline"] = 0xf0166,
  ["md-cloud_question"] = 0xf0a39,
  ["md-cloud_refresh"] = 0xf052a,
  ["md-cloud_search"] = 0xf0956,
  ["md-cloud_search_outline"] = 0xf0957,
  ["md-cloud_sync"] = 0xf063f,
  ["md-cloud_sync_outline"] = 0xf12d6,
  ["md-cloud_tags"] = 0xf07b6,
  ["md-cloud_upload"] = 0xf0167,
  ["md-cloud_upload_outline"] = 0xf0b7e,
  ["md-clover"] = 0xf0816,
  ["md-coach_lamp"] = 0xf1020,
  ["md-coach_lamp_variant"] = 0xf1a37,
  ["md-coat_rack"] = 0xf109e,
  ["md-code_array"] = 0xf0168,
  ["md-code_braces"] = 0xf0169,
  ["md-code_braces_box"] = 0xf10d6,
  ["md-code_brackets"] = 0xf016a,
  ["md-code_equal"] = 0xf016b,
  ["md-code_greater_than"] = 0xf016c,
  ["md-code_greater_than_or_equal"] = 0xf016d,
  ["md-code_json"] = 0xf0626,
  ["md-code_less_than"] = 0xf016e,
  ["md-code_less_than_or_equal"] = 0xf016f,
  ["md-code_not_equal"] = 0xf0170,
  ["md-code_not_equal_variant"] = 0xf0171,
  ["md-code_parentheses"] = 0xf0172,
  ["md-code_parentheses_box"] = 0xf10d7,
  ["md-code_string"] = 0xf0173,
  ["md-code_tags"] = 0xf0174,
  ["md-code_tags_check"] = 0xf0694,
  ["md-codepen"] = 0xf0175,
  ["md-coffee"] = 0xf0176,
  ["md-coffee_maker"] = 0xf109f,
  ["md-coffee_maker_check"] = 0xf1931,
  ["md-coffee_maker_check_outline"] = 0xf1932,
  ["md-coffee_maker_outline"] = 0xf181b,
  ["md-coffee_off"] = 0xf0faa,
  ["md-coffee_off_outline"] = 0xf0fab,
  ["md-coffee_outline"] = 0xf06ca,
  ["md-coffee_to_go"] = 0xf0177,
  ["md-coffee_to_go_outline"] = 0xf130e,
  ["md-coffin"] = 0xf0b7f,
  ["md-cog"] = 0xf0493,
  ["md-cog_box"] = 0xf0494,
  ["md-cog_clockwise"] = 0xf11dd,
  ["md-cog_counterclockwise"] = 0xf11de,
  ["md-cog_off"] = 0xf13ce,
  ["md-cog_off_outline"] = 0xf13cf,
  ["md-cog_outline"] = 0xf08bb,
  ["md-cog_pause"] = 0xf1933,
  ["md-cog_pause_outline"] = 0xf1934,
  ["md-cog_play"] = 0xf1935,
  ["md-cog_play_outline"] = 0xf1936,
  ["md-cog_refresh"] = 0xf145e,
  ["md-cog_refresh_outline"] = 0xf145f,
  ["md-cog_stop"] = 0xf1937,
  ["md-cog_stop_outline"] = 0xf1938,
  ["md-cog_sync"] = 0xf1460,
  ["md-cog_sync_outline"] = 0xf1461,
  ["md-cog_transfer"] = 0xf105b,
  ["md-cog_transfer_outline"] = 0xf105c,
  ["md-cogs"] = 0xf08d6,
  ["md-collage"] = 0xf0640,
  ["md-collapse_all"] = 0xf0aa6,
  ["md-collapse_all_outline"] = 0xf0aa7,
  ["md-color_helper"] = 0xf0179,
  ["md-comma"] = 0xf0e23,
  ["md-comma_box"] = 0xf0e2b,
  ["md-comma_box_outline"] = 0xf0e24,
  ["md-comma_circle"] = 0xf0e25,
  ["md-comma_circle_outline"] = 0xf0e26,
  ["md-comment"] = 0xf017a,
  ["md-comment_account"] = 0xf017b,
  ["md-comment_account_outline"] = 0xf017c,
  ["md-comment_alert"] = 0xf017d,
  ["md-comment_alert_outline"] = 0xf017e,
  ["md-comment_arrow_left"] = 0xf09e1,
  ["md-comment_arrow_left_outline"] = 0xf09e2,
  ["md-comment_arrow_right"] = 0xf09e3,
  ["md-comment_arrow_right_outline"] = 0xf09e4,
  ["md-comment_bookmark"] = 0xf15ae,
  ["md-comment_bookmark_outline"] = 0xf15af,
  ["md-comment_check"] = 0xf017f,
  ["md-comment_check_outline"] = 0xf0180,
  ["md-comment_edit"] = 0xf11bf,
  ["md-comment_edit_outline"] = 0xf12c4,
  ["md-comment_eye"] = 0xf0a3a,
  ["md-comment_eye_outline"] = 0xf0a3b,
  ["md-comment_flash"] = 0xf15b0,
  ["md-comment_flash_outline"] = 0xf15b1,
  ["md-comment_minus"] = 0xf15df,
  ["md-comment_minus_outline"] = 0xf15e0,
  ["md-comment_multiple"] = 0xf085f,
  ["md-comment_multiple_outline"] = 0xf0181,
  ["md-comment_off"] = 0xf15e1,
  ["md-comment_off_outline"] = 0xf15e2,
  ["md-comment_outline"] = 0xf0182,
  ["md-comment_plus"] = 0xf09e5,
  ["md-comment_plus_outline"] = 0xf0183,
  ["md-comment_processing"] = 0xf0184,
  ["md-comment_processing_outline"] = 0xf0185,
  ["md-comment_question"] = 0xf0817,
  ["md-comment_question_outline"] = 0xf0186,
  ["md-comment_quote"] = 0xf1021,
  ["md-comment_quote_outline"] = 0xf1022,
  ["md-comment_remove"] = 0xf05de,
  ["md-comment_remove_outline"] = 0xf0187,
  ["md-comment_search"] = 0xf0a3c,
  ["md-comment_search_outline"] = 0xf0a3d,
  ["md-comment_text"] = 0xf0188,
  ["md-comment_text_multiple"] = 0xf0860,
  ["md-comment_text_multiple_outline"] = 0xf0861,
  ["md-comment_text_outline"] = 0xf0189,
  ["md-compare"] = 0xf018a,
  ["md-compare_horizontal"] = 0xf1492,
  ["md-compare_remove"] = 0xf18b3,
  ["md-compare_vertical"] = 0xf1493,
  ["md-compass"] = 0xf018b,
  ["md-compass_off"] = 0xf0b80,
  ["md-compass_off_outline"] = 0xf0b81,
  ["md-compass_outline"] = 0xf018c,
  ["md-compass_rose"] = 0xf1382,
  ["md-compost"] = 0xf1a38,
  ["md-cone"] = 0xf194c,
  ["md-cone_off"] = 0xf194d,
  ["md-connection"] = 0xf1616,
  ["md-console"] = 0xf018d,
  ["md-console_line"] = 0xf07b7,
  ["md-console_network"] = 0xf08a9,
  ["md-console_network_outline"] = 0xf0c60,
  ["md-consolidate"] = 0xf10d8,
  ["md-contactless_payment"] = 0xf0d6a,
  ["md-contactless_payment_circle"] = 0xf0321,
  ["md-contactless_payment_circle_outline"] = 0xf0408,
  ["md-contacts"] = 0xf06cb,
  ["md-contacts_outline"] = 0xf05b8,
  ["md-contain"] = 0xf0a3e,
  ["md-contain_end"] = 0xf0a3f,
  ["md-contain_start"] = 0xf0a40,
  ["md-content_copy"] = 0xf018f,
  ["md-content_cut"] = 0xf0190,
  ["md-content_duplicate"] = 0xf0191,
  ["md-content_paste"] = 0xf0192,
  ["md-content_save"] = 0xf0193,
  ["md-content_save_alert"] = 0xf0f42,
  ["md-content_save_alert_outline"] = 0xf0f43,
  ["md-content_save_all"] = 0xf0194,
  ["md-content_save_all_outline"] = 0xf0f44,
  ["md-content_save_check"] = 0xf18ea,
  ["md-content_save_check_outline"] = 0xf18eb,
  ["md-content_save_cog"] = 0xf145b,
  ["md-content_save_cog_outline"] = 0xf145c,
  ["md-content_save_edit"] = 0xf0cfb,
  ["md-content_save_edit_outline"] = 0xf0cfc,
  ["md-content_save_move"] = 0xf0e27,
  ["md-content_save_move_outline"] = 0xf0e28,
  ["md-content_save_off"] = 0xf1643,
  ["md-content_save_off_outline"] = 0xf1644,
  ["md-content_save_outline"] = 0xf0818,
  ["md-content_save_settings"] = 0xf061b,
  ["md-content_save_settings_outline"] = 0xf0b2e,
  ["md-contrast"] = 0xf0195,
  ["md-contrast_box"] = 0xf0196,
  ["md-contrast_circle"] = 0xf0197,
  ["md-controller_classic"] = 0xf0b82,
  ["md-controller_classic_outline"] = 0xf0b83,
  ["md-cookie"] = 0xf0198,
  ["md-cookie_alert"] = 0xf16d0,
  ["md-cookie_alert_outline"] = 0xf16d1,
  ["md-cookie_check"] = 0xf16d2,
  ["md-cookie_check_outline"] = 0xf16d3,
  ["md-cookie_clock"] = 0xf16e4,
  ["md-cookie_clock_outline"] = 0xf16e5,
  ["md-cookie_cog"] = 0xf16d4,
  ["md-cookie_cog_outline"] = 0xf16d5,
  ["md-cookie_edit"] = 0xf16e6,
  ["md-cookie_edit_outline"] = 0xf16e7,
  ["md-cookie_lock"] = 0xf16e8,
  ["md-cookie_lock_outline"] = 0xf16e9,
  ["md-cookie_minus"] = 0xf16da,
  ["md-cookie_minus_outline"] = 0xf16db,
  ["md-cookie_off"] = 0xf16ea,
  ["md-cookie_off_outline"] = 0xf16eb,
  ["md-cookie_outline"] = 0xf16de,
  ["md-cookie_plus"] = 0xf16d6,
  ["md-cookie_plus_outline"] = 0xf16d7,
  ["md-cookie_refresh"] = 0xf16ec,
  ["md-cookie_refresh_outline"] = 0xf16ed,
  ["md-cookie_remove"] = 0xf16d8,
  ["md-cookie_remove_outline"] = 0xf16d9,
  ["md-cookie_settings"] = 0xf16dc,
  ["md-cookie_settings_outline"] = 0xf16dd,
  ["md-coolant_temperature"] = 0xf03c8,
  ["md-copyleft"] = 0xf1939,
  ["md-copyright"] = 0xf05e6,
  ["md-cordova"] = 0xf0958,
  ["md-corn"] = 0xf07b8,
  ["md-corn_off"] = 0xf13ef,
  ["md-cosine_wave"] = 0xf1479,
  ["md-counter"] = 0xf0199,
  ["md-countertop"] = 0xf181c,
  ["md-countertop_outline"] = 0xf181d,
  ["md-cow"] = 0xf019a,
  ["md-cow_off"] = 0xf18fc,
  ["md-cpu_32_bit"] = 0xf0edf,
  ["md-cpu_64_bit"] = 0xf0ee0,
  ["md-cradle"] = 0xf198b,
  ["md-cradle_outline"] = 0xf1991,
  ["md-crane"] = 0xf0862,
  ["md-creation"] = 0xf0674,
  ["md-creative_commons"] = 0xf0d6b,
  ["md-credit_card"] = 0xf0fef,
  ["md-credit_card_check"] = 0xf13d0,
  ["md-credit_card_check_outline"] = 0xf13d1,
  ["md-credit_card_chip"] = 0xf190f,
  ["md-credit_card_chip_outline"] = 0xf1910,
  ["md-credit_card_clock"] = 0xf0ee1,
  ["md-credit_card_clock_outline"] = 0xf0ee2,
  ["md-credit_card_edit"] = 0xf17d7,
  ["md-credit_card_edit_outline"] = 0xf17d8,
  ["md-credit_card_fast"] = 0xf1911,
  ["md-credit_card_fast_outline"] = 0xf1912,
  ["md-credit_card_lock"] = 0xf18e7,
  ["md-credit_card_lock_outline"] = 0xf18e8,
  ["md-credit_card_marker"] = 0xf06a8,
  ["md-credit_card_marker_outline"] = 0xf0dbe,
  ["md-credit_card_minus"] = 0xf0fac,
  ["md-credit_card_minus_outline"] = 0xf0fad,
  ["md-credit_card_multiple"] = 0xf0ff0,
  ["md-credit_card_multiple_outline"] = 0xf019c,
  ["md-credit_card_off"] = 0xf0ff1,
  ["md-credit_card_off_outline"] = 0xf05e4,
  ["md-credit_card_outline"] = 0xf019b,
  ["md-credit_card_plus"] = 0xf0ff2,
  ["md-credit_card_plus_outline"] = 0xf0676,
  ["md-credit_card_refresh"] = 0xf1645,
  ["md-credit_card_refresh_outline"] = 0xf1646,
  ["md-credit_card_refund"] = 0xf0ff3,
  ["md-credit_card_refund_outline"] = 0xf0aa8,
  ["md-credit_card_remove"] = 0xf0fae,
  ["md-credit_card_remove_outline"] = 0xf0faf,
  ["md-credit_card_scan"] = 0xf0ff4,
  ["md-credit_card_scan_outline"] = 0xf019d,
  ["md-credit_card_search"] = 0xf1647,
  ["md-credit_card_search_outline"] = 0xf1648,
  ["md-credit_card_settings"] = 0xf0ff5,
  ["md-credit_card_settings_outline"] = 0xf08d7,
  ["md-credit_card_sync"] = 0xf1649,
  ["md-credit_card_sync_outline"] = 0xf164a,
  ["md-credit_card_wireless"] = 0xf0802,
  ["md-credit_card_wireless_off"] = 0xf057a,
  ["md-credit_card_wireless_off_outline"] = 0xf057b,
  ["md-credit_card_wireless_outline"] = 0xf0d6c,
  ["md-cricket"] = 0xf0d6d,
  ["md-crop"] = 0xf019e,
  ["md-crop_free"] = 0xf019f,
  ["md-crop_landscape"] = 0xf01a0,
  ["md-crop_portrait"] = 0xf01a1,
  ["md-crop_rotate"] = 0xf0696,
  ["md-crop_square"] = 0xf01a2,
  ["md-cross"] = 0xf0953,
  ["md-cross_bolnisi"] = 0xf0ced,
  ["md-cross_celtic"] = 0xf0cf5,
  ["md-cross_outline"] = 0xf0cf6,
  ["md-crosshairs"] = 0xf01a3,
  ["md-crosshairs_gps"] = 0xf01a4,
  ["md-crosshairs_off"] = 0xf0f45,
  ["md-crosshairs_question"] = 0xf1136,
  ["md-crowd"] = 0xf1975,
  ["md-crown"] = 0xf01a5,
  ["md-crown_circle"] = 0xf17dc,
  ["md-crown_circle_outline"] = 0xf17dd,
  ["md-crown_outline"] = 0xf11d0,
  ["md-cryengine"] = 0xf0959,
  ["md-crystal_ball"] = 0xf0b2f,
  ["md-cube"] = 0xf01a6,
  ["md-cube_off"] = 0xf141c,
  ["md-cube_off_outline"] = 0xf141d,
  ["md-cube_outline"] = 0xf01a7,
  ["md-cube_scan"] = 0xf0b84,
  ["md-cube_send"] = 0xf01a8,
  ["md-cube_unfolded"] = 0xf01a9,
  ["md-cup"] = 0xf01aa,
  ["md-cup_off"] = 0xf05e5,
  ["md-cup_off_outline"] = 0xf137d,
  ["md-cup_outline"] = 0xf130f,
  ["md-cup_water"] = 0xf01ab,
  ["md-cupboard"] = 0xf0f46,
  ["md-cupboard_outline"] = 0xf0f47,
  ["md-cupcake"] = 0xf095a,
  ["md-curling"] = 0xf0863,
  ["md-currency_bdt"] = 0xf0864,
  ["md-currency_brl"] = 0xf0b85,
  ["md-currency_btc"] = 0xf01ac,
  ["md-currency_cny"] = 0xf07ba,
  ["md-currency_eth"] = 0xf07bb,
  ["md-currency_eur"] = 0xf01ad,
  ["md-currency_eur_off"] = 0xf1315,
  ["md-currency_fra"] = 0xf1a39,
  ["md-currency_gbp"] = 0xf01ae,
  ["md-currency_ils"] = 0xf0c61,
  ["md-currency_inr"] = 0xf01af,
  ["md-currency_jpy"] = 0xf07bc,
  ["md-currency_krw"] = 0xf07bd,
  ["md-currency_kzt"] = 0xf0865,
  ["md-currency_mnt"] = 0xf1512,
  ["md-currency_ngn"] = 0xf01b0,
  ["md-currency_php"] = 0xf09e6,
  ["md-currency_rial"] = 0xf0e9c,
  ["md-currency_rub"] = 0xf01b1,
  ["md-currency_rupee"] = 0xf1976,
  ["md-currency_sign"] = 0xf07be,
  ["md-currency_try"] = 0xf01b2,
  ["md-currency_twd"] = 0xf07bf,
  ["md-currency_usd"] = 0xf01c1,
  ["md-currency_usd_off"] = 0xf067a,
  ["md-current_ac"] = 0xf1480,
  ["md-current_dc"] = 0xf095c,
  ["md-cursor_default"] = 0xf01c0,
  ["md-cursor_default_click"] = 0xf0cfd,
  ["md-cursor_default_click_outline"] = 0xf0cfe,
  ["md-cursor_default_gesture"] = 0xf1127,
  ["md-cursor_default_gesture_outline"] = 0xf1128,
  ["md-cursor_default_outline"] = 0xf01bf,
  ["md-cursor_move"] = 0xf01be,
  ["md-cursor_pointer"] = 0xf01bd,
  ["md-cursor_text"] = 0xf05e7,
  ["md-curtains"] = 0xf1846,
  ["md-curtains_closed"] = 0xf1847,
  ["md-cylinder"] = 0xf194e,
  ["md-cylinder_off"] = 0xf194f,
  ["md-dance_ballroom"] = 0xf15fb,
  ["md-dance_pole"] = 0xf1578,
  ["md-data_matrix"] = 0xf153c,
  ["md-data_matrix_edit"] = 0xf153d,
  ["md-data_matrix_minus"] = 0xf153e,
  ["md-data_matrix_plus"] = 0xf153f,
  ["md-data_matrix_remove"] = 0xf1540,
  ["md-data_matrix_scan"] = 0xf1541,
  ["md-database"] = 0xf01bc,
  ["md-database_alert"] = 0xf163a,
  ["md-database_alert_outline"] = 0xf1624,
  ["md-database_arrow_down"] = 0xf163b,
  ["md-database_arrow_down_outline"] = 0xf1625,
  ["md-database_arrow_left"] = 0xf163c,
  ["md-database_arrow_left_outline"] = 0xf1626,
  ["md-database_arrow_right"] = 0xf163d,
  ["md-database_arrow_right_outline"] = 0xf1627,
  ["md-database_arrow_up"] = 0xf163e,
  ["md-database_arrow_up_outline"] = 0xf1628,
  ["md-database_check"] = 0xf0aa9,
  ["md-database_check_outline"] = 0xf1629,
  ["md-database_clock"] = 0xf163f,
  ["md-database_clock_outline"] = 0xf162a,
  ["md-database_cog"] = 0xf164b,
  ["md-database_cog_outline"] = 0xf164c,
  ["md-database_edit"] = 0xf0b86,
  ["md-database_edit_outline"] = 0xf162b,
  ["md-database_export"] = 0xf095e,
  ["md-database_export_outline"] = 0xf162c,
  ["md-database_eye"] = 0xf191f,
  ["md-database_eye_off"] = 0xf1920,
  ["md-database_eye_off_outline"] = 0xf1921,
  ["md-database_eye_outline"] = 0xf1922,
  ["md-database_import"] = 0xf095d,
  ["md-database_import_outline"] = 0xf162d,
  ["md-database_lock"] = 0xf0aaa,
  ["md-database_lock_outline"] = 0xf162e,
  ["md-database_marker"] = 0xf12f6,
  ["md-database_marker_outline"] = 0xf162f,
  ["md-database_minus"] = 0xf01bb,
  ["md-database_minus_outline"] = 0xf1630,
  ["md-database_off"] = 0xf1640,
  ["md-database_off_outline"] = 0xf1631,
  ["md-database_outline"] = 0xf1632,
  ["md-database_plus"] = 0xf01ba,
  ["md-database_plus_outline"] = 0xf1633,
  ["md-database_refresh"] = 0xf05c2,
  ["md-database_refresh_outline"] = 0xf1634,
  ["md-database_remove"] = 0xf0d00,
  ["md-database_remove_outline"] = 0xf1635,
  ["md-database_search"] = 0xf0866,
  ["md-database_search_outline"] = 0xf1636,
  ["md-database_settings"] = 0xf0d01,
  ["md-database_settings_outline"] = 0xf1637,
  ["md-database_sync"] = 0xf0cff,
  ["md-database_sync_outline"] = 0xf1638,
  ["md-death_star"] = 0xf08d8,
  ["md-death_star_variant"] = 0xf08d9,
  ["md-deathly_hallows"] = 0xf0b87,
  ["md-debian"] = 0xf08da,
  ["md-debug_step_into"] = 0xf01b9,
  ["md-debug_step_out"] = 0xf01b8,
  ["md-debug_step_over"] = 0xf01b7,
  ["md-decagram"] = 0xf076c,
  ["md-decagram_outline"] = 0xf076d,
  ["md-decimal"] = 0xf10a1,
  ["md-decimal_comma"] = 0xf10a2,
  ["md-decimal_comma_decrease"] = 0xf10a3,
  ["md-decimal_comma_increase"] = 0xf10a4,
  ["md-decimal_decrease"] = 0xf01b6,
  ["md-decimal_increase"] = 0xf01b5,
  ["md-delete"] = 0xf01b4,
  ["md-delete_alert"] = 0xf10a5,
  ["md-delete_alert_outline"] = 0xf10a6,
  ["md-delete_circle"] = 0xf0683,
  ["md-delete_circle_outline"] = 0xf0b88,
  ["md-delete_clock"] = 0xf1556,
  ["md-delete_clock_outline"] = 0xf1557,
  ["md-delete_empty"] = 0xf06cc,
  ["md-delete_empty_outline"] = 0xf0e9d,
  ["md-delete_forever"] = 0xf05e8,
  ["md-delete_forever_outline"] = 0xf0b89,
  ["md-delete_off"] = 0xf10a7,
  ["md-delete_off_outline"] = 0xf10a8,
  ["md-delete_outline"] = 0xf09e7,
  ["md-delete_restore"] = 0xf0819,
  ["md-delete_sweep"] = 0xf05e9,
  ["md-delete_sweep_outline"] = 0xf0c62,
  ["md-delete_variant"] = 0xf01b3,
  ["md-delta"] = 0xf01c2,
  ["md-desk"] = 0xf1239,
  ["md-desk_lamp"] = 0xf095f,
  ["md-deskphone"] = 0xf01c3,
  ["md-desktop_classic"] = 0xf07c0,
  ["md-desktop_mac"] = 0xf01c4,
  ["md-desktop_mac_dashboard"] = 0xf09e8,
  ["md-desktop_tower"] = 0xf01c5,
  ["md-desktop_tower_monitor"] = 0xf0aab,
  ["md-details"] = 0xf01c6,
  ["md-dev_to"] = 0xf0d6e,
  ["md-developer_board"] = 0xf0697,
  ["md-deviantart"] = 0xf01c7,
  ["md-devices"] = 0xf0fb0,
  ["md-dharmachakra"] = 0xf094b,
  ["md-diabetes"] = 0xf1126,
  ["md-dialpad"] = 0xf061c,
  ["md-diameter"] = 0xf0c63,
  ["md-diameter_outline"] = 0xf0c64,
  ["md-diameter_variant"] = 0xf0c65,
  ["md-diamond"] = 0xf0b8a,
  ["md-diamond_outline"] = 0xf0b8b,
  ["md-diamond_stone"] = 0xf01c8,
  ["md-dice_1"] = 0xf01ca,
  ["md-dice_1_outline"] = 0xf114a,
  ["md-dice_2"] = 0xf01cb,
  ["md-dice_2_outline"] = 0xf114b,
  ["md-dice_3"] = 0xf01cc,
  ["md-dice_3_outline"] = 0xf114c,
  ["md-dice_4"] = 0xf01cd,
  ["md-dice_4_outline"] = 0xf114d,
  ["md-dice_5"] = 0xf01ce,
  ["md-dice_5_outline"] = 0xf114e,
  ["md-dice_6"] = 0xf01cf,
  ["md-dice_6_outline"] = 0xf114f,
  ["md-dice_d10"] = 0xf1153,
  ["md-dice_d10_outline"] = 0xf076f,
  ["md-dice_d12"] = 0xf1154,
  ["md-dice_d12_outline"] = 0xf0867,
  ["md-dice_d20"] = 0xf1155,
  ["md-dice_d20_outline"] = 0xf05ea,
  ["md-dice_d4"] = 0xf1150,
  ["md-dice_d4_outline"] = 0xf05eb,
  ["md-dice_d6"] = 0xf1151,
  ["md-dice_d6_outline"] = 0xf05ed,
  ["md-dice_d8"] = 0xf1152,
  ["md-dice_d8_outline"] = 0xf05ec,
  ["md-dice_multiple"] = 0xf076e,
  ["md-dice_multiple_outline"] = 0xf1156,
  ["md-digital_ocean"] = 0xf1237,
  ["md-dip_switch"] = 0xf07c1,
  ["md-directions"] = 0xf01d0,
  ["md-directions_fork"] = 0xf0641,
  ["md-disc"] = 0xf05ee,
  ["md-disc_alert"] = 0xf01d1,
  ["md-disc_player"] = 0xf0960,
  ["md-discord"] = 0xf066f,
  ["md-dishwasher"] = 0xf0aac,
  ["md-dishwasher_alert"] = 0xf11b8,
  ["md-dishwasher_off"] = 0xf11b9,
  ["md-disqus"] = 0xf01d2,
  ["md-distribute_horizontal_center"] = 0xf11c9,
  ["md-distribute_horizontal_left"] = 0xf11c8,
  ["md-distribute_horizontal_right"] = 0xf11ca,
  ["md-distribute_vertical_bottom"] = 0xf11cb,
  ["md-distribute_vertical_center"] = 0xf11cc,
  ["md-distribute_vertical_top"] = 0xf11cd,
  ["md-diversify"] = 0xf1877,
  ["md-diving"] = 0xf1977,
  ["md-diving_flippers"] = 0xf0dbf,
  ["md-diving_helmet"] = 0xf0dc0,
  ["md-diving_scuba"] = 0xf0dc1,
  ["md-diving_scuba_flag"] = 0xf0dc2,
  ["md-diving_scuba_tank"] = 0xf0dc3,
  ["md-diving_scuba_tank_multiple"] = 0xf0dc4,
  ["md-diving_snorkel"] = 0xf0dc5,
  ["md-division"] = 0xf01d4,
  ["md-division_box"] = 0xf01d5,
  ["md-dlna"] = 0xf0a41,
  ["md-dna"] = 0xf0684,
  ["md-dns"] = 0xf01d6,
  ["md-dns_outline"] = 0xf0b8c,
  ["md-dock_bottom"] = 0xf10a9,
  ["md-dock_left"] = 0xf10aa,
  ["md-dock_right"] = 0xf10ab,
  ["md-dock_top"] = 0xf1513,
  ["md-dock_window"] = 0xf10ac,
  ["md-docker"] = 0xf0868,
  ["md-doctor"] = 0xf0a42,
  ["md-dog"] = 0xf0a43,
  ["md-dog_service"] = 0xf0aad,
  ["md-dog_side"] = 0xf0a44,
  ["md-dog_side_off"] = 0xf16ee,
  ["md-dolby"] = 0xf06b3,
  ["md-dolly"] = 0xf0e9e,
  ["md-dolphin"] = 0xf18b4,
  ["md-domain"] = 0xf01d7,
  ["md-domain_off"] = 0xf0d6f,
  ["md-domain_plus"] = 0xf10ad,
  ["md-domain_remove"] = 0xf10ae,
  ["md-dome_light"] = 0xf141e,
  ["md-domino_mask"] = 0xf1023,
  ["md-donkey"] = 0xf07c2,
  ["md-door"] = 0xf081a,
  ["md-door_closed"] = 0xf081b,
  ["md-door_closed_lock"] = 0xf10af,
  ["md-door_open"] = 0xf081c,
  ["md-door_sliding"] = 0xf181e,
  ["md-door_sliding_lock"] = 0xf181f,
  ["md-door_sliding_open"] = 0xf1820,
  ["md-doorbell"] = 0xf12e6,
  ["md-doorbell_video"] = 0xf0869,
  ["md-dot_net"] = 0xf0aae,
  ["md-dots_circle"] = 0xf1978,
  ["md-dots_grid"] = 0xf15fc,
  ["md-dots_hexagon"] = 0xf15ff,
  ["md-dots_horizontal"] = 0xf01d8,
  ["md-dots_horizontal_circle"] = 0xf07c3,
  ["md-dots_horizontal_circle_outline"] = 0xf0b8d,
  ["md-dots_square"] = 0xf15fd,
  ["md-dots_triangle"] = 0xf15fe,
  ["md-dots_vertical"] = 0xf01d9,
  ["md-dots_vertical_circle"] = 0xf07c4,
  ["md-dots_vertical_circle_outline"] = 0xf0b8e,
  ["md-download"] = 0xf01da,
  ["md-download_box"] = 0xf1462,
  ["md-download_box_outline"] = 0xf1463,
  ["md-download_circle"] = 0xf1464,
  ["md-download_circle_outline"] = 0xf1465,
  ["md-download_lock"] = 0xf1320,
  ["md-download_lock_outline"] = 0xf1321,
  ["md-download_multiple"] = 0xf09e9,
  ["md-download_network"] = 0xf06f4,
  ["md-download_network_outline"] = 0xf0c66,
  ["md-download_off"] = 0xf10b0,
  ["md-download_off_outline"] = 0xf10b1,
  ["md-download_outline"] = 0xf0b8f,
  ["md-drag"] = 0xf01db,
  ["md-drag_horizontal"] = 0xf01dc,
  ["md-drag_horizontal_variant"] = 0xf12f0,
  ["md-drag_variant"] = 0xf0b90,
  ["md-drag_vertical"] = 0xf01dd,
  ["md-drag_vertical_variant"] = 0xf12f1,
  ["md-drama_masks"] = 0xf0d02,
  ["md-draw"] = 0xf0f49,
  ["md-draw_pen"] = 0xf19b9,
  ["md-drawing"] = 0xf01de,
  ["md-drawing_box"] = 0xf01df,
  ["md-dresser"] = 0xf0f4a,
  ["md-dresser_outline"] = 0xf0f4b,
  ["md-drone"] = 0xf01e2,
  ["md-dropbox"] = 0xf01e3,
  ["md-drupal"] = 0xf01e4,
  ["md-duck"] = 0xf01e5,
  ["md-dumbbell"] = 0xf01e6,
  ["md-dump_truck"] = 0xf0c67,
  ["md-ear_hearing"] = 0xf07c5,
  ["md-ear_hearing_loop"] = 0xf1aee,
  ["md-ear_hearing_off"] = 0xf0a45,
  ["md-earbuds"] = 0xf184f,
  ["md-earbuds_off"] = 0xf1850,
  ["md-earbuds_off_outline"] = 0xf1851,
  ["md-earbuds_outline"] = 0xf1852,
  ["md-earth"] = 0xf01e7,
  ["md-earth_arrow_right"] = 0xf1311,
  ["md-earth_box"] = 0xf06cd,
  ["md-earth_box_minus"] = 0xf1407,
  ["md-earth_box_off"] = 0xf06ce,
  ["md-earth_box_plus"] = 0xf1406,
  ["md-earth_box_remove"] = 0xf1408,
  ["md-earth_minus"] = 0xf1404,
  ["md-earth_off"] = 0xf01e8,
  ["md-earth_plus"] = 0xf1403,
  ["md-earth_remove"] = 0xf1405,
  ["md-egg"] = 0xf0aaf,
  ["md-egg_easter"] = 0xf0ab0,
  ["md-egg_fried"] = 0xf184a,
  ["md-egg_off"] = 0xf13f0,
  ["md-egg_off_outline"] = 0xf13f1,
  ["md-egg_outline"] = 0xf13f2,
  ["md-eiffel_tower"] = 0xf156b,
  ["md-eight_track"] = 0xf09ea,
  ["md-eject"] = 0xf01ea,
  ["md-eject_outline"] = 0xf0b91,
  ["md-electric_switch"] = 0xf0e9f,
  ["md-electric_switch_closed"] = 0xf10d9,
  ["md-electron_framework"] = 0xf1024,
  ["md-elephant"] = 0xf07c6,
  ["md-elevation_decline"] = 0xf01eb,
  ["md-elevation_rise"] = 0xf01ec,
  ["md-elevator"] = 0xf01ed,
  ["md-elevator_down"] = 0xf12c2,
  ["md-elevator_passenger"] = 0xf1381,
  ["md-elevator_passenger_off"] = 0xf1979,
  ["md-elevator_passenger_off_outline"] = 0xf197a,
  ["md-elevator_passenger_outline"] = 0xf197b,
  ["md-elevator_up"] = 0xf12c1,
  ["md-ellipse"] = 0xf0ea0,
  ["md-ellipse_outline"] = 0xf0ea1,
  ["md-email"] = 0xf01ee,
  ["md-email_alert"] = 0xf06cf,
  ["md-email_alert_outline"] = 0xf0d42,
  ["md-email_box"] = 0xf0d03,
  ["md-email_check"] = 0xf0ab1,
  ["md-email_check_outline"] = 0xf0ab2,
  ["md-email_edit"] = 0xf0ee3,
  ["md-email_edit_outline"] = 0xf0ee4,
  ["md-email_fast"] = 0xf186f,
  ["md-email_fast_outline"] = 0xf1870,
  ["md-email_lock"] = 0xf01f1,
  ["md-email_mark_as_unread"] = 0xf0b92,
  ["md-email_minus"] = 0xf0ee5,
  ["md-email_minus_outline"] = 0xf0ee6,
  ["md-email_multiple"] = 0xf0ee7,
  ["md-email_multiple_outline"] = 0xf0ee8,
  ["md-email_newsletter"] = 0xf0fb1,
  ["md-email_off"] = 0xf13e3,
  ["md-email_off_outline"] = 0xf13e4,
  ["md-email_open"] = 0xf01ef,
  ["md-email_open_multiple"] = 0xf0ee9,
  ["md-email_open_multiple_outline"] = 0xf0eea,
  ["md-email_open_outline"] = 0xf05ef,
  ["md-email_outline"] = 0xf01f0,
  ["md-email_plus"] = 0xf09eb,
  ["md-email_plus_outline"] = 0xf09ec,
  ["md-email_receive"] = 0xf10da,
  ["md-email_receive_outline"] = 0xf10db,
  ["md-email_remove"] = 0xf1661,
  ["md-email_remove_outline"] = 0xf1662,
  ["md-email_seal"] = 0xf195b,
  ["md-email_seal_outline"] = 0xf195c,
  ["md-email_search"] = 0xf0961,
  ["md-email_search_outline"] = 0xf0962,
  ["md-email_send"] = 0xf10dc,
  ["md-email_send_outline"] = 0xf10dd,
  ["md-email_sync"] = 0xf12c7,
  ["md-email_sync_outline"] = 0xf12c8,
  ["md-email_variant"] = 0xf05f0,
  ["md-ember"] = 0xf0b30,
  ["md-emby"] = 0xf06b4,
  ["md-emoticon"] = 0xf0c68,
  ["md-emoticon_angry"] = 0xf0c69,
  ["md-emoticon_angry_outline"] = 0xf0c6a,
  ["md-emoticon_confused"] = 0xf10de,
  ["md-emoticon_confused_outline"] = 0xf10df,
  ["md-emoticon_cool"] = 0xf0c6b,
  ["md-emoticon_cool_outline"] = 0xf01f3,
  ["md-emoticon_cry"] = 0xf0c6c,
  ["md-emoticon_cry_outline"] = 0xf0c6d,
  ["md-emoticon_dead"] = 0xf0c6e,
  ["md-emoticon_dead_outline"] = 0xf069b,
  ["md-emoticon_devil"] = 0xf0c6f,
  ["md-emoticon_devil_outline"] = 0xf01f4,
  ["md-emoticon_excited"] = 0xf0c70,
  ["md-emoticon_excited_outline"] = 0xf069c,
  ["md-emoticon_frown"] = 0xf0f4c,
  ["md-emoticon_frown_outline"] = 0xf0f4d,
  ["md-emoticon_happy"] = 0xf0c71,
  ["md-emoticon_happy_outline"] = 0xf01f5,
  ["md-emoticon_kiss"] = 0xf0c72,
  ["md-emoticon_kiss_outline"] = 0xf0c73,
  ["md-emoticon_lol"] = 0xf1214,
  ["md-emoticon_lol_outline"] = 0xf1215,
  ["md-emoticon_neutral"] = 0xf0c74,
  ["md-emoticon_neutral_outline"] = 0xf01f6,
  ["md-emoticon_outline"] = 0xf01f2,
  ["md-emoticon_poop"] = 0xf01f7,
  ["md-emoticon_poop_outline"] = 0xf0c75,
  ["md-emoticon_sad"] = 0xf0c76,
  ["md-emoticon_sad_outline"] = 0xf01f8,
  ["md-emoticon_sick"] = 0xf157c,
  ["md-emoticon_sick_outline"] = 0xf157d,
  ["md-emoticon_tongue"] = 0xf01f9,
  ["md-emoticon_tongue_outline"] = 0xf0c77,
  ["md-emoticon_wink"] = 0xf0c78,
  ["md-emoticon_wink_outline"] = 0xf0c79,
  ["md-engine"] = 0xf01fa,
  ["md-engine_off"] = 0xf0a46,
  ["md-engine_off_outline"] = 0xf0a47,
  ["md-engine_outline"] = 0xf01fb,
  ["md-epsilon"] = 0xf10e0,
  ["md-equal"] = 0xf01fc,
  ["md-equal_box"] = 0xf01fd,
  ["md-equalizer"] = 0xf0ea2,
  ["md-equalizer_outline"] = 0xf0ea3,
  ["md-eraser"] = 0xf01fe,
  ["md-eraser_variant"] = 0xf0642,
  ["md-escalator"] = 0xf01ff,
  ["md-escalator_box"] = 0xf1399,
  ["md-escalator_down"] = 0xf12c0,
  ["md-escalator_up"] = 0xf12bf,
  ["md-eslint"] = 0xf0c7a,
  ["md-et"] = 0xf0ab3,
  ["md-ethereum"] = 0xf086a,
  ["md-ethernet"] = 0xf0200,
  ["md-ethernet_cable"] = 0xf0201,
  ["md-ethernet_cable_off"] = 0xf0202,
  ["md-ev_plug_ccs1"] = 0xf1519,
  ["md-ev_plug_ccs2"] = 0xf151a,
  ["md-ev_plug_chademo"] = 0xf151b,
  ["md-ev_plug_tesla"] = 0xf151c,
  ["md-ev_plug_type1"] = 0xf151d,
  ["md-ev_plug_type2"] = 0xf151e,
  ["md-ev_station"] = 0xf05f1,
  ["md-evernote"] = 0xf0204,
  ["md-excavator"] = 0xf1025,
  ["md-exclamation"] = 0xf0205,
  ["md-exclamation_thick"] = 0xf1238,
  ["md-exit_run"] = 0xf0a48,
  ["md-exit_to_app"] = 0xf05fc,
  ["md-expand_all"] = 0xf0ab4,
  ["md-expand_all_outline"] = 0xf0ab5,
  ["md-expansion_card"] = 0xf08ae,
  ["md-expansion_card_variant"] = 0xf0fb2,
  ["md-exponent"] = 0xf0963,
  ["md-exponent_box"] = 0xf0964,
  ["md-export"] = 0xf0207,
  ["md-export_variant"] = 0xf0b93,
  ["md-eye"] = 0xf0208,
  ["md-eye_arrow_left"] = 0xf18fd,
  ["md-eye_arrow_left_outline"] = 0xf18fe,
  ["md-eye_arrow_right"] = 0xf18ff,
  ["md-eye_arrow_right_outline"] = 0xf1900,
  ["md-eye_check"] = 0xf0d04,
  ["md-eye_check_outline"] = 0xf0d05,
  ["md-eye_circle"] = 0xf0b94,
  ["md-eye_circle_outline"] = 0xf0b95,
  ["md-eye_minus"] = 0xf1026,
  ["md-eye_minus_outline"] = 0xf1027,
  ["md-eye_off"] = 0xf0209,
  ["md-eye_off_outline"] = 0xf06d1,
  ["md-eye_outline"] = 0xf06d0,
  ["md-eye_plus"] = 0xf086b,
  ["md-eye_plus_outline"] = 0xf086c,
  ["md-eye_refresh"] = 0xf197c,
  ["md-eye_refresh_outline"] = 0xf197d,
  ["md-eye_remove"] = 0xf15e3,
  ["md-eye_remove_outline"] = 0xf15e4,
  ["md-eye_settings"] = 0xf086d,
  ["md-eye_settings_outline"] = 0xf086e,
  ["md-eyedropper"] = 0xf020a,
  ["md-eyedropper_minus"] = 0xf13dd,
  ["md-eyedropper_off"] = 0xf13df,
  ["md-eyedropper_plus"] = 0xf13dc,
  ["md-eyedropper_remove"] = 0xf13de,
  ["md-eyedropper_variant"] = 0xf020b,
  ["md-face_agent"] = 0xf0d70,
  ["md-face_man"] = 0xf0643,
  ["md-face_man_outline"] = 0xf0b96,
  ["md-face_man_profile"] = 0xf0644,
  ["md-face_man_shimmer"] = 0xf15cc,
  ["md-face_man_shimmer_outline"] = 0xf15cd,
  ["md-face_mask"] = 0xf1586,
  ["md-face_mask_outline"] = 0xf1587,
  ["md-face_recognition"] = 0xf0c7b,
  ["md-face_woman"] = 0xf1077,
  ["md-face_woman_outline"] = 0xf1078,
  ["md-face_woman_profile"] = 0xf1076,
  ["md-face_woman_shimmer"] = 0xf15ce,
  ["md-face_woman_shimmer_outline"] = 0xf15cf,
  ["md-facebook"] = 0xf020c,
  ["md-facebook_gaming"] = 0xf07dd,
  ["md-facebook_messenger"] = 0xf020e,
  ["md-facebook_workplace"] = 0xf0b31,
  ["md-factory"] = 0xf020f,
  ["md-family_tree"] = 0xf160e,
  ["md-fan"] = 0xf0210,
  ["md-fan_alert"] = 0xf146c,
  ["md-fan_auto"] = 0xf171d,
  ["md-fan_chevron_down"] = 0xf146d,
  ["md-fan_chevron_up"] = 0xf146e,
  ["md-fan_clock"] = 0xf1a3a,
  ["md-fan_minus"] = 0xf1470,
  ["md-fan_off"] = 0xf081d,
  ["md-fan_plus"] = 0xf146f,
  ["md-fan_remove"] = 0xf1471,
  ["md-fan_speed_1"] = 0xf1472,
  ["md-fan_speed_2"] = 0xf1473,
  ["md-fan_speed_3"] = 0xf1474,
  ["md-fast_forward"] = 0xf0211,
  ["md-fast_forward_10"] = 0xf0d71,
  ["md-fast_forward_15"] = 0xf193a,
  ["md-fast_forward_30"] = 0xf0d06,
  ["md-fast_forward_5"] = 0xf11f8,
  ["md-fast_forward_60"] = 0xf160b,
  ["md-fast_forward_outline"] = 0xf06d2,
  ["md-fax"] = 0xf0212,
  ["md-feather"] = 0xf06d3,
  ["md-feature_search"] = 0xf0a49,
  ["md-feature_search_outline"] = 0xf0a4a,
  ["md-fedora"] = 0xf08db,
  ["md-fence"] = 0xf179a,
  ["md-fence_electric"] = 0xf17f6,
  ["md-fencing"] = 0xf14c1,
  ["md-ferris_wheel"] = 0xf0ea4,
  ["md-ferry"] = 0xf0213,
  ["md-file"] = 0xf0214,
  ["md-file_account"] = 0xf073b,
  ["md-file_account_outline"] = 0xf1028,
  ["md-file_alert"] = 0xf0a4b,
  ["md-file_alert_outline"] = 0xf0a4c,
  ["md-file_arrow_left_right"] = 0xf1a93,
  ["md-file_arrow_left_right_outline"] = 0xf1a94,
  ["md-file_arrow_up_down"] = 0xf1a95,
  ["md-file_arrow_up_down_outline"] = 0xf1a96,
  ["md-file_cabinet"] = 0xf0ab6,
  ["md-file_cad"] = 0xf0eeb,
  ["md-file_cad_box"] = 0xf0eec,
  ["md-file_cancel"] = 0xf0dc6,
  ["md-file_cancel_outline"] = 0xf0dc7,
  ["md-file_certificate"] = 0xf1186,
  ["md-file_certificate_outline"] = 0xf1187,
  ["md-file_chart"] = 0xf0215,
  ["md-file_chart_check"] = 0xf19c6,
  ["md-file_chart_check_outline"] = 0xf19c7,
  ["md-file_chart_outline"] = 0xf1029,
  ["md-file_check"] = 0xf0216,
  ["md-file_check_outline"] = 0xf0e29,
  ["md-file_clock"] = 0xf12e1,
  ["md-file_clock_outline"] = 0xf12e2,
  ["md-file_cloud"] = 0xf0217,
  ["md-file_cloud_outline"] = 0xf102a,
  ["md-file_code"] = 0xf022e,
  ["md-file_code_outline"] = 0xf102b,
  ["md-file_cog"] = 0xf107b,
  ["md-file_cog_outline"] = 0xf107c,
  ["md-file_compare"] = 0xf08aa,
  ["md-file_delimited"] = 0xf0218,
  ["md-file_delimited_outline"] = 0xf0ea5,
  ["md-file_document"] = 0xf0219,
  ["md-file_document_alert"] = 0xf1a97,
  ["md-file_document_alert_outline"] = 0xf1a98,
  ["md-file_document_check"] = 0xf1a99,
  ["md-file_document_check_outline"] = 0xf1a9a,
  ["md-file_document_edit"] = 0xf0dc8,
  ["md-file_document_edit_outline"] = 0xf0dc9,
  ["md-file_document_minus"] = 0xf1a9b,
  ["md-file_document_minus_outline"] = 0xf1a9c,
  ["md-file_document_multiple"] = 0xf1517,
  ["md-file_document_multiple_outline"] = 0xf1518,
  ["md-file_document_outline"] = 0xf09ee,
  ["md-file_document_plus"] = 0xf1a9d,
  ["md-file_document_plus_outline"] = 0xf1a9e,
  ["md-file_document_remove"] = 0xf1a9f,
  ["md-file_document_remove_outline"] = 0xf1aa0,
  ["md-file_download"] = 0xf0965,
  ["md-file_download_outline"] = 0xf0966,
  ["md-file_edit"] = 0xf11e7,
  ["md-file_edit_outline"] = 0xf11e8,
  ["md-file_excel"] = 0xf021b,
  ["md-file_excel_box"] = 0xf021c,
  ["md-file_excel_box_outline"] = 0xf102c,
  ["md-file_excel_outline"] = 0xf102d,
  ["md-file_export"] = 0xf021d,
  ["md-file_export_outline"] = 0xf102e,
  ["md-file_eye"] = 0xf0dca,
  ["md-file_eye_outline"] = 0xf0dcb,
  ["md-file_find"] = 0xf021e,
  ["md-file_find_outline"] = 0xf0b97,
  ["md-file_gif_box"] = 0xf0d78,
  ["md-file_hidden"] = 0xf0613,
  ["md-file_image"] = 0xf021f,
  ["md-file_image_marker"] = 0xf1772,
  ["md-file_image_marker_outline"] = 0xf1773,
  ["md-file_image_minus"] = 0xf193b,
  ["md-file_image_minus_outline"] = 0xf193c,
  ["md-file_image_outline"] = 0xf0eb0,
  ["md-file_image_plus"] = 0xf193d,
  ["md-file_image_plus_outline"] = 0xf193e,
  ["md-file_image_remove"] = 0xf193f,
  ["md-file_image_remove_outline"] = 0xf1940,
  ["md-file_import"] = 0xf0220,
  ["md-file_import_outline"] = 0xf102f,
  ["md-file_jpg_box"] = 0xf0225,
  ["md-file_key"] = 0xf1184,
  ["md-file_key_outline"] = 0xf1185,
  ["md-file_link"] = 0xf1177,
  ["md-file_link_outline"] = 0xf1178,
  ["md-file_lock"] = 0xf0221,
  ["md-file_lock_open"] = 0xf19c8,
  ["md-file_lock_open_outline"] = 0xf19c9,
  ["md-file_lock_outline"] = 0xf1030,
  ["md-file_marker"] = 0xf1774,
  ["md-file_marker_outline"] = 0xf1775,
  ["md-file_minus"] = 0xf1aa1,
  ["md-file_minus_outline"] = 0xf1aa2,
  ["md-file_move"] = 0xf0ab9,
  ["md-file_move_outline"] = 0xf1031,
  ["md-file_multiple"] = 0xf0222,
  ["md-file_multiple_outline"] = 0xf1032,
  ["md-file_music"] = 0xf0223,
  ["md-file_music_outline"] = 0xf0e2a,
  ["md-file_outline"] = 0xf0224,
  ["md-file_pdf_box"] = 0xf0226,
  ["md-file_percent"] = 0xf081e,
  ["md-file_percent_outline"] = 0xf1033,
  ["md-file_phone"] = 0xf1179,
  ["md-file_phone_outline"] = 0xf117a,
  ["md-file_plus"] = 0xf0752,
  ["md-file_plus_outline"] = 0xf0eed,
  ["md-file_png_box"] = 0xf0e2d,
  ["md-file_powerpoint"] = 0xf0227,
  ["md-file_powerpoint_box"] = 0xf0228,
  ["md-file_powerpoint_box_outline"] = 0xf1034,
  ["md-file_powerpoint_outline"] = 0xf1035,
  ["md-file_presentation_box"] = 0xf0229,
  ["md-file_question"] = 0xf086f,
  ["md-file_question_outline"] = 0xf1036,
  ["md-file_refresh"] = 0xf0918,
  ["md-file_refresh_outline"] = 0xf0541,
  ["md-file_remove"] = 0xf0b98,
  ["md-file_remove_outline"] = 0xf1037,
  ["md-file_replace"] = 0xf0b32,
  ["md-file_replace_outline"] = 0xf0b33,
  ["md-file_restore"] = 0xf0670,
  ["md-file_restore_outline"] = 0xf1038,
  ["md-file_rotate_left"] = 0xf1a3b,
  ["md-file_rotate_left_outline"] = 0xf1a3c,
  ["md-file_rotate_right"] = 0xf1a3d,
  ["md-file_rotate_right_outline"] = 0xf1a3e,
  ["md-file_search"] = 0xf0c7c,
  ["md-file_search_outline"] = 0xf0c7d,
  ["md-file_send"] = 0xf022a,
  ["md-file_send_outline"] = 0xf1039,
  ["md-file_settings"] = 0xf1079,
  ["md-file_settings_outline"] = 0xf107a,
  ["md-file_sign"] = 0xf19c3,
  ["md-file_star"] = 0xf103a,
  ["md-file_star_outline"] = 0xf103b,
  ["md-file_swap"] = 0xf0fb4,
  ["md-file_swap_outline"] = 0xf0fb5,
  ["md-file_sync"] = 0xf1216,
  ["md-file_sync_outline"] = 0xf1217,
  ["md-file_table"] = 0xf0c7e,
  ["md-file_table_box"] = 0xf10e1,
  ["md-file_table_box_multiple"] = 0xf10e2,
  ["md-file_table_box_multiple_outline"] = 0xf10e3,
  ["md-file_table_box_outline"] = 0xf10e4,
  ["md-file_table_outline"] = 0xf0c7f,
  ["md-file_tree"] = 0xf0645,
  ["md-file_tree_outline"] = 0xf13d2,
  ["md-file_undo"] = 0xf08dc,
  ["md-file_undo_outline"] = 0xf103c,
  ["md-file_upload"] = 0xf0a4d,
  ["md-file_upload_outline"] = 0xf0a4e,
  ["md-file_video"] = 0xf022b,
  ["md-file_video_outline"] = 0xf0e2c,
  ["md-file_word"] = 0xf022c,
  ["md-file_word_box"] = 0xf022d,
  ["md-file_word_box_outline"] = 0xf103d,
  ["md-file_word_outline"] = 0xf103e,
  ["md-film"] = 0xf022f,
  ["md-filmstrip"] = 0xf0230,
  ["md-filmstrip_box"] = 0xf0332,
  ["md-filmstrip_box_multiple"] = 0xf0d18,
  ["md-filmstrip_off"] = 0xf0231,
  ["md-filter"] = 0xf0232,
  ["md-filter_check"] = 0xf18ec,
  ["md-filter_check_outline"] = 0xf18ed,
  ["md-filter_cog"] = 0xf1aa3,
  ["md-filter_cog_outline"] = 0xf1aa4,
  ["md-filter_menu"] = 0xf10e5,
  ["md-filter_menu_outline"] = 0xf10e6,
  ["md-filter_minus"] = 0xf0eee,
  ["md-filter_minus_outline"] = 0xf0eef,
  ["md-filter_multiple"] = 0xf1a3f,
  ["md-filter_multiple_outline"] = 0xf1a40,
  ["md-filter_off"] = 0xf14ef,
  ["md-filter_off_outline"] = 0xf14f0,
  ["md-filter_outline"] = 0xf0233,
  ["md-filter_plus"] = 0xf0ef0,
  ["md-filter_plus_outline"] = 0xf0ef1,
  ["md-filter_remove"] = 0xf0234,
  ["md-filter_remove_outline"] = 0xf0235,
  ["md-filter_settings"] = 0xf1aa5,
  ["md-filter_settings_outline"] = 0xf1aa6,
  ["md-filter_variant"] = 0xf0236,
  ["md-filter_variant_minus"] = 0xf1112,
  ["md-filter_variant_plus"] = 0xf1113,
  ["md-filter_variant_remove"] = 0xf103f,
  ["md-finance"] = 0xf081f,
  ["md-find_replace"] = 0xf06d4,
  ["md-fingerprint"] = 0xf0237,
  ["md-fingerprint_off"] = 0xf0eb1,
  ["md-fire"] = 0xf0238,
  ["md-fire_alert"] = 0xf15d7,
  ["md-fire_circle"] = 0xf1807,
  ["md-fire_extinguisher"] = 0xf0ef2,
  ["md-fire_hydrant"] = 0xf1137,
  ["md-fire_hydrant_alert"] = 0xf1138,
  ["md-fire_hydrant_off"] = 0xf1139,
  ["md-fire_off"] = 0xf1722,
  ["md-fire_truck"] = 0xf08ab,
  ["md-firebase"] = 0xf0967,
  ["md-firefox"] = 0xf0239,
  ["md-fireplace"] = 0xf0e2e,
  ["md-fireplace_off"] = 0xf0e2f,
  ["md-firewire"] = 0xf05be,
  ["md-firework"] = 0xf0e30,
  ["md-firework_off"] = 0xf1723,
  ["md-fish"] = 0xf023a,
  ["md-fish_off"] = 0xf13f3,
  ["md-fishbowl"] = 0xf0ef3,
  ["md-fishbowl_outline"] = 0xf0ef4,
  ["md-fit_to_page"] = 0xf0ef5,
  ["md-fit_to_page_outline"] = 0xf0ef6,
  ["md-fit_to_screen"] = 0xf18f4,
  ["md-fit_to_screen_outline"] = 0xf18f5,
  ["md-flag"] = 0xf023b,
  ["md-flag_checkered"] = 0xf023c,
  ["md-flag_minus"] = 0xf0b99,
  ["md-flag_minus_outline"] = 0xf10b2,
  ["md-flag_off"] = 0xf18ee,
  ["md-flag_off_outline"] = 0xf18ef,
  ["md-flag_outline"] = 0xf023d,
  ["md-flag_plus"] = 0xf0b9a,
  ["md-flag_plus_outline"] = 0xf10b3,
  ["md-flag_remove"] = 0xf0b9b,
  ["md-flag_remove_outline"] = 0xf10b4,
  ["md-flag_triangle"] = 0xf023f,
  ["md-flag_variant"] = 0xf0240,
  ["md-flag_variant_outline"] = 0xf023e,
  ["md-flare"] = 0xf0d72,
  ["md-flash"] = 0xf0241,
  ["md-flash_alert"] = 0xf0ef7,
  ["md-flash_alert_outline"] = 0xf0ef8,
  ["md-flash_auto"] = 0xf0242,
  ["md-flash_off"] = 0xf0243,
  ["md-flash_outline"] = 0xf06d5,
  ["md-flash_red_eye"] = 0xf067b,
  ["md-flashlight"] = 0xf0244,
  ["md-flashlight_off"] = 0xf0245,
  ["md-flask"] = 0xf0093,
  ["md-flask_empty"] = 0xf0094,
  ["md-flask_empty_minus"] = 0xf123a,
  ["md-flask_empty_minus_outline"] = 0xf123b,
  ["md-flask_empty_off"] = 0xf13f4,
  ["md-flask_empty_off_outline"] = 0xf13f5,
  ["md-flask_empty_outline"] = 0xf0095,
  ["md-flask_empty_plus"] = 0xf123c,
  ["md-flask_empty_plus_outline"] = 0xf123d,
  ["md-flask_empty_remove"] = 0xf123e,
  ["md-flask_empty_remove_outline"] = 0xf123f,
  ["md-flask_minus"] = 0xf1240,
  ["md-flask_minus_outline"] = 0xf1241,
  ["md-flask_off"] = 0xf13f6,
  ["md-flask_off_outline"] = 0xf13f7,
  ["md-flask_outline"] = 0xf0096,
  ["md-flask_plus"] = 0xf1242,
  ["md-flask_plus_outline"] = 0xf1243,
  ["md-flask_remove"] = 0xf1244,
  ["md-flask_remove_outline"] = 0xf1245,
  ["md-flask_round_bottom"] = 0xf124b,
  ["md-flask_round_bottom_empty"] = 0xf124c,
  ["md-flask_round_bottom_empty_outline"] = 0xf124d,
  ["md-flask_round_bottom_outline"] = 0xf124e,
  ["md-fleur_de_lis"] = 0xf1303,
  ["md-flip_horizontal"] = 0xf10e7,
  ["md-flip_to_back"] = 0xf0247,
  ["md-flip_to_front"] = 0xf0248,
  ["md-flip_vertical"] = 0xf10e8,
  ["md-floor_lamp"] = 0xf08dd,
  ["md-floor_lamp_dual"] = 0xf1040,
  ["md-floor_lamp_dual_outline"] = 0xf17ce,
  ["md-floor_lamp_outline"] = 0xf17c8,
  ["md-floor_lamp_torchiere"] = 0xf1747,
  ["md-floor_lamp_torchiere_outline"] = 0xf17d6,
  ["md-floor_lamp_torchiere_variant"] = 0xf1041,
  ["md-floor_lamp_torchiere_variant_outline"] = 0xf17cf,
  ["md-floor_plan"] = 0xf0821,
  ["md-floppy"] = 0xf0249,
  ["md-floppy_variant"] = 0xf09ef,
  ["md-flower"] = 0xf024a,
  ["md-flower_outline"] = 0xf09f0,
  ["md-flower_pollen"] = 0xf1885,
  ["md-flower_pollen_outline"] = 0xf1886,
  ["md-flower_poppy"] = 0xf0d08,
  ["md-flower_tulip"] = 0xf09f1,
  ["md-flower_tulip_outline"] = 0xf09f2,
  ["md-focus_auto"] = 0xf0f4e,
  ["md-focus_field"] = 0xf0f4f,
  ["md-focus_field_horizontal"] = 0xf0f50,
  ["md-focus_field_vertical"] = 0xf0f51,
  ["md-folder"] = 0xf024b,
  ["md-folder_account"] = 0xf024c,
  ["md-folder_account_outline"] = 0xf0b9c,
  ["md-folder_alert"] = 0xf0dcc,
  ["md-folder_alert_outline"] = 0xf0dcd,
  ["md-folder_arrow_down"] = 0xf19e8,
  ["md-folder_arrow_down_outline"] = 0xf19e9,
  ["md-folder_arrow_left"] = 0xf19ea,
  ["md-folder_arrow_left_outline"] = 0xf19eb,
  ["md-folder_arrow_left_right"] = 0xf19ec,
  ["md-folder_arrow_left_right_outline"] = 0xf19ed,
  ["md-folder_arrow_right"] = 0xf19ee,
  ["md-folder_arrow_right_outline"] = 0xf19ef,
  ["md-folder_arrow_up"] = 0xf19f0,
  ["md-folder_arrow_up_down"] = 0xf19f1,
  ["md-folder_arrow_up_down_outline"] = 0xf19f2,
  ["md-folder_arrow_up_outline"] = 0xf19f3,
  ["md-folder_cancel"] = 0xf19f4,
  ["md-folder_cancel_outline"] = 0xf19f5,
  ["md-folder_check"] = 0xf197e,
  ["md-folder_check_outline"] = 0xf197f,
  ["md-folder_clock"] = 0xf0aba,
  ["md-folder_clock_outline"] = 0xf0abb,
  ["md-folder_cog"] = 0xf107f,
  ["md-folder_cog_outline"] = 0xf1080,
  ["md-folder_download"] = 0xf024d,
  ["md-folder_download_outline"] = 0xf10e9,
  ["md-folder_edit"] = 0xf08de,
  ["md-folder_edit_outline"] = 0xf0dce,
  ["md-folder_eye"] = 0xf178a,
  ["md-folder_eye_outline"] = 0xf178b,
  ["md-folder_file"] = 0xf19f6,
  ["md-folder_file_outline"] = 0xf19f7,
  ["md-folder_google_drive"] = 0xf024e,
  ["md-folder_heart"] = 0xf10ea,
  ["md-folder_heart_outline"] = 0xf10eb,
  ["md-folder_hidden"] = 0xf179e,
  ["md-folder_home"] = 0xf10b5,
  ["md-folder_home_outline"] = 0xf10b6,
  ["md-folder_image"] = 0xf024f,
  ["md-folder_information"] = 0xf10b7,
  ["md-folder_information_outline"] = 0xf10b8,
  ["md-folder_key"] = 0xf08ac,
  ["md-folder_key_network"] = 0xf08ad,
  ["md-folder_key_network_outline"] = 0xf0c80,
  ["md-folder_key_outline"] = 0xf10ec,
  ["md-folder_lock"] = 0xf0250,
  ["md-folder_lock_open"] = 0xf0251,
  ["md-folder_lock_open_outline"] = 0xf1aa7,
  ["md-folder_lock_outline"] = 0xf1aa8,
  ["md-folder_marker"] = 0xf126d,
  ["md-folder_marker_outline"] = 0xf126e,
  ["md-folder_move"] = 0xf0252,
  ["md-folder_move_outline"] = 0xf1246,
  ["md-folder_multiple"] = 0xf0253,
  ["md-folder_multiple_image"] = 0xf0254,
  ["md-folder_multiple_outline"] = 0xf0255,
  ["md-folder_multiple_plus"] = 0xf147e,
  ["md-folder_multiple_plus_outline"] = 0xf147f,
  ["md-folder_music"] = 0xf1359,
  ["md-folder_music_outline"] = 0xf135a,
  ["md-folder_network"] = 0xf0870,
  ["md-folder_network_outline"] = 0xf0c81,
  ["md-folder_off"] = 0xf19f8,
  ["md-folder_off_outline"] = 0xf19f9,
  ["md-folder_open"] = 0xf0770,
  ["md-folder_open_outline"] = 0xf0dcf,
  ["md-folder_outline"] = 0xf0256,
  ["md-folder_play"] = 0xf19fa,
  ["md-folder_play_outline"] = 0xf19fb,
  ["md-folder_plus"] = 0xf0257,
  ["md-folder_plus_outline"] = 0xf0b9d,
  ["md-folder_pound"] = 0xf0d09,
  ["md-folder_pound_outline"] = 0xf0d0a,
  ["md-folder_question"] = 0xf19ca,
  ["md-folder_question_outline"] = 0xf19cb,
  ["md-folder_refresh"] = 0xf0749,
  ["md-folder_refresh_outline"] = 0xf0542,
  ["md-folder_remove"] = 0xf0258,
  ["md-folder_remove_outline"] = 0xf0b9e,
  ["md-folder_search"] = 0xf0968,
  ["md-folder_search_outline"] = 0xf0969,
  ["md-folder_settings"] = 0xf107d,
  ["md-folder_settings_outline"] = 0xf107e,
  ["md-folder_star"] = 0xf069d,
  ["md-folder_star_multiple"] = 0xf13d3,
  ["md-folder_star_multiple_outline"] = 0xf13d4,
  ["md-folder_star_outline"] = 0xf0b9f,
  ["md-folder_swap"] = 0xf0fb6,
  ["md-folder_swap_outline"] = 0xf0fb7,
  ["md-folder_sync"] = 0xf0d0b,
  ["md-folder_sync_outline"] = 0xf0d0c,
  ["md-folder_table"] = 0xf12e3,
  ["md-folder_table_outline"] = 0xf12e4,
  ["md-folder_text"] = 0xf0c82,
  ["md-folder_text_outline"] = 0xf0c83,
  ["md-folder_upload"] = 0xf0259,
  ["md-folder_upload_outline"] = 0xf10ed,
  ["md-folder_wrench"] = 0xf19fc,
  ["md-folder_wrench_outline"] = 0xf19fd,
  ["md-folder_zip"] = 0xf06eb,
  ["md-folder_zip_outline"] = 0xf07b9,
  ["md-font_awesome"] = 0xf003a,
  ["md-food"] = 0xf025a,
  ["md-food_apple"] = 0xf025b,
  ["md-food_apple_outline"] = 0xf0c84,
  ["md-food_croissant"] = 0xf07c8,
  ["md-food_drumstick"] = 0xf141f,
  ["md-food_drumstick_off"] = 0xf1468,
  ["md-food_drumstick_off_outline"] = 0xf1469,
  ["md-food_drumstick_outline"] = 0xf1420,
  ["md-food_fork_drink"] = 0xf05f2,
  ["md-food_halal"] = 0xf1572,
  ["md-food_hot_dog"] = 0xf184b,
  ["md-food_kosher"] = 0xf1573,
  ["md-food_off"] = 0xf05f3,
  ["md-food_off_outline"] = 0xf1915,
  ["md-food_outline"] = 0xf1916,
  ["md-food_steak"] = 0xf146a,
  ["md-food_steak_off"] = 0xf146b,
  ["md-food_takeout_box"] = 0xf1836,
  ["md-food_takeout_box_outline"] = 0xf1837,
  ["md-food_turkey"] = 0xf171c,
  ["md-food_variant"] = 0xf025c,
  ["md-food_variant_off"] = 0xf13e5,
  ["md-foot_print"] = 0xf0f52,
  ["md-football"] = 0xf025d,
  ["md-football_australian"] = 0xf025e,
  ["md-football_helmet"] = 0xf025f,
  ["md-forest"] = 0xf1897,
  ["md-forklift"] = 0xf07c9,
  ["md-form_dropdown"] = 0xf1400,
  ["md-form_select"] = 0xf1401,
  ["md-form_textarea"] = 0xf1095,
  ["md-form_textbox"] = 0xf060e,
  ["md-form_textbox_lock"] = 0xf135d,
  ["md-form_textbox_password"] = 0xf07f5,
  ["md-format_align_bottom"] = 0xf0753,
  ["md-format_align_center"] = 0xf0260,
  ["md-format_align_justify"] = 0xf0261,
  ["md-format_align_left"] = 0xf0262,
  ["md-format_align_middle"] = 0xf0754,
  ["md-format_align_right"] = 0xf0263,
  ["md-format_align_top"] = 0xf0755,
  ["md-format_annotation_minus"] = 0xf0abc,
  ["md-format_annotation_plus"] = 0xf0646,
  ["md-format_bold"] = 0xf0264,
  ["md-format_clear"] = 0xf0265,
  ["md-format_color_fill"] = 0xf0266,
  ["md-format_color_highlight"] = 0xf0e31,
  ["md-format_color_marker_cancel"] = 0xf1313,
  ["md-format_color_text"] = 0xf069e,
  ["md-format_columns"] = 0xf08df,
  ["md-format_float_center"] = 0xf0267,
  ["md-format_float_left"] = 0xf0268,
  ["md-format_float_none"] = 0xf0269,
  ["md-format_float_right"] = 0xf026a,
  ["md-format_font"] = 0xf06d6,
  ["md-format_font_size_decrease"] = 0xf09f3,
  ["md-format_font_size_increase"] = 0xf09f4,
  ["md-format_header_1"] = 0xf026b,
  ["md-format_header_2"] = 0xf026c,
  ["md-format_header_3"] = 0xf026d,
  ["md-format_header_4"] = 0xf026e,
  ["md-format_header_5"] = 0xf026f,
  ["md-format_header_6"] = 0xf0270,
  ["md-format_header_decrease"] = 0xf0271,
  ["md-format_header_equal"] = 0xf0272,
  ["md-format_header_increase"] = 0xf0273,
  ["md-format_header_pound"] = 0xf0274,
  ["md-format_horizontal_align_center"] = 0xf061e,
  ["md-format_horizontal_align_left"] = 0xf061f,
  ["md-format_horizontal_align_right"] = 0xf0620,
  ["md-format_indent_decrease"] = 0xf0275,
  ["md-format_indent_increase"] = 0xf0276,
  ["md-format_italic"] = 0xf0277,
  ["md-format_letter_case"] = 0xf0b34,
  ["md-format_letter_case_lower"] = 0xf0b35,
  ["md-format_letter_case_upper"] = 0xf0b36,
  ["md-format_letter_ends_with"] = 0xf0fb8,
  ["md-format_letter_matches"] = 0xf0fb9,
  ["md-format_letter_spacing"] = 0xf1956,
  ["md-format_letter_starts_with"] = 0xf0fba,
  ["md-format_line_spacing"] = 0xf0278,
  ["md-format_line_style"] = 0xf05c8,
  ["md-format_line_weight"] = 0xf05c9,
  ["md-format_list_bulleted"] = 0xf0279,
  ["md-format_list_bulleted_square"] = 0xf0dd0,
  ["md-format_list_bulleted_triangle"] = 0xf0eb2,
  ["md-format_list_bulleted_type"] = 0xf027a,
  ["md-format_list_checkbox"] = 0xf096a,
  ["md-format_list_checks"] = 0xf0756,
  ["md-format_list_group"] = 0xf1860,
  ["md-format_list_numbered"] = 0xf027b,
  ["md-format_list_numbered_rtl"] = 0xf0d0d,
  ["md-format_list_text"] = 0xf126f,
  ["md-format_overline"] = 0xf0eb3,
  ["md-format_page_break"] = 0xf06d7,
  ["md-format_page_split"] = 0xf1917,
  ["md-format_paint"] = 0xf027c,
  ["md-format_paragraph"] = 0xf027d,
  ["md-format_pilcrow"] = 0xf06d8,
  ["md-format_quote_close"] = 0xf027e,
  ["md-format_quote_close_outline"] = 0xf11a8,
  ["md-format_quote_open"] = 0xf0757,
  ["md-format_quote_open_outline"] = 0xf11a7,
  ["md-format_rotate_90"] = 0xf06aa,
  ["md-format_section"] = 0xf069f,
  ["md-format_size"] = 0xf027f,
  ["md-format_strikethrough"] = 0xf0280,
  ["md-format_strikethrough_variant"] = 0xf0281,
  ["md-format_subscript"] = 0xf0282,
  ["md-format_superscript"] = 0xf0283,
  ["md-format_text"] = 0xf0284,
  ["md-format_text_rotation_angle_down"] = 0xf0fbb,
  ["md-format_text_rotation_angle_up"] = 0xf0fbc,
  ["md-format_text_rotation_down"] = 0xf0d73,
  ["md-format_text_rotation_down_vertical"] = 0xf0fbd,
  ["md-format_text_rotation_none"] = 0xf0d74,
  ["md-format_text_rotation_up"] = 0xf0fbe,
  ["md-format_text_rotation_vertical"] = 0xf0fbf,
  ["md-format_text_variant"] = 0xf0e32,
  ["md-format_text_variant_outline"] = 0xf150f,
  ["md-format_text_wrapping_clip"] = 0xf0d0e,
  ["md-format_text_wrapping_overflow"] = 0xf0d0f,
  ["md-format_text_wrapping_wrap"] = 0xf0d10,
  ["md-format_textbox"] = 0xf0d11,
  ["md-format_textdirection_l_to_r"] = 0xf0285,
  ["md-format_textdirection_r_to_l"] = 0xf0286,
  ["md-format_title"] = 0xf05f4,
  ["md-format_underline"] = 0xf0287,
  ["md-format_underline_wavy"] = 0xf18e9,
  ["md-format_vertical_align_bottom"] = 0xf0621,
  ["md-format_vertical_align_center"] = 0xf0622,
  ["md-format_vertical_align_top"] = 0xf0623,
  ["md-format_wrap_inline"] = 0xf0288,
  ["md-format_wrap_square"] = 0xf0289,
  ["md-format_wrap_tight"] = 0xf028a,
  ["md-format_wrap_top_bottom"] = 0xf028b,
  ["md-forum"] = 0xf028c,
  ["md-forum_minus"] = 0xf1aa9,
  ["md-forum_minus_outline"] = 0xf1aaa,
  ["md-forum_outline"] = 0xf0822,
  ["md-forum_plus"] = 0xf1aab,
  ["md-forum_plus_outline"] = 0xf1aac,
  ["md-forum_remove"] = 0xf1aad,
  ["md-forum_remove_outline"] = 0xf1aae,
  ["md-forward"] = 0xf028d,
  ["md-forwardburger"] = 0xf0d75,
  ["md-fountain"] = 0xf096b,
  ["md-fountain_pen"] = 0xf0d12,
  ["md-fountain_pen_tip"] = 0xf0d13,
  ["md-fraction_one_half"] = 0xf1992,
  ["md-freebsd"] = 0xf08e0,
  ["md-french_fries"] = 0xf1957,
  ["md-frequently_asked_questions"] = 0xf0eb4,
  ["md-fridge"] = 0xf0290,
  ["md-fridge_alert"] = 0xf11b1,
  ["md-fridge_alert_outline"] = 0xf11b2,
  ["md-fridge_bottom"] = 0xf0292,
  ["md-fridge_industrial"] = 0xf15ee,
  ["md-fridge_industrial_alert"] = 0xf15ef,
  ["md-fridge_industrial_alert_outline"] = 0xf15f0,
  ["md-fridge_industrial_off"] = 0xf15f1,
  ["md-fridge_industrial_off_outline"] = 0xf15f2,
  ["md-fridge_industrial_outline"] = 0xf15f3,
  ["md-fridge_off"] = 0xf11af,
  ["md-fridge_off_outline"] = 0xf11b0,
  ["md-fridge_outline"] = 0xf028f,
  ["md-fridge_top"] = 0xf0291,
  ["md-fridge_variant"] = 0xf15f4,
  ["md-fridge_variant_alert"] = 0xf15f5,
  ["md-fridge_variant_alert_outline"] = 0xf15f6,
  ["md-fridge_variant_off"] = 0xf15f7,
  ["md-fridge_variant_off_outline"] = 0xf15f8,
  ["md-fridge_variant_outline"] = 0xf15f9,
  ["md-fruit_cherries"] = 0xf1042,
  ["md-fruit_cherries_off"] = 0xf13f8,
  ["md-fruit_citrus"] = 0xf1043,
  ["md-fruit_citrus_off"] = 0xf13f9,
  ["md-fruit_grapes"] = 0xf1044,
  ["md-fruit_grapes_outline"] = 0xf1045,
  ["md-fruit_pear"] = 0xf1a0e,
  ["md-fruit_pineapple"] = 0xf1046,
  ["md-fruit_watermelon"] = 0xf1047,
  ["md-fuel"] = 0xf07ca,
  ["md-fuel_cell"] = 0xf18b5,
  ["md-fullscreen"] = 0xf0293,
  ["md-fullscreen_exit"] = 0xf0294,
  ["md-function"] = 0xf0295,
  ["md-function_variant"] = 0xf0871,
  ["md-furigana_horizontal"] = 0xf1081,
  ["md-furigana_vertical"] = 0xf1082,
  ["md-fuse"] = 0xf0c85,
  ["md-fuse_alert"] = 0xf142d,
  ["md-fuse_blade"] = 0xf0c86,
  ["md-fuse_off"] = 0xf142c,
  ["md-gamepad"] = 0xf0296,
  ["md-gamepad_circle"] = 0xf0e33,
  ["md-gamepad_circle_down"] = 0xf0e34,
  ["md-gamepad_circle_left"] = 0xf0e35,
  ["md-gamepad_circle_outline"] = 0xf0e36,
  ["md-gamepad_circle_right"] = 0xf0e37,
  ["md-gamepad_circle_up"] = 0xf0e38,
  ["md-gamepad_down"] = 0xf0e39,
  ["md-gamepad_left"] = 0xf0e3a,
  ["md-gamepad_outline"] = 0xf1919,
  ["md-gamepad_right"] = 0xf0e3b,
  ["md-gamepad_round"] = 0xf0e3c,
  ["md-gamepad_round_down"] = 0xf0e3d,
  ["md-gamepad_round_left"] = 0xf0e3e,
  ["md-gamepad_round_outline"] = 0xf0e3f,
  ["md-gamepad_round_right"] = 0xf0e40,
  ["md-gamepad_round_up"] = 0xf0e41,
  ["md-gamepad_square"] = 0xf0eb5,
  ["md-gamepad_square_outline"] = 0xf0eb6,
  ["md-gamepad_up"] = 0xf0e42,
  ["md-gamepad_variant"] = 0xf0297,
  ["md-gamepad_variant_outline"] = 0xf0eb7,
  ["md-gamma"] = 0xf10ee,
  ["md-gantry_crane"] = 0xf0dd1,
  ["md-garage"] = 0xf06d9,
  ["md-garage_alert"] = 0xf0872,
  ["md-garage_alert_variant"] = 0xf12d5,
  ["md-garage_lock"] = 0xf17fb,
  ["md-garage_open"] = 0xf06da,
  ["md-garage_open_variant"] = 0xf12d4,
  ["md-garage_variant"] = 0xf12d3,
  ["md-garage_variant_lock"] = 0xf17fc,
  ["md-gas_burner"] = 0xf1a1b,
  ["md-gas_cylinder"] = 0xf0647,
  ["md-gas_station"] = 0xf0298,
  ["md-gas_station_off"] = 0xf1409,
  ["md-gas_station_off_outline"] = 0xf140a,
  ["md-gas_station_outline"] = 0xf0eb8,
  ["md-gate"] = 0xf0299,
  ["md-gate_alert"] = 0xf17f8,
  ["md-gate_and"] = 0xf08e1,
  ["md-gate_arrow_left"] = 0xf17f7,
  ["md-gate_arrow_right"] = 0xf1169,
  ["md-gate_nand"] = 0xf08e2,
  ["md-gate_nor"] = 0xf08e3,
  ["md-gate_not"] = 0xf08e4,
  ["md-gate_open"] = 0xf116a,
  ["md-gate_or"] = 0xf08e5,
  ["md-gate_xnor"] = 0xf08e6,
  ["md-gate_xor"] = 0xf08e7,
  ["md-gatsby"] = 0xf0e43,
  ["md-gauge"] = 0xf029a,
  ["md-gauge_empty"] = 0xf0873,
  ["md-gauge_full"] = 0xf0874,
  ["md-gauge_low"] = 0xf0875,
  ["md-gavel"] = 0xf029b,
  ["md-gender_female"] = 0xf029c,
  ["md-gender_male"] = 0xf029d,
  ["md-gender_male_female"] = 0xf029e,
  ["md-gender_male_female_variant"] = 0xf113f,
  ["md-gender_non_binary"] = 0xf1140,
  ["md-gender_transgender"] = 0xf029f,
  ["md-gentoo"] = 0xf08e8,
  ["md-gesture"] = 0xf07cb,
  ["md-gesture_double_tap"] = 0xf073c,
  ["md-gesture_pinch"] = 0xf0abd,
  ["md-gesture_spread"] = 0xf0abe,
  ["md-gesture_swipe"] = 0xf0d76,
  ["md-gesture_swipe_down"] = 0xf073d,
  ["md-gesture_swipe_horizontal"] = 0xf0abf,
  ["md-gesture_swipe_left"] = 0xf073e,
  ["md-gesture_swipe_right"] = 0xf073f,
  ["md-gesture_swipe_up"] = 0xf0740,
  ["md-gesture_swipe_vertical"] = 0xf0ac0,
  ["md-gesture_tap"] = 0xf0741,
  ["md-gesture_tap_box"] = 0xf12a9,
  ["md-gesture_tap_button"] = 0xf12a8,
  ["md-gesture_tap_hold"] = 0xf0d77,
  ["md-gesture_two_double_tap"] = 0xf0742,
  ["md-gesture_two_tap"] = 0xf0743,
  ["md-ghost"] = 0xf02a0,
  ["md-ghost_off"] = 0xf09f5,
  ["md-ghost_off_outline"] = 0xf165c,
  ["md-ghost_outline"] = 0xf165d,
  ["md-gift"] = 0xf0e44,
  ["md-gift_off"] = 0xf16ef,
  ["md-gift_off_outline"] = 0xf16f0,
  ["md-gift_open"] = 0xf16f1,
  ["md-gift_open_outline"] = 0xf16f2,
  ["md-gift_outline"] = 0xf02a1,
  ["md-git"] = 0xf02a2,
  ["md-github"] = 0xf02a4,
  ["md-gitlab"] = 0xf0ba0,
  ["md-glass_cocktail"] = 0xf0356,
  ["md-glass_cocktail_off"] = 0xf15e6,
  ["md-glass_flute"] = 0xf02a5,
  ["md-glass_fragile"] = 0xf1873,
  ["md-glass_mug"] = 0xf02a6,
  ["md-glass_mug_off"] = 0xf15e7,
  ["md-glass_mug_variant"] = 0xf1116,
  ["md-glass_mug_variant_off"] = 0xf15e8,
  ["md-glass_pint_outline"] = 0xf130d,
  ["md-glass_stange"] = 0xf02a7,
  ["md-glass_tulip"] = 0xf02a8,
  ["md-glass_wine"] = 0xf0876,
  ["md-glasses"] = 0xf02aa,
  ["md-globe_light"] = 0xf12d7,
  ["md-globe_model"] = 0xf08e9,
  ["md-gmail"] = 0xf02ab,
  ["md-gnome"] = 0xf02ac,
  ["md-go_kart"] = 0xf0d79,
  ["md-go_kart_track"] = 0xf0d7a,
  ["md-gog"] = 0xf0ba1,
  ["md-gold"] = 0xf124f,
  ["md-golf"] = 0xf0823,
  ["md-golf_cart"] = 0xf11a4,
  ["md-golf_tee"] = 0xf1083,
  ["md-gondola"] = 0xf0686,
  ["md-goodreads"] = 0xf0d7b,
  ["md-google"] = 0xf02ad,
  ["md-google_ads"] = 0xf0c87,
  ["md-google_analytics"] = 0xf07cc,
  ["md-google_assistant"] = 0xf07cd,
  ["md-google_cardboard"] = 0xf02ae,
  ["md-google_chrome"] = 0xf02af,
  ["md-google_circles"] = 0xf02b0,
  ["md-google_circles_communities"] = 0xf02b1,
  ["md-google_circles_extended"] = 0xf02b2,
  ["md-google_circles_group"] = 0xf02b3,
  ["md-google_classroom"] = 0xf02c0,
  ["md-google_cloud"] = 0xf11f6,
  ["md-google_controller"] = 0xf02b4,
  ["md-google_controller_off"] = 0xf02b5,
  ["md-google_downasaur"] = 0xf1362,
  ["md-google_drive"] = 0xf02b6,
  ["md-google_earth"] = 0xf02b7,
  ["md-google_fit"] = 0xf096c,
  ["md-google_glass"] = 0xf02b8,
  ["md-google_hangouts"] = 0xf02c9,
  ["md-google_home"] = 0xf0824,
  ["md-google_keep"] = 0xf06dc,
  ["md-google_lens"] = 0xf09f6,
  ["md-google_maps"] = 0xf05f5,
  ["md-google_my_business"] = 0xf1048,
  ["md-google_nearby"] = 0xf02b9,
  ["md-google_play"] = 0xf02bc,
  ["md-google_plus"] = 0xf02bd,
  ["md-google_podcast"] = 0xf0eb9,
  ["md-google_spreadsheet"] = 0xf09f7,
  ["md-google_street_view"] = 0xf0c88,
  ["md-google_translate"] = 0xf02bf,
  ["md-gradient_horizontal"] = 0xf174a,
  ["md-gradient_vertical"] = 0xf06a0,
  ["md-grain"] = 0xf0d7c,
  ["md-graph"] = 0xf1049,
  ["md-graph_outline"] = 0xf104a,
  ["md-graphql"] = 0xf0877,
  ["md-grass"] = 0xf1510,
  ["md-grave_stone"] = 0xf0ba2,
  ["md-grease_pencil"] = 0xf0648,
  ["md-greater_than"] = 0xf096d,
  ["md-greater_than_or_equal"] = 0xf096e,
  ["md-greenhouse"] = 0xf002d,
  ["md-grid"] = 0xf02c1,
  ["md-grid_large"] = 0xf0758,
  ["md-grid_off"] = 0xf02c2,
  ["md-grill"] = 0xf0e45,
  ["md-grill_outline"] = 0xf118a,
  ["md-group"] = 0xf02c3,
  ["md-guitar_acoustic"] = 0xf0771,
  ["md-guitar_electric"] = 0xf02c4,
  ["md-guitar_pick"] = 0xf02c5,
  ["md-guitar_pick_outline"] = 0xf02c6,
  ["md-guy_fawkes_mask"] = 0xf0825,
  ["md-gymnastics"] = 0xf1a41,
  ["md-hail"] = 0xf0ac1,
  ["md-hair_dryer"] = 0xf10ef,
  ["md-hair_dryer_outline"] = 0xf10f0,
  ["md-halloween"] = 0xf0ba3,
  ["md-hamburger"] = 0xf0685,
  ["md-hamburger_check"] = 0xf1776,
  ["md-hamburger_minus"] = 0xf1777,
  ["md-hamburger_off"] = 0xf1778,
  ["md-hamburger_plus"] = 0xf1779,
  ["md-hamburger_remove"] = 0xf177a,
  ["md-hammer"] = 0xf08ea,
  ["md-hammer_screwdriver"] = 0xf1322,
  ["md-hammer_sickle"] = 0xf1887,
  ["md-hammer_wrench"] = 0xf1323,
  ["md-hand_back_left"] = 0xf0e46,
  ["md-hand_back_left_off"] = 0xf1830,
  ["md-hand_back_left_off_outline"] = 0xf1832,
  ["md-hand_back_left_outline"] = 0xf182c,
  ["md-hand_back_right"] = 0xf0e47,
  ["md-hand_back_right_off"] = 0xf1831,
  ["md-hand_back_right_off_outline"] = 0xf1833,
  ["md-hand_back_right_outline"] = 0xf182d,
  ["md-hand_clap"] = 0xf194b,
  ["md-hand_clap_off"] = 0xf1a42,
  ["md-hand_coin"] = 0xf188f,
  ["md-hand_coin_outline"] = 0xf1890,
  ["md-hand_extended"] = 0xf18b6,
  ["md-hand_extended_outline"] = 0xf18b7,
  ["md-hand_front_left"] = 0xf182b,
  ["md-hand_front_left_outline"] = 0xf182e,
  ["md-hand_front_right"] = 0xf0a4f,
  ["md-hand_front_right_outline"] = 0xf182f,
  ["md-hand_heart"] = 0xf10f1,
  ["md-hand_heart_outline"] = 0xf157e,
  ["md-hand_okay"] = 0xf0a50,
  ["md-hand_peace"] = 0xf0a51,
  ["md-hand_peace_variant"] = 0xf0a52,
  ["md-hand_pointing_down"] = 0xf0a53,
  ["md-hand_pointing_left"] = 0xf0a54,
  ["md-hand_pointing_right"] = 0xf02c7,
  ["md-hand_pointing_up"] = 0xf0a55,
  ["md-hand_saw"] = 0xf0e48,
  ["md-hand_wash"] = 0xf157f,
  ["md-hand_wash_outline"] = 0xf1580,
  ["md-hand_water"] = 0xf139f,
  ["md-hand_wave"] = 0xf1821,
  ["md-hand_wave_outline"] = 0xf1822,
  ["md-handball"] = 0xf0f53,
  ["md-handcuffs"] = 0xf113e,
  ["md-hands_pray"] = 0xf0579,
  ["md-handshake"] = 0xf1218,
  ["md-handshake_outline"] = 0xf15a1,
  ["md-hanger"] = 0xf02c8,
  ["md-hard_hat"] = 0xf096f,
  ["md-harddisk"] = 0xf02ca,
  ["md-harddisk_plus"] = 0xf104b,
  ["md-harddisk_remove"] = 0xf104c,
  ["md-hat_fedora"] = 0xf0ba4,
  ["md-hazard_lights"] = 0xf0c89,
  ["md-hdr"] = 0xf0d7d,
  ["md-hdr_off"] = 0xf0d7e,
  ["md-head"] = 0xf135e,
  ["md-head_alert"] = 0xf1338,
  ["md-head_alert_outline"] = 0xf1339,
  ["md-head_check"] = 0xf133a,
  ["md-head_check_outline"] = 0xf133b,
  ["md-head_cog"] = 0xf133c,
  ["md-head_cog_outline"] = 0xf133d,
  ["md-head_dots_horizontal"] = 0xf133e,
  ["md-head_dots_horizontal_outline"] = 0xf133f,
  ["md-head_flash"] = 0xf1340,
  ["md-head_flash_outline"] = 0xf1341,
  ["md-head_heart"] = 0xf1342,
  ["md-head_heart_outline"] = 0xf1343,
  ["md-head_lightbulb"] = 0xf1344,
  ["md-head_lightbulb_outline"] = 0xf1345,
  ["md-head_minus"] = 0xf1346,
  ["md-head_minus_outline"] = 0xf1347,
  ["md-head_outline"] = 0xf135f,
  ["md-head_plus"] = 0xf1348,
  ["md-head_plus_outline"] = 0xf1349,
  ["md-head_question"] = 0xf134a,
  ["md-head_question_outline"] = 0xf134b,
  ["md-head_remove"] = 0xf134c,
  ["md-head_remove_outline"] = 0xf134d,
  ["md-head_snowflake"] = 0xf134e,
  ["md-head_snowflake_outline"] = 0xf134f,
  ["md-head_sync"] = 0xf1350,
  ["md-head_sync_outline"] = 0xf1351,
  ["md-headphones"] = 0xf02cb,
  ["md-headphones_bluetooth"] = 0xf0970,
  ["md-headphones_box"] = 0xf02cc,
  ["md-headphones_off"] = 0xf07ce,
  ["md-headphones_settings"] = 0xf02cd,
  ["md-headset"] = 0xf02ce,
  ["md-headset_dock"] = 0xf02cf,
  ["md-headset_off"] = 0xf02d0,
  ["md-heart"] = 0xf08d0,
  ["md-heart_box"] = 0xf02d2,
  ["md-heart_box_outline"] = 0xf02d3,
  ["md-heart_broken"] = 0xf02d4,
  ["md-heart_broken_outline"] = 0xf0d14,
  ["md-heart_circle"] = 0xf0971,
  ["md-heart_circle_outline"] = 0xf0972,
  ["md-heart_cog"] = 0xf1663,
  ["md-heart_cog_outline"] = 0xf1664,
  ["md-heart_flash"] = 0xf0ef9,
  ["md-heart_half"] = 0xf06df,
  ["md-heart_half_full"] = 0xf06de,
  ["md-heart_half_outline"] = 0xf06e0,
  ["md-heart_minus"] = 0xf142f,
  ["md-heart_minus_outline"] = 0xf1432,
  ["md-heart_multiple"] = 0xf0a56,
  ["md-heart_multiple_outline"] = 0xf0a57,
  ["md-heart_off"] = 0xf0759,
  ["md-heart_off_outline"] = 0xf1434,
  ["md-heart_outline"] = 0xf18a0,
  ["md-heart_plus"] = 0xf142e,
  ["md-heart_plus_outline"] = 0xf1431,
  ["md-heart_pulse"] = 0xf05f6,
  ["md-heart_remove"] = 0xf1430,
  ["md-heart_remove_outline"] = 0xf1433,
  ["md-heart_settings"] = 0xf1665,
  ["md-heart_settings_outline"] = 0xf1666,
  ["md-heat_pump"] = 0xf1a43,
  ["md-heat_pump_outline"] = 0xf1a44,
  ["md-heat_wave"] = 0xf1a45,
  ["md-heating_coil"] = 0xf1aaf,
  ["md-helicopter"] = 0xf0ac2,
  ["md-help"] = 0xf02d6,
  ["md-help_box"] = 0xf078b,
  ["md-help_circle"] = 0xf02d7,
  ["md-help_circle_outline"] = 0xf0625,
  ["md-help_network"] = 0xf06f5,
  ["md-help_network_outline"] = 0xf0c8a,
  ["md-help_rhombus"] = 0xf0ba5,
  ["md-help_rhombus_outline"] = 0xf0ba6,
  ["md-hexadecimal"] = 0xf12a7,
  ["md-hexagon"] = 0xf02d8,
  ["md-hexagon_multiple"] = 0xf06e1,
  ["md-hexagon_multiple_outline"] = 0xf10f2,
  ["md-hexagon_outline"] = 0xf02d9,
  ["md-hexagon_slice_1"] = 0xf0ac3,
  ["md-hexagon_slice_2"] = 0xf0ac4,
  ["md-hexagon_slice_3"] = 0xf0ac5,
  ["md-hexagon_slice_4"] = 0xf0ac6,
  ["md-hexagon_slice_5"] = 0xf0ac7,
  ["md-hexagon_slice_6"] = 0xf0ac8,
  ["md-hexagram"] = 0xf0ac9,
  ["md-hexagram_outline"] = 0xf0aca,
  ["md-high_definition"] = 0xf07cf,
  ["md-high_definition_box"] = 0xf0878,
  ["md-highway"] = 0xf05f7,
  ["md-hiking"] = 0xf0d7f,
  ["md-history"] = 0xf02da,
  ["md-hockey_puck"] = 0xf0879,
  ["md-hockey_sticks"] = 0xf087a,
  ["md-hololens"] = 0xf02db,
  ["md-home"] = 0xf02dc,
  ["md-home_account"] = 0xf0826,
  ["md-home_alert"] = 0xf087b,
  ["md-home_alert_outline"] = 0xf15d0,
  ["md-home_analytics"] = 0xf0eba,
  ["md-home_assistant"] = 0xf07d0,
  ["md-home_automation"] = 0xf07d1,
  ["md-home_battery"] = 0xf1901,
  ["md-home_battery_outline"] = 0xf1902,
  ["md-home_circle"] = 0xf07d2,
  ["md-home_circle_outline"] = 0xf104d,
  ["md-home_city"] = 0xf0d15,
  ["md-home_city_outline"] = 0xf0d16,
  ["md-home_clock"] = 0xf1a12,
  ["md-home_clock_outline"] = 0xf1a13,
  ["md-home_edit"] = 0xf1159,
  ["md-home_edit_outline"] = 0xf115a,
  ["md-home_export_outline"] = 0xf0f9b,
  ["md-home_flood"] = 0xf0efa,
  ["md-home_floor_0"] = 0xf0dd2,
  ["md-home_floor_1"] = 0xf0d80,
  ["md-home_floor_2"] = 0xf0d81,
  ["md-home_floor_3"] = 0xf0d82,
  ["md-home_floor_a"] = 0xf0d83,
  ["md-home_floor_b"] = 0xf0d84,
  ["md-home_floor_g"] = 0xf0d85,
  ["md-home_floor_l"] = 0xf0d86,
  ["md-home_floor_negative_1"] = 0xf0dd3,
  ["md-home_group"] = 0xf0dd4,
  ["md-home_group_minus"] = 0xf19c1,
  ["md-home_group_plus"] = 0xf19c0,
  ["md-home_group_remove"] = 0xf19c2,
  ["md-home_heart"] = 0xf0827,
  ["md-home_import_outline"] = 0xf0f9c,
  ["md-home_lightbulb"] = 0xf1251,
  ["md-home_lightbulb_outline"] = 0xf1252,
  ["md-home_lightning_bolt"] = 0xf1903,
  ["md-home_lightning_bolt_outline"] = 0xf1904,
  ["md-home_lock"] = 0xf08eb,
  ["md-home_lock_open"] = 0xf08ec,
  ["md-home_map_marker"] = 0xf05f8,
  ["md-home_minus"] = 0xf0974,
  ["md-home_minus_outline"] = 0xf13d5,
  ["md-home_modern"] = 0xf02dd,
  ["md-home_off"] = 0xf1a46,
  ["md-home_off_outline"] = 0xf1a47,
  ["md-home_outline"] = 0xf06a1,
  ["md-home_plus"] = 0xf0975,
  ["md-home_plus_outline"] = 0xf13d6,
  ["md-home_remove"] = 0xf1247,
  ["md-home_remove_outline"] = 0xf13d7,
  ["md-home_roof"] = 0xf112b,
  ["md-home_search"] = 0xf13b0,
  ["md-home_search_outline"] = 0xf13b1,
  ["md-home_switch"] = 0xf1794,
  ["md-home_switch_outline"] = 0xf1795,
  ["md-home_thermometer"] = 0xf0f54,
  ["md-home_thermometer_outline"] = 0xf0f55,
  ["md-home_variant"] = 0xf02de,
  ["md-home_variant_outline"] = 0xf0ba7,
  ["md-hook"] = 0xf06e2,
  ["md-hook_off"] = 0xf06e3,
  ["md-hoop_house"] = 0xf0e56,
  ["md-hops"] = 0xf02df,
  ["md-horizontal_rotate_clockwise"] = 0xf10f3,
  ["md-horizontal_rotate_counterclockwise"] = 0xf10f4,
  ["md-horse"] = 0xf15bf,
  ["md-horse_human"] = 0xf15c0,
  ["md-horse_variant"] = 0xf15c1,
  ["md-horse_variant_fast"] = 0xf186e,
  ["md-horseshoe"] = 0xf0a58,
  ["md-hospital"] = 0xf0ff6,
  ["md-hospital_box"] = 0xf02e0,
  ["md-hospital_box_outline"] = 0xf0ff7,
  ["md-hospital_building"] = 0xf02e1,
  ["md-hospital_marker"] = 0xf02e2,
  ["md-hot_tub"] = 0xf0828,
  ["md-hours_24"] = 0xf1478,
  ["md-hubspot"] = 0xf0d17,
  ["md-hulu"] = 0xf0829,
  ["md-human"] = 0xf02e6,
  ["md-human_baby_changing_table"] = 0xf138b,
  ["md-human_cane"] = 0xf1581,
  ["md-human_capacity_decrease"] = 0xf159b,
  ["md-human_capacity_increase"] = 0xf159c,
  ["md-human_child"] = 0xf02e7,
  ["md-human_dolly"] = 0xf1980,
  ["md-human_edit"] = 0xf14e8,
  ["md-human_female"] = 0xf0649,
  ["md-human_female_boy"] = 0xf0a59,
  ["md-human_female_dance"] = 0xf15c9,
  ["md-human_female_female"] = 0xf0a5a,
  ["md-human_female_girl"] = 0xf0a5b,
  ["md-human_greeting"] = 0xf17c4,
  ["md-human_greeting_proximity"] = 0xf159d,
  ["md-human_greeting_variant"] = 0xf064a,
  ["md-human_handsdown"] = 0xf064b,
  ["md-human_handsup"] = 0xf064c,
  ["md-human_male"] = 0xf064d,
  ["md-human_male_board"] = 0xf0890,
  ["md-human_male_board_poll"] = 0xf0846,
  ["md-human_male_boy"] = 0xf0a5c,
  ["md-human_male_child"] = 0xf138c,
  ["md-human_male_female"] = 0xf02e8,
  ["md-human_male_female_child"] = 0xf1823,
  ["md-human_male_girl"] = 0xf0a5d,
  ["md-human_male_height"] = 0xf0efb,
  ["md-human_male_height_variant"] = 0xf0efc,
  ["md-human_male_male"] = 0xf0a5e,
  ["md-human_non_binary"] = 0xf1848,
  ["md-human_pregnant"] = 0xf05cf,
  ["md-human_queue"] = 0xf1571,
  ["md-human_scooter"] = 0xf11e9,
  ["md-human_wheelchair"] = 0xf138d,
  ["md-human_white_cane"] = 0xf1981,
  ["md-humble_bundle"] = 0xf0744,
  ["md-hvac"] = 0xf1352,
  ["md-hvac_off"] = 0xf159e,
  ["md-hydraulic_oil_level"] = 0xf1324,
  ["md-hydraulic_oil_temperature"] = 0xf1325,
  ["md-hydro_power"] = 0xf12e5,
  ["md-hydrogen_station"] = 0xf1894,
  ["md-ice_cream"] = 0xf082a,
  ["md-ice_cream_off"] = 0xf0e52,
  ["md-ice_pop"] = 0xf0efd,
  ["md-id_card"] = 0xf0fc0,
  ["md-identifier"] = 0xf0efe,
  ["md-ideogram_cjk"] = 0xf1331,
  ["md-ideogram_cjk_variant"] = 0xf1332,
  ["md-image"] = 0xf02e9,
  ["md-image_album"] = 0xf02ea,
  ["md-image_area"] = 0xf02eb,
  ["md-image_area_close"] = 0xf02ec,
  ["md-image_auto_adjust"] = 0xf0fc1,
  ["md-image_broken"] = 0xf02ed,
  ["md-image_broken_variant"] = 0xf02ee,
  ["md-image_edit"] = 0xf11e3,
  ["md-image_edit_outline"] = 0xf11e4,
  ["md-image_filter_black_white"] = 0xf02f0,
  ["md-image_filter_center_focus"] = 0xf02f1,
  ["md-image_filter_center_focus_strong"] = 0xf0eff,
  ["md-image_filter_center_focus_strong_outline"] = 0xf0f00,
  ["md-image_filter_center_focus_weak"] = 0xf02f2,
  ["md-image_filter_drama"] = 0xf02f3,
  ["md-image_filter_frames"] = 0xf02f4,
  ["md-image_filter_hdr"] = 0xf0509,
  ["md-image_filter_none"] = 0xf02f6,
  ["md-image_filter_tilt_shift"] = 0xf02f7,
  ["md-image_filter_vintage"] = 0xf02f8,
  ["md-image_frame"] = 0xf0e49,
  ["md-image_lock"] = 0xf1ab0,
  ["md-image_lock_outline"] = 0xf1ab1,
  ["md-image_marker"] = 0xf177b,
  ["md-image_marker_outline"] = 0xf177c,
  ["md-image_minus"] = 0xf1419,
  ["md-image_move"] = 0xf09f8,
  ["md-image_multiple"] = 0xf02f9,
  ["md-image_multiple_outline"] = 0xf02ef,
  ["md-image_off"] = 0xf082b,
  ["md-image_off_outline"] = 0xf11d1,
  ["md-image_outline"] = 0xf0976,
  ["md-image_plus"] = 0xf087c,
  ["md-image_refresh"] = 0xf19fe,
  ["md-image_refresh_outline"] = 0xf19ff,
  ["md-image_remove"] = 0xf1418,
  ["md-image_search"] = 0xf0977,
  ["md-image_search_outline"] = 0xf0978,
  ["md-image_size_select_actual"] = 0xf0c8d,
  ["md-image_size_select_large"] = 0xf0c8e,
  ["md-image_size_select_small"] = 0xf0c8f,
  ["md-image_sync"] = 0xf1a00,
  ["md-image_sync_outline"] = 0xf1a01,
  ["md-image_text"] = 0xf160d,
  ["md-import"] = 0xf02fa,
  ["md-inbox"] = 0xf0687,
  ["md-inbox_arrow_down"] = 0xf02fb,
  ["md-inbox_arrow_down_outline"] = 0xf1270,
  ["md-inbox_arrow_up"] = 0xf03d1,
  ["md-inbox_arrow_up_outline"] = 0xf1271,
  ["md-inbox_full"] = 0xf1272,
  ["md-inbox_full_outline"] = 0xf1273,
  ["md-inbox_multiple"] = 0xf08b0,
  ["md-inbox_multiple_outline"] = 0xf0ba8,
  ["md-inbox_outline"] = 0xf1274,
  ["md-inbox_remove"] = 0xf159f,
  ["md-inbox_remove_outline"] = 0xf15a0,
  ["md-incognito"] = 0xf05f9,
  ["md-incognito_circle"] = 0xf1421,
  ["md-incognito_circle_off"] = 0xf1422,
  ["md-incognito_off"] = 0xf0075,
  ["md-induction"] = 0xf184c,
  ["md-infinity"] = 0xf06e4,
  ["md-information"] = 0xf02fc,
  ["md-information_off"] = 0xf178c,
  ["md-information_off_outline"] = 0xf178d,
  ["md-information_outline"] = 0xf02fd,
  ["md-information_variant"] = 0xf064e,
  ["md-instagram"] = 0xf02fe,
  ["md-instrument_triangle"] = 0xf104e,
  ["md-integrated_circuit_chip"] = 0xf1913,
  ["md-invert_colors"] = 0xf0301,
  ["md-invert_colors_off"] = 0xf0e4a,
  ["md-iobroker"] = 0xf12e8,
  ["md-ip"] = 0xf0a5f,
  ["md-ip_network"] = 0xf0a60,
  ["md-ip_network_outline"] = 0xf0c90,
  ["md-ip_outline"] = 0xf1982,
  ["md-ipod"] = 0xf0c91,
  ["md-iron"] = 0xf1824,
  ["md-iron_board"] = 0xf1838,
  ["md-iron_outline"] = 0xf1825,
  ["md-island"] = 0xf104f,
  ["md-iv_bag"] = 0xf10b9,
  ["md-jabber"] = 0xf0dd5,
  ["md-jeepney"] = 0xf0302,
  ["md-jellyfish"] = 0xf0f01,
  ["md-jellyfish_outline"] = 0xf0f02,
  ["md-jira"] = 0xf0303,
  ["md-jquery"] = 0xf087d,
  ["md-jsfiddle"] = 0xf0304,
  ["md-jump_rope"] = 0xf12ff,
  ["md-kabaddi"] = 0xf0d87,
  ["md-kangaroo"] = 0xf1558,
  ["md-karate"] = 0xf082c,
  ["md-kayaking"] = 0xf08af,
  ["md-keg"] = 0xf0305,
  ["md-kettle"] = 0xf05fa,
  ["md-kettle_alert"] = 0xf1317,
  ["md-kettle_alert_outline"] = 0xf1318,
  ["md-kettle_off"] = 0xf131b,
  ["md-kettle_off_outline"] = 0xf131c,
  ["md-kettle_outline"] = 0xf0f56,
  ["md-kettle_pour_over"] = 0xf173c,
  ["md-kettle_steam"] = 0xf1319,
  ["md-kettle_steam_outline"] = 0xf131a,
  ["md-kettlebell"] = 0xf1300,
  ["md-key"] = 0xf0306,
  ["md-key_alert"] = 0xf1983,
  ["md-key_alert_outline"] = 0xf1984,
  ["md-key_arrow_right"] = 0xf1312,
  ["md-key_chain"] = 0xf1574,
  ["md-key_chain_variant"] = 0xf1575,
  ["md-key_change"] = 0xf0307,
  ["md-key_link"] = 0xf119f,
  ["md-key_minus"] = 0xf0308,
  ["md-key_outline"] = 0xf0dd6,
  ["md-key_plus"] = 0xf0309,
  ["md-key_remove"] = 0xf030a,
  ["md-key_star"] = 0xf119e,
  ["md-key_variant"] = 0xf030b,
  ["md-key_wireless"] = 0xf0fc2,
  ["md-keyboard"] = 0xf030c,
  ["md-keyboard_backspace"] = 0xf030d,
  ["md-keyboard_caps"] = 0xf030e,
  ["md-keyboard_close"] = 0xf030f,
  ["md-keyboard_esc"] = 0xf12b7,
  ["md-keyboard_f1"] = 0xf12ab,
  ["md-keyboard_f10"] = 0xf12b4,
  ["md-keyboard_f11"] = 0xf12b5,
  ["md-keyboard_f12"] = 0xf12b6,
  ["md-keyboard_f2"] = 0xf12ac,
  ["md-keyboard_f3"] = 0xf12ad,
  ["md-keyboard_f4"] = 0xf12ae,
  ["md-keyboard_f5"] = 0xf12af,
  ["md-keyboard_f6"] = 0xf12b0,
  ["md-keyboard_f7"] = 0xf12b1,
  ["md-keyboard_f8"] = 0xf12b2,
  ["md-keyboard_f9"] = 0xf12b3,
  ["md-keyboard_off"] = 0xf0310,
  ["md-keyboard_off_outline"] = 0xf0e4b,
  ["md-keyboard_outline"] = 0xf097b,
  ["md-keyboard_return"] = 0xf0311,
  ["md-keyboard_settings"] = 0xf09f9,
  ["md-keyboard_settings_outline"] = 0xf09fa,
  ["md-keyboard_space"] = 0xf1050,
  ["md-keyboard_tab"] = 0xf0312,
  ["md-keyboard_tab_reverse"] = 0xf0325,
  ["md-keyboard_variant"] = 0xf0313,
  ["md-khanda"] = 0xf10fd,
  ["md-kickstarter"] = 0xf0745,
  ["md-kite"] = 0xf1985,
  ["md-kite_outline"] = 0xf1986,
  ["md-kitesurfing"] = 0xf1744,
  ["md-klingon"] = 0xf135b,
  ["md-knife"] = 0xf09fb,
  ["md-knife_military"] = 0xf09fc,
  ["md-koala"] = 0xf173f,
  ["md-kodi"] = 0xf0314,
  ["md-kubernetes"] = 0xf10fe,
  ["md-label"] = 0xf0315,
  ["md-label_multiple"] = 0xf1375,
  ["md-label_multiple_outline"] = 0xf1376,
  ["md-label_off"] = 0xf0acb,
  ["md-label_off_outline"] = 0xf0acc,
  ["md-label_outline"] = 0xf0316,
  ["md-label_percent"] = 0xf12ea,
  ["md-label_percent_outline"] = 0xf12eb,
  ["md-label_variant"] = 0xf0acd,
  ["md-label_variant_outline"] = 0xf0ace,
  ["md-ladder"] = 0xf15a2,
  ["md-ladybug"] = 0xf082d,
  ["md-lambda"] = 0xf0627,
  ["md-lamp"] = 0xf06b5,
  ["md-lamp_outline"] = 0xf17d0,
  ["md-lamps"] = 0xf1576,
  ["md-lamps_outline"] = 0xf17d1,
  ["md-lan"] = 0xf0317,
  ["md-lan_check"] = 0xf12aa,
  ["md-lan_connect"] = 0xf0318,
  ["md-lan_disconnect"] = 0xf0319,
  ["md-lan_pending"] = 0xf031a,
  ["md-land_fields"] = 0xf1ab2,
  ["md-land_plots"] = 0xf1ab3,
  ["md-land_plots_circle"] = 0xf1ab4,
  ["md-land_plots_circle_variant"] = 0xf1ab5,
  ["md-land_rows_horizontal"] = 0xf1ab6,
  ["md-land_rows_vertical"] = 0xf1ab7,
  ["md-landslide"] = 0xf1a48,
  ["md-landslide_outline"] = 0xf1a49,
  ["md-language_c"] = 0xf0671,
  ["md-language_cpp"] = 0xf0672,
  ["md-language_csharp"] = 0xf031b,
  ["md-language_css3"] = 0xf031c,
  ["md-language_fortran"] = 0xf121a,
  ["md-language_go"] = 0xf07d3,
  ["md-language_haskell"] = 0xf0c92,
  ["md-language_html5"] = 0xf031d,
  ["md-language_java"] = 0xf0b37,
  ["md-language_javascript"] = 0xf031e,
  ["md-language_kotlin"] = 0xf1219,
  ["md-language_lua"] = 0xf08b1,
  ["md-language_markdown"] = 0xf0354,
  ["md-language_markdown_outline"] = 0xf0f5b,
  ["md-language_php"] = 0xf031f,
  ["md-language_python"] = 0xf0320,
  ["md-language_r"] = 0xf07d4,
  ["md-language_ruby"] = 0xf0d2d,
  ["md-language_ruby_on_rails"] = 0xf0acf,
  ["md-language_rust"] = 0xf1617,
  ["md-language_swift"] = 0xf06e5,
  ["md-language_typescript"] = 0xf06e6,
  ["md-language_xaml"] = 0xf0673,
  ["md-laptop"] = 0xf0322,
  ["md-laptop_account"] = 0xf1a4a,
  ["md-laptop_off"] = 0xf06e7,
  ["md-laravel"] = 0xf0ad0,
  ["md-laser_pointer"] = 0xf1484,
  ["md-lasso"] = 0xf0f03,
  ["md-lastpass"] = 0xf0446,
  ["md-latitude"] = 0xf0f57,
  ["md-launch"] = 0xf0327,
  ["md-lava_lamp"] = 0xf07d5,
  ["md-layers"] = 0xf0328,
  ["md-layers_edit"] = 0xf1892,
  ["md-layers_minus"] = 0xf0e4c,
  ["md-layers_off"] = 0xf0329,
  ["md-layers_off_outline"] = 0xf09fd,
  ["md-layers_outline"] = 0xf09fe,
  ["md-layers_plus"] = 0xf0e4d,
  ["md-layers_remove"] = 0xf0e4e,
  ["md-layers_search"] = 0xf1206,
  ["md-layers_search_outline"] = 0xf1207,
  ["md-layers_triple"] = 0xf0f58,
  ["md-layers_triple_outline"] = 0xf0f59,
  ["md-lead_pencil"] = 0xf064f,
  ["md-leaf"] = 0xf032a,
  ["md-leaf_circle"] = 0xf1905,
  ["md-leaf_circle_outline"] = 0xf1906,
  ["md-leaf_maple"] = 0xf0c93,
  ["md-leaf_maple_off"] = 0xf12da,
  ["md-leaf_off"] = 0xf12d9,
  ["md-leak"] = 0xf0dd7,
  ["md-leak_off"] = 0xf0dd8,
  ["md-lecturn"] = 0xf1af0,
  ["md-led_off"] = 0xf032b,
  ["md-led_on"] = 0xf032c,
  ["md-led_outline"] = 0xf032d,
  ["md-led_strip"] = 0xf07d6,
  ["md-led_strip_variant"] = 0xf1051,
  ["md-led_strip_variant_off"] = 0xf1a4b,
  ["md-led_variant_off"] = 0xf032e,
  ["md-led_variant_on"] = 0xf032f,
  ["md-led_variant_outline"] = 0xf0330,
  ["md-leek"] = 0xf117d,
  ["md-less_than"] = 0xf097c,
  ["md-less_than_or_equal"] = 0xf097d,
  ["md-library"] = 0xf0331,
  ["md-library_outline"] = 0xf1a22,
  ["md-library_shelves"] = 0xf0ba9,
  ["md-license"] = 0xf0fc3,
  ["md-lifebuoy"] = 0xf087e,
  ["md-light_flood_down"] = 0xf1987,
  ["md-light_flood_up"] = 0xf1988,
  ["md-light_recessed"] = 0xf179b,
  ["md-light_switch"] = 0xf097e,
  ["md-light_switch_off"] = 0xf1a24,
  ["md-lightbulb"] = 0xf0335,
  ["md-lightbulb_alert"] = 0xf19e1,
  ["md-lightbulb_alert_outline"] = 0xf19e2,
  ["md-lightbulb_auto"] = 0xf1800,
  ["md-lightbulb_auto_outline"] = 0xf1801,
  ["md-lightbulb_cfl"] = 0xf1208,
  ["md-lightbulb_cfl_off"] = 0xf1209,
  ["md-lightbulb_cfl_spiral"] = 0xf1275,
  ["md-lightbulb_cfl_spiral_off"] = 0xf12c3,
  ["md-lightbulb_fluorescent_tube"] = 0xf1804,
  ["md-lightbulb_fluorescent_tube_outline"] = 0xf1805,
  ["md-lightbulb_group"] = 0xf1253,
  ["md-lightbulb_group_off"] = 0xf12cd,
  ["md-lightbulb_group_off_outline"] = 0xf12ce,
  ["md-lightbulb_group_outline"] = 0xf1254,
  ["md-lightbulb_multiple"] = 0xf1255,
  ["md-lightbulb_multiple_off"] = 0xf12cf,
  ["md-lightbulb_multiple_off_outline"] = 0xf12d0,
  ["md-lightbulb_multiple_outline"] = 0xf1256,
  ["md-lightbulb_night"] = 0xf1a4c,
  ["md-lightbulb_night_outline"] = 0xf1a4d,
  ["md-lightbulb_off"] = 0xf0e4f,
  ["md-lightbulb_off_outline"] = 0xf0e50,
  ["md-lightbulb_on"] = 0xf06e8,
  ["md-lightbulb_on_10"] = 0xf1a4e,
  ["md-lightbulb_on_20"] = 0xf1a4f,
  ["md-lightbulb_on_30"] = 0xf1a50,
  ["md-lightbulb_on_40"] = 0xf1a51,
  ["md-lightbulb_on_50"] = 0xf1a52,
  ["md-lightbulb_on_60"] = 0xf1a53,
  ["md-lightbulb_on_70"] = 0xf1a54,
  ["md-lightbulb_on_80"] = 0xf1a55,
  ["md-lightbulb_on_90"] = 0xf1a56,
  ["md-lightbulb_on_outline"] = 0xf06e9,
  ["md-lightbulb_outline"] = 0xf0336,
  ["md-lightbulb_question"] = 0xf19e3,
  ["md-lightbulb_question_outline"] = 0xf19e4,
  ["md-lightbulb_spot"] = 0xf17f4,
  ["md-lightbulb_spot_off"] = 0xf17f5,
  ["md-lightbulb_variant"] = 0xf1802,
  ["md-lightbulb_variant_outline"] = 0xf1803,
  ["md-lighthouse"] = 0xf09ff,
  ["md-lighthouse_on"] = 0xf0a00,
  ["md-lightning_bolt"] = 0xf140b,
  ["md-lightning_bolt_circle"] = 0xf0820,
  ["md-lightning_bolt_outline"] = 0xf140c,
  ["md-line_scan"] = 0xf0624,
  ["md-lingerie"] = 0xf1476,
  ["md-link"] = 0xf0337,
  ["md-link_box"] = 0xf0d1a,
  ["md-link_box_outline"] = 0xf0d1b,
  ["md-link_box_variant"] = 0xf0d1c,
  ["md-link_box_variant_outline"] = 0xf0d1d,
  ["md-link_lock"] = 0xf10ba,
  ["md-link_off"] = 0xf0338,
  ["md-link_plus"] = 0xf0c94,
  ["md-link_variant"] = 0xf0339,
  ["md-link_variant_minus"] = 0xf10ff,
  ["md-link_variant_off"] = 0xf033a,
  ["md-link_variant_plus"] = 0xf1100,
  ["md-link_variant_remove"] = 0xf1101,
  ["md-linkedin"] = 0xf033b,
  ["md-linux"] = 0xf033d,
  ["md-linux_mint"] = 0xf08ed,
  ["md-lipstick"] = 0xf13b5,
  ["md-liquid_spot"] = 0xf1826,
  ["md-liquor"] = 0xf191e,
  ["md-list_status"] = 0xf15ab,
  ["md-litecoin"] = 0xf0a61,
  ["md-loading"] = 0xf0772,
  ["md-location_enter"] = 0xf0fc4,
  ["md-location_exit"] = 0xf0fc5,
  ["md-lock"] = 0xf033e,
  ["md-lock_alert"] = 0xf08ee,
  ["md-lock_alert_outline"] = 0xf15d1,
  ["md-lock_check"] = 0xf139a,
  ["md-lock_check_outline"] = 0xf16a8,
  ["md-lock_clock"] = 0xf097f,
  ["md-lock_minus"] = 0xf16a9,
  ["md-lock_minus_outline"] = 0xf16aa,
  ["md-lock_off"] = 0xf1671,
  ["md-lock_off_outline"] = 0xf1672,
  ["md-lock_open"] = 0xf033f,
  ["md-lock_open_alert"] = 0xf139b,
  ["md-lock_open_alert_outline"] = 0xf15d2,
  ["md-lock_open_check"] = 0xf139c,
  ["md-lock_open_check_outline"] = 0xf16ab,
  ["md-lock_open_minus"] = 0xf16ac,
  ["md-lock_open_minus_outline"] = 0xf16ad,
  ["md-lock_open_outline"] = 0xf0340,
  ["md-lock_open_plus"] = 0xf16ae,
  ["md-lock_open_plus_outline"] = 0xf16af,
  ["md-lock_open_remove"] = 0xf16b0,
  ["md-lock_open_remove_outline"] = 0xf16b1,
  ["md-lock_open_variant"] = 0xf0fc6,
  ["md-lock_open_variant_outline"] = 0xf0fc7,
  ["md-lock_outline"] = 0xf0341,
  ["md-lock_pattern"] = 0xf06ea,
  ["md-lock_plus"] = 0xf05fb,
  ["md-lock_plus_outline"] = 0xf16b2,
  ["md-lock_question"] = 0xf08ef,
  ["md-lock_remove"] = 0xf16b3,
  ["md-lock_remove_outline"] = 0xf16b4,
  ["md-lock_reset"] = 0xf0773,
  ["md-lock_smart"] = 0xf08b2,
  ["md-locker"] = 0xf07d7,
  ["md-locker_multiple"] = 0xf07d8,
  ["md-login"] = 0xf0342,
  ["md-logout"] = 0xf0343,
  ["md-logout_variant"] = 0xf05fd,
  ["md-longitude"] = 0xf0f5a,
  ["md-looks"] = 0xf0344,
  ["md-lotion"] = 0xf1582,
  ["md-lotion_outline"] = 0xf1583,
  ["md-lotion_plus"] = 0xf1584,
  ["md-lotion_plus_outline"] = 0xf1585,
  ["md-loupe"] = 0xf0345,
  ["md-lumx"] = 0xf0346,
  ["md-lungs"] = 0xf1084,
  ["md-mace"] = 0xf1843,
  ["md-magazine_pistol"] = 0xf0324,
  ["md-magazine_rifle"] = 0xf0323,
  ["md-magic_staff"] = 0xf1844,
  ["md-magnet"] = 0xf0347,
  ["md-magnet_on"] = 0xf0348,
  ["md-magnify"] = 0xf0349,
  ["md-magnify_close"] = 0xf0980,
  ["md-magnify_expand"] = 0xf1874,
  ["md-magnify_minus"] = 0xf034a,
  ["md-magnify_minus_cursor"] = 0xf0a62,
  ["md-magnify_minus_outline"] = 0xf06ec,
  ["md-magnify_plus"] = 0xf034b,
  ["md-magnify_plus_cursor"] = 0xf0a63,
  ["md-magnify_plus_outline"] = 0xf06ed,
  ["md-magnify_remove_cursor"] = 0xf120c,
  ["md-magnify_remove_outline"] = 0xf120d,
  ["md-magnify_scan"] = 0xf1276,
  ["md-mail"] = 0xf0ebb,
  ["md-mailbox"] = 0xf06ee,
  ["md-mailbox_open"] = 0xf0d88,
  ["md-mailbox_open_outline"] = 0xf0d89,
  ["md-mailbox_open_up"] = 0xf0d8a,
  ["md-mailbox_open_up_outline"] = 0xf0d8b,
  ["md-mailbox_outline"] = 0xf0d8c,
  ["md-mailbox_up"] = 0xf0d8d,
  ["md-mailbox_up_outline"] = 0xf0d8e,
  ["md-manjaro"] = 0xf160a,
  ["md-map"] = 0xf034d,
  ["md-map_check"] = 0xf0ebc,
  ["md-map_check_outline"] = 0xf0ebd,
  ["md-map_clock"] = 0xf0d1e,
  ["md-map_clock_outline"] = 0xf0d1f,
  ["md-map_legend"] = 0xf0a01,
  ["md-map_marker"] = 0xf034e,
  ["md-map_marker_account"] = 0xf18e3,
  ["md-map_marker_account_outline"] = 0xf18e4,
  ["md-map_marker_alert"] = 0xf0f05,
  ["md-map_marker_alert_outline"] = 0xf0f06,
  ["md-map_marker_check"] = 0xf0c95,
  ["md-map_marker_check_outline"] = 0xf12fb,
  ["md-map_marker_circle"] = 0xf034f,
  ["md-map_marker_distance"] = 0xf08f0,
  ["md-map_marker_down"] = 0xf1102,
  ["md-map_marker_left"] = 0xf12db,
  ["md-map_marker_left_outline"] = 0xf12dd,
  ["md-map_marker_minus"] = 0xf0650,
  ["md-map_marker_minus_outline"] = 0xf12f9,
  ["md-map_marker_multiple"] = 0xf0350,
  ["md-map_marker_multiple_outline"] = 0xf1277,
  ["md-map_marker_off"] = 0xf0351,
  ["md-map_marker_off_outline"] = 0xf12fd,
  ["md-map_marker_outline"] = 0xf07d9,
  ["md-map_marker_path"] = 0xf0d20,
  ["md-map_marker_plus"] = 0xf0651,
  ["md-map_marker_plus_outline"] = 0xf12f8,
  ["md-map_marker_question"] = 0xf0f07,
  ["md-map_marker_question_outline"] = 0xf0f08,
  ["md-map_marker_radius"] = 0xf0352,
  ["md-map_marker_radius_outline"] = 0xf12fc,
  ["md-map_marker_remove"] = 0xf0f09,
  ["md-map_marker_remove_outline"] = 0xf12fa,
  ["md-map_marker_remove_variant"] = 0xf0f0a,
  ["md-map_marker_right"] = 0xf12dc,
  ["md-map_marker_right_outline"] = 0xf12de,
  ["md-map_marker_star"] = 0xf1608,
  ["md-map_marker_star_outline"] = 0xf1609,
  ["md-map_marker_up"] = 0xf1103,
  ["md-map_minus"] = 0xf0981,
  ["md-map_outline"] = 0xf0982,
  ["md-map_plus"] = 0xf0983,
  ["md-map_search"] = 0xf0984,
  ["md-map_search_outline"] = 0xf0985,
  ["md-mapbox"] = 0xf0baa,
  ["md-margin"] = 0xf0353,
  ["md-marker"] = 0xf0652,
  ["md-marker_cancel"] = 0xf0dd9,
  ["md-marker_check"] = 0xf0355,
  ["md-mastodon"] = 0xf0ad1,
  ["md-material_design"] = 0xf0986,
  ["md-material_ui"] = 0xf0357,
  ["md-math_compass"] = 0xf0358,
  ["md-math_cos"] = 0xf0c96,
  ["md-math_integral"] = 0xf0fc8,
  ["md-math_integral_box"] = 0xf0fc9,
  ["md-math_log"] = 0xf1085,
  ["md-math_norm"] = 0xf0fca,
  ["md-math_norm_box"] = 0xf0fcb,
  ["md-math_sin"] = 0xf0c97,
  ["md-math_tan"] = 0xf0c98,
  ["md-matrix"] = 0xf0628,
  ["md-medal"] = 0xf0987,
  ["md-medal_outline"] = 0xf1326,
  ["md-medical_bag"] = 0xf06ef,
  ["md-medical_cotton_swab"] = 0xf1ab8,
  ["md-meditation"] = 0xf117b,
  ["md-memory"] = 0xf035b,
  ["md-menorah"] = 0xf17d4,
  ["md-menorah_fire"] = 0xf17d5,
  ["md-menu"] = 0xf035c,
  ["md-menu_down"] = 0xf035d,
  ["md-menu_down_outline"] = 0xf06b6,
  ["md-menu_left"] = 0xf035e,
  ["md-menu_left_outline"] = 0xf0a02,
  ["md-menu_open"] = 0xf0bab,
  ["md-menu_right"] = 0xf035f,
  ["md-menu_right_outline"] = 0xf0a03,
  ["md-menu_swap"] = 0xf0a64,
  ["md-menu_swap_outline"] = 0xf0a65,
  ["md-menu_up"] = 0xf0360,
  ["md-menu_up_outline"] = 0xf06b7,
  ["md-merge"] = 0xf0f5c,
  ["md-message"] = 0xf0361,
  ["md-message_alert"] = 0xf0362,
  ["md-message_alert_outline"] = 0xf0a04,
  ["md-message_arrow_left"] = 0xf12f2,
  ["md-message_arrow_left_outline"] = 0xf12f3,
  ["md-message_arrow_right"] = 0xf12f4,
  ["md-message_arrow_right_outline"] = 0xf12f5,
  ["md-message_badge"] = 0xf1941,
  ["md-message_badge_outline"] = 0xf1942,
  ["md-message_bookmark"] = 0xf15ac,
  ["md-message_bookmark_outline"] = 0xf15ad,
  ["md-message_bulleted"] = 0xf06a2,
  ["md-message_bulleted_off"] = 0xf06a3,
  ["md-message_cog"] = 0xf06f1,
  ["md-message_cog_outline"] = 0xf1172,
  ["md-message_draw"] = 0xf0363,
  ["md-message_fast"] = 0xf19cc,
  ["md-message_fast_outline"] = 0xf19cd,
  ["md-message_flash"] = 0xf15a9,
  ["md-message_flash_outline"] = 0xf15aa,
  ["md-message_image"] = 0xf0364,
  ["md-message_image_outline"] = 0xf116c,
  ["md-message_lock"] = 0xf0fcc,
  ["md-message_lock_outline"] = 0xf116d,
  ["md-message_minus"] = 0xf116e,
  ["md-message_minus_outline"] = 0xf116f,
  ["md-message_off"] = 0xf164d,
  ["md-message_off_outline"] = 0xf164e,
  ["md-message_outline"] = 0xf0365,
  ["md-message_plus"] = 0xf0653,
  ["md-message_plus_outline"] = 0xf10bb,
  ["md-message_processing"] = 0xf0366,
  ["md-message_processing_outline"] = 0xf1170,
  ["md-message_question"] = 0xf173a,
  ["md-message_question_outline"] = 0xf173b,
  ["md-message_reply"] = 0xf0367,
  ["md-message_reply_outline"] = 0xf173d,
  ["md-message_reply_text"] = 0xf0368,
  ["md-message_reply_text_outline"] = 0xf173e,
  ["md-message_settings"] = 0xf06f0,
  ["md-message_settings_outline"] = 0xf1171,
  ["md-message_star"] = 0xf069a,
  ["md-message_star_outline"] = 0xf1250,
  ["md-message_text"] = 0xf0369,
  ["md-message_text_clock"] = 0xf1173,
  ["md-message_text_clock_outline"] = 0xf1174,
  ["md-message_text_fast"] = 0xf19ce,
  ["md-message_text_fast_outline"] = 0xf19cf,
  ["md-message_text_lock"] = 0xf0fcd,
  ["md-message_text_lock_outline"] = 0xf1175,
  ["md-message_text_outline"] = 0xf036a,
  ["md-message_video"] = 0xf036b,
  ["md-meteor"] = 0xf0629,
  ["md-meter_electric"] = 0xf1a57,
  ["md-meter_electric_outline"] = 0xf1a58,
  ["md-meter_gas"] = 0xf1a59,
  ["md-meter_gas_outline"] = 0xf1a5a,
  ["md-metronome"] = 0xf07da,
  ["md-metronome_tick"] = 0xf07db,
  ["md-micro_sd"] = 0xf07dc,
  ["md-microphone"] = 0xf036c,
  ["md-microphone_minus"] = 0xf08b3,
  ["md-microphone_off"] = 0xf036d,
  ["md-microphone_outline"] = 0xf036e,
  ["md-microphone_plus"] = 0xf08b4,
  ["md-microphone_question"] = 0xf1989,
  ["md-microphone_question_outline"] = 0xf198a,
  ["md-microphone_settings"] = 0xf036f,
  ["md-microphone_variant"] = 0xf0370,
  ["md-microphone_variant_off"] = 0xf0371,
  ["md-microscope"] = 0xf0654,
  ["md-microsoft"] = 0xf0372,
  ["md-microsoft_access"] = 0xf138e,
  ["md-microsoft_azure"] = 0xf0805,
  ["md-microsoft_azure_devops"] = 0xf0fd5,
  ["md-microsoft_bing"] = 0xf00a4,
  ["md-microsoft_dynamics_365"] = 0xf0988,
  ["md-microsoft_edge"] = 0xf01e9,
  ["md-microsoft_excel"] = 0xf138f,
  ["md-microsoft_internet_explorer"] = 0xf0300,
  ["md-microsoft_office"] = 0xf03c6,
  ["md-microsoft_onedrive"] = 0xf03ca,
  ["md-microsoft_onenote"] = 0xf0747,
  ["md-microsoft_outlook"] = 0xf0d22,
  ["md-microsoft_powerpoint"] = 0xf1390,
  ["md-microsoft_sharepoint"] = 0xf1391,
  ["md-microsoft_teams"] = 0xf02bb,
  ["md-microsoft_visual_studio"] = 0xf0610,
  ["md-microsoft_visual_studio_code"] = 0xf0a1e,
  ["md-microsoft_windows"] = 0xf05b3,
  ["md-microsoft_windows_classic"] = 0xf0a21,
  ["md-microsoft_word"] = 0xf1392,
  ["md-microsoft_xbox"] = 0xf05b9,
  ["md-microsoft_xbox_controller"] = 0xf05ba,
  ["md-microsoft_xbox_controller_battery_alert"] = 0xf074b,
  ["md-microsoft_xbox_controller_battery_charging"] = 0xf0a22,
  ["md-microsoft_xbox_controller_battery_empty"] = 0xf074c,
  ["md-microsoft_xbox_controller_battery_full"] = 0xf074d,
  ["md-microsoft_xbox_controller_battery_low"] = 0xf074e,
  ["md-microsoft_xbox_controller_battery_medium"] = 0xf074f,
  ["md-microsoft_xbox_controller_battery_unknown"] = 0xf0750,
  ["md-microsoft_xbox_controller_menu"] = 0xf0e6f,
  ["md-microsoft_xbox_controller_off"] = 0xf05bb,
  ["md-microsoft_xbox_controller_view"] = 0xf0e70,
  ["md-microwave"] = 0xf0c99,
  ["md-microwave_off"] = 0xf1423,
  ["md-middleware"] = 0xf0f5d,
  ["md-middleware_outline"] = 0xf0f5e,
  ["md-midi"] = 0xf08f1,
  ["md-midi_port"] = 0xf08f2,
  ["md-mine"] = 0xf0dda,
  ["md-minecraft"] = 0xf0373,
  ["md-mini_sd"] = 0xf0a05,
  ["md-minidisc"] = 0xf0a06,
  ["md-minus"] = 0xf0374,
  ["md-minus_box"] = 0xf0375,
  ["md-minus_box_multiple"] = 0xf1141,
  ["md-minus_box_multiple_outline"] = 0xf1142,
  ["md-minus_box_outline"] = 0xf06f2,
  ["md-minus_circle"] = 0xf0376,
  ["md-minus_circle_multiple"] = 0xf035a,
  ["md-minus_circle_multiple_outline"] = 0xf0ad3,
  ["md-minus_circle_off"] = 0xf1459,
  ["md-minus_circle_off_outline"] = 0xf145a,
  ["md-minus_circle_outline"] = 0xf0377,
  ["md-minus_network"] = 0xf0378,
  ["md-minus_network_outline"] = 0xf0c9a,
  ["md-minus_thick"] = 0xf1639,
  ["md-mirror"] = 0xf11fd,
  ["md-mirror_rectangle"] = 0xf179f,
  ["md-mirror_variant"] = 0xf17a0,
  ["md-mixed_martial_arts"] = 0xf0d8f,
  ["md-mixed_reality"] = 0xf087f,
  ["md-molecule"] = 0xf0bac,
  ["md-molecule_co"] = 0xf12fe,
  ["md-molecule_co2"] = 0xf07e4,
  ["md-monitor"] = 0xf0379,
  ["md-monitor_account"] = 0xf1a5b,
  ["md-monitor_arrow_down"] = 0xf19d0,
  ["md-monitor_arrow_down_variant"] = 0xf19d1,
  ["md-monitor_cellphone"] = 0xf0989,
  ["md-monitor_cellphone_star"] = 0xf098a,
  ["md-monitor_dashboard"] = 0xf0a07,
  ["md-monitor_edit"] = 0xf12c6,
  ["md-monitor_eye"] = 0xf13b4,
  ["md-monitor_lock"] = 0xf0ddb,
  ["md-monitor_multiple"] = 0xf037a,
  ["md-monitor_off"] = 0xf0d90,
  ["md-monitor_screenshot"] = 0xf0e51,
  ["md-monitor_share"] = 0xf1483,
  ["md-monitor_shimmer"] = 0xf1104,
  ["md-monitor_small"] = 0xf1876,
  ["md-monitor_speaker"] = 0xf0f5f,
  ["md-monitor_speaker_off"] = 0xf0f60,
  ["md-monitor_star"] = 0xf0ddc,
  ["md-moon_first_quarter"] = 0xf0f61,
  ["md-moon_full"] = 0xf0f62,
  ["md-moon_last_quarter"] = 0xf0f63,
  ["md-moon_new"] = 0xf0f64,
  ["md-moon_waning_crescent"] = 0xf0f65,
  ["md-moon_waning_gibbous"] = 0xf0f66,
  ["md-moon_waxing_crescent"] = 0xf0f67,
  ["md-moon_waxing_gibbous"] = 0xf0f68,
  ["md-moped"] = 0xf1086,
  ["md-moped_electric"] = 0xf15b7,
  ["md-moped_electric_outline"] = 0xf15b8,
  ["md-moped_outline"] = 0xf15b9,
  ["md-more"] = 0xf037b,
  ["md-mortar_pestle"] = 0xf1748,
  ["md-mortar_pestle_plus"] = 0xf03f1,
  ["md-mosque"] = 0xf1827,
  ["md-mother_heart"] = 0xf1314,
  ["md-mother_nurse"] = 0xf0d21,
  ["md-motion"] = 0xf15b2,
  ["md-motion_outline"] = 0xf15b3,
  ["md-motion_pause"] = 0xf1590,
  ["md-motion_pause_outline"] = 0xf1592,
  ["md-motion_play"] = 0xf158f,
  ["md-motion_play_outline"] = 0xf1591,
  ["md-motion_sensor"] = 0xf0d91,
  ["md-motion_sensor_off"] = 0xf1435,
  ["md-motorbike"] = 0xf037c,
  ["md-motorbike_electric"] = 0xf15ba,
  ["md-mouse"] = 0xf037d,
  ["md-mouse_bluetooth"] = 0xf098b,
  ["md-mouse_move_down"] = 0xf1550,
  ["md-mouse_move_up"] = 0xf1551,
  ["md-mouse_move_vertical"] = 0xf1552,
  ["md-mouse_off"] = 0xf037e,
  ["md-mouse_variant"] = 0xf037f,
  ["md-mouse_variant_off"] = 0xf0380,
  ["md-move_resize"] = 0xf0655,
  ["md-move_resize_variant"] = 0xf0656,
  ["md-movie"] = 0xf0381,
  ["md-movie_check"] = 0xf16f3,
  ["md-movie_check_outline"] = 0xf16f4,
  ["md-movie_cog"] = 0xf16f5,
  ["md-movie_cog_outline"] = 0xf16f6,
  ["md-movie_edit"] = 0xf1122,
  ["md-movie_edit_outline"] = 0xf1123,
  ["md-movie_filter"] = 0xf1124,
  ["md-movie_filter_outline"] = 0xf1125,
  ["md-movie_minus"] = 0xf16f7,
  ["md-movie_minus_outline"] = 0xf16f8,
  ["md-movie_off"] = 0xf16f9,
  ["md-movie_off_outline"] = 0xf16fa,
  ["md-movie_open"] = 0xf0fce,
  ["md-movie_open_check"] = 0xf16fb,
  ["md-movie_open_check_outline"] = 0xf16fc,
  ["md-movie_open_cog"] = 0xf16fd,
  ["md-movie_open_cog_outline"] = 0xf16fe,
  ["md-movie_open_edit"] = 0xf16ff,
  ["md-movie_open_edit_outline"] = 0xf1700,
  ["md-movie_open_minus"] = 0xf1701,
  ["md-movie_open_minus_outline"] = 0xf1702,
  ["md-movie_open_off"] = 0xf1703,
  ["md-movie_open_off_outline"] = 0xf1704,
  ["md-movie_open_outline"] = 0xf0fcf,
  ["md-movie_open_play"] = 0xf1705,
  ["md-movie_open_play_outline"] = 0xf1706,
  ["md-movie_open_plus"] = 0xf1707,
  ["md-movie_open_plus_outline"] = 0xf1708,
  ["md-movie_open_remove"] = 0xf1709,
  ["md-movie_open_remove_outline"] = 0xf170a,
  ["md-movie_open_settings"] = 0xf170b,
  ["md-movie_open_settings_outline"] = 0xf170c,
  ["md-movie_open_star"] = 0xf170d,
  ["md-movie_open_star_outline"] = 0xf170e,
  ["md-movie_outline"] = 0xf0ddd,
  ["md-movie_play"] = 0xf170f,
  ["md-movie_play_outline"] = 0xf1710,
  ["md-movie_plus"] = 0xf1711,
  ["md-movie_plus_outline"] = 0xf1712,
  ["md-movie_remove"] = 0xf1713,
  ["md-movie_remove_outline"] = 0xf1714,
  ["md-movie_roll"] = 0xf07de,
  ["md-movie_search"] = 0xf11d2,
  ["md-movie_search_outline"] = 0xf11d3,
  ["md-movie_settings"] = 0xf1715,
  ["md-movie_settings_outline"] = 0xf1716,
  ["md-movie_star"] = 0xf1717,
  ["md-movie_star_outline"] = 0xf1718,
  ["md-mower"] = 0xf166f,
  ["md-mower_bag"] = 0xf1670,
  ["md-muffin"] = 0xf098c,
  ["md-multicast"] = 0xf1893,
  ["md-multiplication"] = 0xf0382,
  ["md-multiplication_box"] = 0xf0383,
  ["md-mushroom"] = 0xf07df,
  ["md-mushroom_off"] = 0xf13fa,
  ["md-mushroom_off_outline"] = 0xf13fb,
  ["md-mushroom_outline"] = 0xf07e0,
  ["md-music"] = 0xf075a,
  ["md-music_accidental_double_flat"] = 0xf0f69,
  ["md-music_accidental_double_sharp"] = 0xf0f6a,
  ["md-music_accidental_flat"] = 0xf0f6b,
  ["md-music_accidental_natural"] = 0xf0f6c,
  ["md-music_accidental_sharp"] = 0xf0f6d,
  ["md-music_box"] = 0xf0384,
  ["md-music_box_multiple"] = 0xf0333,
  ["md-music_box_multiple_outline"] = 0xf0f04,
  ["md-music_box_outline"] = 0xf0385,
  ["md-music_circle"] = 0xf0386,
  ["md-music_circle_outline"] = 0xf0ad4,
  ["md-music_clef_alto"] = 0xf0f6e,
  ["md-music_clef_bass"] = 0xf0f6f,
  ["md-music_clef_treble"] = 0xf0f70,
  ["md-music_note"] = 0xf0388,
  ["md-music_note_bluetooth"] = 0xf05fe,
  ["md-music_note_bluetooth_off"] = 0xf05ff,
  ["md-music_note_eighth_dotted"] = 0xf0f71,
  ["md-music_note_half"] = 0xf0389,
  ["md-music_note_half_dotted"] = 0xf0f72,
  ["md-music_note_off"] = 0xf038a,
  ["md-music_note_off_outline"] = 0xf0f73,
  ["md-music_note_outline"] = 0xf0f74,
  ["md-music_note_plus"] = 0xf0dde,
  ["md-music_note_quarter"] = 0xf038b,
  ["md-music_note_quarter_dotted"] = 0xf0f75,
  ["md-music_note_sixteenth"] = 0xf038c,
  ["md-music_note_sixteenth_dotted"] = 0xf0f76,
  ["md-music_note_whole"] = 0xf038d,
  ["md-music_note_whole_dotted"] = 0xf0f77,
  ["md-music_off"] = 0xf075b,
  ["md-music_rest_eighth"] = 0xf0f78,
  ["md-music_rest_half"] = 0xf0f79,
  ["md-music_rest_quarter"] = 0xf0f7a,
  ["md-music_rest_sixteenth"] = 0xf0f7b,
  ["md-music_rest_whole"] = 0xf0f7c,
  ["md-mustache"] = 0xf15de,
  ["md-nail"] = 0xf0ddf,
  ["md-nas"] = 0xf08f3,
  ["md-nativescript"] = 0xf0880,
  ["md-nature"] = 0xf038e,
  ["md-nature_people"] = 0xf038f,
  ["md-navigation"] = 0xf0390,
  ["md-navigation_outline"] = 0xf1607,
  ["md-navigation_variant_outline"] = 0xf18f1,
  ["md-near_me"] = 0xf18f0,
  ["md-necklace"] = 0xf0f0b,
  ["md-needle"] = 0xf0391,
  ["md-needle_off"] = 0xf19d2,
  ["md-netflix"] = 0xf0746,
  ["md-network"] = 0xf06f3,
  ["md-network_off"] = 0xf0c9b,
  ["md-network_off_outline"] = 0xf0c9c,
  ["md-network_outline"] = 0xf0c9d,
  ["md-network_pos"] = 0xf1acb,
  ["md-network_strength_1"] = 0xf08f4,
  ["md-network_strength_1_alert"] = 0xf08f5,
  ["md-network_strength_2"] = 0xf08f6,
  ["md-network_strength_2_alert"] = 0xf08f7,
  ["md-network_strength_3"] = 0xf08f8,
  ["md-network_strength_3_alert"] = 0xf08f9,
  ["md-network_strength_4"] = 0xf08fa,
  ["md-network_strength_4_alert"] = 0xf08fb,
  ["md-network_strength_4_cog"] = 0xf191a,
  ["md-network_strength_off"] = 0xf08fc,
  ["md-network_strength_off_outline"] = 0xf08fd,
  ["md-network_strength_outline"] = 0xf08fe,
  ["md-new_box"] = 0xf0394,
  ["md-newspaper"] = 0xf0395,
  ["md-newspaper_check"] = 0xf1943,
  ["md-newspaper_minus"] = 0xf0f0c,
  ["md-newspaper_plus"] = 0xf0f0d,
  ["md-newspaper_remove"] = 0xf1944,
  ["md-newspaper_variant"] = 0xf1001,
  ["md-newspaper_variant_multiple"] = 0xf1002,
  ["md-newspaper_variant_multiple_outline"] = 0xf1003,
  ["md-newspaper_variant_outline"] = 0xf1004,
  ["md-nfc"] = 0xf0396,
  ["md-nfc_search_variant"] = 0xf0e53,
  ["md-nfc_tap"] = 0xf0397,
  ["md-nfc_variant"] = 0xf0398,
  ["md-nfc_variant_off"] = 0xf0e54,
  ["md-ninja"] = 0xf0774,
  ["md-nintendo_game_boy"] = 0xf1393,
  ["md-nintendo_switch"] = 0xf07e1,
  ["md-nintendo_wii"] = 0xf05ab,
  ["md-nintendo_wiiu"] = 0xf072d,
  ["md-nix"] = 0xf1105,
  ["md-nodejs"] = 0xf0399,
  ["md-noodles"] = 0xf117e,
  ["md-not_equal"] = 0xf098d,
  ["md-not_equal_variant"] = 0xf098e,
  ["md-note"] = 0xf039a,
  ["md-note_alert"] = 0xf177d,
  ["md-note_alert_outline"] = 0xf177e,
  ["md-note_check"] = 0xf177f,
  ["md-note_check_outline"] = 0xf1780,
  ["md-note_edit"] = 0xf1781,
  ["md-note_edit_outline"] = 0xf1782,
  ["md-note_minus"] = 0xf164f,
  ["md-note_minus_outline"] = 0xf1650,
  ["md-note_multiple"] = 0xf06b8,
  ["md-note_multiple_outline"] = 0xf06b9,
  ["md-note_off"] = 0xf1783,
  ["md-note_off_outline"] = 0xf1784,
  ["md-note_outline"] = 0xf039b,
  ["md-note_plus"] = 0xf039c,
  ["md-note_plus_outline"] = 0xf039d,
  ["md-note_remove"] = 0xf1651,
  ["md-note_remove_outline"] = 0xf1652,
  ["md-note_search"] = 0xf1653,
  ["md-note_search_outline"] = 0xf1654,
  ["md-note_text"] = 0xf039e,
  ["md-note_text_outline"] = 0xf11d7,
  ["md-notebook"] = 0xf082e,
  ["md-notebook_check"] = 0xf14f5,
  ["md-notebook_check_outline"] = 0xf14f6,
  ["md-notebook_edit"] = 0xf14e7,
  ["md-notebook_edit_outline"] = 0xf14e9,
  ["md-notebook_heart"] = 0xf1a0b,
  ["md-notebook_heart_outline"] = 0xf1a0c,
  ["md-notebook_minus"] = 0xf1610,
  ["md-notebook_minus_outline"] = 0xf1611,
  ["md-notebook_multiple"] = 0xf0e55,
  ["md-notebook_outline"] = 0xf0ebf,
  ["md-notebook_plus"] = 0xf1612,
  ["md-notebook_plus_outline"] = 0xf1613,
  ["md-notebook_remove"] = 0xf1614,
  ["md-notebook_remove_outline"] = 0xf1615,
  ["md-notification_clear_all"] = 0xf039f,
  ["md-npm"] = 0xf06f7,
  ["md-nuke"] = 0xf06a4,
  ["md-null"] = 0xf07e2,
  ["md-numeric"] = 0xf03a0,
  ["md-numeric_0_box"] = 0xf03a1,
  ["md-numeric_0_box_multiple"] = 0xf0f0e,
  ["md-numeric_0_box_multiple_outline"] = 0xf03a2,
  ["md-numeric_0_box_outline"] = 0xf03a3,
  ["md-numeric_1"] = 0xf0b3a,
  ["md-numeric_10"] = 0xf0fe9,
  ["md-numeric_10_box"] = 0xf0f7d,
  ["md-numeric_10_box_multiple"] = 0xf0fea,
  ["md-numeric_10_box_multiple_outline"] = 0xf0feb,
  ["md-numeric_10_box_outline"] = 0xf0f7e,
  ["md-numeric_10_circle"] = 0xf0fec,
  ["md-numeric_10_circle_outline"] = 0xf0fed,
  ["md-numeric_1_box"] = 0xf03a4,
  ["md-numeric_1_box_multiple"] = 0xf0f0f,
  ["md-numeric_1_box_multiple_outline"] = 0xf03a5,
  ["md-numeric_1_box_outline"] = 0xf03a6,
  ["md-numeric_1_circle"] = 0xf0ca0,
  ["md-numeric_1_circle_outline"] = 0xf0ca1,
  ["md-numeric_2"] = 0xf0b3b,
  ["md-numeric_2_box"] = 0xf03a7,
  ["md-numeric_2_box_multiple"] = 0xf0f10,
  ["md-numeric_2_box_multiple_outline"] = 0xf03a8,
  ["md-numeric_2_box_outline"] = 0xf03a9,
  ["md-numeric_2_circle"] = 0xf0ca2,
  ["md-numeric_2_circle_outline"] = 0xf0ca3,
  ["md-numeric_3"] = 0xf0b3c,
  ["md-numeric_3_box"] = 0xf03aa,
  ["md-numeric_3_box_multiple"] = 0xf0f11,
  ["md-numeric_3_box_multiple_outline"] = 0xf03ab,
  ["md-numeric_3_box_outline"] = 0xf03ac,
  ["md-numeric_3_circle"] = 0xf0ca4,
  ["md-numeric_3_circle_outline"] = 0xf0ca5,
  ["md-numeric_4"] = 0xf0b3d,
  ["md-numeric_4_box"] = 0xf03ad,
  ["md-numeric_4_box_multiple"] = 0xf0f12,
  ["md-numeric_4_box_multiple_outline"] = 0xf03b2,
  ["md-numeric_4_box_outline"] = 0xf03ae,
  ["md-numeric_4_circle"] = 0xf0ca6,
  ["md-numeric_4_circle_outline"] = 0xf0ca7,
  ["md-numeric_5"] = 0xf0b3e,
  ["md-numeric_5_box"] = 0xf03b1,
  ["md-numeric_5_box_multiple"] = 0xf0f13,
  ["md-numeric_5_box_multiple_outline"] = 0xf03af,
  ["md-numeric_5_box_outline"] = 0xf03b0,
  ["md-numeric_5_circle"] = 0xf0ca8,
  ["md-numeric_5_circle_outline"] = 0xf0ca9,
  ["md-numeric_6"] = 0xf0b3f,
  ["md-numeric_6_box"] = 0xf03b3,
  ["md-numeric_6_box_multiple"] = 0xf0f14,
  ["md-numeric_6_box_multiple_outline"] = 0xf03b4,
  ["md-numeric_6_box_outline"] = 0xf03b5,
  ["md-numeric_6_circle"] = 0xf0caa,
  ["md-numeric_6_circle_outline"] = 0xf0cab,
  ["md-numeric_7"] = 0xf0b40,
  ["md-numeric_7_box"] = 0xf03b6,
  ["md-numeric_7_box_multiple"] = 0xf0f15,
  ["md-numeric_7_box_multiple_outline"] = 0xf03b7,
  ["md-numeric_7_box_outline"] = 0xf03b8,
  ["md-numeric_7_circle"] = 0xf0cac,
  ["md-numeric_7_circle_outline"] = 0xf0cad,
  ["md-numeric_8"] = 0xf0b41,
  ["md-numeric_8_box"] = 0xf03b9,
  ["md-numeric_8_box_multiple"] = 0xf0f16,
  ["md-numeric_8_box_multiple_outline"] = 0xf03ba,
  ["md-numeric_8_box_outline"] = 0xf03bb,
  ["md-numeric_8_circle"] = 0xf0cae,
  ["md-numeric_8_circle_outline"] = 0xf0caf,
  ["md-numeric_9"] = 0xf0b42,
  ["md-numeric_9_box"] = 0xf03bc,
  ["md-numeric_9_box_multiple"] = 0xf0f17,
  ["md-numeric_9_box_multiple_outline"] = 0xf03bd,
  ["md-numeric_9_box_outline"] = 0xf03be,
  ["md-numeric_9_circle"] = 0xf0cb0,
  ["md-numeric_9_circle_outline"] = 0xf0cb1,
  ["md-numeric_9_plus"] = 0xf0fee,
  ["md-numeric_9_plus_box"] = 0xf03bf,
  ["md-numeric_9_plus_box_multiple"] = 0xf0f18,
  ["md-numeric_9_plus_box_multiple_outline"] = 0xf03c0,
  ["md-numeric_9_plus_box_outline"] = 0xf03c1,
  ["md-numeric_9_plus_circle"] = 0xf0cb2,
  ["md-numeric_9_plus_circle_outline"] = 0xf0cb3,
  ["md-numeric_negative_1"] = 0xf1052,
  ["md-numeric_off"] = 0xf19d3,
  ["md-numeric_positive_1"] = 0xf15cb,
  ["md-nut"] = 0xf06f8,
  ["md-nutrition"] = 0xf03c2,
  ["md-nuxt"] = 0xf1106,
  ["md-oar"] = 0xf067c,
  ["md-ocarina"] = 0xf0de0,
  ["md-oci"] = 0xf12e9,
  ["md-ocr"] = 0xf113a,
  ["md-octagon"] = 0xf03c3,
  ["md-octagon_outline"] = 0xf03c4,
  ["md-octagram"] = 0xf06f9,
  ["md-octagram_outline"] = 0xf0775,
  ["md-octahedron"] = 0xf1950,
  ["md-octahedron_off"] = 0xf1951,
  ["md-odnoklassniki"] = 0xf03c5,
  ["md-offer"] = 0xf121b,
  ["md-office_building"] = 0xf0991,
  ["md-office_building_cog"] = 0xf1949,
  ["md-office_building_cog_outline"] = 0xf194a,
  ["md-office_building_marker"] = 0xf1520,
  ["md-office_building_marker_outline"] = 0xf1521,
  ["md-office_building_outline"] = 0xf151f,
  ["md-oil"] = 0xf03c7,
  ["md-oil_lamp"] = 0xf0f19,
  ["md-oil_level"] = 0xf1053,
  ["md-oil_temperature"] = 0xf0ff8,
  ["md-om"] = 0xf0973,
  ["md-omega"] = 0xf03c9,
  ["md-one_up"] = 0xf0bad,
  ["md-onepassword"] = 0xf0881,
  ["md-opacity"] = 0xf05cc,
  ["md-open_in_app"] = 0xf03cb,
  ["md-open_in_new"] = 0xf03cc,
  ["md-open_source_initiative"] = 0xf0bae,
  ["md-openid"] = 0xf03cd,
  ["md-opera"] = 0xf03ce,
  ["md-orbit"] = 0xf0018,
  ["md-orbit_variant"] = 0xf15db,
  ["md-order_alphabetical_ascending"] = 0xf020d,
  ["md-order_alphabetical_descending"] = 0xf0d07,
  ["md-order_bool_ascending"] = 0xf02be,
  ["md-order_bool_ascending_variant"] = 0xf098f,
  ["md-order_bool_descending"] = 0xf1384,
  ["md-order_bool_descending_variant"] = 0xf0990,
  ["md-order_numeric_ascending"] = 0xf0545,
  ["md-order_numeric_descending"] = 0xf0546,
  ["md-origin"] = 0xf0b43,
  ["md-ornament"] = 0xf03cf,
  ["md-ornament_variant"] = 0xf03d0,
  ["md-outdoor_lamp"] = 0xf1054,
  ["md-overscan"] = 0xf1005,
  ["md-owl"] = 0xf03d2,
  ["md-pac_man"] = 0xf0baf,
  ["md-package"] = 0xf03d3,
  ["md-package_down"] = 0xf03d4,
  ["md-package_up"] = 0xf03d5,
  ["md-package_variant"] = 0xf03d6,
  ["md-package_variant_closed"] = 0xf03d7,
  ["md-package_variant_closed_minus"] = 0xf19d4,
  ["md-package_variant_closed_plus"] = 0xf19d5,
  ["md-package_variant_closed_remove"] = 0xf19d6,
  ["md-package_variant_minus"] = 0xf19d7,
  ["md-package_variant_plus"] = 0xf19d8,
  ["md-package_variant_remove"] = 0xf19d9,
  ["md-page_first"] = 0xf0600,
  ["md-page_last"] = 0xf0601,
  ["md-page_layout_body"] = 0xf06fa,
  ["md-page_layout_footer"] = 0xf06fb,
  ["md-page_layout_header"] = 0xf06fc,
  ["md-page_layout_header_footer"] = 0xf0f7f,
  ["md-page_layout_sidebar_left"] = 0xf06fd,
  ["md-page_layout_sidebar_right"] = 0xf06fe,
  ["md-page_next"] = 0xf0bb0,
  ["md-page_next_outline"] = 0xf0bb1,
  ["md-page_previous"] = 0xf0bb2,
  ["md-page_previous_outline"] = 0xf0bb3,
  ["md-pail"] = 0xf1417,
  ["md-pail_minus"] = 0xf1437,
  ["md-pail_minus_outline"] = 0xf143c,
  ["md-pail_off"] = 0xf1439,
  ["md-pail_off_outline"] = 0xf143e,
  ["md-pail_outline"] = 0xf143a,
  ["md-pail_plus"] = 0xf1436,
  ["md-pail_plus_outline"] = 0xf143b,
  ["md-pail_remove"] = 0xf1438,
  ["md-pail_remove_outline"] = 0xf143d,
  ["md-palette"] = 0xf03d8,
  ["md-palette_advanced"] = 0xf03d9,
  ["md-palette_outline"] = 0xf0e0c,
  ["md-palette_swatch"] = 0xf08b5,
  ["md-palette_swatch_outline"] = 0xf135c,
  ["md-palette_swatch_variant"] = 0xf195a,
  ["md-palm_tree"] = 0xf1055,
  ["md-pan"] = 0xf0bb4,
  ["md-pan_bottom_left"] = 0xf0bb5,
  ["md-pan_bottom_right"] = 0xf0bb6,
  ["md-pan_down"] = 0xf0bb7,
  ["md-pan_horizontal"] = 0xf0bb8,
  ["md-pan_left"] = 0xf0bb9,
  ["md-pan_right"] = 0xf0bba,
  ["md-pan_top_left"] = 0xf0bbb,
  ["md-pan_top_right"] = 0xf0bbc,
  ["md-pan_up"] = 0xf0bbd,
  ["md-pan_vertical"] = 0xf0bbe,
  ["md-panda"] = 0xf03da,
  ["md-pandora"] = 0xf03db,
  ["md-panorama"] = 0xf03dc,
  ["md-panorama_fisheye"] = 0xf03dd,
  ["md-panorama_horizontal"] = 0xf1928,
  ["md-panorama_horizontal_outline"] = 0xf03de,
  ["md-panorama_outline"] = 0xf198c,
  ["md-panorama_sphere"] = 0xf198d,
  ["md-panorama_sphere_outline"] = 0xf198e,
  ["md-panorama_variant"] = 0xf198f,
  ["md-panorama_variant_outline"] = 0xf1990,
  ["md-panorama_vertical"] = 0xf1929,
  ["md-panorama_vertical_outline"] = 0xf03df,
  ["md-panorama_wide_angle"] = 0xf195f,
  ["md-panorama_wide_angle_outline"] = 0xf03e0,
  ["md-paper_cut_vertical"] = 0xf03e1,
  ["md-paper_roll"] = 0xf1157,
  ["md-paper_roll_outline"] = 0xf1158,
  ["md-paperclip"] = 0xf03e2,
  ["md-paperclip_check"] = 0xf1ac6,
  ["md-paperclip_lock"] = 0xf19da,
  ["md-paperclip_minus"] = 0xf1ac7,
  ["md-paperclip_off"] = 0xf1ac8,
  ["md-paperclip_plus"] = 0xf1ac9,
  ["md-paperclip_remove"] = 0xf1aca,
  ["md-parachute"] = 0xf0cb4,
  ["md-parachute_outline"] = 0xf0cb5,
  ["md-paragliding"] = 0xf1745,
  ["md-parking"] = 0xf03e3,
  ["md-party_popper"] = 0xf1056,
  ["md-passport"] = 0xf07e3,
  ["md-passport_biometric"] = 0xf0de1,
  ["md-pasta"] = 0xf1160,
  ["md-patio_heater"] = 0xf0f80,
  ["md-patreon"] = 0xf0882,
  ["md-pause"] = 0xf03e4,
  ["md-pause_circle"] = 0xf03e5,
  ["md-pause_circle_outline"] = 0xf03e6,
  ["md-pause_octagon"] = 0xf03e7,
  ["md-pause_octagon_outline"] = 0xf03e8,
  ["md-paw"] = 0xf03e9,
  ["md-paw_off"] = 0xf0657,
  ["md-paw_off_outline"] = 0xf1676,
  ["md-paw_outline"] = 0xf1675,
  ["md-peace"] = 0xf0884,
  ["md-peanut"] = 0xf0ffc,
  ["md-peanut_off"] = 0xf0ffd,
  ["md-peanut_off_outline"] = 0xf0fff,
  ["md-peanut_outline"] = 0xf0ffe,
  ["md-pen"] = 0xf03ea,
  ["md-pen_lock"] = 0xf0de2,
  ["md-pen_minus"] = 0xf0de3,
  ["md-pen_off"] = 0xf0de4,
  ["md-pen_plus"] = 0xf0de5,
  ["md-pen_remove"] = 0xf0de6,
  ["md-pencil"] = 0xf03eb,
  ["md-pencil_box"] = 0xf03ec,
  ["md-pencil_box_multiple"] = 0xf1144,
  ["md-pencil_box_multiple_outline"] = 0xf1145,
  ["md-pencil_box_outline"] = 0xf03ed,
  ["md-pencil_circle"] = 0xf06ff,
  ["md-pencil_circle_outline"] = 0xf0776,
  ["md-pencil_lock"] = 0xf03ee,
  ["md-pencil_lock_outline"] = 0xf0de7,
  ["md-pencil_minus"] = 0xf0de8,
  ["md-pencil_minus_outline"] = 0xf0de9,
  ["md-pencil_off"] = 0xf03ef,
  ["md-pencil_off_outline"] = 0xf0dea,
  ["md-pencil_outline"] = 0xf0cb6,
  ["md-pencil_plus"] = 0xf0deb,
  ["md-pencil_plus_outline"] = 0xf0dec,
  ["md-pencil_remove"] = 0xf0ded,
  ["md-pencil_remove_outline"] = 0xf0dee,
  ["md-pencil_ruler"] = 0xf1353,
  ["md-penguin"] = 0xf0ec0,
  ["md-pentagon"] = 0xf0701,
  ["md-pentagon_outline"] = 0xf0700,
  ["md-pentagram"] = 0xf1667,
  ["md-percent"] = 0xf03f0,
  ["md-percent_box"] = 0xf1a02,
  ["md-percent_box_outline"] = 0xf1a03,
  ["md-percent_circle"] = 0xf1a04,
  ["md-percent_circle_outline"] = 0xf1a05,
  ["md-percent_outline"] = 0xf1278,
  ["md-periodic_table"] = 0xf08b6,
  ["md-perspective_less"] = 0xf0d23,
  ["md-perspective_more"] = 0xf0d24,
  ["md-ph"] = 0xf17c5,
  ["md-phone"] = 0xf03f2,
  ["md-phone_alert"] = 0xf0f1a,
  ["md-phone_alert_outline"] = 0xf118e,
  ["md-phone_bluetooth"] = 0xf03f3,
  ["md-phone_bluetooth_outline"] = 0xf118f,
  ["md-phone_cancel"] = 0xf10bc,
  ["md-phone_cancel_outline"] = 0xf1190,
  ["md-phone_check"] = 0xf11a9,
  ["md-phone_check_outline"] = 0xf11aa,
  ["md-phone_classic"] = 0xf0602,
  ["md-phone_classic_off"] = 0xf1279,
  ["md-phone_clock"] = 0xf19db,
  ["md-phone_dial"] = 0xf1559,
  ["md-phone_dial_outline"] = 0xf155a,
  ["md-phone_forward"] = 0xf03f4,
  ["md-phone_forward_outline"] = 0xf1191,
  ["md-phone_hangup"] = 0xf03f5,
  ["md-phone_hangup_outline"] = 0xf1192,
  ["md-phone_in_talk"] = 0xf03f6,
  ["md-phone_in_talk_outline"] = 0xf1182,
  ["md-phone_incoming"] = 0xf03f7,
  ["md-phone_incoming_outline"] = 0xf1193,
  ["md-phone_lock"] = 0xf03f8,
  ["md-phone_lock_outline"] = 0xf1194,
  ["md-phone_log"] = 0xf03f9,
  ["md-phone_log_outline"] = 0xf1195,
  ["md-phone_message"] = 0xf1196,
  ["md-phone_message_outline"] = 0xf1197,
  ["md-phone_minus"] = 0xf0658,
  ["md-phone_minus_outline"] = 0xf1198,
  ["md-phone_missed"] = 0xf03fa,
  ["md-phone_missed_outline"] = 0xf11a5,
  ["md-phone_off"] = 0xf0def,
  ["md-phone_off_outline"] = 0xf11a6,
  ["md-phone_outgoing"] = 0xf03fb,
  ["md-phone_outgoing_outline"] = 0xf1199,
  ["md-phone_outline"] = 0xf0df0,
  ["md-phone_paused"] = 0xf03fc,
  ["md-phone_paused_outline"] = 0xf119a,
  ["md-phone_plus"] = 0xf0659,
  ["md-phone_plus_outline"] = 0xf119b,
  ["md-phone_refresh"] = 0xf1993,
  ["md-phone_refresh_outline"] = 0xf1994,
  ["md-phone_remove"] = 0xf152f,
  ["md-phone_remove_outline"] = 0xf1530,
  ["md-phone_return"] = 0xf082f,
  ["md-phone_return_outline"] = 0xf119c,
  ["md-phone_ring"] = 0xf11ab,
  ["md-phone_ring_outline"] = 0xf11ac,
  ["md-phone_rotate_landscape"] = 0xf0885,
  ["md-phone_rotate_portrait"] = 0xf0886,
  ["md-phone_settings"] = 0xf03fd,
  ["md-phone_settings_outline"] = 0xf119d,
  ["md-phone_sync"] = 0xf1995,
  ["md-phone_sync_outline"] = 0xf1996,
  ["md-phone_voip"] = 0xf03fe,
  ["md-pi"] = 0xf03ff,
  ["md-pi_box"] = 0xf0400,
  ["md-pi_hole"] = 0xf0df1,
  ["md-piano"] = 0xf067d,
  ["md-piano_off"] = 0xf0698,
  ["md-pickaxe"] = 0xf08b7,
  ["md-picture_in_picture_bottom_right"] = 0xf0e57,
  ["md-picture_in_picture_bottom_right_outline"] = 0xf0e58,
  ["md-picture_in_picture_top_right"] = 0xf0e59,
  ["md-picture_in_picture_top_right_outline"] = 0xf0e5a,
  ["md-pier"] = 0xf0887,
  ["md-pier_crane"] = 0xf0888,
  ["md-pig"] = 0xf0401,
  ["md-pig_variant"] = 0xf1006,
  ["md-pig_variant_outline"] = 0xf1678,
  ["md-piggy_bank"] = 0xf1007,
  ["md-piggy_bank_outline"] = 0xf1679,
  ["md-pill"] = 0xf0402,
  ["md-pill_off"] = 0xf1a5c,
  ["md-pillar"] = 0xf0702,
  ["md-pin"] = 0xf0403,
  ["md-pin_off"] = 0xf0404,
  ["md-pin_off_outline"] = 0xf0930,
  ["md-pin_outline"] = 0xf0931,
  ["md-pine_tree"] = 0xf0405,
  ["md-pine_tree_box"] = 0xf0406,
  ["md-pine_tree_fire"] = 0xf141a,
  ["md-pinterest"] = 0xf0407,
  ["md-pinwheel"] = 0xf0ad5,
  ["md-pinwheel_outline"] = 0xf0ad6,
  ["md-pipe"] = 0xf07e5,
  ["md-pipe_disconnected"] = 0xf07e6,
  ["md-pipe_leak"] = 0xf0889,
  ["md-pipe_valve"] = 0xf184d,
  ["md-pipe_wrench"] = 0xf1354,
  ["md-pirate"] = 0xf0a08,
  ["md-pistol"] = 0xf0703,
  ["md-piston"] = 0xf088a,
  ["md-pitchfork"] = 0xf1553,
  ["md-pizza"] = 0xf0409,
  ["md-play"] = 0xf040a,
  ["md-play_box"] = 0xf127a,
  ["md-play_box_lock"] = 0xf1a16,
  ["md-play_box_lock_open"] = 0xf1a17,
  ["md-play_box_lock_open_outline"] = 0xf1a18,
  ["md-play_box_lock_outline"] = 0xf1a19,
  ["md-play_box_multiple"] = 0xf0d19,
  ["md-play_box_multiple_outline"] = 0xf13e6,
  ["md-play_box_outline"] = 0xf040b,
  ["md-play_circle"] = 0xf040c,
  ["md-play_circle_outline"] = 0xf040d,
  ["md-play_network"] = 0xf088b,
  ["md-play_network_outline"] = 0xf0cb7,
  ["md-play_outline"] = 0xf0f1b,
  ["md-play_pause"] = 0xf040e,
  ["md-play_protected_content"] = 0xf040f,
  ["md-play_speed"] = 0xf08ff,
  ["md-playlist_check"] = 0xf05c7,
  ["md-playlist_edit"] = 0xf0900,
  ["md-playlist_minus"] = 0xf0410,
  ["md-playlist_music"] = 0xf0cb8,
  ["md-playlist_music_outline"] = 0xf0cb9,
  ["md-playlist_play"] = 0xf0411,
  ["md-playlist_plus"] = 0xf0412,
  ["md-playlist_remove"] = 0xf0413,
  ["md-playlist_star"] = 0xf0df2,
  ["md-plex"] = 0xf06ba,
  ["md-pliers"] = 0xf19a4,
  ["md-plus"] = 0xf0415,
  ["md-plus_box"] = 0xf0416,
  ["md-plus_box_multiple"] = 0xf0334,
  ["md-plus_box_multiple_outline"] = 0xf1143,
  ["md-plus_box_outline"] = 0xf0704,
  ["md-plus_circle"] = 0xf0417,
  ["md-plus_circle_multiple"] = 0xf034c,
  ["md-plus_circle_multiple_outline"] = 0xf0418,
  ["md-plus_circle_outline"] = 0xf0419,
  ["md-plus_lock"] = 0xf1a5d,
  ["md-plus_lock_open"] = 0xf1a5e,
  ["md-plus_minus"] = 0xf0992,
  ["md-plus_minus_box"] = 0xf0993,
  ["md-plus_minus_variant"] = 0xf14c9,
  ["md-plus_network"] = 0xf041a,
  ["md-plus_network_outline"] = 0xf0cba,
  ["md-plus_outline"] = 0xf0705,
  ["md-plus_thick"] = 0xf11ec,
  ["md-podcast"] = 0xf0994,
  ["md-podium"] = 0xf0d25,
  ["md-podium_bronze"] = 0xf0d26,
  ["md-podium_gold"] = 0xf0d27,
  ["md-podium_silver"] = 0xf0d28,
  ["md-point_of_sale"] = 0xf0d92,
  ["md-pokeball"] = 0xf041d,
  ["md-pokemon_go"] = 0xf0a09,
  ["md-poker_chip"] = 0xf0830,
  ["md-polaroid"] = 0xf041e,
  ["md-police_badge"] = 0xf1167,
  ["md-police_badge_outline"] = 0xf1168,
  ["md-police_station"] = 0xf1839,
  ["md-poll"] = 0xf041f,
  ["md-polo"] = 0xf14c3,
  ["md-polymer"] = 0xf0421,
  ["md-pool"] = 0xf0606,
  ["md-pool_thermometer"] = 0xf1a5f,
  ["md-popcorn"] = 0xf0422,
  ["md-post"] = 0xf1008,
  ["md-post_lamp"] = 0xf1a60,
  ["md-post_outline"] = 0xf1009,
  ["md-postage_stamp"] = 0xf0cbb,
  ["md-pot"] = 0xf02e5,
  ["md-pot_mix"] = 0xf065b,
  ["md-pot_mix_outline"] = 0xf0677,
  ["md-pot_outline"] = 0xf02ff,
  ["md-pot_steam"] = 0xf065a,
  ["md-pot_steam_outline"] = 0xf0326,
  ["md-pound"] = 0xf0423,
  ["md-pound_box"] = 0xf0424,
  ["md-pound_box_outline"] = 0xf117f,
  ["md-power"] = 0xf0425,
  ["md-power_cycle"] = 0xf0901,
  ["md-power_off"] = 0xf0902,
  ["md-power_on"] = 0xf0903,
  ["md-power_plug"] = 0xf06a5,
  ["md-power_plug_off"] = 0xf06a6,
  ["md-power_plug_off_outline"] = 0xf1424,
  ["md-power_plug_outline"] = 0xf1425,
  ["md-power_settings"] = 0xf0426,
  ["md-power_sleep"] = 0xf0904,
  ["md-power_socket"] = 0xf0427,
  ["md-power_socket_au"] = 0xf0905,
  ["md-power_socket_ch"] = 0xf0fb3,
  ["md-power_socket_de"] = 0xf1107,
  ["md-power_socket_eu"] = 0xf07e7,
  ["md-power_socket_fr"] = 0xf1108,
  ["md-power_socket_it"] = 0xf14ff,
  ["md-power_socket_jp"] = 0xf1109,
  ["md-power_socket_uk"] = 0xf07e8,
  ["md-power_socket_us"] = 0xf07e9,
  ["md-power_standby"] = 0xf0906,
  ["md-powershell"] = 0xf0a0a,
  ["md-prescription"] = 0xf0706,
  ["md-presentation"] = 0xf0428,
  ["md-presentation_play"] = 0xf0429,
  ["md-pretzel"] = 0xf1562,
  ["md-printer"] = 0xf042a,
  ["md-printer_3d"] = 0xf042b,
  ["md-printer_3d_nozzle"] = 0xf0e5b,
  ["md-printer_3d_nozzle_alert"] = 0xf11c0,
  ["md-printer_3d_nozzle_alert_outline"] = 0xf11c1,
  ["md-printer_3d_nozzle_heat"] = 0xf18b8,
  ["md-printer_3d_nozzle_heat_outline"] = 0xf18b9,
  ["md-printer_3d_nozzle_outline"] = 0xf0e5c,
  ["md-printer_alert"] = 0xf042c,
  ["md-printer_check"] = 0xf1146,
  ["md-printer_eye"] = 0xf1458,
  ["md-printer_off"] = 0xf0e5d,
  ["md-printer_off_outline"] = 0xf1785,
  ["md-printer_outline"] = 0xf1786,
  ["md-printer_pos"] = 0xf1057,
  ["md-printer_search"] = 0xf1457,
  ["md-printer_settings"] = 0xf0707,
  ["md-printer_wireless"] = 0xf0a0b,
  ["md-priority_high"] = 0xf0603,
  ["md-priority_low"] = 0xf0604,
  ["md-professional_hexagon"] = 0xf042d,
  ["md-progress_alert"] = 0xf0cbc,
  ["md-progress_check"] = 0xf0995,
  ["md-progress_clock"] = 0xf0996,
  ["md-progress_close"] = 0xf110a,
  ["md-progress_download"] = 0xf0997,
  ["md-progress_pencil"] = 0xf1787,
  ["md-progress_question"] = 0xf1522,
  ["md-progress_star"] = 0xf1788,
  ["md-progress_upload"] = 0xf0998,
  ["md-progress_wrench"] = 0xf0cbd,
  ["md-projector"] = 0xf042e,
  ["md-projector_off"] = 0xf1a23,
  ["md-projector_screen"] = 0xf042f,
  ["md-projector_screen_off"] = 0xf180d,
  ["md-projector_screen_off_outline"] = 0xf180e,
  ["md-projector_screen_outline"] = 0xf1724,
  ["md-projector_screen_variant"] = 0xf180f,
  ["md-projector_screen_variant_off"] = 0xf1810,
  ["md-projector_screen_variant_off_outline"] = 0xf1811,
  ["md-projector_screen_variant_outline"] = 0xf1812,
  ["md-propane_tank"] = 0xf1357,
  ["md-propane_tank_outline"] = 0xf1358,
  ["md-protocol"] = 0xf0fd8,
  ["md-publish"] = 0xf06a7,
  ["md-publish_off"] = 0xf1945,
  ["md-pulse"] = 0xf0430,
  ["md-pump"] = 0xf1402,
  ["md-pumpkin"] = 0xf0bbf,
  ["md-purse"] = 0xf0f1c,
  ["md-purse_outline"] = 0xf0f1d,
  ["md-puzzle"] = 0xf0431,
  ["md-puzzle_check"] = 0xf1426,
  ["md-puzzle_check_outline"] = 0xf1427,
  ["md-puzzle_edit"] = 0xf14d3,
  ["md-puzzle_edit_outline"] = 0xf14d9,
  ["md-puzzle_heart"] = 0xf14d4,
  ["md-puzzle_heart_outline"] = 0xf14da,
  ["md-puzzle_minus"] = 0xf14d1,
  ["md-puzzle_minus_outline"] = 0xf14d7,
  ["md-puzzle_outline"] = 0xf0a66,
  ["md-puzzle_plus"] = 0xf14d0,
  ["md-puzzle_plus_outline"] = 0xf14d6,
  ["md-puzzle_remove"] = 0xf14d2,
  ["md-puzzle_remove_outline"] = 0xf14d8,
  ["md-puzzle_star"] = 0xf14d5,
  ["md-puzzle_star_outline"] = 0xf14db,
  ["md-pyramid"] = 0xf1952,
  ["md-pyramid_off"] = 0xf1953,
  ["md-qi"] = 0xf0999,
  ["md-qqchat"] = 0xf0605,
  ["md-qrcode"] = 0xf0432,
  ["md-qrcode_edit"] = 0xf08b8,
  ["md-qrcode_minus"] = 0xf118c,
  ["md-qrcode_plus"] = 0xf118b,
  ["md-qrcode_remove"] = 0xf118d,
  ["md-qrcode_scan"] = 0xf0433,
  ["md-quadcopter"] = 0xf0434,
  ["md-quality_high"] = 0xf0435,
  ["md-quality_low"] = 0xf0a0c,
  ["md-quality_medium"] = 0xf0a0d,
  ["md-quora"] = 0xf0d29,
  ["md-rabbit"] = 0xf0907,
  ["md-rabbit_variant"] = 0xf1a61,
  ["md-rabbit_variant_outline"] = 0xf1a62,
  ["md-racing_helmet"] = 0xf0d93,
  ["md-racquetball"] = 0xf0d94,
  ["md-radar"] = 0xf0437,
  ["md-radiator"] = 0xf0438,
  ["md-radiator_disabled"] = 0xf0ad7,
  ["md-radiator_off"] = 0xf0ad8,
  ["md-radio"] = 0xf0439,
  ["md-radio_am"] = 0xf0cbe,
  ["md-radio_fm"] = 0xf0cbf,
  ["md-radio_handheld"] = 0xf043a,
  ["md-radio_off"] = 0xf121c,
  ["md-radio_tower"] = 0xf043b,
  ["md-radioactive"] = 0xf043c,
  ["md-radioactive_circle"] = 0xf185d,
  ["md-radioactive_circle_outline"] = 0xf185e,
  ["md-radioactive_off"] = 0xf0ec1,
  ["md-radiobox_marked"] = 0xf043e,
  ["md-radiology_box"] = 0xf14c5,
  ["md-radiology_box_outline"] = 0xf14c6,
  ["md-radius"] = 0xf0cc0,
  ["md-radius_outline"] = 0xf0cc1,
  ["md-railroad_light"] = 0xf0f1e,
  ["md-rake"] = 0xf1544,
  ["md-raspberry_pi"] = 0xf043f,
  ["md-raw"] = 0xf1a0f,
  ["md-raw_off"] = 0xf1a10,
  ["md-ray_end"] = 0xf0440,
  ["md-ray_end_arrow"] = 0xf0441,
  ["md-ray_start"] = 0xf0442,
  ["md-ray_start_arrow"] = 0xf0443,
  ["md-ray_start_end"] = 0xf0444,
  ["md-ray_start_vertex_end"] = 0xf15d8,
  ["md-ray_vertex"] = 0xf0445,
  ["md-razor_double_edge"] = 0xf1997,
  ["md-razor_single_edge"] = 0xf1998,
  ["md-react"] = 0xf0708,
  ["md-read"] = 0xf0447,
  ["md-receipt"] = 0xf0449,
  ["md-receipt_outline"] = 0xf19dc,
  ["md-receipt_text_check"] = 0xf1a63,
  ["md-receipt_text_check_outline"] = 0xf1a64,
  ["md-receipt_text_minus"] = 0xf1a65,
  ["md-receipt_text_minus_outline"] = 0xf1a66,
  ["md-receipt_text_plus"] = 0xf1a67,
  ["md-receipt_text_plus_outline"] = 0xf1a68,
  ["md-receipt_text_remove"] = 0xf1a69,
  ["md-receipt_text_remove_outline"] = 0xf1a6a,
  ["md-record"] = 0xf044a,
  ["md-record_circle"] = 0xf0ec2,
  ["md-record_circle_outline"] = 0xf0ec3,
  ["md-record_player"] = 0xf099a,
  ["md-record_rec"] = 0xf044b,
  ["md-rectangle"] = 0xf0e5e,
  ["md-rectangle_outline"] = 0xf0e5f,
  ["md-recycle"] = 0xf044c,
  ["md-recycle_variant"] = 0xf139d,
  ["md-reddit"] = 0xf044d,
  ["md-redhat"] = 0xf111b,
  ["md-redo"] = 0xf044e,
  ["md-redo_variant"] = 0xf044f,
  ["md-reflect_horizontal"] = 0xf0a0e,
  ["md-reflect_vertical"] = 0xf0a0f,
  ["md-refresh"] = 0xf0450,
  ["md-refresh_auto"] = 0xf18f2,
  ["md-refresh_circle"] = 0xf1377,
  ["md-regex"] = 0xf0451,
  ["md-registered_trademark"] = 0xf0a67,
  ["md-reiterate"] = 0xf1588,
  ["md-relation_many_to_many"] = 0xf1496,
  ["md-relation_many_to_one"] = 0xf1497,
  ["md-relation_many_to_one_or_many"] = 0xf1498,
  ["md-relation_many_to_only_one"] = 0xf1499,
  ["md-relation_many_to_zero_or_many"] = 0xf149a,
  ["md-relation_many_to_zero_or_one"] = 0xf149b,
  ["md-relation_one_or_many_to_many"] = 0xf149c,
  ["md-relation_one_or_many_to_one"] = 0xf149d,
  ["md-relation_one_or_many_to_one_or_many"] = 0xf149e,
  ["md-relation_one_or_many_to_only_one"] = 0xf149f,
  ["md-relation_one_or_many_to_zero_or_many"] = 0xf14a0,
  ["md-relation_one_or_many_to_zero_or_one"] = 0xf14a1,
  ["md-relation_one_to_many"] = 0xf14a2,
  ["md-relation_one_to_one"] = 0xf14a3,
  ["md-relation_one_to_one_or_many"] = 0xf14a4,
  ["md-relation_one_to_only_one"] = 0xf14a5,
  ["md-relation_one_to_zero_or_many"] = 0xf14a6,
  ["md-relation_one_to_zero_or_one"] = 0xf14a7,
  ["md-relation_only_one_to_many"] = 0xf14a8,
  ["md-relation_only_one_to_one"] = 0xf14a9,
  ["md-relation_only_one_to_one_or_many"] = 0xf14aa,
  ["md-relation_only_one_to_only_one"] = 0xf14ab,
  ["md-relation_only_one_to_zero_or_many"] = 0xf14ac,
  ["md-relation_only_one_to_zero_or_one"] = 0xf14ad,
  ["md-relation_zero_or_many_to_many"] = 0xf14ae,
  ["md-relation_zero_or_many_to_one"] = 0xf14af,
  ["md-relation_zero_or_many_to_one_or_many"] = 0xf14b0,
  ["md-relation_zero_or_many_to_only_one"] = 0xf14b1,
  ["md-relation_zero_or_many_to_zero_or_many"] = 0xf14b2,
  ["md-relation_zero_or_many_to_zero_or_one"] = 0xf14b3,
  ["md-relation_zero_or_one_to_many"] = 0xf14b4,
  ["md-relation_zero_or_one_to_one"] = 0xf14b5,
  ["md-relation_zero_or_one_to_one_or_many"] = 0xf14b6,
  ["md-relation_zero_or_one_to_only_one"] = 0xf14b7,
  ["md-relation_zero_or_one_to_zero_or_many"] = 0xf14b8,
  ["md-relation_zero_or_one_to_zero_or_one"] = 0xf14b9,
  ["md-relative_scale"] = 0xf0452,
  ["md-reload"] = 0xf0453,
  ["md-reload_alert"] = 0xf110b,
  ["md-reminder"] = 0xf088c,
  ["md-remote"] = 0xf0454,
  ["md-remote_desktop"] = 0xf08b9,
  ["md-remote_off"] = 0xf0ec4,
  ["md-remote_tv"] = 0xf0ec5,
  ["md-remote_tv_off"] = 0xf0ec6,
  ["md-rename_box"] = 0xf0455,
  ["md-reorder_horizontal"] = 0xf0688,
  ["md-reorder_vertical"] = 0xf0689,
  ["md-repeat"] = 0xf0456,
  ["md-repeat_off"] = 0xf0457,
  ["md-repeat_once"] = 0xf0458,
  ["md-repeat_variant"] = 0xf0547,
  ["md-replay"] = 0xf0459,
  ["md-reply"] = 0xf045a,
  ["md-reply_all"] = 0xf045b,
  ["md-reply_all_outline"] = 0xf0f1f,
  ["md-reply_circle"] = 0xf11ae,
  ["md-reply_outline"] = 0xf0f20,
  ["md-reproduction"] = 0xf045c,
  ["md-resistor"] = 0xf0b44,
  ["md-resistor_nodes"] = 0xf0b45,
  ["md-resize"] = 0xf0a68,
  ["md-resize_bottom_right"] = 0xf045d,
  ["md-responsive"] = 0xf045e,
  ["md-restart"] = 0xf0709,
  ["md-restart_alert"] = 0xf110c,
  ["md-restart_off"] = 0xf0d95,
  ["md-restore"] = 0xf099b,
  ["md-restore_alert"] = 0xf110d,
  ["md-rewind"] = 0xf045f,
  ["md-rewind_10"] = 0xf0d2a,
  ["md-rewind_15"] = 0xf1946,
  ["md-rewind_30"] = 0xf0d96,
  ["md-rewind_5"] = 0xf11f9,
  ["md-rewind_60"] = 0xf160c,
  ["md-rewind_outline"] = 0xf070a,
  ["md-rhombus"] = 0xf070b,
  ["md-rhombus_medium"] = 0xf0a10,
  ["md-rhombus_medium_outline"] = 0xf14dc,
  ["md-rhombus_outline"] = 0xf070c,
  ["md-rhombus_split"] = 0xf0a11,
  ["md-rhombus_split_outline"] = 0xf14dd,
  ["md-ribbon"] = 0xf0460,
  ["md-rice"] = 0xf07ea,
  ["md-rickshaw"] = 0xf15bb,
  ["md-rickshaw_electric"] = 0xf15bc,
  ["md-ring"] = 0xf07eb,
  ["md-rivet"] = 0xf0e60,
  ["md-road"] = 0xf0461,
  ["md-road_variant"] = 0xf0462,
  ["md-robber"] = 0xf1058,
  ["md-robot"] = 0xf06a9,
  ["md-robot_angry"] = 0xf169d,
  ["md-robot_angry_outline"] = 0xf169e,
  ["md-robot_confused"] = 0xf169f,
  ["md-robot_confused_outline"] = 0xf16a0,
  ["md-robot_dead"] = 0xf16a1,
  ["md-robot_dead_outline"] = 0xf16a2,
  ["md-robot_excited"] = 0xf16a3,
  ["md-robot_excited_outline"] = 0xf16a4,
  ["md-robot_happy"] = 0xf1719,
  ["md-robot_happy_outline"] = 0xf171a,
  ["md-robot_industrial"] = 0xf0b46,
  ["md-robot_industrial_outline"] = 0xf1a1a,
  ["md-robot_love"] = 0xf16a5,
  ["md-robot_love_outline"] = 0xf16a6,
  ["md-robot_mower"] = 0xf11f7,
  ["md-robot_mower_outline"] = 0xf11f3,
  ["md-robot_off"] = 0xf16a7,
  ["md-robot_off_outline"] = 0xf167b,
  ["md-robot_outline"] = 0xf167a,
  ["md-robot_vacuum"] = 0xf070d,
  ["md-robot_vacuum_variant"] = 0xf0908,
  ["md-rocket"] = 0xf0463,
  ["md-rocket_launch"] = 0xf14de,
  ["md-rocket_launch_outline"] = 0xf14df,
  ["md-rocket_outline"] = 0xf13af,
  ["md-rodent"] = 0xf1327,
  ["md-roller_shade"] = 0xf1a6b,
  ["md-roller_shade_closed"] = 0xf1a6c,
  ["md-roller_skate"] = 0xf0d2b,
  ["md-roller_skate_off"] = 0xf0145,
  ["md-rollerblade"] = 0xf0d2c,
  ["md-rollerblade_off"] = 0xf002e,
  ["md-rollupjs"] = 0xf0bc0,
  ["md-rolodex"] = 0xf1ab9,
  ["md-rolodex_outline"] = 0xf1aba,
  ["md-roman_numeral_2"] = 0xf1089,
  ["md-roman_numeral_3"] = 0xf108a,
  ["md-roman_numeral_4"] = 0xf108b,
  ["md-roman_numeral_6"] = 0xf108d,
  ["md-roman_numeral_7"] = 0xf108e,
  ["md-roman_numeral_8"] = 0xf108f,
  ["md-roman_numeral_9"] = 0xf1090,
  ["md-room_service"] = 0xf088d,
  ["md-room_service_outline"] = 0xf0d97,
  ["md-rotate_360"] = 0xf1999,
  ["md-rotate_3d"] = 0xf0ec7,
  ["md-rotate_3d_variant"] = 0xf0464,
  ["md-rotate_left"] = 0xf0465,
  ["md-rotate_left_variant"] = 0xf0466,
  ["md-rotate_orbit"] = 0xf0d98,
  ["md-rotate_right"] = 0xf0467,
  ["md-rotate_right_variant"] = 0xf0468,
  ["md-rounded_corner"] = 0xf0607,
  ["md-router"] = 0xf11e2,
  ["md-router_network"] = 0xf1087,
  ["md-router_wireless"] = 0xf0469,
  ["md-router_wireless_off"] = 0xf15a3,
  ["md-router_wireless_settings"] = 0xf0a69,
  ["md-routes"] = 0xf046a,
  ["md-routes_clock"] = 0xf1059,
  ["md-rowing"] = 0xf0608,
  ["md-rss"] = 0xf046b,
  ["md-rss_box"] = 0xf046c,
  ["md-rss_off"] = 0xf0f21,
  ["md-rug"] = 0xf1475,
  ["md-rugby"] = 0xf0d99,
  ["md-ruler"] = 0xf046d,
  ["md-ruler_square"] = 0xf0cc2,
  ["md-ruler_square_compass"] = 0xf0ebe,
  ["md-run"] = 0xf070e,
  ["md-run_fast"] = 0xf046e,
  ["md-rv_truck"] = 0xf11d4,
  ["md-sack"] = 0xf0d2e,
  ["md-sack_percent"] = 0xf0d2f,
  ["md-safe"] = 0xf0a6a,
  ["md-safe_square"] = 0xf127c,
  ["md-safe_square_outline"] = 0xf127d,
  ["md-safety_goggles"] = 0xf0d30,
  ["md-sail_boat"] = 0xf0ec8,
  ["md-sail_boat_sink"] = 0xf1aef,
  ["md-sale"] = 0xf046f,
  ["md-sale_outline"] = 0xf1a06,
  ["md-salesforce"] = 0xf088e,
  ["md-sass"] = 0xf07ec,
  ["md-satellite"] = 0xf0470,
  ["md-satellite_uplink"] = 0xf0909,
  ["md-satellite_variant"] = 0xf0471,
  ["md-sausage"] = 0xf08ba,
  ["md-sausage_off"] = 0xf1789,
  ["md-saw_blade"] = 0xf0e61,
  ["md-sawtooth_wave"] = 0xf147a,
  ["md-saxophone"] = 0xf0609,
  ["md-scale"] = 0xf0472,
  ["md-scale_balance"] = 0xf05d1,
  ["md-scale_bathroom"] = 0xf0473,
  ["md-scale_off"] = 0xf105a,
  ["md-scale_unbalanced"] = 0xf19b8,
  ["md-scan_helper"] = 0xf13d8,
  ["md-scanner"] = 0xf06ab,
  ["md-scanner_off"] = 0xf090a,
  ["md-scatter_plot"] = 0xf0ec9,
  ["md-scatter_plot_outline"] = 0xf0eca,
  ["md-scent"] = 0xf1958,
  ["md-scent_off"] = 0xf1959,
  ["md-school"] = 0xf0474,
  ["md-school_outline"] = 0xf1180,
  ["md-scissors_cutting"] = 0xf0a6b,
  ["md-scooter"] = 0xf15bd,
  ["md-scooter_electric"] = 0xf15be,
  ["md-scoreboard"] = 0xf127e,
  ["md-scoreboard_outline"] = 0xf127f,
  ["md-screen_rotation"] = 0xf0475,
  ["md-screen_rotation_lock"] = 0xf0478,
  ["md-screw_flat_top"] = 0xf0df3,
  ["md-screw_lag"] = 0xf0df4,
  ["md-screw_machine_flat_top"] = 0xf0df5,
  ["md-screw_machine_round_top"] = 0xf0df6,
  ["md-screw_round_top"] = 0xf0df7,
  ["md-screwdriver"] = 0xf0476,
  ["md-script"] = 0xf0bc1,
  ["md-script_outline"] = 0xf0477,
  ["md-script_text"] = 0xf0bc2,
  ["md-script_text_key"] = 0xf1725,
  ["md-script_text_key_outline"] = 0xf1726,
  ["md-script_text_outline"] = 0xf0bc3,
  ["md-script_text_play"] = 0xf1727,
  ["md-script_text_play_outline"] = 0xf1728,
  ["md-sd"] = 0xf0479,
  ["md-seal"] = 0xf047a,
  ["md-seal_variant"] = 0xf0fd9,
  ["md-search_web"] = 0xf070f,
  ["md-seat"] = 0xf0cc3,
  ["md-seat_flat"] = 0xf047b,
  ["md-seat_flat_angled"] = 0xf047c,
  ["md-seat_individual_suite"] = 0xf047d,
  ["md-seat_legroom_extra"] = 0xf047e,
  ["md-seat_legroom_normal"] = 0xf047f,
  ["md-seat_legroom_reduced"] = 0xf0480,
  ["md-seat_outline"] = 0xf0cc4,
  ["md-seat_passenger"] = 0xf1249,
  ["md-seat_recline_extra"] = 0xf0481,
  ["md-seat_recline_normal"] = 0xf0482,
  ["md-seatbelt"] = 0xf0cc5,
  ["md-security"] = 0xf0483,
  ["md-security_network"] = 0xf0484,
  ["md-seed"] = 0xf0e62,
  ["md-seed_off"] = 0xf13fd,
  ["md-seed_off_outline"] = 0xf13fe,
  ["md-seed_outline"] = 0xf0e63,
  ["md-seed_plus"] = 0xf1a6d,
  ["md-seed_plus_outline"] = 0xf1a6e,
  ["md-seesaw"] = 0xf15a4,
  ["md-segment"] = 0xf0ecb,
  ["md-select"] = 0xf0485,
  ["md-select_all"] = 0xf0486,
  ["md-select_color"] = 0xf0d31,
  ["md-select_compare"] = 0xf0ad9,
  ["md-select_drag"] = 0xf0a6c,
  ["md-select_group"] = 0xf0f82,
  ["md-select_inverse"] = 0xf0487,
  ["md-select_marker"] = 0xf1280,
  ["md-select_multiple"] = 0xf1281,
  ["md-select_multiple_marker"] = 0xf1282,
  ["md-select_off"] = 0xf0488,
  ["md-select_place"] = 0xf0fda,
  ["md-select_remove"] = 0xf17c1,
  ["md-select_search"] = 0xf1204,
  ["md-selection"] = 0xf0489,
  ["md-selection_drag"] = 0xf0a6d,
  ["md-selection_ellipse"] = 0xf0d32,
  ["md-selection_ellipse_arrow_inside"] = 0xf0f22,
  ["md-selection_ellipse_remove"] = 0xf17c2,
  ["md-selection_marker"] = 0xf1283,
  ["md-selection_multiple"] = 0xf1285,
  ["md-selection_multiple_marker"] = 0xf1284,
  ["md-selection_off"] = 0xf0777,
  ["md-selection_remove"] = 0xf17c3,
  ["md-selection_search"] = 0xf1205,
  ["md-semantic_web"] = 0xf1316,
  ["md-send"] = 0xf048a,
  ["md-send_check"] = 0xf1161,
  ["md-send_check_outline"] = 0xf1162,
  ["md-send_circle"] = 0xf0df8,
  ["md-send_circle_outline"] = 0xf0df9,
  ["md-send_clock"] = 0xf1163,
  ["md-send_clock_outline"] = 0xf1164,
  ["md-send_lock"] = 0xf07ed,
  ["md-send_lock_outline"] = 0xf1166,
  ["md-send_outline"] = 0xf1165,
  ["md-serial_port"] = 0xf065c,
  ["md-server"] = 0xf048b,
  ["md-server_minus"] = 0xf048c,
  ["md-server_network"] = 0xf048d,
  ["md-server_network_off"] = 0xf048e,
  ["md-server_off"] = 0xf048f,
  ["md-server_plus"] = 0xf0490,
  ["md-server_remove"] = 0xf0491,
  ["md-server_security"] = 0xf0492,
  ["md-set_all"] = 0xf0778,
  ["md-set_center"] = 0xf0779,
  ["md-set_center_right"] = 0xf077a,
  ["md-set_left"] = 0xf077b,
  ["md-set_left_center"] = 0xf077c,
  ["md-set_left_right"] = 0xf077d,
  ["md-set_merge"] = 0xf14e0,
  ["md-set_none"] = 0xf077e,
  ["md-set_right"] = 0xf077f,
  ["md-set_split"] = 0xf14e1,
  ["md-set_square"] = 0xf145d,
  ["md-set_top_box"] = 0xf099f,
  ["md-settings_helper"] = 0xf0a6e,
  ["md-shaker"] = 0xf110e,
  ["md-shaker_outline"] = 0xf110f,
  ["md-shape"] = 0xf0831,
  ["md-shape_circle_plus"] = 0xf065d,
  ["md-shape_outline"] = 0xf0832,
  ["md-shape_oval_plus"] = 0xf11fa,
  ["md-shape_plus"] = 0xf0495,
  ["md-shape_polygon_plus"] = 0xf065e,
  ["md-shape_rectangle_plus"] = 0xf065f,
  ["md-shape_square_plus"] = 0xf0660,
  ["md-shape_square_rounded_plus"] = 0xf14fa,
  ["md-share"] = 0xf0496,
  ["md-share_all"] = 0xf11f4,
  ["md-share_all_outline"] = 0xf11f5,
  ["md-share_circle"] = 0xf11ad,
  ["md-share_off"] = 0xf0f23,
  ["md-share_off_outline"] = 0xf0f24,
  ["md-share_outline"] = 0xf0932,
  ["md-share_variant"] = 0xf0497,
  ["md-share_variant_outline"] = 0xf1514,
  ["md-shark"] = 0xf18ba,
  ["md-shark_fin"] = 0xf1673,
  ["md-shark_fin_outline"] = 0xf1674,
  ["md-shark_off"] = 0xf18bb,
  ["md-sheep"] = 0xf0cc6,
  ["md-shield"] = 0xf0498,
  ["md-shield_account"] = 0xf088f,
  ["md-shield_account_outline"] = 0xf0a12,
  ["md-shield_account_variant"] = 0xf15a7,
  ["md-shield_account_variant_outline"] = 0xf15a8,
  ["md-shield_airplane"] = 0xf06bb,
  ["md-shield_airplane_outline"] = 0xf0cc7,
  ["md-shield_alert"] = 0xf0ecc,
  ["md-shield_alert_outline"] = 0xf0ecd,
  ["md-shield_bug"] = 0xf13da,
  ["md-shield_bug_outline"] = 0xf13db,
  ["md-shield_car"] = 0xf0f83,
  ["md-shield_check"] = 0xf0565,
  ["md-shield_check_outline"] = 0xf0cc8,
  ["md-shield_cross"] = 0xf0cc9,
  ["md-shield_cross_outline"] = 0xf0cca,
  ["md-shield_crown"] = 0xf18bc,
  ["md-shield_crown_outline"] = 0xf18bd,
  ["md-shield_edit"] = 0xf11a0,
  ["md-shield_edit_outline"] = 0xf11a1,
  ["md-shield_half"] = 0xf1360,
  ["md-shield_half_full"] = 0xf0780,
  ["md-shield_home"] = 0xf068a,
  ["md-shield_home_outline"] = 0xf0ccb,
  ["md-shield_key"] = 0xf0bc4,
  ["md-shield_key_outline"] = 0xf0bc5,
  ["md-shield_link_variant"] = 0xf0d33,
  ["md-shield_link_variant_outline"] = 0xf0d34,
  ["md-shield_lock"] = 0xf099d,
  ["md-shield_lock_open"] = 0xf199a,
  ["md-shield_lock_open_outline"] = 0xf199b,
  ["md-shield_lock_outline"] = 0xf0ccc,
  ["md-shield_moon"] = 0xf1828,
  ["md-shield_moon_outline"] = 0xf1829,
  ["md-shield_off"] = 0xf099e,
  ["md-shield_off_outline"] = 0xf099c,
  ["md-shield_outline"] = 0xf0499,
  ["md-shield_plus"] = 0xf0ada,
  ["md-shield_plus_outline"] = 0xf0adb,
  ["md-shield_refresh"] = 0xf00aa,
  ["md-shield_refresh_outline"] = 0xf01e0,
  ["md-shield_remove"] = 0xf0adc,
  ["md-shield_remove_outline"] = 0xf0add,
  ["md-shield_search"] = 0xf0d9a,
  ["md-shield_star"] = 0xf113b,
  ["md-shield_star_outline"] = 0xf113c,
  ["md-shield_sun"] = 0xf105d,
  ["md-shield_sun_outline"] = 0xf105e,
  ["md-shield_sword"] = 0xf18be,
  ["md-shield_sword_outline"] = 0xf18bf,
  ["md-shield_sync"] = 0xf11a2,
  ["md-shield_sync_outline"] = 0xf11a3,
  ["md-shimmer"] = 0xf1545,
  ["md-ship_wheel"] = 0xf0833,
  ["md-shipping_pallet"] = 0xf184e,
  ["md-shoe_ballet"] = 0xf15ca,
  ["md-shoe_cleat"] = 0xf15c7,
  ["md-shoe_formal"] = 0xf0b47,
  ["md-shoe_heel"] = 0xf0b48,
  ["md-shoe_print"] = 0xf0dfa,
  ["md-shoe_sneaker"] = 0xf15c8,
  ["md-shopping"] = 0xf049a,
  ["md-shopping_music"] = 0xf049b,
  ["md-shopping_outline"] = 0xf11d5,
  ["md-shopping_search"] = 0xf0f84,
  ["md-shopping_search_outline"] = 0xf1a6f,
  ["md-shore"] = 0xf14f9,
  ["md-shovel"] = 0xf0710,
  ["md-shovel_off"] = 0xf0711,
  ["md-shower"] = 0xf09a0,
  ["md-shower_head"] = 0xf09a1,
  ["md-shredder"] = 0xf049c,
  ["md-shuffle"] = 0xf049d,
  ["md-shuffle_disabled"] = 0xf049e,
  ["md-shuffle_variant"] = 0xf049f,
  ["md-shuriken"] = 0xf137f,
  ["md-sickle"] = 0xf18c0,
  ["md-sigma"] = 0xf04a0,
  ["md-sigma_lower"] = 0xf062b,
  ["md-sign_caution"] = 0xf04a1,
  ["md-sign_direction"] = 0xf0781,
  ["md-sign_direction_minus"] = 0xf1000,
  ["md-sign_direction_plus"] = 0xf0fdc,
  ["md-sign_direction_remove"] = 0xf0fdd,
  ["md-sign_pole"] = 0xf14f8,
  ["md-sign_real_estate"] = 0xf1118,
  ["md-sign_text"] = 0xf0782,
  ["md-signal"] = 0xf04a2,
  ["md-signal_2g"] = 0xf0712,
  ["md-signal_3g"] = 0xf0713,
  ["md-signal_4g"] = 0xf0714,
  ["md-signal_5g"] = 0xf0a6f,
  ["md-signal_cellular_1"] = 0xf08bc,
  ["md-signal_cellular_2"] = 0xf08bd,
  ["md-signal_cellular_3"] = 0xf08be,
  ["md-signal_cellular_outline"] = 0xf08bf,
  ["md-signal_distance_variant"] = 0xf0e64,
  ["md-signal_hspa"] = 0xf0715,
  ["md-signal_hspa_plus"] = 0xf0716,
  ["md-signal_off"] = 0xf0783,
  ["md-signal_variant"] = 0xf060a,
  ["md-signature"] = 0xf0dfb,
  ["md-signature_freehand"] = 0xf0dfc,
  ["md-signature_image"] = 0xf0dfd,
  ["md-signature_text"] = 0xf0dfe,
  ["md-silo"] = 0xf0b49,
  ["md-silverware"] = 0xf04a3,
  ["md-silverware_clean"] = 0xf0fde,
  ["md-silverware_fork"] = 0xf04a4,
  ["md-silverware_fork_knife"] = 0xf0a70,
  ["md-silverware_spoon"] = 0xf04a5,
  ["md-silverware_variant"] = 0xf04a6,
  ["md-sim"] = 0xf04a7,
  ["md-sim_alert"] = 0xf04a8,
  ["md-sim_alert_outline"] = 0xf15d3,
  ["md-sim_off"] = 0xf04a9,
  ["md-sim_off_outline"] = 0xf15d4,
  ["md-sim_outline"] = 0xf15d5,
  ["md-simple_icons"] = 0xf131d,
  ["md-sina_weibo"] = 0xf0adf,
  ["md-sine_wave"] = 0xf095b,
  ["md-sitemap"] = 0xf04aa,
  ["md-sitemap_outline"] = 0xf199c,
  ["md-size_m"] = 0xf13a5,
  ["md-size_s"] = 0xf13a4,
  ["md-size_xl"] = 0xf13a7,
  ["md-size_xs"] = 0xf13a3,
  ["md-size_xxl"] = 0xf13a8,
  ["md-size_xxs"] = 0xf13a2,
  ["md-size_xxxl"] = 0xf13a9,
  ["md-skate"] = 0xf0d35,
  ["md-skate_off"] = 0xf0699,
  ["md-skateboard"] = 0xf14c2,
  ["md-skateboarding"] = 0xf0501,
  ["md-skew_less"] = 0xf0d36,
  ["md-skew_more"] = 0xf0d37,
  ["md-ski"] = 0xf1304,
  ["md-ski_cross_country"] = 0xf1305,
  ["md-ski_water"] = 0xf1306,
  ["md-skip_backward"] = 0xf04ab,
  ["md-skip_backward_outline"] = 0xf0f25,
  ["md-skip_forward"] = 0xf04ac,
  ["md-skip_forward_outline"] = 0xf0f26,
  ["md-skip_next"] = 0xf04ad,
  ["md-skip_next_circle"] = 0xf0661,
  ["md-skip_next_circle_outline"] = 0xf0662,
  ["md-skip_next_outline"] = 0xf0f27,
  ["md-skip_previous"] = 0xf04ae,
  ["md-skip_previous_circle"] = 0xf0663,
  ["md-skip_previous_circle_outline"] = 0xf0664,
  ["md-skip_previous_outline"] = 0xf0f28,
  ["md-skull"] = 0xf068c,
  ["md-skull_crossbones"] = 0xf0bc6,
  ["md-skull_crossbones_outline"] = 0xf0bc7,
  ["md-skull_outline"] = 0xf0bc8,
  ["md-skull_scan"] = 0xf14c7,
  ["md-skull_scan_outline"] = 0xf14c8,
  ["md-skype"] = 0xf04af,
  ["md-skype_business"] = 0xf04b0,
  ["md-slack"] = 0xf04b1,
  ["md-slash_forward"] = 0xf0fdf,
  ["md-slash_forward_box"] = 0xf0fe0,
  ["md-sledding"] = 0xf041b,
  ["md-sleep"] = 0xf04b2,
  ["md-sleep_off"] = 0xf04b3,
  ["md-slide"] = 0xf15a5,
  ["md-slope_downhill"] = 0xf0dff,
  ["md-slope_uphill"] = 0xf0e00,
  ["md-slot_machine"] = 0xf1114,
  ["md-slot_machine_outline"] = 0xf1115,
  ["md-smart_card"] = 0xf10bd,
  ["md-smart_card_off"] = 0xf18f7,
  ["md-smart_card_off_outline"] = 0xf18f8,
  ["md-smart_card_outline"] = 0xf10be,
  ["md-smart_card_reader"] = 0xf10bf,
  ["md-smart_card_reader_outline"] = 0xf10c0,
  ["md-smog"] = 0xf0a71,
  ["md-smoke"] = 0xf1799,
  ["md-smoke_detector"] = 0xf0392,
  ["md-smoke_detector_alert"] = 0xf192e,
  ["md-smoke_detector_alert_outline"] = 0xf192f,
  ["md-smoke_detector_off"] = 0xf1809,
  ["md-smoke_detector_off_outline"] = 0xf180a,
  ["md-smoke_detector_outline"] = 0xf1808,
  ["md-smoke_detector_variant"] = 0xf180b,
  ["md-smoke_detector_variant_alert"] = 0xf1930,
  ["md-smoke_detector_variant_off"] = 0xf180c,
  ["md-smoking"] = 0xf04b4,
  ["md-smoking_off"] = 0xf04b5,
  ["md-smoking_pipe"] = 0xf140d,
  ["md-smoking_pipe_off"] = 0xf1428,
  ["md-snail"] = 0xf1677,
  ["md-snake"] = 0xf150e,
  ["md-snapchat"] = 0xf04b6,
  ["md-snowboard"] = 0xf1307,
  ["md-snowflake"] = 0xf0717,
  ["md-snowflake_alert"] = 0xf0f29,
  ["md-snowflake_check"] = 0xf1a70,
  ["md-snowflake_melt"] = 0xf12cb,
  ["md-snowflake_off"] = 0xf14e3,
  ["md-snowflake_thermometer"] = 0xf1a71,
  ["md-snowflake_variant"] = 0xf0f2a,
  ["md-snowman"] = 0xf04b7,
  ["md-snowmobile"] = 0xf06dd,
  ["md-snowshoeing"] = 0xf1a72,
  ["md-soccer"] = 0xf04b8,
  ["md-soccer_field"] = 0xf0834,
  ["md-social_distance_2_meters"] = 0xf1579,
  ["md-social_distance_6_feet"] = 0xf157a,
  ["md-sofa"] = 0xf04b9,
  ["md-sofa_outline"] = 0xf156d,
  ["md-sofa_single"] = 0xf156e,
  ["md-sofa_single_outline"] = 0xf156f,
  ["md-solar_panel"] = 0xf0d9b,
  ["md-solar_panel_large"] = 0xf0d9c,
  ["md-solar_power"] = 0xf0a72,
  ["md-solar_power_variant"] = 0xf1a73,
  ["md-solar_power_variant_outline"] = 0xf1a74,
  ["md-soldering_iron"] = 0xf1092,
  ["md-solid"] = 0xf068d,
  ["md-sony_playstation"] = 0xf0414,
  ["md-sort"] = 0xf04ba,
  ["md-sort_alphabetical_ascending"] = 0xf05bd,
  ["md-sort_alphabetical_ascending_variant"] = 0xf1148,
  ["md-sort_alphabetical_descending"] = 0xf05bf,
  ["md-sort_alphabetical_descending_variant"] = 0xf1149,
  ["md-sort_alphabetical_variant"] = 0xf04bb,
  ["md-sort_ascending"] = 0xf04bc,
  ["md-sort_bool_ascending"] = 0xf1385,
  ["md-sort_bool_ascending_variant"] = 0xf1386,
  ["md-sort_bool_descending"] = 0xf1387,
  ["md-sort_bool_descending_variant"] = 0xf1388,
  ["md-sort_calendar_ascending"] = 0xf1547,
  ["md-sort_calendar_descending"] = 0xf1548,
  ["md-sort_clock_ascending"] = 0xf1549,
  ["md-sort_clock_ascending_outline"] = 0xf154a,
  ["md-sort_clock_descending"] = 0xf154b,
  ["md-sort_clock_descending_outline"] = 0xf154c,
  ["md-sort_descending"] = 0xf04bd,
  ["md-sort_numeric_ascending"] = 0xf1389,
  ["md-sort_numeric_ascending_variant"] = 0xf090d,
  ["md-sort_numeric_descending"] = 0xf138a,
  ["md-sort_numeric_descending_variant"] = 0xf0ad2,
  ["md-sort_numeric_variant"] = 0xf04be,
  ["md-sort_reverse_variant"] = 0xf033c,
  ["md-sort_variant"] = 0xf04bf,
  ["md-sort_variant_lock"] = 0xf0ccd,
  ["md-sort_variant_lock_open"] = 0xf0cce,
  ["md-sort_variant_off"] = 0xf1abb,
  ["md-sort_variant_remove"] = 0xf1147,
  ["md-soundbar"] = 0xf17db,
  ["md-soundcloud"] = 0xf04c0,
  ["md-source_branch"] = 0xf062c,
  ["md-source_branch_check"] = 0xf14cf,
  ["md-source_branch_minus"] = 0xf14cb,
  ["md-source_branch_plus"] = 0xf14ca,
  ["md-source_branch_refresh"] = 0xf14cd,
  ["md-source_branch_remove"] = 0xf14cc,
  ["md-source_branch_sync"] = 0xf14ce,
  ["md-source_commit"] = 0xf0718,
  ["md-source_commit_end"] = 0xf0719,
  ["md-source_commit_end_local"] = 0xf071a,
  ["md-source_commit_local"] = 0xf071b,
  ["md-source_commit_next_local"] = 0xf071c,
  ["md-source_commit_start"] = 0xf071d,
  ["md-source_commit_start_next_local"] = 0xf071e,
  ["md-source_fork"] = 0xf04c1,
  ["md-source_merge"] = 0xf062d,
  ["md-source_pull"] = 0xf04c2,
  ["md-source_repository"] = 0xf0ccf,
  ["md-source_repository_multiple"] = 0xf0cd0,
  ["md-soy_sauce"] = 0xf07ee,
  ["md-soy_sauce_off"] = 0xf13fc,
  ["md-spa"] = 0xf0cd1,
  ["md-spa_outline"] = 0xf0cd2,
  ["md-space_invaders"] = 0xf0bc9,
  ["md-space_station"] = 0xf1383,
  ["md-spade"] = 0xf0e65,
  ["md-speaker"] = 0xf04c3,
  ["md-speaker_bluetooth"] = 0xf09a2,
  ["md-speaker_multiple"] = 0xf0d38,
  ["md-speaker_off"] = 0xf04c4,
  ["md-speaker_wireless"] = 0xf071f,
  ["md-spear"] = 0xf1845,
  ["md-speedometer"] = 0xf04c5,
  ["md-speedometer_medium"] = 0xf0f85,
  ["md-speedometer_slow"] = 0xf0f86,
  ["md-spellcheck"] = 0xf04c6,
  ["md-sphere"] = 0xf1954,
  ["md-sphere_off"] = 0xf1955,
  ["md-spider"] = 0xf11ea,
  ["md-spider_thread"] = 0xf11eb,
  ["md-spider_web"] = 0xf0bca,
  ["md-spirit_level"] = 0xf14f1,
  ["md-spoon_sugar"] = 0xf1429,
  ["md-spotify"] = 0xf04c7,
  ["md-spotlight"] = 0xf04c8,
  ["md-spotlight_beam"] = 0xf04c9,
  ["md-spray"] = 0xf0665,
  ["md-spray_bottle"] = 0xf0ae0,
  ["md-sprinkler"] = 0xf105f,
  ["md-sprinkler_fire"] = 0xf199d,
  ["md-sprinkler_variant"] = 0xf1060,
  ["md-sprout"] = 0xf0e66,
  ["md-sprout_outline"] = 0xf0e67,
  ["md-square"] = 0xf0764,
  ["md-square_circle"] = 0xf1500,
  ["md-square_edit_outline"] = 0xf090c,
  ["md-square_medium"] = 0xf0a13,
  ["md-square_medium_outline"] = 0xf0a14,
  ["md-square_off"] = 0xf12ee,
  ["md-square_off_outline"] = 0xf12ef,
  ["md-square_opacity"] = 0xf1854,
  ["md-square_outline"] = 0xf0763,
  ["md-square_root"] = 0xf0784,
  ["md-square_root_box"] = 0xf09a3,
  ["md-square_rounded"] = 0xf14fb,
  ["md-square_rounded_badge"] = 0xf1a07,
  ["md-square_rounded_badge_outline"] = 0xf1a08,
  ["md-square_rounded_outline"] = 0xf14fc,
  ["md-square_small"] = 0xf0a15,
  ["md-square_wave"] = 0xf147b,
  ["md-squeegee"] = 0xf0ae1,
  ["md-ssh"] = 0xf08c0,
  ["md-stack_exchange"] = 0xf060b,
  ["md-stack_overflow"] = 0xf04cc,
  ["md-stackpath"] = 0xf0359,
  ["md-stadium"] = 0xf0ff9,
  ["md-stadium_variant"] = 0xf0720,
  ["md-stairs"] = 0xf04cd,
  ["md-stairs_box"] = 0xf139e,
  ["md-stairs_down"] = 0xf12be,
  ["md-stairs_up"] = 0xf12bd,
  ["md-stamper"] = 0xf0d39,
  ["md-standard_definition"] = 0xf07ef,
  ["md-star"] = 0xf04ce,
  ["md-star_box"] = 0xf0a73,
  ["md-star_box_multiple"] = 0xf1286,
  ["md-star_box_multiple_outline"] = 0xf1287,
  ["md-star_box_outline"] = 0xf0a74,
  ["md-star_check"] = 0xf1566,
  ["md-star_check_outline"] = 0xf156a,
  ["md-star_circle"] = 0xf04cf,
  ["md-star_circle_outline"] = 0xf09a4,
  ["md-star_cog"] = 0xf1668,
  ["md-star_cog_outline"] = 0xf1669,
  ["md-star_crescent"] = 0xf0979,
  ["md-star_david"] = 0xf097a,
  ["md-star_face"] = 0xf09a5,
  ["md-star_four_points"] = 0xf0ae2,
  ["md-star_four_points_outline"] = 0xf0ae3,
  ["md-star_half"] = 0xf0246,
  ["md-star_half_full"] = 0xf04d0,
  ["md-star_minus"] = 0xf1564,
  ["md-star_minus_outline"] = 0xf1568,
  ["md-star_off"] = 0xf04d1,
  ["md-star_off_outline"] = 0xf155b,
  ["md-star_outline"] = 0xf04d2,
  ["md-star_plus"] = 0xf1563,
  ["md-star_plus_outline"] = 0xf1567,
  ["md-star_remove"] = 0xf1565,
  ["md-star_remove_outline"] = 0xf1569,
  ["md-star_settings"] = 0xf166a,
  ["md-star_settings_outline"] = 0xf166b,
  ["md-star_shooting"] = 0xf1741,
  ["md-star_shooting_outline"] = 0xf1742,
  ["md-star_three_points"] = 0xf0ae4,
  ["md-star_three_points_outline"] = 0xf0ae5,
  ["md-state_machine"] = 0xf11ef,
  ["md-steam"] = 0xf04d3,
  ["md-steering"] = 0xf04d4,
  ["md-steering_off"] = 0xf090e,
  ["md-step_backward"] = 0xf04d5,
  ["md-step_backward_2"] = 0xf04d6,
  ["md-step_forward"] = 0xf04d7,
  ["md-step_forward_2"] = 0xf04d8,
  ["md-stethoscope"] = 0xf04d9,
  ["md-sticker"] = 0xf1364,
  ["md-sticker_alert"] = 0xf1365,
  ["md-sticker_alert_outline"] = 0xf1366,
  ["md-sticker_check"] = 0xf1367,
  ["md-sticker_check_outline"] = 0xf1368,
  ["md-sticker_circle_outline"] = 0xf05d0,
  ["md-sticker_emoji"] = 0xf0785,
  ["md-sticker_minus"] = 0xf1369,
  ["md-sticker_minus_outline"] = 0xf136a,
  ["md-sticker_outline"] = 0xf136b,
  ["md-sticker_plus"] = 0xf136c,
  ["md-sticker_plus_outline"] = 0xf136d,
  ["md-sticker_remove"] = 0xf136e,
  ["md-sticker_remove_outline"] = 0xf136f,
  ["md-sticker_text"] = 0xf178e,
  ["md-sticker_text_outline"] = 0xf178f,
  ["md-stocking"] = 0xf04da,
  ["md-stomach"] = 0xf1093,
  ["md-stool"] = 0xf195d,
  ["md-stool_outline"] = 0xf195e,
  ["md-stop"] = 0xf04db,
  ["md-stop_circle"] = 0xf0666,
  ["md-stop_circle_outline"] = 0xf0667,
  ["md-storage_tank"] = 0xf1a75,
  ["md-storage_tank_outline"] = 0xf1a76,
  ["md-store"] = 0xf04dc,
  ["md-store_24_hour"] = 0xf04dd,
  ["md-store_alert"] = 0xf18c1,
  ["md-store_alert_outline"] = 0xf18c2,
  ["md-store_check"] = 0xf18c3,
  ["md-store_check_outline"] = 0xf18c4,
  ["md-store_clock"] = 0xf18c5,
  ["md-store_clock_outline"] = 0xf18c6,
  ["md-store_cog"] = 0xf18c7,
  ["md-store_cog_outline"] = 0xf18c8,
  ["md-store_edit"] = 0xf18c9,
  ["md-store_edit_outline"] = 0xf18ca,
  ["md-store_marker"] = 0xf18cb,
  ["md-store_marker_outline"] = 0xf18cc,
  ["md-store_minus"] = 0xf165e,
  ["md-store_minus_outline"] = 0xf18cd,
  ["md-store_off"] = 0xf18ce,
  ["md-store_off_outline"] = 0xf18cf,
  ["md-store_outline"] = 0xf1361,
  ["md-store_plus"] = 0xf165f,
  ["md-store_plus_outline"] = 0xf18d0,
  ["md-store_remove"] = 0xf1660,
  ["md-store_remove_outline"] = 0xf18d1,
  ["md-store_search"] = 0xf18d2,
  ["md-store_search_outline"] = 0xf18d3,
  ["md-store_settings"] = 0xf18d4,
  ["md-store_settings_outline"] = 0xf18d5,
  ["md-storefront"] = 0xf07c7,
  ["md-storefront_outline"] = 0xf10c1,
  ["md-stove"] = 0xf04de,
  ["md-strategy"] = 0xf11d6,
  ["md-stretch_to_page"] = 0xf0f2b,
  ["md-stretch_to_page_outline"] = 0xf0f2c,
  ["md-string_lights"] = 0xf12ba,
  ["md-string_lights_off"] = 0xf12bb,
  ["md-subdirectory_arrow_left"] = 0xf060c,
  ["md-subdirectory_arrow_right"] = 0xf060d,
  ["md-submarine"] = 0xf156c,
  ["md-subtitles"] = 0xf0a16,
  ["md-subtitles_outline"] = 0xf0a17,
  ["md-subway"] = 0xf06ac,
  ["md-subway_alert_variant"] = 0xf0d9d,
  ["md-subway_variant"] = 0xf04df,
  ["md-summit"] = 0xf0786,
  ["md-sun_clock"] = 0xf1a77,
  ["md-sun_clock_outline"] = 0xf1a78,
  ["md-sun_compass"] = 0xf19a5,
  ["md-sun_snowflake"] = 0xf1796,
  ["md-sun_snowflake_variant"] = 0xf1a79,
  ["md-sun_thermometer"] = 0xf18d6,
  ["md-sun_thermometer_outline"] = 0xf18d7,
  ["md-sun_wireless"] = 0xf17fe,
  ["md-sun_wireless_outline"] = 0xf17ff,
  ["md-sunglasses"] = 0xf04e0,
  ["md-surfing"] = 0xf1746,
  ["md-surround_sound"] = 0xf05c5,
  ["md-surround_sound_2_0"] = 0xf07f0,
  ["md-surround_sound_2_1"] = 0xf1729,
  ["md-surround_sound_3_1"] = 0xf07f1,
  ["md-surround_sound_5_1"] = 0xf07f2,
  ["md-surround_sound_5_1_2"] = 0xf172a,
  ["md-surround_sound_7_1"] = 0xf07f3,
  ["md-svg"] = 0xf0721,
  ["md-swap_horizontal"] = 0xf04e1,
  ["md-swap_horizontal_bold"] = 0xf0bcd,
  ["md-swap_horizontal_circle"] = 0xf0fe1,
  ["md-swap_horizontal_circle_outline"] = 0xf0fe2,
  ["md-swap_horizontal_variant"] = 0xf08c1,
  ["md-swap_vertical"] = 0xf04e2,
  ["md-swap_vertical_bold"] = 0xf0bce,
  ["md-swap_vertical_circle"] = 0xf0fe3,
  ["md-swap_vertical_circle_outline"] = 0xf0fe4,
  ["md-swap_vertical_variant"] = 0xf08c2,
  ["md-swim"] = 0xf04e3,
  ["md-switch"] = 0xf04e4,
  ["md-sword"] = 0xf04e5,
  ["md-sword_cross"] = 0xf0787,
  ["md-syllabary_hangul"] = 0xf1333,
  ["md-syllabary_hiragana"] = 0xf1334,
  ["md-syllabary_katakana"] = 0xf1335,
  ["md-syllabary_katakana_halfwidth"] = 0xf1336,
  ["md-symbol"] = 0xf1501,
  ["md-symfony"] = 0xf0ae6,
  ["md-sync"] = 0xf04e6,
  ["md-sync_alert"] = 0xf04e7,
  ["md-sync_circle"] = 0xf1378,
  ["md-sync_off"] = 0xf04e8,
  ["md-tab"] = 0xf04e9,
  ["md-tab_minus"] = 0xf0b4b,
  ["md-tab_plus"] = 0xf075c,
  ["md-tab_remove"] = 0xf0b4c,
  ["md-tab_search"] = 0xf199e,
  ["md-tab_unselected"] = 0xf04ea,
  ["md-table"] = 0xf04eb,
  ["md-table_account"] = 0xf13b9,
  ["md-table_alert"] = 0xf13ba,
  ["md-table_arrow_down"] = 0xf13bb,
  ["md-table_arrow_left"] = 0xf13bc,
  ["md-table_arrow_right"] = 0xf13bd,
  ["md-table_arrow_up"] = 0xf13be,
  ["md-table_border"] = 0xf0a18,
  ["md-table_cancel"] = 0xf13bf,
  ["md-table_chair"] = 0xf1061,
  ["md-table_check"] = 0xf13c0,
  ["md-table_clock"] = 0xf13c1,
  ["md-table_cog"] = 0xf13c2,
  ["md-table_column"] = 0xf0835,
  ["md-table_column_plus_after"] = 0xf04ec,
  ["md-table_column_plus_before"] = 0xf04ed,
  ["md-table_column_remove"] = 0xf04ee,
  ["md-table_column_width"] = 0xf04ef,
  ["md-table_edit"] = 0xf04f0,
  ["md-table_eye"] = 0xf1094,
  ["md-table_eye_off"] = 0xf13c3,
  ["md-table_furniture"] = 0xf05bc,
  ["md-table_headers_eye"] = 0xf121d,
  ["md-table_headers_eye_off"] = 0xf121e,
  ["md-table_heart"] = 0xf13c4,
  ["md-table_key"] = 0xf13c5,
  ["md-table_large"] = 0xf04f1,
  ["md-table_large_plus"] = 0xf0f87,
  ["md-table_large_remove"] = 0xf0f88,
  ["md-table_lock"] = 0xf13c6,
  ["md-table_merge_cells"] = 0xf09a6,
  ["md-table_minus"] = 0xf13c7,
  ["md-table_multiple"] = 0xf13c8,
  ["md-table_network"] = 0xf13c9,
  ["md-table_of_contents"] = 0xf0836,
  ["md-table_off"] = 0xf13ca,
  ["md-table_picnic"] = 0xf1743,
  ["md-table_pivot"] = 0xf183c,
  ["md-table_plus"] = 0xf0a75,
  ["md-table_refresh"] = 0xf13a0,
  ["md-table_remove"] = 0xf0a76,
  ["md-table_row"] = 0xf0837,
  ["md-table_row_height"] = 0xf04f2,
  ["md-table_row_plus_after"] = 0xf04f3,
  ["md-table_row_plus_before"] = 0xf04f4,
  ["md-table_row_remove"] = 0xf04f5,
  ["md-table_search"] = 0xf090f,
  ["md-table_settings"] = 0xf0838,
  ["md-table_split_cell"] = 0xf142a,
  ["md-table_star"] = 0xf13cb,
  ["md-table_sync"] = 0xf13a1,
  ["md-table_tennis"] = 0xf0e68,
  ["md-tablet"] = 0xf04f6,
  ["md-tablet_android"] = 0xf04f7,
  ["md-tablet_cellphone"] = 0xf09a7,
  ["md-tablet_dashboard"] = 0xf0ece,
  ["md-taco"] = 0xf0762,
  ["md-tag"] = 0xf04f9,
  ["md-tag_arrow_down"] = 0xf172b,
  ["md-tag_arrow_down_outline"] = 0xf172c,
  ["md-tag_arrow_left"] = 0xf172d,
  ["md-tag_arrow_left_outline"] = 0xf172e,
  ["md-tag_arrow_right"] = 0xf172f,
  ["md-tag_arrow_right_outline"] = 0xf1730,
  ["md-tag_arrow_up"] = 0xf1731,
  ["md-tag_arrow_up_outline"] = 0xf1732,
  ["md-tag_check"] = 0xf1a7a,
  ["md-tag_check_outline"] = 0xf1a7b,
  ["md-tag_faces"] = 0xf04fa,
  ["md-tag_heart"] = 0xf068b,
  ["md-tag_heart_outline"] = 0xf0bcf,
  ["md-tag_minus"] = 0xf0910,
  ["md-tag_minus_outline"] = 0xf121f,
  ["md-tag_multiple"] = 0xf04fb,
  ["md-tag_multiple_outline"] = 0xf12f7,
  ["md-tag_off"] = 0xf1220,
  ["md-tag_off_outline"] = 0xf1221,
  ["md-tag_outline"] = 0xf04fc,
  ["md-tag_plus"] = 0xf0722,
  ["md-tag_plus_outline"] = 0xf1222,
  ["md-tag_remove"] = 0xf0723,
  ["md-tag_remove_outline"] = 0xf1223,
  ["md-tag_search"] = 0xf1907,
  ["md-tag_search_outline"] = 0xf1908,
  ["md-tag_text"] = 0xf1224,
  ["md-tag_text_outline"] = 0xf04fd,
  ["md-tailwind"] = 0xf13ff,
  ["md-tally_mark_1"] = 0xf1abc,
  ["md-tally_mark_2"] = 0xf1abd,
  ["md-tally_mark_3"] = 0xf1abe,
  ["md-tally_mark_4"] = 0xf1abf,
  ["md-tally_mark_5"] = 0xf1ac0,
  ["md-tangram"] = 0xf04f8,
  ["md-tank"] = 0xf0d3a,
  ["md-tanker_truck"] = 0xf0fe5,
  ["md-tape_drive"] = 0xf16df,
  ["md-tape_measure"] = 0xf0b4d,
  ["md-target"] = 0xf04fe,
  ["md-target_account"] = 0xf0bd0,
  ["md-target_variant"] = 0xf0a77,
  ["md-taxi"] = 0xf04ff,
  ["md-tea"] = 0xf0d9e,
  ["md-tea_outline"] = 0xf0d9f,
  ["md-teamviewer"] = 0xf0500,
  ["md-teddy_bear"] = 0xf18fb,
  ["md-telescope"] = 0xf0b4e,
  ["md-television"] = 0xf0502,
  ["md-television_ambient_light"] = 0xf1356,
  ["md-television_box"] = 0xf0839,
  ["md-television_classic"] = 0xf07f4,
  ["md-television_classic_off"] = 0xf083a,
  ["md-television_guide"] = 0xf0503,
  ["md-television_off"] = 0xf083b,
  ["md-television_pause"] = 0xf0f89,
  ["md-television_play"] = 0xf0ecf,
  ["md-television_shimmer"] = 0xf1110,
  ["md-television_stop"] = 0xf0f8a,
  ["md-temperature_celsius"] = 0xf0504,
  ["md-temperature_fahrenheit"] = 0xf0505,
  ["md-temperature_kelvin"] = 0xf0506,
  ["md-tennis"] = 0xf0da0,
  ["md-tennis_ball"] = 0xf0507,
  ["md-tent"] = 0xf0508,
  ["md-terraform"] = 0xf1062,
  ["md-test_tube"] = 0xf0668,
  ["md-test_tube_empty"] = 0xf0911,
  ["md-test_tube_off"] = 0xf0912,
  ["md-text"] = 0xf09a8,
  ["md-text_account"] = 0xf1570,
  ["md-text_box"] = 0xf021a,
  ["md-text_box_check"] = 0xf0ea6,
  ["md-text_box_check_outline"] = 0xf0ea7,
  ["md-text_box_edit"] = 0xf1a7c,
  ["md-text_box_edit_outline"] = 0xf1a7d,
  ["md-text_box_minus"] = 0xf0ea8,
  ["md-text_box_minus_outline"] = 0xf0ea9,
  ["md-text_box_multiple"] = 0xf0ab7,
  ["md-text_box_multiple_outline"] = 0xf0ab8,
  ["md-text_box_outline"] = 0xf09ed,
  ["md-text_box_plus"] = 0xf0eaa,
  ["md-text_box_plus_outline"] = 0xf0eab,
  ["md-text_box_remove"] = 0xf0eac,
  ["md-text_box_remove_outline"] = 0xf0ead,
  ["md-text_box_search"] = 0xf0eae,
  ["md-text_box_search_outline"] = 0xf0eaf,
  ["md-text_long"] = 0xf09aa,
  ["md-text_recognition"] = 0xf113d,
  ["md-text_search"] = 0xf13b8,
  ["md-text_search_variant"] = 0xf1a7e,
  ["md-text_shadow"] = 0xf0669,
  ["md-text_short"] = 0xf09a9,
  ["md-text_to_speech"] = 0xf050a,
  ["md-text_to_speech_off"] = 0xf050b,
  ["md-texture"] = 0xf050c,
  ["md-texture_box"] = 0xf0fe6,
  ["md-theater"] = 0xf050d,
  ["md-theme_light_dark"] = 0xf050e,
  ["md-thermometer"] = 0xf050f,
  ["md-thermometer_alert"] = 0xf0e01,
  ["md-thermometer_bluetooth"] = 0xf1895,
  ["md-thermometer_check"] = 0xf1a7f,
  ["md-thermometer_chevron_down"] = 0xf0e02,
  ["md-thermometer_chevron_up"] = 0xf0e03,
  ["md-thermometer_high"] = 0xf10c2,
  ["md-thermometer_lines"] = 0xf0510,
  ["md-thermometer_low"] = 0xf10c3,
  ["md-thermometer_minus"] = 0xf0e04,
  ["md-thermometer_off"] = 0xf1531,
  ["md-thermometer_plus"] = 0xf0e05,
  ["md-thermometer_water"] = 0xf1a80,
  ["md-thermostat"] = 0xf0393,
  ["md-thermostat_box"] = 0xf0891,
  ["md-thought_bubble"] = 0xf07f6,
  ["md-thought_bubble_outline"] = 0xf07f7,
  ["md-thumb_down"] = 0xf0511,
  ["md-thumb_down_outline"] = 0xf0512,
  ["md-thumb_up"] = 0xf0513,
  ["md-thumb_up_outline"] = 0xf0514,
  ["md-thumbs_up_down"] = 0xf0515,
  ["md-thumbs_up_down_outline"] = 0xf1914,
  ["md-ticket"] = 0xf0516,
  ["md-ticket_account"] = 0xf0517,
  ["md-ticket_confirmation"] = 0xf0518,
  ["md-ticket_confirmation_outline"] = 0xf13aa,
  ["md-ticket_outline"] = 0xf0913,
  ["md-ticket_percent"] = 0xf0724,
  ["md-ticket_percent_outline"] = 0xf142b,
  ["md-tie"] = 0xf0519,
  ["md-tilde"] = 0xf0725,
  ["md-tilde_off"] = 0xf18f3,
  ["md-timelapse"] = 0xf051a,
  ["md-timeline"] = 0xf0bd1,
  ["md-timeline_alert"] = 0xf0f95,
  ["md-timeline_alert_outline"] = 0xf0f98,
  ["md-timeline_check"] = 0xf1532,
  ["md-timeline_check_outline"] = 0xf1533,
  ["md-timeline_clock"] = 0xf11fb,
  ["md-timeline_clock_outline"] = 0xf11fc,
  ["md-timeline_help"] = 0xf0f99,
  ["md-timeline_help_outline"] = 0xf0f9a,
  ["md-timeline_minus"] = 0xf1534,
  ["md-timeline_minus_outline"] = 0xf1535,
  ["md-timeline_outline"] = 0xf0bd2,
  ["md-timeline_plus"] = 0xf0f96,
  ["md-timeline_plus_outline"] = 0xf0f97,
  ["md-timeline_remove"] = 0xf1536,
  ["md-timeline_remove_outline"] = 0xf1537,
  ["md-timeline_text"] = 0xf0bd3,
  ["md-timeline_text_outline"] = 0xf0bd4,
  ["md-timer"] = 0xf13ab,
  ["md-timer_10"] = 0xf051c,
  ["md-timer_3"] = 0xf051d,
  ["md-timer_alert"] = 0xf1acc,
  ["md-timer_alert_outline"] = 0xf1acd,
  ["md-timer_cancel"] = 0xf1ace,
  ["md-timer_cancel_outline"] = 0xf1acf,
  ["md-timer_check"] = 0xf1ad0,
  ["md-timer_check_outline"] = 0xf1ad1,
  ["md-timer_cog"] = 0xf1925,
  ["md-timer_cog_outline"] = 0xf1926,
  ["md-timer_edit"] = 0xf1ad2,
  ["md-timer_edit_outline"] = 0xf1ad3,
  ["md-timer_lock"] = 0xf1ad4,
  ["md-timer_lock_open"] = 0xf1ad5,
  ["md-timer_lock_open_outline"] = 0xf1ad6,
  ["md-timer_lock_outline"] = 0xf1ad7,
  ["md-timer_marker"] = 0xf1ad8,
  ["md-timer_marker_outline"] = 0xf1ad9,
  ["md-timer_minus"] = 0xf1ada,
  ["md-timer_minus_outline"] = 0xf1adb,
  ["md-timer_music"] = 0xf1adc,
  ["md-timer_music_outline"] = 0xf1add,
  ["md-timer_off"] = 0xf13ac,
  ["md-timer_off_outline"] = 0xf051e,
  ["md-timer_outline"] = 0xf051b,
  ["md-timer_pause"] = 0xf1ade,
  ["md-timer_pause_outline"] = 0xf1adf,
  ["md-timer_play"] = 0xf1ae0,
  ["md-timer_play_outline"] = 0xf1ae1,
  ["md-timer_plus"] = 0xf1ae2,
  ["md-timer_plus_outline"] = 0xf1ae3,
  ["md-timer_refresh"] = 0xf1ae4,
  ["md-timer_refresh_outline"] = 0xf1ae5,
  ["md-timer_remove"] = 0xf1ae6,
  ["md-timer_remove_outline"] = 0xf1ae7,
  ["md-timer_sand"] = 0xf051f,
  ["md-timer_sand_complete"] = 0xf199f,
  ["md-timer_sand_empty"] = 0xf06ad,
  ["md-timer_sand_full"] = 0xf078c,
  ["md-timer_sand_paused"] = 0xf19a0,
  ["md-timer_settings"] = 0xf1923,
  ["md-timer_settings_outline"] = 0xf1924,
  ["md-timer_star"] = 0xf1ae8,
  ["md-timer_star_outline"] = 0xf1ae9,
  ["md-timer_stop"] = 0xf1aea,
  ["md-timer_stop_outline"] = 0xf1aeb,
  ["md-timer_sync"] = 0xf1aec,
  ["md-timer_sync_outline"] = 0xf1aed,
  ["md-timetable"] = 0xf0520,
  ["md-tire"] = 0xf1896,
  ["md-toaster"] = 0xf1063,
  ["md-toaster_off"] = 0xf11b7,
  ["md-toaster_oven"] = 0xf0cd3,
  ["md-toggle_switch"] = 0xf0521,
  ["md-toggle_switch_off"] = 0xf0522,
  ["md-toggle_switch_off_outline"] = 0xf0a19,
  ["md-toggle_switch_outline"] = 0xf0a1a,
  ["md-toggle_switch_variant"] = 0xf1a25,
  ["md-toggle_switch_variant_off"] = 0xf1a26,
  ["md-toilet"] = 0xf09ab,
  ["md-toolbox"] = 0xf09ac,
  ["md-toolbox_outline"] = 0xf09ad,
  ["md-tools"] = 0xf1064,
  ["md-tooltip"] = 0xf0523,
  ["md-tooltip_account"] = 0xf000c,
  ["md-tooltip_cellphone"] = 0xf183b,
  ["md-tooltip_check"] = 0xf155c,
  ["md-tooltip_check_outline"] = 0xf155d,
  ["md-tooltip_edit"] = 0xf0524,
  ["md-tooltip_edit_outline"] = 0xf12c5,
  ["md-tooltip_image"] = 0xf0525,
  ["md-tooltip_image_outline"] = 0xf0bd5,
  ["md-tooltip_minus"] = 0xf155e,
  ["md-tooltip_minus_outline"] = 0xf155f,
  ["md-tooltip_outline"] = 0xf0526,
  ["md-tooltip_plus"] = 0xf0bd6,
  ["md-tooltip_plus_outline"] = 0xf0527,
  ["md-tooltip_remove"] = 0xf1560,
  ["md-tooltip_remove_outline"] = 0xf1561,
  ["md-tooltip_text"] = 0xf0528,
  ["md-tooltip_text_outline"] = 0xf0bd7,
  ["md-tooth"] = 0xf08c3,
  ["md-tooth_outline"] = 0xf0529,
  ["md-toothbrush"] = 0xf1129,
  ["md-toothbrush_electric"] = 0xf112c,
  ["md-toothbrush_paste"] = 0xf112a,
  ["md-torch"] = 0xf1606,
  ["md-tortoise"] = 0xf0d3b,
  ["md-toslink"] = 0xf12b8,
  ["md-tournament"] = 0xf09ae,
  ["md-tow_truck"] = 0xf083c,
  ["md-tower_beach"] = 0xf0681,
  ["md-tower_fire"] = 0xf0682,
  ["md-town_hall"] = 0xf1875,
  ["md-toy_brick"] = 0xf1288,
  ["md-toy_brick_marker"] = 0xf1289,
  ["md-toy_brick_marker_outline"] = 0xf128a,
  ["md-toy_brick_minus"] = 0xf128b,
  ["md-toy_brick_minus_outline"] = 0xf128c,
  ["md-toy_brick_outline"] = 0xf128d,
  ["md-toy_brick_plus"] = 0xf128e,
  ["md-toy_brick_plus_outline"] = 0xf128f,
  ["md-toy_brick_remove"] = 0xf1290,
  ["md-toy_brick_remove_outline"] = 0xf1291,
  ["md-toy_brick_search"] = 0xf1292,
  ["md-toy_brick_search_outline"] = 0xf1293,
  ["md-track_light"] = 0xf0914,
  ["md-trackpad"] = 0xf07f8,
  ["md-trackpad_lock"] = 0xf0933,
  ["md-tractor"] = 0xf0892,
  ["md-tractor_variant"] = 0xf14c4,
  ["md-trademark"] = 0xf0a78,
  ["md-traffic_cone"] = 0xf137c,
  ["md-traffic_light"] = 0xf052b,
  ["md-traffic_light_outline"] = 0xf182a,
  ["md-train"] = 0xf052c,
  ["md-train_car"] = 0xf0bd8,
  ["md-train_car_passenger"] = 0xf1733,
  ["md-train_car_passenger_door"] = 0xf1734,
  ["md-train_car_passenger_door_open"] = 0xf1735,
  ["md-train_car_passenger_variant"] = 0xf1736,
  ["md-train_variant"] = 0xf08c4,
  ["md-tram"] = 0xf052d,
  ["md-tram_side"] = 0xf0fe7,
  ["md-transcribe"] = 0xf052e,
  ["md-transcribe_close"] = 0xf052f,
  ["md-transfer"] = 0xf1065,
  ["md-transfer_down"] = 0xf0da1,
  ["md-transfer_left"] = 0xf0da2,
  ["md-transfer_right"] = 0xf0530,
  ["md-transfer_up"] = 0xf0da3,
  ["md-transit_connection"] = 0xf0d3c,
  ["md-transit_connection_horizontal"] = 0xf1546,
  ["md-transit_connection_variant"] = 0xf0d3d,
  ["md-transit_detour"] = 0xf0f8b,
  ["md-transit_skip"] = 0xf1515,
  ["md-transit_transfer"] = 0xf06ae,
  ["md-transition"] = 0xf0915,
  ["md-transition_masked"] = 0xf0916,
  ["md-translate"] = 0xf05ca,
  ["md-translate_off"] = 0xf0e06,
  ["md-transmission_tower"] = 0xf0d3e,
  ["md-transmission_tower_export"] = 0xf192c,
  ["md-transmission_tower_import"] = 0xf192d,
  ["md-transmission_tower_off"] = 0xf19dd,
  ["md-trash_can"] = 0xf0a79,
  ["md-trash_can_outline"] = 0xf0a7a,
  ["md-tray"] = 0xf1294,
  ["md-tray_alert"] = 0xf1295,
  ["md-tray_arrow_down"] = 0xf0120,
  ["md-tray_arrow_up"] = 0xf011d,
  ["md-tray_full"] = 0xf1296,
  ["md-tray_minus"] = 0xf1297,
  ["md-tray_plus"] = 0xf1298,
  ["md-tray_remove"] = 0xf1299,
  ["md-treasure_chest"] = 0xf0726,
  ["md-tree"] = 0xf0531,
  ["md-tree_outline"] = 0xf0e69,
  ["md-trello"] = 0xf0532,
  ["md-trending_down"] = 0xf0533,
  ["md-trending_neutral"] = 0xf0534,
  ["md-trending_up"] = 0xf0535,
  ["md-triangle"] = 0xf0536,
  ["md-triangle_outline"] = 0xf0537,
  ["md-triangle_small_down"] = 0xf1a09,
  ["md-triangle_small_up"] = 0xf1a0a,
  ["md-triangle_wave"] = 0xf147c,
  ["md-triforce"] = 0xf0bd9,
  ["md-trophy"] = 0xf0538,
  ["md-trophy_award"] = 0xf0539,
  ["md-trophy_broken"] = 0xf0da4,
  ["md-trophy_outline"] = 0xf053a,
  ["md-trophy_variant"] = 0xf053b,
  ["md-trophy_variant_outline"] = 0xf053c,
  ["md-truck"] = 0xf053d,
  ["md-truck_alert"] = 0xf19de,
  ["md-truck_alert_outline"] = 0xf19df,
  ["md-truck_cargo_container"] = 0xf18d8,
  ["md-truck_check"] = 0xf0cd4,
  ["md-truck_check_outline"] = 0xf129a,
  ["md-truck_delivery"] = 0xf053e,
  ["md-truck_delivery_outline"] = 0xf129b,
  ["md-truck_fast"] = 0xf0788,
  ["md-truck_fast_outline"] = 0xf129c,
  ["md-truck_flatbed"] = 0xf1891,
  ["md-truck_minus"] = 0xf19ae,
  ["md-truck_minus_outline"] = 0xf19bd,
  ["md-truck_outline"] = 0xf129d,
  ["md-truck_plus"] = 0xf19ad,
  ["md-truck_plus_outline"] = 0xf19bc,
  ["md-truck_remove"] = 0xf19af,
  ["md-truck_remove_outline"] = 0xf19be,
  ["md-truck_snowflake"] = 0xf19a6,
  ["md-truck_trailer"] = 0xf0727,
  ["md-trumpet"] = 0xf1096,
  ["md-tshirt_crew"] = 0xf0a7b,
  ["md-tshirt_crew_outline"] = 0xf053f,
  ["md-tshirt_v"] = 0xf0a7c,
  ["md-tshirt_v_outline"] = 0xf0540,
  ["md-tsunami"] = 0xf1a81,
  ["md-tumble_dryer"] = 0xf0917,
  ["md-tumble_dryer_alert"] = 0xf11ba,
  ["md-tumble_dryer_off"] = 0xf11bb,
  ["md-tune"] = 0xf062e,
  ["md-tune_variant"] = 0xf1542,
  ["md-tune_vertical"] = 0xf066a,
  ["md-tune_vertical_variant"] = 0xf1543,
  ["md-tunnel"] = 0xf183d,
  ["md-tunnel_outline"] = 0xf183e,
  ["md-turbine"] = 0xf1a82,
  ["md-turkey"] = 0xf171b,
  ["md-turnstile"] = 0xf0cd5,
  ["md-turnstile_outline"] = 0xf0cd6,
  ["md-turtle"] = 0xf0cd7,
  ["md-twitch"] = 0xf0543,
  ["md-twitter"] = 0xf0544,
  ["md-two_factor_authentication"] = 0xf09af,
  ["md-typewriter"] = 0xf0f2d,
  ["md-ubisoft"] = 0xf0bda,
  ["md-ubuntu"] = 0xf0548,
  ["md-ufo"] = 0xf10c4,
  ["md-ufo_outline"] = 0xf10c5,
  ["md-ultra_high_definition"] = 0xf07f9,
  ["md-umbraco"] = 0xf0549,
  ["md-umbrella"] = 0xf054a,
  ["md-umbrella_beach"] = 0xf188a,
  ["md-umbrella_beach_outline"] = 0xf188b,
  ["md-umbrella_closed"] = 0xf09b0,
  ["md-umbrella_closed_outline"] = 0xf13e2,
  ["md-umbrella_closed_variant"] = 0xf13e1,
  ["md-umbrella_outline"] = 0xf054b,
  ["md-undo"] = 0xf054c,
  ["md-undo_variant"] = 0xf054d,
  ["md-unfold_less_horizontal"] = 0xf054e,
  ["md-unfold_less_vertical"] = 0xf0760,
  ["md-unfold_more_horizontal"] = 0xf054f,
  ["md-unfold_more_vertical"] = 0xf0761,
  ["md-ungroup"] = 0xf0550,
  ["md-unicode"] = 0xf0ed0,
  ["md-unicorn"] = 0xf15c2,
  ["md-unicorn_variant"] = 0xf15c3,
  ["md-unicycle"] = 0xf15e5,
  ["md-unity"] = 0xf06af,
  ["md-unreal"] = 0xf09b1,
  ["md-update"] = 0xf06b0,
  ["md-upload"] = 0xf0552,
  ["md-upload_lock"] = 0xf1373,
  ["md-upload_lock_outline"] = 0xf1374,
  ["md-upload_multiple"] = 0xf083d,
  ["md-upload_network"] = 0xf06f6,
  ["md-upload_network_outline"] = 0xf0cd8,
  ["md-upload_off"] = 0xf10c6,
  ["md-upload_off_outline"] = 0xf10c7,
  ["md-upload_outline"] = 0xf0e07,
  ["md-usb"] = 0xf0553,
  ["md-usb_flash_drive"] = 0xf129e,
  ["md-usb_flash_drive_outline"] = 0xf129f,
  ["md-usb_port"] = 0xf11f0,
  ["md-vacuum"] = 0xf19a1,
  ["md-vacuum_outline"] = 0xf19a2,
  ["md-valve"] = 0xf1066,
  ["md-valve_closed"] = 0xf1067,
  ["md-valve_open"] = 0xf1068,
  ["md-van_passenger"] = 0xf07fa,
  ["md-van_utility"] = 0xf07fb,
  ["md-vanish"] = 0xf07fc,
  ["md-vanish_quarter"] = 0xf1554,
  ["md-vanity_light"] = 0xf11e1,
  ["md-variable"] = 0xf0ae7,
  ["md-variable_box"] = 0xf1111,
  ["md-vector_arrange_above"] = 0xf0554,
  ["md-vector_arrange_below"] = 0xf0555,
  ["md-vector_bezier"] = 0xf0ae8,
  ["md-vector_circle"] = 0xf0556,
  ["md-vector_circle_variant"] = 0xf0557,
  ["md-vector_combine"] = 0xf0558,
  ["md-vector_curve"] = 0xf0559,
  ["md-vector_difference"] = 0xf055a,
  ["md-vector_difference_ab"] = 0xf055b,
  ["md-vector_difference_ba"] = 0xf055c,
  ["md-vector_ellipse"] = 0xf0893,
  ["md-vector_intersection"] = 0xf055d,
  ["md-vector_line"] = 0xf055e,
  ["md-vector_link"] = 0xf0fe8,
  ["md-vector_point"] = 0xf055f,
  ["md-vector_polygon"] = 0xf0560,
  ["md-vector_polygon_variant"] = 0xf1856,
  ["md-vector_polyline"] = 0xf0561,
  ["md-vector_polyline_edit"] = 0xf1225,
  ["md-vector_polyline_minus"] = 0xf1226,
  ["md-vector_polyline_plus"] = 0xf1227,
  ["md-vector_polyline_remove"] = 0xf1228,
  ["md-vector_radius"] = 0xf074a,
  ["md-vector_rectangle"] = 0xf05c6,
  ["md-vector_selection"] = 0xf0562,
  ["md-vector_square"] = 0xf0001,
  ["md-vector_square_close"] = 0xf1857,
  ["md-vector_square_edit"] = 0xf18d9,
  ["md-vector_square_minus"] = 0xf18da,
  ["md-vector_square_open"] = 0xf1858,
  ["md-vector_square_plus"] = 0xf18db,
  ["md-vector_square_remove"] = 0xf18dc,
  ["md-vector_triangle"] = 0xf0563,
  ["md-vector_union"] = 0xf0564,
  ["md-vhs"] = 0xf0a1b,
  ["md-vibrate"] = 0xf0566,
  ["md-vibrate_off"] = 0xf0cd9,
  ["md-video"] = 0xf0567,
  ["md-video_2d"] = 0xf1a1c,
  ["md-video_3d"] = 0xf07fd,
  ["md-video_3d_off"] = 0xf13d9,
  ["md-video_3d_variant"] = 0xf0ed1,
  ["md-video_4k_box"] = 0xf083e,
  ["md-video_account"] = 0xf0919,
  ["md-video_box"] = 0xf00fd,
  ["md-video_box_off"] = 0xf00fe,
  ["md-video_check"] = 0xf1069,
  ["md-video_check_outline"] = 0xf106a,
  ["md-video_high_definition"] = 0xf152e,
  ["md-video_image"] = 0xf091a,
  ["md-video_input_antenna"] = 0xf083f,
  ["md-video_input_component"] = 0xf0840,
  ["md-video_input_hdmi"] = 0xf0841,
  ["md-video_input_scart"] = 0xf0f8c,
  ["md-video_input_svideo"] = 0xf0842,
  ["md-video_marker"] = 0xf19a9,
  ["md-video_marker_outline"] = 0xf19aa,
  ["md-video_minus"] = 0xf09b2,
  ["md-video_minus_outline"] = 0xf02ba,
  ["md-video_off"] = 0xf0568,
  ["md-video_off_outline"] = 0xf0bdb,
  ["md-video_outline"] = 0xf0bdc,
  ["md-video_plus"] = 0xf09b3,
  ["md-video_plus_outline"] = 0xf01d3,
  ["md-video_stabilization"] = 0xf091b,
  ["md-video_switch"] = 0xf0569,
  ["md-video_switch_outline"] = 0xf0790,
  ["md-video_vintage"] = 0xf0a1c,
  ["md-video_wireless"] = 0xf0ed2,
  ["md-video_wireless_outline"] = 0xf0ed3,
  ["md-view_agenda"] = 0xf056a,
  ["md-view_agenda_outline"] = 0xf11d8,
  ["md-view_array"] = 0xf056b,
  ["md-view_array_outline"] = 0xf1485,
  ["md-view_carousel"] = 0xf056c,
  ["md-view_carousel_outline"] = 0xf1486,
  ["md-view_column"] = 0xf056d,
  ["md-view_column_outline"] = 0xf1487,
  ["md-view_comfy"] = 0xf0e6a,
  ["md-view_comfy_outline"] = 0xf1488,
  ["md-view_compact"] = 0xf0e6b,
  ["md-view_compact_outline"] = 0xf0e6c,
  ["md-view_dashboard"] = 0xf056e,
  ["md-view_dashboard_edit"] = 0xf1947,
  ["md-view_dashboard_edit_outline"] = 0xf1948,
  ["md-view_dashboard_outline"] = 0xf0a1d,
  ["md-view_dashboard_variant"] = 0xf0843,
  ["md-view_dashboard_variant_outline"] = 0xf1489,
  ["md-view_day"] = 0xf056f,
  ["md-view_day_outline"] = 0xf148a,
  ["md-view_gallery"] = 0xf1888,
  ["md-view_gallery_outline"] = 0xf1889,
  ["md-view_grid"] = 0xf0570,
  ["md-view_grid_outline"] = 0xf11d9,
  ["md-view_grid_plus"] = 0xf0f8d,
  ["md-view_grid_plus_outline"] = 0xf11da,
  ["md-view_headline"] = 0xf0571,
  ["md-view_list"] = 0xf0572,
  ["md-view_list_outline"] = 0xf148b,
  ["md-view_module"] = 0xf0573,
  ["md-view_module_outline"] = 0xf148c,
  ["md-view_parallel"] = 0xf0728,
  ["md-view_parallel_outline"] = 0xf148d,
  ["md-view_quilt"] = 0xf0574,
  ["md-view_quilt_outline"] = 0xf148e,
  ["md-view_sequential"] = 0xf0729,
  ["md-view_sequential_outline"] = 0xf148f,
  ["md-view_split_horizontal"] = 0xf0bcb,
  ["md-view_split_vertical"] = 0xf0bcc,
  ["md-view_stream"] = 0xf0575,
  ["md-view_stream_outline"] = 0xf1490,
  ["md-view_week"] = 0xf0576,
  ["md-view_week_outline"] = 0xf1491,
  ["md-vimeo"] = 0xf0577,
  ["md-violin"] = 0xf060f,
  ["md-virtual_reality"] = 0xf0894,
  ["md-virus"] = 0xf13b6,
  ["md-virus_off"] = 0xf18e1,
  ["md-virus_off_outline"] = 0xf18e2,
  ["md-virus_outline"] = 0xf13b7,
  ["md-vlc"] = 0xf057c,
  ["md-voicemail"] = 0xf057d,
  ["md-volcano"] = 0xf1a83,
  ["md-volcano_outline"] = 0xf1a84,
  ["md-volleyball"] = 0xf09b4,
  ["md-volume_high"] = 0xf057e,
  ["md-volume_low"] = 0xf057f,
  ["md-volume_medium"] = 0xf0580,
  ["md-volume_minus"] = 0xf075e,
  ["md-volume_mute"] = 0xf075f,
  ["md-volume_off"] = 0xf0581,
  ["md-volume_plus"] = 0xf075d,
  ["md-volume_source"] = 0xf1120,
  ["md-volume_variant_off"] = 0xf0e08,
  ["md-volume_vibrate"] = 0xf1121,
  ["md-vote"] = 0xf0a1f,
  ["md-vote_outline"] = 0xf0a20,
  ["md-vpn"] = 0xf0582,
  ["md-vuejs"] = 0xf0844,
  ["md-vuetify"] = 0xf0e6d,
  ["md-walk"] = 0xf0583,
  ["md-wall"] = 0xf07fe,
  ["md-wall_fire"] = 0xf1a11,
  ["md-wall_sconce"] = 0xf091c,
  ["md-wall_sconce_flat"] = 0xf091d,
  ["md-wall_sconce_flat_outline"] = 0xf17c9,
  ["md-wall_sconce_flat_variant"] = 0xf041c,
  ["md-wall_sconce_flat_variant_outline"] = 0xf17ca,
  ["md-wall_sconce_outline"] = 0xf17cb,
  ["md-wall_sconce_round"] = 0xf0748,
  ["md-wall_sconce_round_outline"] = 0xf17cc,
  ["md-wall_sconce_round_variant"] = 0xf091e,
  ["md-wall_sconce_round_variant_outline"] = 0xf17cd,
  ["md-wallet"] = 0xf0584,
  ["md-wallet_giftcard"] = 0xf0585,
  ["md-wallet_membership"] = 0xf0586,
  ["md-wallet_outline"] = 0xf0bdd,
  ["md-wallet_plus"] = 0xf0f8e,
  ["md-wallet_plus_outline"] = 0xf0f8f,
  ["md-wallet_travel"] = 0xf0587,
  ["md-wallpaper"] = 0xf0e09,
  ["md-wan"] = 0xf0588,
  ["md-wardrobe"] = 0xf0f90,
  ["md-wardrobe_outline"] = 0xf0f91,
  ["md-warehouse"] = 0xf0f81,
  ["md-washing_machine"] = 0xf072a,
  ["md-washing_machine_alert"] = 0xf11bc,
  ["md-washing_machine_off"] = 0xf11bd,
  ["md-watch"] = 0xf0589,
  ["md-watch_export"] = 0xf058a,
  ["md-watch_export_variant"] = 0xf0895,
  ["md-watch_import"] = 0xf058b,
  ["md-watch_import_variant"] = 0xf0896,
  ["md-watch_variant"] = 0xf0897,
  ["md-watch_vibrate"] = 0xf06b1,
  ["md-watch_vibrate_off"] = 0xf0cda,
  ["md-water"] = 0xf058c,
  ["md-water_alert"] = 0xf1502,
  ["md-water_alert_outline"] = 0xf1503,
  ["md-water_boiler"] = 0xf0f92,
  ["md-water_boiler_alert"] = 0xf11b3,
  ["md-water_boiler_off"] = 0xf11b4,
  ["md-water_check"] = 0xf1504,
  ["md-water_check_outline"] = 0xf1505,
  ["md-water_circle"] = 0xf1806,
  ["md-water_minus"] = 0xf1506,
  ["md-water_minus_outline"] = 0xf1507,
  ["md-water_off"] = 0xf058d,
  ["md-water_off_outline"] = 0xf1508,
  ["md-water_opacity"] = 0xf1855,
  ["md-water_outline"] = 0xf0e0a,
  ["md-water_percent"] = 0xf058e,
  ["md-water_percent_alert"] = 0xf1509,
  ["md-water_plus"] = 0xf150a,
  ["md-water_plus_outline"] = 0xf150b,
  ["md-water_polo"] = 0xf12a0,
  ["md-water_pump"] = 0xf058f,
  ["md-water_pump_off"] = 0xf0f93,
  ["md-water_remove"] = 0xf150c,
  ["md-water_remove_outline"] = 0xf150d,
  ["md-water_sync"] = 0xf17c6,
  ["md-water_thermometer"] = 0xf1a85,
  ["md-water_thermometer_outline"] = 0xf1a86,
  ["md-water_well"] = 0xf106b,
  ["md-water_well_outline"] = 0xf106c,
  ["md-waterfall"] = 0xf1849,
  ["md-watering_can"] = 0xf1481,
  ["md-watering_can_outline"] = 0xf1482,
  ["md-watermark"] = 0xf0612,
  ["md-wave"] = 0xf0f2e,
  ["md-waveform"] = 0xf147d,
  ["md-waves"] = 0xf078d,
  ["md-waves_arrow_left"] = 0xf1859,
  ["md-waves_arrow_right"] = 0xf185a,
  ["md-waves_arrow_up"] = 0xf185b,
  ["md-waze"] = 0xf0bde,
  ["md-weather_cloudy"] = 0xf0590,
  ["md-weather_cloudy_alert"] = 0xf0f2f,
  ["md-weather_cloudy_arrow_right"] = 0xf0e6e,
  ["md-weather_cloudy_clock"] = 0xf18f6,
  ["md-weather_fog"] = 0xf0591,
  ["md-weather_hail"] = 0xf0592,
  ["md-weather_hazy"] = 0xf0f30,
  ["md-weather_hurricane"] = 0xf0898,
  ["md-weather_lightning"] = 0xf0593,
  ["md-weather_lightning_rainy"] = 0xf067e,
  ["md-weather_night"] = 0xf0594,
  ["md-weather_night_partly_cloudy"] = 0xf0f31,
  ["md-weather_partly_cloudy"] = 0xf0595,
  ["md-weather_partly_lightning"] = 0xf0f32,
  ["md-weather_partly_rainy"] = 0xf0f33,
  ["md-weather_partly_snowy"] = 0xf0f34,
  ["md-weather_partly_snowy_rainy"] = 0xf0f35,
  ["md-weather_pouring"] = 0xf0596,
  ["md-weather_rainy"] = 0xf0597,
  ["md-weather_snowy"] = 0xf0598,
  ["md-weather_snowy_heavy"] = 0xf0f36,
  ["md-weather_snowy_rainy"] = 0xf067f,
  ["md-weather_sunny"] = 0xf0599,
  ["md-weather_sunny_alert"] = 0xf0f37,
  ["md-weather_sunny_off"] = 0xf14e4,
  ["md-weather_sunset"] = 0xf059a,
  ["md-weather_sunset_down"] = 0xf059b,
  ["md-weather_sunset_up"] = 0xf059c,
  ["md-weather_tornado"] = 0xf0f38,
  ["md-weather_windy"] = 0xf059d,
  ["md-weather_windy_variant"] = 0xf059e,
  ["md-web"] = 0xf059f,
  ["md-web_box"] = 0xf0f94,
  ["md-web_cancel"] = 0xf1790,
  ["md-web_check"] = 0xf0789,
  ["md-web_clock"] = 0xf124a,
  ["md-web_minus"] = 0xf10a0,
  ["md-web_off"] = 0xf0a8e,
  ["md-web_plus"] = 0xf0033,
  ["md-web_refresh"] = 0xf1791,
  ["md-web_remove"] = 0xf0551,
  ["md-web_sync"] = 0xf1792,
  ["md-webcam"] = 0xf05a0,
  ["md-webcam_off"] = 0xf1737,
  ["md-webhook"] = 0xf062f,
  ["md-webpack"] = 0xf072b,
  ["md-webrtc"] = 0xf1248,
  ["md-wechat"] = 0xf0611,
  ["md-weight"] = 0xf05a1,
  ["md-weight_gram"] = 0xf0d3f,
  ["md-weight_kilogram"] = 0xf05a2,
  ["md-weight_lifter"] = 0xf115d,
  ["md-weight_pound"] = 0xf09b5,
  ["md-whatsapp"] = 0xf05a3,
  ["md-wheel_barrow"] = 0xf14f2,
  ["md-wheelchair"] = 0xf1a87,
  ["md-wheelchair_accessibility"] = 0xf05a4,
  ["md-whistle"] = 0xf09b6,
  ["md-whistle_outline"] = 0xf12bc,
  ["md-white_balance_auto"] = 0xf05a5,
  ["md-white_balance_incandescent"] = 0xf05a6,
  ["md-white_balance_iridescent"] = 0xf05a7,
  ["md-white_balance_sunny"] = 0xf05a8,
  ["md-widgets"] = 0xf072c,
  ["md-widgets_outline"] = 0xf1355,
  ["md-wifi"] = 0xf05a9,
  ["md-wifi_alert"] = 0xf16b5,
  ["md-wifi_arrow_down"] = 0xf16b6,
  ["md-wifi_arrow_left"] = 0xf16b7,
  ["md-wifi_arrow_left_right"] = 0xf16b8,
  ["md-wifi_arrow_right"] = 0xf16b9,
  ["md-wifi_arrow_up"] = 0xf16ba,
  ["md-wifi_arrow_up_down"] = 0xf16bb,
  ["md-wifi_cancel"] = 0xf16bc,
  ["md-wifi_check"] = 0xf16bd,
  ["md-wifi_cog"] = 0xf16be,
  ["md-wifi_lock"] = 0xf16bf,
  ["md-wifi_lock_open"] = 0xf16c0,
  ["md-wifi_marker"] = 0xf16c1,
  ["md-wifi_minus"] = 0xf16c2,
  ["md-wifi_off"] = 0xf05aa,
  ["md-wifi_plus"] = 0xf16c3,
  ["md-wifi_refresh"] = 0xf16c4,
  ["md-wifi_remove"] = 0xf16c5,
  ["md-wifi_settings"] = 0xf16c6,
  ["md-wifi_star"] = 0xf0e0b,
  ["md-wifi_strength_1"] = 0xf091f,
  ["md-wifi_strength_1_alert"] = 0xf0920,
  ["md-wifi_strength_1_lock"] = 0xf0921,
  ["md-wifi_strength_1_lock_open"] = 0xf16cb,
  ["md-wifi_strength_2"] = 0xf0922,
  ["md-wifi_strength_2_alert"] = 0xf0923,
  ["md-wifi_strength_2_lock"] = 0xf0924,
  ["md-wifi_strength_2_lock_open"] = 0xf16cc,
  ["md-wifi_strength_3"] = 0xf0925,
  ["md-wifi_strength_3_alert"] = 0xf0926,
  ["md-wifi_strength_3_lock"] = 0xf0927,
  ["md-wifi_strength_3_lock_open"] = 0xf16cd,
  ["md-wifi_strength_4"] = 0xf0928,
  ["md-wifi_strength_4_alert"] = 0xf0929,
  ["md-wifi_strength_4_lock"] = 0xf092a,
  ["md-wifi_strength_4_lock_open"] = 0xf16ce,
  ["md-wifi_strength_alert_outline"] = 0xf092b,
  ["md-wifi_strength_lock_open_outline"] = 0xf16cf,
  ["md-wifi_strength_lock_outline"] = 0xf092c,
  ["md-wifi_strength_off"] = 0xf092d,
  ["md-wifi_strength_off_outline"] = 0xf092e,
  ["md-wifi_strength_outline"] = 0xf092f,
  ["md-wifi_sync"] = 0xf16c7,
  ["md-wikipedia"] = 0xf05ac,
  ["md-wind_power"] = 0xf1a88,
  ["md-wind_power_outline"] = 0xf1a89,
  ["md-wind_turbine"] = 0xf0da5,
  ["md-wind_turbine_alert"] = 0xf19ab,
  ["md-wind_turbine_check"] = 0xf19ac,
  ["md-window_close"] = 0xf05ad,
  ["md-window_closed"] = 0xf05ae,
  ["md-window_closed_variant"] = 0xf11db,
  ["md-window_maximize"] = 0xf05af,
  ["md-window_minimize"] = 0xf05b0,
  ["md-window_open"] = 0xf05b1,
  ["md-window_open_variant"] = 0xf11dc,
  ["md-window_restore"] = 0xf05b2,
  ["md-window_shutter"] = 0xf111c,
  ["md-window_shutter_alert"] = 0xf111d,
  ["md-window_shutter_cog"] = 0xf1a8a,
  ["md-window_shutter_open"] = 0xf111e,
  ["md-window_shutter_settings"] = 0xf1a8b,
  ["md-windsock"] = 0xf15fa,
  ["md-wiper"] = 0xf0ae9,
  ["md-wiper_wash"] = 0xf0da6,
  ["md-wiper_wash_alert"] = 0xf18df,
  ["md-wizard_hat"] = 0xf1477,
  ["md-wordpress"] = 0xf05b4,
  ["md-wrap"] = 0xf05b6,
  ["md-wrap_disabled"] = 0xf0bdf,
  ["md-wrench"] = 0xf05b7,
  ["md-wrench_clock"] = 0xf19a3,
  ["md-wrench_outline"] = 0xf0be0,
  ["md-xamarin"] = 0xf0845,
  ["md-xml"] = 0xf05c0,
  ["md-xmpp"] = 0xf07ff,
  ["md-yahoo"] = 0xf0b4f,
  ["md-yeast"] = 0xf05c1,
  ["md-yin_yang"] = 0xf0680,
  ["md-yoga"] = 0xf117c,
  ["md-youtube"] = 0xf05c3,
  ["md-youtube_gaming"] = 0xf0848,
  ["md-youtube_studio"] = 0xf0847,
  ["md-youtube_subscription"] = 0xf0d40,
  ["md-youtube_tv"] = 0xf0448,
  ["md-yurt"] = 0xf1516,
  ["md-z_wave"] = 0xf0aea,
  ["md-zend"] = 0xf0aeb,
  ["md-zigbee"] = 0xf0d41,
  ["md-zip_box"] = 0xf05c4,
  ["md-zip_box_outline"] = 0xf0ffa,
  ["md-zip_disk"] = 0xf0a23,
  ["md-zodiac_aquarius"] = 0xf0a7d,
  ["md-zodiac_aries"] = 0xf0a7e,
  ["md-zodiac_cancer"] = 0xf0a7f,
  ["md-zodiac_capricorn"] = 0xf0a80,
  ["md-zodiac_gemini"] = 0xf0a81,
  ["md-zodiac_leo"] = 0xf0a82,
  ["md-zodiac_libra"] = 0xf0a83,
  ["md-zodiac_pisces"] = 0xf0a84,
  ["md-zodiac_sagittarius"] = 0xf0a85,
  ["md-zodiac_scorpio"] = 0xf0a86,
  ["md-zodiac_taurus"] = 0xf0a87,
  ["md-zodiac_virgo"] = 0xf0a88,
  ["oct-accessibility"] = 0xf406,
  ["oct-accessibility_inset"] = 0xf40b,
  ["oct-alert"] = 0xf421,
  ["oct-alert_fill"] = 0xf40c,
  ["oct-apps"] = 0xf40e,
  ["oct-archive"] = 0xf411,
  ["oct-arrow_both"] = 0xf416,
  ["oct-arrow_down"] = 0xf433,
  ["oct-arrow_down_left"] = 0xf424,
  ["oct-arrow_down_right"] = 0xf43e,
  ["oct-arrow_left"] = 0xf434,
  ["oct-arrow_right"] = 0xf432,
  ["oct-arrow_switch"] = 0xf443,
  ["oct-arrow_up"] = 0xf431,
  ["oct-arrow_up_left"] = 0xf45c,
  ["oct-arrow_up_right"] = 0xf46c,
  ["oct-beaker"] = 0xf499,
  ["oct-bell"] = 0xf49a,
  ["oct-bell_fill"] = 0xf476,
  ["oct-bell_slash"] = 0xf478,
  ["oct-blocked"] = 0xf479,
  ["oct-bold"] = 0xf49d,
  ["oct-book"] = 0xf405,
  ["oct-bookmark"] = 0xf461,
  ["oct-bookmark_fill"] = 0xf47a,
  ["oct-bookmark_slash"] = 0xf533,
  ["oct-bookmark_slash_fill"] = 0xf493,
  ["oct-briefcase"] = 0xf491,
  ["oct-broadcast"] = 0xf43c,
  ["oct-browser"] = 0xf488,
  ["oct-bug"] = 0xf46f,
  ["oct-cache"] = 0xf49b,
  ["oct-calendar"] = 0xf455,
  ["oct-check"] = 0xf42e,
  ["oct-check_circle"] = 0xf49e,
  ["oct-check_circle_fill"] = 0xf4a4,
  ["oct-checkbox"] = 0xf4a7,
  ["oct-checklist"] = 0xf45e,
  ["oct-chevron_down"] = 0xf47c,
  ["oct-chevron_left"] = 0xf47d,
  ["oct-chevron_right"] = 0xf460,
  ["oct-chevron_up"] = 0xf47b,
  ["oct-circle"] = 0xf4aa,
  ["oct-circle_slash"] = 0xf468,
  ["oct-clock"] = 0xf43a,
  ["oct-clock_fill"] = 0xf4ab,
  ["oct-cloud"] = 0xf4ac,
  ["oct-cloud_offline"] = 0xf4ad,
  ["oct-code"] = 0xf44f,
  ["oct-code_of_conduct"] = 0xf4ae,
  ["oct-code_review"] = 0xf4af,
  ["oct-code_square"] = 0xf4b0,
  ["oct-codescan"] = 0xf4b1,
  ["oct-codescan_checkmark"] = 0xf4b2,
  ["oct-codespaces"] = 0xf4b3,
  ["oct-columns"] = 0xf4b4,
  ["oct-command_palette"] = 0xf4b5,
  ["oct-comment"] = 0xf41f,
  ["oct-comment_discussion"] = 0xf442,
  ["oct-commit"] = 0xf4b6,
  ["oct-container"] = 0xf4b7,
  ["oct-copilot"] = 0xf4b8,
  ["oct-copilot_error"] = 0xf4b9,
  ["oct-copilot_warning"] = 0xf4ba,
  ["oct-copy"] = 0xf4bb,
  ["oct-cpu"] = 0xf4bc,
  ["oct-credit_card"] = 0xf439,
  ["oct-cross_reference"] = 0xf4bd,
  ["oct-dash"] = 0xf48b,
  ["oct-database"] = 0xf472,
  ["oct-dependabot"] = 0xf4be,
  ["oct-desktop_download"] = 0xf498,
  ["oct-device_camera"] = 0xf446,
  ["oct-device_camera_video"] = 0xf447,
  ["oct-device_desktop"] = 0xf4a9,
  ["oct-device_mobile"] = 0xf42c,
  ["oct-diamond"] = 0xf4bf,
  ["oct-diff"] = 0xf440,
  ["oct-diff_added"] = 0xf457,
  ["oct-diff_ignored"] = 0xf474,
  ["oct-diff_modified"] = 0xf459,
  ["oct-diff_removed"] = 0xf458,
  ["oct-diff_renamed"] = 0xf45a,
  ["oct-discussion_closed"] = 0xf4c0,
  ["oct-discussion_duplicate"] = 0xf4c1,
  ["oct-discussion_outdated"] = 0xf4c2,
  ["oct-dot"] = 0xf4c3,
  ["oct-dot_fill"] = 0xf444,
  ["oct-download"] = 0xf409,
  ["oct-duplicate"] = 0xf4c4,
  ["oct-ellipsis"] = 0xf475,
  ["oct-eye"] = 0xf441,
  ["oct-eye_closed"] = 0xf4c5,
  ["oct-feed_discussion"] = 0xf4c6,
  ["oct-feed_forked"] = 0xf4c7,
  ["oct-feed_heart"] = 0xf4c8,
  ["oct-feed_merged"] = 0xf4c9,
  ["oct-feed_person"] = 0xf4ca,
  ["oct-feed_repo"] = 0xf4cb,
  ["oct-feed_rocket"] = 0xf4cc,
  ["oct-feed_star"] = 0xf4cd,
  ["oct-feed_tag"] = 0xf4ce,
  ["oct-feed_trophy"] = 0xf4cf,
  ["oct-file"] = 0xf4a5,
  ["oct-file_added"] = 0xf4d0,
  ["oct-file_badge"] = 0xf4d1,
  ["oct-file_binary"] = 0xf471,
  ["oct-file_code"] = 0xf40d,
  ["oct-file_diff"] = 0xf4d2,
  ["oct-file_directory"] = 0xf413,
  ["oct-file_directory_fill"] = 0xf4d3,
  ["oct-file_directory_open_fill"] = 0xf4d4,
  ["oct-file_media"] = 0xf40f,
  ["oct-file_moved"] = 0xf4d5,
  ["oct-file_removed"] = 0xf4d6,
  ["oct-file_submodule"] = 0xf414,
  ["oct-file_symlink_directory"] = 0xf482,
  ["oct-file_symlink_file"] = 0xf481,
  ["oct-file_zip"] = 0xf410,
  ["oct-filter"] = 0xf4d7,
  ["oct-fiscal_host"] = 0xf4d8,
  ["oct-flame"] = 0xf490,
  ["oct-fold"] = 0xf48c,
  ["oct-fold_down"] = 0xf4d9,
  ["oct-fold_up"] = 0xf4da,
  ["oct-gear"] = 0xf423,
  ["oct-gift"] = 0xf436,
  ["oct-git_branch"] = 0xf418,
  ["oct-git_commit"] = 0xf417,
  ["oct-git_compare"] = 0xf47f,
  ["oct-git_merge"] = 0xf419,
  ["oct-git_merge_queue"] = 0xf4db,
  ["oct-git_pull_request"] = 0xf407,
  ["oct-git_pull_request_closed"] = 0xf4dc,
  ["oct-git_pull_request_draft"] = 0xf4dd,
  ["oct-globe"] = 0xf484,
  ["oct-goal"] = 0xf4de,
  ["oct-grabber"] = 0xf4a6,
  ["oct-graph"] = 0xf437,
  ["oct-hash"] = 0xf4df,
  ["oct-heading"] = 0xf4e0,
  ["oct-heart"] = 0x2665,
  ["oct-heart_fill"] = 0xf4e1,
  ["oct-history"] = 0xf464,
  ["oct-home"] = 0xf46d,
  ["oct-home_fill"] = 0xf4e2,
  ["oct-horizontal_rule"] = 0xf45b,
  ["oct-hourglass"] = 0xf4e3,
  ["oct-hubot"] = 0xf477,
  ["oct-id_badge"] = 0xf4e4,
  ["oct-image"] = 0xf4e5,
  ["oct-inbox"] = 0xf48d,
  ["oct-infinity"] = 0xf4e6,
  ["oct-info"] = 0xf449,
  ["oct-issue_closed"] = 0xf41d,
  ["oct-issue_draft"] = 0xf4e7,
  ["oct-issue_opened"] = 0xf41b,
  ["oct-issue_reopened"] = 0xf41c,
  ["oct-issue_tracked_by"] = 0xf4e8,
  ["oct-issue_tracks"] = 0xf4e9,
  ["oct-italic"] = 0xf49f,
  ["oct-iterations"] = 0xf4ea,
  ["oct-kebab_horizontal"] = 0xf4eb,
  ["oct-key"] = 0xf43d,
  ["oct-key_asterisk"] = 0xf4ec,
  ["oct-law"] = 0xf495,
  ["oct-light_bulb"] = 0xf400,
  ["oct-link"] = 0xf44c,
  ["oct-link_external"] = 0xf465,
  ["oct-list_ordered"] = 0xf452,
  ["oct-list_unordered"] = 0xf451,
  ["oct-location"] = 0xf450,
  ["oct-lock"] = 0xf456,
  ["oct-log"] = 0xf4ed,
  ["oct-logo_gist"] = 0xf480,
  ["oct-logo_github"] = 0xf470,
  ["oct-mail"] = 0xf42f,
  ["oct-mark_github"] = 0xf408,
  ["oct-markdown"] = 0xf48a,
  ["oct-megaphone"] = 0xf45f,
  ["oct-mention"] = 0xf486,
  ["oct-meter"] = 0xf463,
  ["oct-milestone"] = 0xf45d,
  ["oct-mirror"] = 0xf41a,
  ["oct-moon"] = 0xf4ee,
  ["oct-mortar_board"] = 0xf494,
  ["oct-move_to_bottom"] = 0xf4ef,
  ["oct-move_to_end"] = 0xf4f0,
  ["oct-move_to_start"] = 0xf4f1,
  ["oct-move_to_top"] = 0xf4f2,
  ["oct-multi_select"] = 0xf4f3,
  ["oct-mute"] = 0xf466,
  ["oct-no_entry"] = 0xf4f4,
  ["oct-north_star"] = 0xf4f5,
  ["oct-note"] = 0xf4f6,
  ["oct-number"] = 0xf4f7,
  ["oct-organization"] = 0xf42b,
  ["oct-package"] = 0xf487,
  ["oct-package_dependencies"] = 0xf4f8,
  ["oct-package_dependents"] = 0xf4f9,
  ["oct-paintbrush"] = 0xf48f,
  ["oct-paper_airplane"] = 0xf4fa,
  ["oct-paperclip"] = 0xf4fb,
  ["oct-passkey_fill"] = 0xf4fc,
  ["oct-paste"] = 0xf429,
  ["oct-pencil"] = 0xf448,
  ["oct-people"] = 0xf4fd,
  ["oct-person"] = 0xf415,
  ["oct-person_add"] = 0xf4fe,
  ["oct-person_fill"] = 0xf4ff,
  ["oct-pin"] = 0xf435,
  ["oct-play"] = 0xf500,
  ["oct-plug"] = 0xf492,
  ["oct-plus"] = 0xf44d,
  ["oct-plus_circle"] = 0xf501,
  ["oct-project"] = 0xf502,
  ["oct-project_roadmap"] = 0xf503,
  ["oct-project_symlink"] = 0xf504,
  ["oct-project_template"] = 0xf505,
  ["oct-pulse"] = 0xf469,
  ["oct-question"] = 0xf420,
  ["oct-quote"] = 0xf453,
  ["oct-read"] = 0xf430,
  ["oct-rel_file_path"] = 0xf506,
  ["oct-reply"] = 0xf4a8,
  ["oct-repo"] = 0xf401,
  ["oct-repo_clone"] = 0xf43f,
  ["oct-repo_deleted"] = 0xf507,
  ["oct-repo_forked"] = 0xf402,
  ["oct-repo_locked"] = 0xf508,
  ["oct-repo_pull"] = 0xf404,
  ["oct-repo_push"] = 0xf403,
  ["oct-repo_template"] = 0xf509,
  ["oct-report"] = 0xf50a,
  ["oct-rocket"] = 0xf427,
  ["oct-rows"] = 0xf50b,
  ["oct-rss"] = 0xf428,
  ["oct-ruby"] = 0xf43b,
  ["oct-screen_full"] = 0xf50c,
  ["oct-screen_normal"] = 0xf50d,
  ["oct-search"] = 0xf422,
  ["oct-server"] = 0xf473,
  ["oct-share"] = 0xf50e,
  ["oct-share_android"] = 0xf50f,
  ["oct-shield"] = 0xf49c,
  ["oct-shield_check"] = 0xf510,
  ["oct-shield_lock"] = 0xf511,
  ["oct-shield_slash"] = 0xf512,
  ["oct-shield_x"] = 0xf513,
  ["oct-sidebar_collapse"] = 0xf514,
  ["oct-sidebar_expand"] = 0xf515,
  ["oct-sign_in"] = 0xf42a,
  ["oct-sign_out"] = 0xf426,
  ["oct-single_select"] = 0xf516,
  ["oct-skip"] = 0xf517,
  ["oct-skip_fill"] = 0xf518,
  ["oct-sliders"] = 0xf462,
  ["oct-smiley"] = 0xf4a2,
  ["oct-sort_asc"] = 0xf519,
  ["oct-sort_desc"] = 0xf51a,
  ["oct-sparkle_fill"] = 0xf51b,
  ["oct-sponsor_tiers"] = 0xf51c,
  ["oct-square"] = 0xf51d,
  ["oct-square_fill"] = 0xf445,
  ["oct-squirrel"] = 0xf483,
  ["oct-stack"] = 0xf51e,
  ["oct-star"] = 0xf41e,
  ["oct-star_fill"] = 0xf51f,
  ["oct-stop"] = 0xf46e,
  ["oct-stopwatch"] = 0xf520,
  ["oct-strikethrough"] = 0xf521,
  ["oct-sun"] = 0xf522,
  ["oct-sync"] = 0xf46a,
  ["oct-tab"] = 0xf523,
  ["oct-tab_external"] = 0xf524,
  ["oct-table"] = 0xf525,
  ["oct-tag"] = 0xf412,
  ["oct-tasklist"] = 0xf4a0,
  ["oct-telescope"] = 0xf46b,
  ["oct-telescope_fill"] = 0xf526,
  ["oct-terminal"] = 0xf489,
  ["oct-three_bars"] = 0xf44e,
  ["oct-thumbsdown"] = 0xf497,
  ["oct-thumbsup"] = 0xf496,
  ["oct-tools"] = 0xf425,
  ["oct-trash"] = 0xf48e,
  ["oct-triangle_down"] = 0xf44b,
  ["oct-triangle_left"] = 0xf438,
  ["oct-triangle_right"] = 0xf44a,
  ["oct-triangle_up"] = 0xf47e,
  ["oct-trophy"] = 0xf527,
  ["oct-typography"] = 0xf528,
  ["oct-unfold"] = 0xf42d,
  ["oct-unlink"] = 0xf529,
  ["oct-unlock"] = 0xf52a,
  ["oct-unmute"] = 0xf485,
  ["oct-unread"] = 0xf52b,
  ["oct-unverified"] = 0xf4a3,
  ["oct-upload"] = 0xf40a,
  ["oct-verified"] = 0xf4a1,
  ["oct-versions"] = 0xf454,
  ["oct-video"] = 0xf52c,
  ["oct-webhook"] = 0xf52d,
  ["oct-workflow"] = 0xf52e,
  ["oct-x"] = 0xf467,
  ["oct-x_circle"] = 0xf52f,
  ["oct-x_circle_fill"] = 0xf530,
  ["oct-zap"] = 0x26a1,
  ["oct-zoom_in"] = 0xf531,
  ["oct-zoom_out"] = 0xf532,
  ["pl-branch"] = 0xe0a0,
  ["pl-current_line"] = 0xe0a1,
  ["pl-hostname"] = 0xe0a2,
  ["pl-left_hard_divider"] = 0xe0b0,
  ["pl-left_soft_divider"] = 0xe0b1,
  ["pl-line_number"] = 0xe0a1,
  ["pl-readonly"] = 0xe0a2,
  ["pl-right_hard_divider"] = 0xe0b2,
  ["pl-right_soft_divider"] = 0xe0b3,
  ["ple-backslash_separator"] = 0xe0b9,
  ["ple-backslash_separator_redundant"] = 0xe0bf,
  ["ple-column_number"] = 0xe0a3,
  ["ple-current_column"] = 0xe0a3,
  ["ple-flame_thick"] = 0xe0c0,
  ["ple-flame_thick_mirrored"] = 0xe0c2,
  ["ple-flame_thin"] = 0xe0c1,
  ["ple-flame_thin_mirrored"] = 0xe0c3,
  ["ple-forwardslash_separator"] = 0xe0bb,
  ["ple-forwardslash_separator_redundant"] = 0xe0bd,
  ["ple-honeycomb"] = 0xe0cc,
  ["ple-honeycomb_outline"] = 0xe0cd,
  ["ple-ice_waveform"] = 0xe0c8,
  ["ple-ice_waveform_mirrored"] = 0xe0ca,
  ["ple-left_half_circle_thick"] = 0xe0b6,
  ["ple-left_half_circle_thin"] = 0xe0b7,
  ["ple-lego_block_facing"] = 0xe0d0,
  ["ple-lego_block_sideways"] = 0xe0d1,
  ["ple-lego_separator"] = 0xe0ce,
  ["ple-lego_separator_thin"] = 0xe0cf,
  ["ple-lower_left_triangle"] = 0xe0b8,
  ["ple-lower_right_triangle"] = 0xe0ba,
  ["ple-pixelated_squares_big"] = 0xe0c6,
  ["ple-pixelated_squares_big_mirrored"] = 0xe0c7,
  ["ple-pixelated_squares_small"] = 0xe0c4,
  ["ple-pixelated_squares_small_mirrored"] = 0xe0c5,
  ["ple-right_half_circle_thick"] = 0xe0b4,
  ["ple-right_half_circle_thin"] = 0xe0b5,
  ["ple-trapezoid_top_bottom"] = 0xe0d2,
  ["ple-trapezoid_top_bottom_mirrored"] = 0xe0d4,
  ["ple-upper_left_triangle"] = 0xe0bc,
  ["ple-upper_right_triangle"] = 0xe0be,
  ["pom-away"] = 0xe007,
  ["pom-clean_code"] = 0xe000,
  ["pom-external_interruption"] = 0xe00a,
  ["pom-internal_interruption"] = 0xe009,
  ["pom-long_pause"] = 0xe006,
  ["pom-pair_programming"] = 0xe008,
  ["pom-pomodoro_done"] = 0xe001,
  ["pom-pomodoro_estimated"] = 0xe002,
  ["pom-pomodoro_squashed"] = 0xe004,
  ["pom-pomodoro_ticking"] = 0xe003,
  ["pom-short_pause"] = 0xe005,
  ["seti-apple"] = 0xe635,
  ["seti-argdown"] = 0xe636,
  ["seti-asm"] = 0xe637,
  ["seti-audio"] = 0xe638,
  ["seti-babel"] = 0xe639,
  ["seti-bazel"] = 0xe63a,
  ["seti-bicep"] = 0xe63b,
  ["seti-bower"] = 0xe61a,
  ["seti-bsl"] = 0xe63c,
  ["seti-c"] = 0xe649,
  ["seti-c_sharp"] = 0xe648,
  ["seti-cake"] = 0xe63e,
  ["seti-cake_php"] = 0xe63d,
  ["seti-checkbox"] = 0xe63f,
  ["seti-checkbox_unchecked"] = 0xe640,
  ["seti-cjsx"] = 0xe61b,
  ["seti-clock"] = 0xe641,
  ["seti-clojure"] = 0xe642,
  ["seti-code_climate"] = 0xe643,
  ["seti-code_search"] = 0xe644,
  ["seti-coffee"] = 0xe61b,
  ["seti-coldfusion"] = 0xe645,
  ["seti-config"] = 0xe615,
  ["seti-cpp"] = 0xe646,
  ["seti-crystal"] = 0xe62f,
  ["seti-crystal_embedded"] = 0xe647,
  ["seti-css"] = 0xe614,
  ["seti-csv"] = 0xe64a,
  ["seti-cu"] = 0xe64b,
  ["seti-d"] = 0xe651,
  ["seti-dart"] = 0xe64c,
  ["seti-db"] = 0xe64d,
  ["seti-default"] = 0xe64e,
  ["seti-deprecation_cop"] = 0xe64f,
  ["seti-docker"] = 0xe650,
  ["seti-editorconfig"] = 0xe652,
  ["seti-ejs"] = 0xe618,
  ["seti-elixir"] = 0xe62d,
  ["seti-elixir_script"] = 0xe653,
  ["seti-elm"] = 0xe62c,
  ["seti-error"] = 0xe654,
  ["seti-eslint"] = 0xe655,
  ["seti-ethereum"] = 0xe656,
  ["seti-f_sharp"] = 0xe65a,
  ["seti-favicon"] = 0xe623,
  ["seti-firebase"] = 0xe657,
  ["seti-firefox"] = 0xe658,
  ["seti-folder"] = 0xe613,
  ["seti-font"] = 0xe659,
  ["seti-git"] = 0xe65d,
  ["seti-git_folder"] = 0xe65d,
  ["seti-git_ignore"] = 0xe65d,
  ["seti-github"] = 0xe65b,
  ["seti-gitlab"] = 0xe65c,
  ["seti-go"] = 0xe627,
  ["seti-go2"] = 0xe65e,
  ["seti-godot"] = 0xe65f,
  ["seti-gradle"] = 0xe660,
  ["seti-grails"] = 0xe661,
  ["seti-graphql"] = 0xe662,
  ["seti-grunt"] = 0xe611,
  ["seti-gulp"] = 0xe610,
  ["seti-hacklang"] = 0xe663,
  ["seti-haml"] = 0xe664,
  ["seti-happenings"] = 0xe665,
  ["seti-haskell"] = 0xe61f,
  ["seti-haxe"] = 0xe666,
  ["seti-heroku"] = 0xe607,
  ["seti-hex"] = 0xe667,
  ["seti-home"] = 0xe617,
  ["seti-html"] = 0xe60e,
  ["seti-ignored"] = 0xe668,
  ["seti-illustrator"] = 0xe669,
  ["seti-image"] = 0xe60d,
  ["seti-info"] = 0xe66a,
  ["seti-ionic"] = 0xe66b,
  ["seti-jade"] = 0xe66c,
  ["seti-java"] = 0xe66d,
  ["seti-javascript"] = 0xe60c,
  ["seti-jenkins"] = 0xe66e,
  ["seti-jinja"] = 0xe66f,
  ["seti-json"] = 0xe60b,
  ["seti-julia"] = 0xe624,
  ["seti-karma"] = 0xe622,
  ["seti-kotlin"] = 0xe634,
  ["seti-less"] = 0xe60b,
  ["seti-license"] = 0xe60a,
  ["seti-liquid"] = 0xe670,
  ["seti-livescript"] = 0xe671,
  ["seti-lock"] = 0xe672,
  ["seti-lua"] = 0xe620,
  ["seti-makefile"] = 0xe673,
  ["seti-markdown"] = 0xe609,
  ["seti-maven"] = 0xe674,
  ["seti-mdo"] = 0xe675,
  ["seti-mustache"] = 0xe60f,
  ["seti-new_file"] = 0xe676,
  ["seti-nim"] = 0xe677,
  ["seti-notebook"] = 0xe678,
  ["seti-npm"] = 0xe616,
  ["seti-npm_ignored"] = 0xe616,
  ["seti-nunjucks"] = 0xe679,
  ["seti-ocaml"] = 0xe67a,
  ["seti-odata"] = 0xe67b,
  ["seti-pddl"] = 0xe67c,
  ["seti-pdf"] = 0xe67d,
  ["seti-perl"] = 0xe67e,
  ["seti-photoshop"] = 0xe67f,
  ["seti-php"] = 0xe608,
  ["seti-pipeline"] = 0xe680,
  ["seti-plan"] = 0xe681,
  ["seti-platformio"] = 0xe682,
  ["seti-play_arrow"] = 0xe602,
  ["seti-powershell"] = 0xe683,
  ["seti-prisma"] = 0xe684,
  ["seti-project"] = 0xe601,
  ["seti-prolog"] = 0xe685,
  ["seti-pug"] = 0xe686,
  ["seti-puppet"] = 0xe631,
  ["seti-purescript"] = 0xe630,
  ["seti-python"] = 0xe606,
  ["seti-r"] = 0xe68a,
  ["seti-rails"] = 0xe604,
  ["seti-react"] = 0xe625,
  ["seti-reasonml"] = 0xe687,
  ["seti-rescript"] = 0xe688,
  ["seti-rollup"] = 0xe689,
  ["seti-ruby"] = 0xe605,
  ["seti-rust"] = 0xe68b,
  ["seti-salesforce"] = 0xe68c,
  ["seti-sass"] = 0xe603,
  ["seti-sbt"] = 0xe68d,
  ["seti-scala"] = 0xe68e,
  ["seti-search"] = 0xe68f,
  ["seti-settings"] = 0xe690,
  ["seti-shell"] = 0xe691,
  ["seti-slim"] = 0xe692,
  ["seti-smarty"] = 0xe693,
  ["seti-spring"] = 0xe694,
  ["seti-stylelint"] = 0xe695,
  ["seti-stylus"] = 0xe600,
  ["seti-sublime"] = 0xe696,
  ["seti-svelte"] = 0xe697,
  ["seti-svg"] = 0xe698,
  ["seti-swift"] = 0xe699,
  ["seti-terraform"] = 0xe69a,
  ["seti-tex"] = 0xe69b,
  ["seti-text"] = 0xe612,
  ["seti-time_cop"] = 0xe641,
  ["seti-todo"] = 0xe69c,
  ["seti-tsconfig"] = 0xe69d,
  ["seti-twig"] = 0xe61c,
  ["seti-typescript"] = 0xe628,
  ["seti-vala"] = 0xe69e,
  ["seti-video"] = 0xe69f,
  ["seti-vue"] = 0xe6a0,
  ["seti-wasm"] = 0xe6a1,
  ["seti-wat"] = 0xe6a2,
  ["seti-webpack"] = 0xe6a3,
  ["seti-wgt"] = 0xe6a4,
  ["seti-word"] = 0xe6a5,
  ["seti-xls"] = 0xe6a6,
  ["seti-xml"] = 0xe619,
  ["seti-yarn"] = 0xe6a7,
  ["seti-yml"] = 0xe6a8,
  ["seti-zig"] = 0xe6a9,
  ["seti-zip"] = 0xe6aa,
  ["weather-alien"] = 0xe36e,
  ["weather-aliens"] = 0xe345,
  ["weather-barometer"] = 0xe372,
  ["weather-celsius"] = 0xe339,
  ["weather-cloud"] = 0xe33d,
  ["weather-cloud_down"] = 0xe33a,
  ["weather-cloud_refresh"] = 0xe33b,
  ["weather-cloud_up"] = 0xe33c,
  ["weather-cloudy"] = 0xe312,
  ["weather-cloudy_gusts"] = 0xe310,
  ["weather-cloudy_windy"] = 0xe311,
  ["weather-day_cloudy"] = 0xe302,
  ["weather-day_cloudy_gusts"] = 0xe300,
  ["weather-day_cloudy_high"] = 0xe376,
  ["weather-day_cloudy_windy"] = 0xe301,
  ["weather-day_fog"] = 0xe303,
  ["weather-day_hail"] = 0xe304,
  ["weather-day_haze"] = 0xe3ae,
  ["weather-day_light_wind"] = 0xe3bc,
  ["weather-day_lightning"] = 0xe305,
  ["weather-day_rain"] = 0xe308,
  ["weather-day_rain_mix"] = 0xe306,
  ["weather-day_rain_wind"] = 0xe307,
  ["weather-day_showers"] = 0xe309,
  ["weather-day_sleet"] = 0xe3aa,
  ["weather-day_sleet_storm"] = 0xe362,
  ["weather-day_snow"] = 0xe30a,
  ["weather-day_snow_thunderstorm"] = 0xe365,
  ["weather-day_snow_wind"] = 0xe35f,
  ["weather-day_sprinkle"] = 0xe30b,
  ["weather-day_storm_showers"] = 0xe30e,
  ["weather-day_sunny"] = 0xe30d,
  ["weather-day_sunny_overcast"] = 0xe30c,
  ["weather-day_thunderstorm"] = 0xe30f,
  ["weather-day_windy"] = 0xe37d,
  ["weather-degrees"] = 0xe33e,
  ["weather-direction_down"] = 0xe340,
  ["weather-direction_down_left"] = 0xe33f,
  ["weather-direction_down_right"] = 0xe380,
  ["weather-direction_left"] = 0xe344,
  ["weather-direction_right"] = 0xe349,
  ["weather-direction_up"] = 0xe353,
  ["weather-direction_up_left"] = 0xe37f,
  ["weather-direction_up_right"] = 0xe352,
  ["weather-dust"] = 0xe35d,
  ["weather-earthquake"] = 0xe3be,
  ["weather-fahrenheit"] = 0xe341,
  ["weather-fire"] = 0xe3bf,
  ["weather-flood"] = 0xe375,
  ["weather-fog"] = 0xe313,
  ["weather-gale_warning"] = 0xe3c5,
  ["weather-hail"] = 0xe314,
  ["weather-horizon"] = 0xe343,
  ["weather-horizon_alt"] = 0xe342,
  ["weather-hot"] = 0xe36b,
  ["weather-humidity"] = 0xe373,
  ["weather-hurricane"] = 0xe36c,
  ["weather-hurricane_warning"] = 0xe3c7,
  ["weather-lightning"] = 0xe315,
  ["weather-lunar_eclipse"] = 0xe369,
  ["weather-meteor"] = 0xe36a,
  ["weather-moon_alt_first_quarter"] = 0xe3ce,
  ["weather-moon_alt_full"] = 0xe3d5,
  ["weather-moon_alt_new"] = 0xe3e3,
  ["weather-moon_alt_third_quarter"] = 0xe3dc,
  ["weather-moon_alt_waning_crescent_1"] = 0xe3dd,
  ["weather-moon_alt_waning_crescent_2"] = 0xe3de,
  ["weather-moon_alt_waning_crescent_3"] = 0xe3df,
  ["weather-moon_alt_waning_crescent_4"] = 0xe3e0,
  ["weather-moon_alt_waning_crescent_5"] = 0xe3e1,
  ["weather-moon_alt_waning_crescent_6"] = 0xe3e2,
  ["weather-moon_alt_waning_gibbous_1"] = 0xe3d6,
  ["weather-moon_alt_waning_gibbous_2"] = 0xe3d7,
  ["weather-moon_alt_waning_gibbous_3"] = 0xe3d8,
  ["weather-moon_alt_waning_gibbous_4"] = 0xe3d9,
  ["weather-moon_alt_waning_gibbous_5"] = 0xe3da,
  ["weather-moon_alt_waning_gibbous_6"] = 0xe3db,
  ["weather-moon_alt_waxing_crescent_1"] = 0xe3c8,
  ["weather-moon_alt_waxing_crescent_2"] = 0xe3c9,
  ["weather-moon_alt_waxing_crescent_3"] = 0xe3ca,
  ["weather-moon_alt_waxing_crescent_4"] = 0xe3cb,
  ["weather-moon_alt_waxing_crescent_5"] = 0xe3cc,
  ["weather-moon_alt_waxing_crescent_6"] = 0xe3cd,
  ["weather-moon_alt_waxing_gibbous_1"] = 0xe3cf,
  ["weather-moon_alt_waxing_gibbous_2"] = 0xe3d0,
  ["weather-moon_alt_waxing_gibbous_3"] = 0xe3d1,
  ["weather-moon_alt_waxing_gibbous_4"] = 0xe3d2,
  ["weather-moon_alt_waxing_gibbous_5"] = 0xe3d3,
  ["weather-moon_alt_waxing_gibbous_6"] = 0xe3d4,
  ["weather-moon_first_quarter"] = 0xe394,
  ["weather-moon_full"] = 0xe39b,
  ["weather-moon_new"] = 0xe38d,
  ["weather-moon_third_quarter"] = 0xe3a2,
  ["weather-moon_waning_crescent_1"] = 0xe3a3,
  ["weather-moon_waning_crescent_2"] = 0xe3a4,
  ["weather-moon_waning_crescent_3"] = 0xe3a5,
  ["weather-moon_waning_crescent_4"] = 0xe3a6,
  ["weather-moon_waning_crescent_5"] = 0xe3a7,
  ["weather-moon_waning_crescent_6"] = 0xe3a8,
  ["weather-moon_waning_gibbous_1"] = 0xe39c,
  ["weather-moon_waning_gibbous_2"] = 0xe39d,
  ["weather-moon_waning_gibbous_3"] = 0xe39e,
  ["weather-moon_waning_gibbous_4"] = 0xe39f,
  ["weather-moon_waning_gibbous_5"] = 0xe3a0,
  ["weather-moon_waning_gibbous_6"] = 0xe3a1,
  ["weather-moon_waxing_crescent_1"] = 0xe38e,
  ["weather-moon_waxing_crescent_2"] = 0xe38f,
  ["weather-moon_waxing_crescent_3"] = 0xe390,
  ["weather-moon_waxing_crescent_4"] = 0xe391,
  ["weather-moon_waxing_crescent_5"] = 0xe392,
  ["weather-moon_waxing_crescent_6"] = 0xe393,
  ["weather-moon_waxing_gibbous_1"] = 0xe395,
  ["weather-moon_waxing_gibbous_2"] = 0xe396,
  ["weather-moon_waxing_gibbous_3"] = 0xe397,
  ["weather-moon_waxing_gibbous_4"] = 0xe398,
  ["weather-moon_waxing_gibbous_5"] = 0xe399,
  ["weather-moon_waxing_gibbous_6"] = 0xe39a,
  ["weather-moonrise"] = 0xe3c1,
  ["weather-moonset"] = 0xe3c2,
  ["weather-na"] = 0xe374,
  ["weather-night_alt_cloudy"] = 0xe37e,
  ["weather-night_alt_cloudy_gusts"] = 0xe31f,
  ["weather-night_alt_cloudy_high"] = 0xe377,
  ["weather-night_alt_cloudy_windy"] = 0xe320,
  ["weather-night_alt_hail"] = 0xe321,
  ["weather-night_alt_lightning"] = 0xe322,
  ["weather-night_alt_partly_cloudy"] = 0xe379,
  ["weather-night_alt_rain"] = 0xe325,
  ["weather-night_alt_rain_mix"] = 0xe323,
  ["weather-night_alt_rain_wind"] = 0xe324,
  ["weather-night_alt_showers"] = 0xe326,
  ["weather-night_alt_sleet"] = 0xe3ac,
  ["weather-night_alt_sleet_storm"] = 0xe364,
  ["weather-night_alt_snow"] = 0xe327,
  ["weather-night_alt_snow_thunderstorm"] = 0xe367,
  ["weather-night_alt_snow_wind"] = 0xe361,
  ["weather-night_alt_sprinkle"] = 0xe328,
  ["weather-night_alt_storm_showers"] = 0xe329,
  ["weather-night_alt_thunderstorm"] = 0xe32a,
  ["weather-night_clear"] = 0xe32b,
  ["weather-night_cloudy"] = 0xe32e,
  ["weather-night_cloudy_gusts"] = 0xe32c,
  ["weather-night_cloudy_high"] = 0xe378,
  ["weather-night_cloudy_windy"] = 0xe32d,
  ["weather-night_fog"] = 0xe346,
  ["weather-night_hail"] = 0xe32f,
  ["weather-night_lightning"] = 0xe330,
  ["weather-night_partly_cloudy"] = 0xe37b,
  ["weather-night_rain"] = 0xe333,
  ["weather-night_rain_mix"] = 0xe331,
  ["weather-night_rain_wind"] = 0xe332,
  ["weather-night_showers"] = 0xe334,
  ["weather-night_sleet"] = 0xe3ab,
  ["weather-night_sleet_storm"] = 0xe363,
  ["weather-night_snow"] = 0xe335,
  ["weather-night_snow_thunderstorm"] = 0xe366,
  ["weather-night_snow_wind"] = 0xe360,
  ["weather-night_sprinkle"] = 0xe336,
  ["weather-night_storm_showers"] = 0xe337,
  ["weather-night_thunderstorm"] = 0xe338,
  ["weather-rain"] = 0xe318,
  ["weather-rain_mix"] = 0xe316,
  ["weather-rain_wind"] = 0xe317,
  ["weather-raindrop"] = 0xe371,
  ["weather-raindrops"] = 0xe34a,
  ["weather-refresh"] = 0xe348,
  ["weather-refresh_alt"] = 0xe347,
  ["weather-sandstorm"] = 0xe37a,
  ["weather-showers"] = 0xe319,
  ["weather-sleet"] = 0xe3ad,
  ["weather-small_craft_advisory"] = 0xe3c4,
  ["weather-smog"] = 0xe36d,
  ["weather-smoke"] = 0xe35c,
  ["weather-snow"] = 0xe31a,
  ["weather-snow_wind"] = 0xe35e,
  ["weather-snowflake_cold"] = 0xe36f,
  ["weather-solar_eclipse"] = 0xe368,
  ["weather-sprinkle"] = 0xe31b,
  ["weather-stars"] = 0xe370,
  ["weather-storm_showers"] = 0xe31c,
  ["weather-storm_warning"] = 0xe3c6,
  ["weather-strong_wind"] = 0xe34b,
  ["weather-sunrise"] = 0xe34c,
  ["weather-sunset"] = 0xe34d,
  ["weather-thermometer"] = 0xe350,
  ["weather-thermometer_exterior"] = 0xe34e,
  ["weather-thermometer_internal"] = 0xe34f,
  ["weather-thunderstorm"] = 0xe31d,
  ["weather-time_1"] = 0xe382,
  ["weather-time_10"] = 0xe38b,
  ["weather-time_11"] = 0xe38c,
  ["weather-time_12"] = 0xe381,
  ["weather-time_2"] = 0xe383,
  ["weather-time_3"] = 0xe384,
  ["weather-time_4"] = 0xe385,
  ["weather-time_5"] = 0xe386,
  ["weather-time_6"] = 0xe387,
  ["weather-time_7"] = 0xe388,
  ["weather-time_8"] = 0xe389,
  ["weather-time_9"] = 0xe38a,
  ["weather-tornado"] = 0xe351,
  ["weather-train"] = 0xe3c3,
  ["weather-tsunami"] = 0xe3bd,
  ["weather-umbrella"] = 0xe37c,
  ["weather-volcano"] = 0xe3c0,
  ["weather-wind_beaufort_0"] = 0xe3af,
  ["weather-wind_beaufort_1"] = 0xe3b0,
  ["weather-wind_beaufort_10"] = 0xe3b9,
  ["weather-wind_beaufort_11"] = 0xe3ba,
  ["weather-wind_beaufort_12"] = 0xe3bb,
  ["weather-wind_beaufort_2"] = 0xe3b1,
  ["weather-wind_beaufort_3"] = 0xe3b2,
  ["weather-wind_beaufort_4"] = 0xe3b3,
  ["weather-wind_beaufort_5"] = 0xe3b4,
  ["weather-wind_beaufort_6"] = 0xe3b5,
  ["weather-wind_beaufort_7"] = 0xe3b6,
  ["weather-wind_beaufort_8"] = 0xe3b7,
  ["weather-wind_beaufort_9"] = 0xe3b8,
  ["weather-wind_direction"] = 0xe3a9,
  ["weather-wind_east"] = 0xe35b,
  ["weather-wind_north"] = 0xe35a,
  ["weather-wind_north_east"] = 0xe359,
  ["weather-wind_north_west"] = 0xe358,
  ["weather-wind_south"] = 0xe357,
  ["weather-wind_south_east"] = 0xe356,
  ["weather-wind_south_west"] = 0xe355,
  ["weather-wind_west"] = 0xe354,
  ["weather-windy"] = 0xe31e,
}

local utf8 = setmetatable({}, {
  __index = function(t, k)
    local cp = codepoints[k]
    if not cp then return nil end

    local res
    if cp < 0x0080 then
      res = cp
    elseif cp < 0x0800 then
      res = string.char(0xC0 | (cp >> 6), 0x80 | (cp & 0x3F))
    elseif cp < 0x10000 then
      res = string.char(0xE0 | (cp >> 12), 0x80 | ((cp >> 6) & 0x3F), 0x80 | (cp & 0x3F))
    else
      res = string.char(0xF0 | (cp >> 18), 0x80 | ((cp >> 12) & 0x3F), 0x80 | ((cp >> 6) & 0x3F), 0x80 | (cp & 0x3F))
    end

    t[k] = res
    return res
  end
})

return {
  codepoints = codepoints,
  utf8 = utf8,
  path = USERDIR .. PATHSEP .. "libraries" .. PATHSEP .. "font_symbols_nerdfont_mono_regular" .. PATHSEP .. "SymbolsNerdFontMono-Regular.ttf"
}
